﻿// *---------------------------------------------------------------------------*
//  (C) Copyright 1998-2018, Technologies Quazal Inc.  All rights reserved.
//  Quazal Net-Z, Quazal Rendez-Vous and Quazal are trademarks of Quazal.
//
//  Copyright (C)2011-2018 Nintendo  All rights reserved.
//
//  These coded instructions, statements, and computer programs contain
//  proprietary information of Nintendo and/or its licensors and are 
//  protected by national and international copyright laws.
//  They may not be disclosed to third parties or copied or duplicated
//  in any form, in whole or in part, without the prior written consent
//  of Nintendo.
//  The content herein is highly confidential and should be handled
//  accordingly.
// *---------------------------------------------------------------------------*

//
// DDLBasic.ddl
//

// ホストマイグレーションを行うために、以下のインクルードが必要です
#use <NetZ/src/Core/HostMigration/HostMigrationExt.ddl>

title "DDLBasic";

// 一般的なデータです。信頼性ありのチャンネルで送信され、値を更新した後に Update を
// 実行して変更をデュプリカに反映させる必要があります。
dataset Position
{
    float x;
    float y;
};

// 推定フィルタあり、信頼性のないチャンネルでの送信をセットします
dataset ExtrapolatedPosition
{
	float x;
	float y;
} extrapolation_filter, unreliable;

// ExtrapolatedPosition に加え、推定フィルタでの補間を複製マスタにも適用します
dataset ExtrapolatedLoopbackPosition
{
	float x;
	float y;
} extrapolation_filter, unreliable, loopback;

// その他情報
// ステーション ID を記録します
dataset AvatarInfo
{
    int32 stationID;
};

// アバタクラスの定義です
// 通常に位置、推定フィルタにより更新される値、等のパラメータを持ちます
doclass Avatar
{
    AvatarInfo m_dsInfo;
    Position m_dsPosition;
	ExtrapolatedPosition m_dsExtrapolatedPosition;
	ExtrapolatedLoopbackPosition m_dsExtrapolatedLoopbackPosition;
};

// constant として定義します
dataset Boundaries
{
    float minX;
    float maxX;
    float minY;
    float maxY;
} constant;

// たった一つ存在するワールドオブジェクトの定義です
doclass World
{
    Boundaries m_dsBoundaries;
};

// World は既知オブジェクトとして定義します
// これはセッションマスタにより作成され、セッション開始前に
// 各ステーションにコピーされることが保障されます。
wellknown World g_hWorld;

