#include <OnlineCore/src/DDLTypes/CGCoreExports.h>
#include <NetZ/NetZ.h>
#include "AvatarDDL.h"
#include "Avatar.h"
BEGIN_NAMESPACE_NEX

_DOC_ImplementSomeGeneralMethods(Avatar)
_DO_InitAutoID(Avatar)
_PR_globaldo_derived_impl(Avatar,RootDO)

_DOC_Avatar::_DOC_Avatar(qUnsignedInt32 uiClassID):
	DOClassTemplate<DOCLASS(Avatar), _DOC_RootDO>(uiClassID) {
}

bool _DOC_Avatar::IsAKindOf(DOClassID idDOCID) {
	if(DOCLASSID(Avatar) == idDOCID) return true;
	return _DOC_RootDO::IsAKindOf(idDOCID);
}
void _DOC_Avatar::DataSetsOperation(qUnsignedInt32 uiOp) {
	_DOC_RootDO::DataSetsOperation(uiOp);
	_DOC_RegisterProtocol(1,_PR_basic_update_protocol_protodecl( _DSDECL_AvatarInfo ));
	_DOC_RegisterProtocol(2,_PR_basic_update_protocol_protodecl( _DSDECL_Position ));
	_DOC_RegisterProtocol(3,_PR_extrapolation_filter_protodecl( _DSDECL_ExtrapolatedPosition ));
	_DOC_RegisterProtocol(4,_PR_extrapolation_filter_protodecl( _DSDECL_ExtrapolatedLoopbackPosition ));
	_DSDECL_AvatarInfo::RegisterCounters(uiOp);
	_DSDECL_Position::RegisterCounters(uiOp);
	_DSDECL_ExtrapolatedPosition::RegisterCounters(uiOp);
	_DSDECL_ExtrapolatedLoopbackPosition::RegisterCounters(uiOp);
}
qBool _DOC_Avatar::FormatVariableValue(const DuplicatedObject *pDO, Variable *pDataset, Variable *pVariable, NAMESPACE_NEX String *pstrResult) const {
	_DOC_FormatMatchingVariableValue(Avatar,m_dsInfo);
	_DOC_FormatMatchingVariableValue(Avatar,m_dsPosition);
	_DOC_FormatMatchingVariableValue(Avatar,m_dsExtrapolatedPosition);
	_DOC_FormatMatchingVariableValue(Avatar,m_dsExtrapolatedLoopbackPosition);
	return _DOC_RootDO::FormatVariableValue(pDO, pDataset, pVariable, pstrResult);
}

bool _DOC_Avatar::DispatchAction(DuplicatedObject* pDO, MethodID idMethod, Message* pMsg) {
	return _DOC_RootDO::DispatchAction(pDO, idMethod, pMsg);
}

void _DOC_Avatar::DispatchRMCCall(const CallMethodOperation& refOp) {
	_DOC_RootDO::DispatchRMCCall(refOp);
}

bool _DOC_Avatar::DispatchRMCResult(RMCContext* pContext) {
	return _DOC_RootDO::DispatchRMCResult(pContext);
}


void _DOC_Avatar::FillDupSpacesInfo(DupSpace::Role eRole, DupSpace::ID* pArray, qUnsignedInt* puiIndex) {
	_DOC_RootDO::FillDupSpacesInfo(eRole, pArray, puiIndex);
}

const qChar * _DOC_Avatar::GetDatasetNameString(qByte byDatasetIndex) const { 

	switch (byDatasetIndex) {
		_DOC_DSGetDatasetName(AvatarInfo,1);
		_DOC_DSGetDatasetName(Position,2);
		_DOC_DSGetDatasetName(ExtrapolatedPosition,3);
		_DOC_DSGetDatasetName(ExtrapolatedLoopbackPosition,4);
	}
	return _DOC_RootDO::GetDatasetNameString(byDatasetIndex);
}



_DO_Avatar::_DO_Avatar()  {_DO_InitDO(Avatar);}

_DO_ImplementSomeGeneralMethods(Avatar)



void _DO_Avatar::RegisterDatasets() {
	_DO_RegisterDataset(m_dsInfo);
	_DO_RegisterDataset(m_dsPosition);
	_DO_RegisterDataset(m_dsExtrapolatedPosition);
	_DO_RegisterDataset(m_dsExtrapolatedLoopbackPosition);
}

void _DO_Avatar::SpecificAddDSToDiscoveryMessage(Message* pMsg, Station* pStation) {
	_DO_DSAddToDiscovery(m_dsInfo,pStation,1);
	_DO_DSAddToDiscovery(m_dsPosition,pStation,2);
	_DO_DSAddToDiscovery(m_dsExtrapolatedPosition,pStation,3);
	_DO_DSAddToDiscovery(m_dsExtrapolatedLoopbackPosition,pStation,4);
	RootDO::SpecificAddDSToDiscoveryMessage(pMsg, pStation);
}

void _DO_Avatar::SpecificExtractDSFromDiscoveryMessage(Message* pMsg) {
	_DO_DSExtractFromDiscovery(m_dsInfo,1);
	_DO_DSExtractFromDiscovery(m_dsPosition,2);
	_DO_DSExtractFromDiscovery(m_dsExtrapolatedPosition,3);
	_DO_DSExtractFromDiscovery(m_dsExtrapolatedLoopbackPosition,4);
	RootDO::SpecificExtractDSFromDiscoveryMessage(pMsg);
}

void _DO_Avatar::CallOperationOnDatasets(DOOperation* pOperation, Operation::Event eEvent) {
	if ( eEvent == Operation::Begin )
	{
		if ( pOperation->CallsBackOnDataSet(1) )
		{
			m_dsInfo.OperationBegin(pOperation);
			m_dsInfo.CallOperationOnVars(eEvent, pOperation);
		}
		if ( pOperation->CallsBackOnDataSet(2) )
		{
			m_dsPosition.OperationBegin(pOperation);
			m_dsPosition.CallOperationOnVars(eEvent, pOperation);
		}
		if ( pOperation->CallsBackOnDataSet(3) )
		{
			m_dsExtrapolatedPosition.OperationBegin(pOperation);
			m_dsExtrapolatedPosition.CallOperationOnVars(eEvent, pOperation);
		}
		if ( pOperation->CallsBackOnDataSet(4) )
		{
			m_dsExtrapolatedLoopbackPosition.OperationBegin(pOperation);
			m_dsExtrapolatedLoopbackPosition.CallOperationOnVars(eEvent, pOperation);
		}
	}
	else if ( eEvent == Operation::End )
	{
		if ( pOperation->CallsBackOnDataSet(1) )
		{
			m_dsInfo.OperationEnd(pOperation);
			m_dsInfo.CallOperationOnVars(eEvent, pOperation);
		}
		if ( pOperation->CallsBackOnDataSet(2) )
		{
			m_dsPosition.OperationEnd(pOperation);
			m_dsPosition.CallOperationOnVars(eEvent, pOperation);
		}
		if ( pOperation->CallsBackOnDataSet(3) )
		{
			m_dsExtrapolatedPosition.OperationEnd(pOperation);
			m_dsExtrapolatedPosition.CallOperationOnVars(eEvent, pOperation);
		}
		if ( pOperation->CallsBackOnDataSet(4) )
		{
			m_dsExtrapolatedLoopbackPosition.OperationEnd(pOperation);
			m_dsExtrapolatedLoopbackPosition.CallOperationOnVars(eEvent, pOperation);
		}
	}
	RootDO::CallOperationOnDatasets(pOperation,eEvent);
}

qResult _DO_Avatar::SpecificUpdate(DataSet *pDataset, const Time& tUpdateTime) {
	_DO_DatasetUpdate(m_dsInfo,1);
	_DO_DatasetUpdate(m_dsPosition,2);
	_DO_DatasetUpdate(m_dsExtrapolatedPosition,3);
	_DO_DatasetUpdate(m_dsExtrapolatedLoopbackPosition,4);
	return RootDO::SpecificUpdate(pDataset, tUpdateTime);
}

bool _DO_Avatar::SpecificRefresh(DataSet *pDataset, const Time& tRefreshTime) {
	_DO_DataSetRefresh(m_dsInfo);
	_DO_DataSetRefresh(m_dsPosition);
	_DO_DataSetRefresh(m_dsExtrapolatedPosition);
	_DO_DataSetRefresh(m_dsExtrapolatedLoopbackPosition);
	return RootDO::SpecificRefresh(pDataset, tRefreshTime);
}

bool _DO_Avatar::SpecificExtractADataset(Message* pMsg, qByte byDatasetIndex) { 

	switch (byDatasetIndex) {
		_DO_DSExtract(m_dsInfo,1);
		_DO_DSExtract(m_dsPosition,2);
		_DO_DSExtract(m_dsExtrapolatedPosition,3);
		_DO_DSExtract(m_dsExtrapolatedLoopbackPosition,4);
	}
	return RootDO::SpecificExtractADataset(pMsg, byDatasetIndex);
}

END_NAMESPACE_NEX
