﻿/*---------------------------------------------------------------------------*
  (C) Copyright 1998-2018, Technologies Quazal Inc.  All rights reserved.
  Quazal Net-Z, Quazal Rendez-Vous and Quazal are trademarks of Quazal.

  Copyright (C)2011-2018 Nintendo  All rights reserved.

  These coded instructions, statements, and computer programs contain
  proprietary information of Nintendo and/or its licensors and are
  protected by national and international copyright laws.
  They may not be disclosed to third parties or copied or duplicated
  in any form, in whole or in part, without the prior written consent
  of Nintendo.
  The content herein is highly confidential and should be handled
  accordingly.
 *---------------------------------------------------------------------------*/
//
//  推定フィルタ及びループバックによる位置を表現するクラス
//

#pragma once

#include <NetZ/NetZ.h>
#include "ExtrapolatedLoopbackPositionDDL.h"

/*!
    @brief 推定フィルタ & ループバック付き位置クラス。
 */
class ExtrapolatedLoopbackPosition: public NAMESPACE_NEX DATASET(ExtrapolatedLoopbackPosition)
{
public:
    ExtrapolatedLoopbackPosition()
    {
        x = 0;
        y = 0;
    }

    // 相対移動する
    void Move(qReal dx, qReal dy)
    {
        x += dx;
        y += dy;
    }

    // 絶対移動する
    void Set(qReal dx, qReal dy)
    {
        x = dx;
        y = dy;
    }
};

