#pragma once
#if defined(__ARMCC_VERSION) && (__ARMCC_VERSION >= 5000000)
#pragma push
#pragma diag_suppress 228,381,550,1300,1301,2530
#endif // defined(__ARMCC_VERSION) && (__ARMCC_VERSION >= 5000000)
#if defined(_MSC_VER)
#pragma warning( push )
#pragma warning( disable : 4458 )
#endif // defined(_MSC_VER)

#include <OnlineCore/src/DDLTypes/CGCoreExports.h>
#include <NetZ/NetZ.h>
#include <NetZ/NetZ.h>
#include <NetZ/src/Extensions/PHBDR/PHBDRExports.h>
#include "OnlineCore/src/DDLTypes/OnlineCoreTypes.h"
BEGIN_NAMESPACE_NEX
class OSDK_CLIENT DATASET(ExtrapolatedLoopbackPosition): public DataSet {
public:
	DDLTYPE(byte)::CPPType _mRevision;

/* ************** Begin the dataset definitions ************** */
	/* --- You can access these values directly. --- */

	//define float x
	DDLTYPE(float)::CPPType x;

	//define float y
	DDLTYPE(float)::CPPType y;

/* ************** End the dataset definitions ************** */

	qUnsignedInt32 GetRevision() { return _mRevision; }

	void InitVariables() {
		_mRevision=0;
	}

	_DS_GENERAL_DECLARATIONS(ExtrapolatedLoopbackPosition)
	DATASET(ExtrapolatedLoopbackPosition)( const DATASET(ExtrapolatedLoopbackPosition) &oOther ):DataSet() ,
		_mRevision(oOther._mRevision), 
		x(oOther.x), 
		y(oOther.y)
	{
	}

	_DS_ASSIGN_OPERATOR(ExtrapolatedLoopbackPosition){
		_DS_COPYDATASET_VAR(_mRevision);
		_DS_COPYDATASET_VAR(x);
		_DS_COPYDATASET_VAR(y);
	}

	_DS_EQUAL_OPERATOR(ExtrapolatedLoopbackPosition){
		_DS_EQUAL_VAR(_mRevision);
		_DS_EQUAL_VAR(x);
		_DS_EQUAL_VAR(y);
		return true;
	}

	_DS_TMPL_EQUAL_OPERATOR(ExtrapolatedLoopbackPosition)

	class OSDK_CLIENT Buffer: public PHBDRModel {
	public:
		_DS_DECLARE_EXTRAPOLATION_VAR(qFloat,x);
		_DS_DECLARE_EXTRAPOLATION_VAR(qFloat,y);
		void DelayedUpdateModel() {
			while (_DS_READY_TO_USE()) {
				_DS_DELAYED_UPDATE_TIME();
				_DS_DELAYED_UPDATE_VAR(x);
				_DS_DELAYED_UPDATE_VAR(y);
			}
		}

		void UpdateModel(Time tTime, DDLTYPE(float)::CPPType x, DDLTYPE(float)::CPPType y, qByte byRole, const ContinuityBreak& oContinuityBreak) {
			DelayedUpdateModel();
			_DS_UPDATE_TIME(tTime);
			_DS_UPDATE_VAR(x);
			_DS_UPDATE_VAR(y);
		}

		void ExtractFrom(Message* pMsg) {
			_DS_EXTRACT_TIMESTAMP();
			_DS_EXTRACT_BREAK();
			//define float x
			DDLTYPE(float)::CPPType x;

			//define float y
			DDLTYPE(float)::CPPType y;

			_MSG_EXTRACT_VARIABLE(T_mRevision, _mRevision);
			_MSG_EXTRACT_VARIABLE(Tx,x);
			_MSG_EXTRACT_VARIABLE(Ty,y);
			if(!pMsg->ErrorHasOccured()){
			UpdateModel(tTimeStamp, x, y, DUPLICA, oContinuityBreak);
			}
		}

		_DS_REFRESHVARS(ExtrapolatedLoopbackPosition) {
			DelayedUpdateModel();
			_DS_EXTRAPOLATE_VAR(x);
			_DS_EXTRAPOLATE_VAR(y);
			pDS->_mRevision=_mRevision;
			return true;
		}

		DDLTYPE(byte)::CPPType _mRevision;
	};
	void AddPredictedPoint(Time tTimestamp) {
		_DS_PREDICT_NEWPOINT_VAR(x);
		_DS_PREDICT_NEWPOINT_VAR(y);
	}


	void UpdateModel(Buffer* pBuffer, Time tTime, qBool bReliable) {
		pBuffer->UpdateModel(tTime, x, y, DUPLICATION_MASTER, m_oBreak.GetState());
		pBuffer->AddPointReliabilityData(bReliable);
	}


	qReal ComputeExtrapolationSquaredError(Buffer* pBuffer, const Time& tPredictionTime) {
		qReal dESE=0;
		_DS_ADDESE_VAR(x);
		_DS_ADDESE_VAR(y);
		return dESE;
	}

	_DS_DECLARE_LOOPBACK();
	_DS_DECLARE_EXTRAPOLATED();
	_PR_extrapolation_filter_pudecl()
	_PR_unreliable_pudecl()


	DATASET_VALID_REVISION_DEF(x, 0);
	qBool DATASET_ISVALID(x){ return true; /* The revision is 0. Always true */}
	DATASET_VALID_REVISION_DEF(y, 0);
	qBool DATASET_ISVALID(y){ return true; /* The revision is 0. Always true */}

protected:
	_PR_extrapolation_filter_prdecl()
	_PR_unreliable_prdecl()
private:
	typedef DDLTYPE(byte) T_mRevision;
	typedef DDLTYPE(float) Tx;
	typedef DDLTYPE(float) Ty;
};

#define _DSDECL_ExtrapolatedLoopbackPosition _PR_extrapolation_filter_dsdecl(ExtrapolatedLoopbackPosition)

END_NAMESPACE_NEX

#if defined(__ARMCC_VERSION) && (__ARMCC_VERSION >= 5000000)
#pragma pop
#endif // defined(__ARMCC_VERSION) && (__ARMCC_VERSION >= 5000000)
#if defined(_MSC_VER)
#pragma warning( pop )
#endif // defined(_MSC_VER)
