#include <OnlineCore/src/DDLTypes/CGCoreExports.h>
#include <NetZ/NetZ.h>
#include "WorldDDL.h"
#include "World.h"
BEGIN_NAMESPACE_NEX

_DOC_ImplementSomeGeneralMethods(World)
_DO_InitAutoID(World)
_PR_globaldo_derived_impl(World,RootDO)

_DOC_World::_DOC_World(qUnsignedInt32 uiClassID):
	DOClassTemplate<DOCLASS(World), _DOC_RootDO>(uiClassID) {
}

bool _DOC_World::IsAKindOf(DOClassID idDOCID) {
	if(DOCLASSID(World) == idDOCID) return true;
	return _DOC_RootDO::IsAKindOf(idDOCID);
}
void _DOC_World::DataSetsOperation(qUnsignedInt32 uiOp) {
	_DOC_RootDO::DataSetsOperation(uiOp);
	_DOC_RegisterProtocol(1,_PR_basic_update_protocol_protodecl( _DSDECL_Boundaries ));
	_DOC_RegisterFilter(1,_PR_constant_filterdecl( _DSDECL_Boundaries ));
	_DSDECL_Boundaries::RegisterCounters(uiOp);
}
qBool _DOC_World::FormatVariableValue(const DuplicatedObject *pDO, Variable *pDataset, Variable *pVariable, NAMESPACE_NEX String *pstrResult) const {
	_DOC_FormatMatchingVariableValue(World,m_dsBoundaries);
	return _DOC_RootDO::FormatVariableValue(pDO, pDataset, pVariable, pstrResult);
}

bool _DOC_World::DispatchAction(DuplicatedObject* pDO, MethodID idMethod, Message* pMsg) {
	return _DOC_RootDO::DispatchAction(pDO, idMethod, pMsg);
}

void _DOC_World::DispatchRMCCall(const CallMethodOperation& refOp) {
	_DOC_RootDO::DispatchRMCCall(refOp);
}

bool _DOC_World::DispatchRMCResult(RMCContext* pContext) {
	return _DOC_RootDO::DispatchRMCResult(pContext);
}


void _DOC_World::FillDupSpacesInfo(DupSpace::Role eRole, DupSpace::ID* pArray, qUnsignedInt* puiIndex) {
	_DOC_RootDO::FillDupSpacesInfo(eRole, pArray, puiIndex);
}

const qChar * _DOC_World::GetDatasetNameString(qByte byDatasetIndex) const { 

	switch (byDatasetIndex) {
		_DOC_DSGetDatasetName(Boundaries,1);
	}
	return _DOC_RootDO::GetDatasetNameString(byDatasetIndex);
}



_DO_World::_DO_World()  {_DO_InitDO(World);}

_DO_ImplementSomeGeneralMethods(World)



void _DO_World::RegisterDatasets() {
	_DO_RegisterDataset(m_dsBoundaries);
}

void _DO_World::SpecificAddDSToDiscoveryMessage(Message* pMsg, Station* pStation) {
	_DO_DSAddToDiscovery(m_dsBoundaries,pStation,1);
	RootDO::SpecificAddDSToDiscoveryMessage(pMsg, pStation);
}

void _DO_World::SpecificExtractDSFromDiscoveryMessage(Message* pMsg) {
	_DO_DSExtractFromDiscovery(m_dsBoundaries,1);
	RootDO::SpecificExtractDSFromDiscoveryMessage(pMsg);
}

void _DO_World::CallOperationOnDatasets(DOOperation* pOperation, Operation::Event eEvent) {
	if ( eEvent == Operation::Begin )
	{
		if ( pOperation->CallsBackOnDataSet(1) )
		{
			m_dsBoundaries.OperationBegin(pOperation);
			m_dsBoundaries.CallOperationOnVars(eEvent, pOperation);
		}
	}
	else if ( eEvent == Operation::End )
	{
		if ( pOperation->CallsBackOnDataSet(1) )
		{
			m_dsBoundaries.OperationEnd(pOperation);
			m_dsBoundaries.CallOperationOnVars(eEvent, pOperation);
		}
	}
	RootDO::CallOperationOnDatasets(pOperation,eEvent);
}

qResult _DO_World::SpecificUpdate(DataSet *pDataset, const Time& tUpdateTime) {
	_DO_DatasetUpdate(m_dsBoundaries,1);
	return RootDO::SpecificUpdate(pDataset, tUpdateTime);
}

bool _DO_World::SpecificRefresh(DataSet *pDataset, const Time& tRefreshTime) {
	_DO_DataSetRefresh(m_dsBoundaries);
	return RootDO::SpecificRefresh(pDataset, tRefreshTime);
}

bool _DO_World::SpecificExtractADataset(Message* pMsg, qByte byDatasetIndex) { 

	switch (byDatasetIndex) {
		_DO_DSExtract(m_dsBoundaries,1);
	}
	return RootDO::SpecificExtractADataset(pMsg, byDatasetIndex);
}

END_NAMESPACE_NEX
