﻿/*---------------------------------------------------------------------------*
  (C) Copyright 1998-2018, Technologies Quazal Inc.  All rights reserved.
  Quazal Net-Z, Quazal Rendez-Vous and Quazal are trademarks of Quazal.

  Copyright (C)2011-2018 Nintendo  All rights reserved.

  These coded instructions, statements, and computer programs contain
  proprietary information of Nintendo and/or its licensors and are
  protected by national and international copyright laws.
  They may not be disclosed to third parties or copied or duplicated
  in any form, in whole or in part, without the prior written consent
  of Nintendo.
  The content herein is highly confidential and should be handled
  accordingly.
 *---------------------------------------------------------------------------*/

#pragma once

#include "demo/Body/demo_Body.h"

namespace demo
{
/*!
@internal

@brief 円柱のクラスです。
*/

class Cylinder : public Body
{
public:
    /*!
    @brief    コンストラクタです。
    */
    Cylinder(void);

    /*!
    @brief    デストラクタです。
    */
    virtual ~Cylinder(void);

public:
    virtual void Initialize(void);
    void InitializeCylinder(const u32 vertexAttributes,
                            const f32 radius, const f32 height, const u32 division);

protected:
    f32 m_Radius;
    f32 m_Height;
    u32 m_Division;
};

}

