﻿/*---------------------------------------------------------------------------*
  (C) Copyright 1998-2018, Technologies Quazal Inc.  All rights reserved.
  Quazal Net-Z, Quazal Rendez-Vous and Quazal are trademarks of Quazal.

  Copyright (C)2011-2018 Nintendo  All rights reserved.

  These coded instructions, statements, and computer programs contain
  proprietary information of Nintendo and/or its licensors and are
  protected by national and international copyright laws.
  They may not be disclosed to third parties or copied or duplicated
  in any form, in whole or in part, without the prior written consent
  of Nintendo.
  The content herein is highly confidential and should be handled
  accordingly.
 *---------------------------------------------------------------------------*/

#pragma once

#include "demo/ShaderProgram/demo_ProgramObject.h"

namespace demo
{

/*!
@internal

@brief ポリゴンに対してテクスチャデカールを行うためのシェーダプログラムのクラスです。
*/

class DecalTextureProgram : public ProgramObject
{
public:
    /*!
    @internal

    @brief    コンストラクタです。
    */
    DecalTextureProgram(void);

    /*!
    @internal

    @brief    デストラクタです。
    */
    virtual ~DecalTextureProgram(void);

public:
    /*!
    @internal

    @brief    シェーダプログラムオブジェクトの初期処理を行います。
    */
    virtual bool Initialize(const GLuint shaderId);

    /*!
    @internal

    @brief    シェーダプログラムオブジェクトの終了処理を行います。
    */
    virtual bool Finalize(void);
public:
    /*!
    @internal

    @brief    シェーダプログラムオブジェクトを使用します。
    */
    virtual bool Use(void);

public:
    /*!
    @internal

    @brief    テクスチャオブジェクトのハンドルを設定します。

    @param[in]    textureId    テクスチャオブジェクトのハンドル
    */
    virtual void SetTextureId(const GLuint textureId);

    /*!
    @internal

    @brief    シェーダプログラムオブジェクトの内部状態を更新します。
    */
    virtual void Update(void);

protected:
    virtual void InitializeVertexAttributes(void);

protected:
    GLuint m_TextureId;
};

}

