﻿/*---------------------------------------------------------------------------*
  Copyright (C)2011-2018 Nintendo Co., Ltd.  All rights reserved.
 
  These coded instructions, statements, and computer programs contain
  proprietary information of Nintendo of America Inc. and/or Nintendo
  Company Ltd., and are protected by Federal copyright law.  They may
  not be disclosed to third parties or copied or duplicated in any form,
  in whole or in part, without the prior written consent of Nintendo.
 *---------------------------------------------------------------------------*/

#include <nn/fnd.h>

#include "DemoMem.h"

namespace nex_demo_util
{

namespace
{
nn::fnd::ThreadSafeExpHeap s_nexHeap;
}

void DemoMem::InnerInitialize(void* memBlock, size_t memSize)
{
    s_nexHeap.Initialize(reinterpret_cast<uptr>(memBlock), memSize);
}

void DemoMem::InnerFinalize()
{
    s_nexHeap.Finalize();
}

void DemoMem::InnerInvalidate()
{
    s_nexHeap.Invalidate();
}

void* DemoMem::InnerAlloc(size_t size)
{
    return s_nexHeap.Allocate(size, DemoMem::ALIGNMENT);
}

void DemoMem::InnerFree(void* p)
{
    s_nexHeap.Free(p);
}

void DemoMem::Dump()
{
    s_nexHeap.Dump();
}

size_t DemoMem::GetBlockSize(const void* p) const
{
    return s_nexHeap.GetSizeOf(p);
}

}   // end of namespace nex_demo_util
