﻿/*---------------------------------------------------------------------------*
  Copyright (C)2011-2018 Nintendo Co., Ltd.  All rights reserved.
 
  These coded instructions, statements, and computer programs contain
  proprietary information of Nintendo of America Inc. and/or Nintendo
  Company Ltd., and are protected by Federal copyright law.  They may
  not be disclosed to third parties or copied or duplicated in any form,
  in whole or in part, without the prior written consent of Nintendo.
 *---------------------------------------------------------------------------*/

#include <nn/hid.h>
#include "DemoPad.h"
#include "NexUtilDefs.h"

namespace nex_demo_util
{

namespace
{
nex_demo_util::PadStatus s_button;
}

// 初期化処理を行う
void DemoPad::Initialize()
{
    nn::hid::Initialize();
}

// 終了処理を行う
void DemoPad::Finalize()
{
    nn::hid::Finalize();
}

// ボタンの入力を更新する
void DemoPad::Update(PadStatus* pPadStatus)
{
    nn::hid::PadReader pad;
    nn::hid::PadStatus status;
    pad.ReadLatest(&status);

    s_button.hold = 0;
    if (status.hold & nn::hid::BUTTON_LEFT)     s_button.hold |= DEMO_PAD_BUTTON_LEFT;
    if (status.hold & nn::hid::BUTTON_RIGHT)    s_button.hold |= DEMO_PAD_BUTTON_RIGHT;
    if (status.hold & nn::hid::BUTTON_DOWN) s_button.hold |= DEMO_PAD_BUTTON_DOWN;
    if (status.hold & nn::hid::BUTTON_UP)   s_button.hold |= DEMO_PAD_BUTTON_UP;
    if (status.hold & nn::hid::BUTTON_A)        s_button.hold |= DEMO_PAD_BUTTON_A;
    if (status.hold & nn::hid::BUTTON_B)        s_button.hold |= DEMO_PAD_BUTTON_B;
    if (status.hold & nn::hid::BUTTON_X)        s_button.hold |= DEMO_PAD_BUTTON_X;
    if (status.hold & nn::hid::BUTTON_Y)        s_button.hold |= DEMO_PAD_BUTTON_Y;

    s_button.trigger = (s_button.hold ^ pPadStatus->hold) & s_button.hold;
    s_button.release = (s_button.hold ^ pPadStatus->hold) & pPadStatus->hold;

    memcpy(pPadStatus, &s_button, sizeof (nex_demo_util::PadStatus));
}

}   // end of namespace nex_demo_util
