﻿/*---------------------------------------------------------------------------*
  Copyright (C)2011-2018 Nintendo Co., Ltd.  All rights reserved.
 
  These coded instructions, statements, and computer programs contain
  proprietary information of Nintendo of America Inc. and/or Nintendo
  Company Ltd., and are protected by Federal copyright law.  They may
  not be disclosed to third parties or copied or duplicated in any form,
  in whole or in part, without the prior written consent of Nintendo.
 *---------------------------------------------------------------------------*/

#pragma once

#include <nex.h>

namespace nex_demo_util
{

/*!
   @brief インターネットへの接続を開始します。

   @return インターネットへの接続が成功したかどうか。
 */
qBool NetInit();

/*!
   @brief インターネット接続を終了します。
 */
void NetTerm();

/*!
   @brief ネットワークの接続性をチェックします。

   @return ネットワークにつながっているかどうか。
 */
qBool IsNetworkConnected();

/*!
   @brief HTTPライブラリを初期化します。
 */
qBool InitializeHttpLibrary();

/*!
   @brief HTTPライブラリを終了します。
 */
void FinalizeHttpLibrary();

}   // end of namespace nex_demo_util
