﻿/*---------------------------------------------------------------------------*
  Copyright (C)2011-2018 Nintendo Co., Ltd.  All rights reserved.

  These coded instructions, statements, and computer programs contain
  proprietary information of Nintendo of America Inc. and/or Nintendo
  Company Ltd., and are protected by Federal copyright law.  They may
  not be disclosed to third parties or copied or duplicated in any form,
  in whole or in part, without the prior written consent of Nintendo.
 *---------------------------------------------------------------------------*/

#pragma once

#include <nex.h>
#if defined(NEX_NNSDK_FAMILY)
#include <nn/nn_Log.h>
#elif defined(CTR_TARGET)
#include <nn.h>
#elif defined(CAFE_TARGET)
#include <cafe.h>
#endif

// 標準出力にログを出力します
#if defined(CTR_TARGET) || defined(NEX_NNSDK_FAMILY)
#define NEX_DEMO_LOG( ... ) do { \
    if (::nex_demo_util::IsEnableNexDemoLog()) { \
        NN_LOG(__VA_ARGS__); \
    } \
} while(0)
#elif defined(CAFE_TARGET)
#define NEX_DEMO_LOG( ... ) do { \
    if (::nex_demo_util::IsEnableNexDemoLog()) { \
        printf(__VA_ARGS__); \
    } \
} while(0)
#else
#define NEX_DEMO_LOG( ... ) do { \
    if (::nex_demo_util::IsEnableNexDemoLog()) { \
        std::printf(__VA_ARGS__); \
    } \
} while(0)
#endif

namespace nex_demo_util
{
/*!
    @brief NEX_DEMO_LOG でログを表示するかどうか設定します
    @param enableNexDemoLog 表示するかどうかのフラグ
*/
extern void SetEnableNexDemoLog(nn::nex::qBool enableNexDemoLog);

/*!
  @brief NEX_DEMO_LOG でログを表示するかどうかのフラグを取得します
  @return 表示するかどうかのフラグ
*/
extern nn::nex::qBool IsEnableNexDemoLog();

}   // end of namespace nex_demo_util
