﻿/*---------------------------------------------------------------------------*
  (C) Copyright 1998-2018, Technologies Quazal Inc.  All rights reserved.
  Quazal Net-Z, Quazal Rendez-Vous and Quazal are trademarks of Quazal.

  Copyright (C)2011-2018 Nintendo  All rights reserved.

  These coded instructions, statements, and computer programs contain
  proprietary information of Nintendo and/or its licensors and are
  protected by national and international copyright laws.
  They may not be disclosed to third parties or copied or duplicated
  in any form, in whole or in part, without the prior written consent
  of Nintendo.
  The content herein is highly confidential and should be handled
  accordingly.
 *---------------------------------------------------------------------------*/

#pragma once

#include <NetZ/src/Core/DOCore/ObjDupDecl.h>

// The filters are declared here.

#include <NetZ/src/Core/DOCore/DOCoreDSProperties.h>

// Then here are the other properties.

BEGIN_NAMESPACE_NEX

class Message;

//
// Default update protocol
//

#define _PR_basic_update_protocol_protodecl(DS) BasicUpdateProtocol< DS >()

//
// Extrapolation filter
//

//n1589:memo:現状これが使用される
// TODO: While we use the special inner loop, this is required.  Will
// eventually be removed.

#define _PR_extrapolation_filter_protodecl(DS)  LegacyUpdateProtocol< DS >()

//n1589:memo:現状これが使用される
// TODO: Should eventually be moved out to an extension.

#define _PR_extrapolation_filter_pudecl()   \
    _DS_DECLARE_MAXUPDATEDELAY()        \
    _DS_DECLARE_MINUPDATEDELAY()        \
    _DS_DECLARE_CONTINUITY_BREAKS()     \
    _DS_DECLARE_ERRORTOLERANCE()        \
    _DS_DECLARE_PHBDRPARAMETERS()

#define _PR_extrapolation_filter_prdecl()

#define _PR_extrapolation_filter_impl(DS)       \
    _DS_IMPLEMENT_MAXUPDATEDELAY(DS)            \
    _DS_IMPLEMENT_MINUPDATEDELAY(DS)            \
    _DS_IMPLEMENT_ERRORTOLERANCE(DS)            \
    _DS_IMPLEMENT_PHBDRPARAMETERS(DS)

#define _PR_extrapolation_filter_dsdecl(DS) EDataSetTemplate< DS >

// doclass properties

#define _PR_bootstrapdo_pudecl()    virtual qBool IsABootstrapDO() const {return true;}
#define _PR_bootstrapdo_prdecl()
#define _PR_bootstrapdo_impl(DOCLASS)
#define _PR_bootstrapdo_derived_impl(DOCLASS,PARENT)

#define _PR_coredo_pudecl() virtual qBool IsACoreDO() const {\
    NEX_STATIC_ASSERT(HAS_STATIC_ID); /*need set a classid in the coredo.*/ \
    return true; }

#define _PR_coredo_prdecl()
#define _PR_coredo_impl(DOCLASS)
#define _PR_coredo_derived_impl(DOCLASS,PARENT)

#define _PR_userdo_pudecl() virtual qBool IsACoreDO() const {return false;}
#define _PR_userdo_prdecl()
#define _PR_userdo_impl(DOCLASS)
#define _PR_userdo_derived_impl(DOCLASS,PARENT)

#define _PR_globaldo_pudecl()   virtual qBool HasGlobalDOProperty() const {return true;}
#define _PR_globaldo_prdecl()
#define _PR_globaldo_impl(DOCLASS)
#define _PR_globaldo_derived_impl(DOCLASS,PARENT)

#define _PR_nonglobal_pudecl()  virtual qBool HasForcedNonGlobalProperty() const {return true;}
#define _PR_nonglobal_prdecl()
#define _PR_nonglobal_impl(DOCLASS)
#define _PR_nonglobal_derived_impl(DOCLASS,PARENT)

END_NAMESPACE_NEX

