﻿/*---------------------------------------------------------------------------*
  (C) Copyright 1998-2018, Technologies Quazal Inc.  All rights reserved.
  Quazal Net-Z, Quazal Rendez-Vous and Quazal are trademarks of Quazal.

  Copyright (C)2011-2018 Nintendo  All rights reserved.

  These coded instructions, statements, and computer programs contain
  proprietary information of Nintendo and/or its licensors and are
  protected by national and international copyright laws.
  They may not be disclosed to third parties or copied or duplicated
  in any form, in whole or in part, without the prior written consent
  of Nintendo.
  The content herein is highly confidential and should be handled
  accordingly.
 *---------------------------------------------------------------------------*/

#pragma once

#include <NetZ/src/Core/DOCore/ObjDupDecl.h>
#include <NetZ/src/Core/DOCore/DOHandle.h>
#include <OnlineCore/src/Platform/Core/RefCountedObject.h>

BEGIN_NAMESPACE_NEX

class DuplicatedObject;

// TODO: DOFilters can be optimized, by specifying a range of DOHandle
// than can pass - e.g. based on min and max ClassID.  This would speed
// up iteration.

/*

summary:
DOFilter is the class that filters...

*/
class DOFilter: public RefCountedObject
{
public:
    DOFilter();
    virtual ~DOFilter();

    virtual qBool Filter(DuplicatedObject* pDO)=0;
    virtual qBool Filter(DOHandle hDO)=0;

    // In some cases the minimum or maximum values can be known,
    // and used to speed up iterators.
    virtual DOHandle GetMinimumValidHandle();
    virtual DOHandle GetMaximumValidHandle();

    qBool HandleIsWithinRange(DOHandle hHandle);

protected:
};

END_NAMESPACE_NEX

