﻿/*---------------------------------------------------------------------------*
  (C) Copyright 1998-2018, Technologies Quazal Inc.  All rights reserved.
  Quazal Net-Z, Quazal Rendez-Vous and Quazal are trademarks of Quazal.

  Copyright (C)2011-2018 Nintendo  All rights reserved.

  These coded instructions, statements, and computer programs contain
  proprietary information of Nintendo and/or its licensors and are
  protected by national and international copyright laws.
  They may not be disclosed to third parties or copied or duplicated
  in any form, in whole or in part, without the prior written consent
  of Nintendo.
  The content herein is highly confidential and should be handled
  accordingly.
 *---------------------------------------------------------------------------*/

#pragma once

#include <NetZ/src/Core/DOCore/ObjDupDecl.h>
#include <NetZ/src/Core/DOCore/DOHandle.h>

BEGIN_NAMESPACE_NEX

class DistanceComputationCache: public RootObject
{
public:
    DistanceComputationCache();
    virtual ~DistanceComputationCache();

    qReal ComputeDistance(DOHandle hA, DOHandle hB);

private:

    void RecomputeDistanceIfRequired(DOHandle hA, DOHandle hB);
    qReal RecomputeDistance(DOHandle hA, DOHandle hB);

private:
    // Previous computation result.
    qReal m_dDistance;
    DOHandle m_hA;
    DOHandle m_hB;
    Time m_tUpdateTime;

    static Time s_tMaximumUpdateDelay;
};

END_NAMESPACE_NEX


