﻿/*---------------------------------------------------------------------------*
  (C) Copyright 1998-2018, Technologies Quazal Inc.  All rights reserved.
  Quazal Net-Z, Quazal Rendez-Vous and Quazal are trademarks of Quazal.

  Copyright (C)2011-2018 Nintendo  All rights reserved.

  These coded instructions, statements, and computer programs contain
  proprietary information of Nintendo and/or its licensors and are
  protected by national and international copyright laws.
  They may not be disclosed to third parties or copied or duplicated
  in any form, in whole or in part, without the prior written consent
  of Nintendo.
  The content herein is highly confidential and should be handled
  accordingly.
 *---------------------------------------------------------------------------*/

#pragma once

BEGIN_NAMESPACE_NEX

#define UNASSIGNED_METHODID 0

// Group = Miscellaneous Types and Macros

/*
Description: A unique identifier for a given DDL-defined method.
Remarks: Each method (Actions, RMC) defined in the DDL is assigned by $PRODUCTNAME$ a unique MethodID. MethodIDs are
generated via the MethodIDGenerator class.
See Also: MethodIDGenerator
*/

/*!
 * @brief   DDLに定義されているメソッドの一意な識別子です。
 *
 * DDL(データ定義言語)に定義されているそれぞれのメソッド(アクションかRMC：リモートメソッドコール)には、
 * 一意な識別しであるMethodIDが割り当てられます。この、MethodIDは、
 * @ref MethodIDGenerator によって生成されます。
 *
 * @see     MethodIDGenerator
 */
typedef qUnsignedInt16 MethodID;

END_NAMESPACE_NEX

