﻿/*---------------------------------------------------------------------------*
  (C) Copyright 1998-2018, Technologies Quazal Inc.  All rights reserved.
  Quazal Net-Z, Quazal Rendez-Vous and Quazal are trademarks of Quazal.

  Copyright (C)2011-2018 Nintendo  All rights reserved.

  These coded instructions, statements, and computer programs contain
  proprietary information of Nintendo and/or its licensors and are
  protected by national and international copyright laws.
  They may not be disclosed to third parties or copied or duplicated
  in any form, in whole or in part, without the prior written consent
  of Nintendo.
  The content herein is highly confidential and should be handled
  accordingly.
 *---------------------------------------------------------------------------*/

// This file must have the name of the DOClass that it implements, RootDO

#pragma once

#include <NetZ/src/Core/DOCore/ObjDupDecl.h>
#include <NetZ/src/Core/DOCore/RootDODDL.h>

BEGIN_NAMESPACE_NEX

class RootDO: public DOCLASS(RootDO)
{
public:
    RootDO();
    virtual ~RootDO();

    qBool AddDuplicaLocation(DOHandle hOperationOrigin, DOHandle hStation,
                             qBool bForceRedundantAdd,
                             DOHandle hAvailableRouting=INVALID_DOHANDLE);

    void DeleteDuplica(DOHandle hLocation);

    // This method is called on a duplica as a result of a
    // relevance check.
    void DeleteLocalDuplica();
};

END_NAMESPACE_NEX

