﻿/*---------------------------------------------------------------------------*
  (C) Copyright 1998-2018, Technologies Quazal Inc.  All rights reserved.
  Quazal Net-Z, Quazal Rendez-Vous and Quazal are trademarks of Quazal.

  Copyright (C)2011-2018 Nintendo  All rights reserved.

  These coded instructions, statements, and computer programs contain
  proprietary information of Nintendo and/or its licensors and are
  protected by national and international copyright laws.
  They may not be disclosed to third parties or copied or duplicated
  in any form, in whole or in part, without the prior written consent
  of Nintendo.
  The content herein is highly confidential and should be handled
  accordingly.
 *---------------------------------------------------------------------------*/

// This file must have the name of the Dataset that it implements, SessionInfo.h

#pragma once

#include <NetZ/src/Core/DOCore/ObjDupDecl.h>
#include <NetZ/src/Core/DOCore/DataSet.h>
#include <NetZ/src/Core/DOCore/SessionInfoDDL.h>

BEGIN_NAMESPACE_NEX

class SessionInfo: public DATASET(SessionInfo)
{
public:
    SessionInfo();
    virtual ~SessionInfo();

    void SetRootMulticastGroup(DOHandle dohGroup);
    DOHandle GetRootMulticastGroup();

    void SetSessionName(const qChar *szSessionName);
    const qChar *GetSessionName();

    void GenerateSessionID();
    void SetSessionID(qUnsignedInt32 uiSessionID);
    qUnsignedInt32 GetSessionID();
};

END_NAMESPACE_NEX

