﻿/*---------------------------------------------------------------------------*
  (C) Copyright 1998-2018, Technologies Quazal Inc.  All rights reserved.
  Quazal Net-Z, Quazal Rendez-Vous and Quazal are trademarks of Quazal.

  Copyright (C)2011-2018 Nintendo  All rights reserved.

  These coded instructions, statements, and computer programs contain
  proprietary information of Nintendo and/or its licensors and are
  protected by national and international copyright laws.
  They may not be disclosed to third parties or copied or duplicated
  in any form, in whole or in part, without the prior written consent
  of Nintendo.
  The content herein is highly confidential and should be handled
  accordingly.
 *---------------------------------------------------------------------------*/

#pragma once

#include <NetZ/src/Core/DOCore/ObjDupDecl.h>
#include <OnlineCore/src/Core/Operation.h>
#include <NetZ/src/Core/DOCore/Station.h>

BEGIN_NAMESPACE_NEX

//Group = System Operations

/*
Description: Encapsulates Session object operations.
Remarks: A SessionOperation may be either a JoinSessionOperation or a LeaveSessionOperation.
See Also: JoinSessionOperation, LeaveSessionOperation
*/

/*!
 * @brief   セッションに対する操作をカプセル化します。
 *
 * この操作は、@ref JoinSessionOperation の基底クラスです。
 */
class SessionOperation: public Operation
{
    //Group=Methods
public:
    //{secret}
    SessionOperation(DOHandle hOrigin);
    //{secret}
    virtual ~SessionOperation();

    // {secret}
    void Begin();
    // {secret}
    void End();
};

END_NAMESPACE_NEX

