﻿/*---------------------------------------------------------------------------*
  (C) Copyright 1998-2018, Technologies Quazal Inc.  All rights reserved.
  Quazal Net-Z, Quazal Rendez-Vous and Quazal are trademarks of Quazal.

  Copyright (C)2011-2018 Nintendo  All rights reserved.

  These coded instructions, statements, and computer programs contain
  proprietary information of Nintendo and/or its licensors and are
  protected by national and international copyright laws.
  They may not be disclosed to third parties or copied or duplicated
  in any form, in whole or in part, without the prior written consent
  of Nintendo.
  The content herein is highly confidential and should be handled
  accordingly.
 *---------------------------------------------------------------------------*/

#pragma once

#include <NetZ/src/Core/DOCore/ObjDupDecl.h>
#include <OnlineCore/src/Core/Operation.h>

BEGIN_NAMESPACE_NEX

class DuplicationSpace;


//group=DDL Output

/*
Description: Encapsulates operations performed on DuplicationSpace
instances.
Remarks: The only type of DuplicationSpace operation is the Match operation.
See Also: MatchOperation
*/
class DupSpaceOperation: public Operation
{
    //Group=Methods
public:
    //{secret}
    DupSpaceOperation(DuplicationSpace* pDupSpace);
    //{secret}
    virtual ~DupSpaceOperation();

    /*
    Description: Returns a pointer to the DuplicationSpace instance that is associated with
    this operation.
    Returns: A DuplicationSpace pointer to the duplication space instance associated with the operation.
    See Also: MatchOperation
    */
    DuplicationSpace* GetAssociatedDupSpace()
    {
        return m_pDupSpace;
    }

protected:
    //{secret}
    void OperationBegin();
    //{secret}
    void OperationEnd();

protected:
    DuplicationSpace* m_pDupSpace;
private:
#ifdef NEX_DEBUG_VERSION
    qBool m_bOpBeginCalled;
    qBool m_bOpEndCalled;
#endif
};

END_NAMESPACE_NEX

