﻿/*---------------------------------------------------------------------------*
  (C) Copyright 1998-2018, Technologies Quazal Inc.  All rights reserved.
  Quazal Net-Z, Quazal Rendez-Vous and Quazal are trademarks of Quazal.

  Copyright (C)2011-2018 Nintendo  All rights reserved.

  These coded instructions, statements, and computer programs contain
  proprietary information of Nintendo and/or its licensors and are
  protected by national and international copyright laws.
  They may not be disclosed to third parties or copied or duplicated
  in any form, in whole or in part, without the prior written consent
  of Nintendo.
  The content herein is highly confidential and should be handled
  accordingly.
 *---------------------------------------------------------------------------*/

#pragma once
#if NEX_ENABLE_USE_PRODUCT_KEY


#include <NetZ/src/Core/Facade/FacadesDecl.h>
#include <NetZ/src/ProductInfo/ProductInfo.h>

BEGIN_NAMESPACE_NEX

class ProductSpecifics: public RootObject
{
public:
    ProductSpecifics();
    virtual ~ProductSpecifics();

#ifdef NEX_CLIENT_OPTIMIZATION
    ProductInfo * GetProductInfo()
#else
    ProductInfo * const GetProductInfo()
#endif
    {
        return ProductInfo::FindInstance(GetProductID());
    }
    virtual qUnsignedInt32 GetProductID()=0;
    virtual void RegisterSpecificDDLs() {};
    virtual void RegisterSpecificComponents() {};
};

END_NAMESPACE_NEX


#endif
