﻿/*---------------------------------------------------------------------------*
  (C) Copyright 1998-2018, Technologies Quazal Inc.  All rights reserved.
  Quazal Net-Z, Quazal Rendez-Vous and Quazal are trademarks of Quazal.

  Copyright (C)2011-2018 Nintendo  All rights reserved.

  These coded instructions, statements, and computer programs contain
  proprietary information of Nintendo and/or its licensors and are
  protected by national and international copyright laws.
  They may not be disclosed to third parties or copied or duplicated
  in any form, in whole or in part, without the prior written consent
  of Nintendo.
  The content herein is highly confidential and should be handled
  accordingly.
 *---------------------------------------------------------------------------*/

#pragma once

#include <NetZ/src/Core/DOCore/ObjDupDecl.h>

BEGIN_NAMESPACE_NEX

#define _DOC_DeclareAdapterMethods()    \
    virtual Adapter* CreateAdapter(DuplicatedObject* pDO, qUnsignedInt uiIndex); \
    virtual void DeleteAdapter(DuplicatedObject* pDO, qUnsignedInt uiIndex, Adapter* pAdapterToDelete);


#define _DO_DeclareAdapter(TYPE, NAME)                  TYPE *m_pad##NAME;

#define _DO_DeclareAdapterMethods(TYPE, NAME)           \
    TYPE* Get##NAME() {return m_pad##NAME;}         \
    void Attach##NAME(TYPE* padAdapter);

#define _DO_DeclareGeneralAdapterMethods()                      \
    void CallOperationEndOnAdapters(DOOperation* pOperation);

#define _DO_InitAdapter(NAME)   m_pad##NAME=NULL;

#define _DO_ImplementAdapter(CLASS, TYPE, NAME)                             \
    void _DO_##CLASS::Attach##NAME(TYPE* padAdapter) {if (m_pad##NAME!=NULL) {((CLASS*)this)->Delete##NAME(m_pad##NAME);} m_pad##NAME=padAdapter; m_pad##NAME->AttachAssociatedDO(this);}

#define _DO_DispatchAdapterOperation(NAME,INDEX) {AdapterEventDispatcher::GetInstance()->DispatchDOOperation(pOperation, (Adapter**)&m_pad##NAME, INDEX);}

#define _DOC_CreateAdapter(CLASS, NAME, INDEX) if (uiIndex==INDEX) {return ((CLASS*)pDO)->Create##NAME();}
#define _DOC_DeleteAdapter(CLASS, ADAPTERTYPE, NAME, INDEX) if (uiIndex==INDEX) {((CLASS*)pDO)->Delete##NAME((ADAPTERTYPE*)pAdapterToDelete);}

END_NAMESPACE_NEX

