﻿/*---------------------------------------------------------------------------*
  (C) Copyright 1998-2018, Technologies Quazal Inc.  All rights reserved.
  Quazal Net-Z, Quazal Rendez-Vous and Quazal are trademarks of Quazal.

  Copyright (C)2011-2018 Nintendo  All rights reserved.

  These coded instructions, statements, and computer programs contain
  proprietary information of Nintendo and/or its licensors and are
  protected by national and international copyright laws.
  They may not be disclosed to third parties or copied or duplicated
  in any form, in whole or in part, without the prior written consent
  of Nintendo.
  The content herein is highly confidential and should be handled
  accordingly.
 *---------------------------------------------------------------------------*/

#pragma once

#ifdef NEX_WINDOWS_MFC_SUPPORT

/////////////////////////////////////////////////////////////////////////////
// SessionEnumeratorDialog dialog

class SessionEnumeratorDialog : public CDialog
{
    // Construction
public:
    typedef void (*CreateCallbackFuncPtr)();

    SessionEnumeratorDialog( CreateCallbackFuncPtr pfCreateCallback, bool boAllowSessionCreation, CWnd* pParent = NULL, qBool bFilterOnTitle=true);   // standard constructor

    bool m_boCreateSessionAllowed;
    bool m_bPortConfigurationAllowed;
    qUnsignedInt m_uiPortNumber;

    // Dialog Data
    //{{AFX_DATA(SessionEnumeratorDialog)
    enum { IDD = IDD_SESSION_DIALOG };
    CString     m_strRemoteIP;
    CButton     m_btnCreateSession;
    CListCtrl   m_lstSessions;
    CString     m_strSessionName;

    //}}AFX_DATA

private:
    CreateCallbackFuncPtr m_pfCreateCallback;
    qBool m_bFilterOnTitle;

    void UpdateSessionList();

    qList<SessionDescription> m_lstSessionDescriptions;

    // Overrides
    // ClassWizard generated virtual function overrides
    //{{AFX_VIRTUAL(SessionEnumeratorDialog)
protected:
    virtual void DoDataExchange(CDataExchange* pDX);    // DDX/DDV support
    //}}AFX_VIRTUAL

    // Implementation
protected:

    // Generated message map functions
    //{{AFX_MSG(SessionEnumeratorDialog)
    afx_msg void OnCreateSession();
    virtual BOOL OnInitDialog();
    afx_msg void OnRefreshSessions();
    afx_msg void OnJoinLocalSession();
    afx_msg void OnJoinRemoteSession();
    //}}AFX_MSG
    DECLARE_MESSAGE_MAP()
};

//{{AFX_INSERT_LOCATION}}
// Microsoft Visual C++ will insert additional declarations immediately before the previous line.

#endif

