﻿/*---------------------------------------------------------------------------*
  (C) Copyright 1998-2018, Technologies Quazal Inc.  All rights reserved.
  Quazal Net-Z, Quazal Rendez-Vous and Quazal are trademarks of Quazal.

  Copyright (C)2011-2018 Nintendo  All rights reserved.

  These coded instructions, statements, and computer programs contain
  proprietary information of Nintendo and/or its licensors and are
  protected by national and international copyright laws.
  They may not be disclosed to third parties or copied or duplicated
  in any form, in whole or in part, without the prior written consent
  of Nintendo.
  The content herein is highly confidential and should be handled
  accordingly.
 *---------------------------------------------------------------------------*/

#pragma once

BEGIN_NAMESPACE_NEX

namespace InetPorts
{
enum
{
    Dynamic             = 0,
    SandBoxMgmt         = 9101,
    Clustering          = 9104
};
}

namespace StreamID
{
enum
{
    Dynamic             = 0,    // TransportStreamManager::RegisterStream()のidDesiredStreamにDynamicを指定すると自動的にDynamicBegin以降のIDを使いVPortを割り当てる。
                                // 0番自体は実際には使用されない。
                                // 自動で割り振った場合は事前に通信相手のVPortを知る必要がある。自分からConnectする場合はDyanmicで良い。
    DynamicBegin        = 1,    // Dynamicの場合はこのID以降に降順で割り当てる
    WellKnown           = 1,    // 事前に共有済みの汎用ID
    RvAuth              = 1,    // Authノードへの接続に利用するID
    RvSecure            = 2     // Serviceノードへの接続に利用するID
};
}


END_NAMESPACE_NEX

