﻿/*---------------------------------------------------------------------------*
  (C) Copyright 1998-2018, Technologies Quazal Inc.  All rights reserved.
  Quazal Net-Z, Quazal Rendez-Vous and Quazal are trademarks of Quazal.

  Copyright (C)2011-2018 Nintendo  All rights reserved.

  These coded instructions, statements, and computer programs contain
  proprietary information of Nintendo and/or its licensors and are
  protected by national and international copyright laws.
  They may not be disclosed to third parties or copied or duplicated
  in any form, in whole or in part, without the prior written consent
  of Nintendo.
  The content herein is highly confidential and should be handled
  accordingly.
 *---------------------------------------------------------------------------*/

//NetZ/src/DDLTypes/ClassCGMacros.hにも存在

#pragma once

#define DDLCLASS(C) _DDL_##C


/*! @brief classの値が、データが生成されたDDLのリビジョン番号で有効な値か判定するマクロです。
 * @param[in] VAR 取得する値の名前を指定します。
 * @return true 生成されたリビジョン番号で有効な値です。 false 生成されたリビジョン番号で無効な値です。
 */
#define NEX_CLASS_ISVALID(VAR) _class_isValid_ ## VAR()

/*! @brief classの値が、どのDDLのリビジョン番号で有効か取得するマクロです。
 * @param[in] VAR 取得する値の名前を指定します。
 * @return 有効なリビジョン番号です。
 */
#define NEX_CLASS_VALID_REVISION(VAR) _class_validRevision_ ## VAR

#define NEX_CLASS_VALID_REVISION_DEF(VAR, VAL) static const qByte _class_validRevision_ ## VAR = VAL

