﻿/*---------------------------------------------------------------------------*
  (C) Copyright 1998-2018, Technologies Quazal Inc.  All rights reserved.
  Quazal Net-Z, Quazal Rendez-Vous and Quazal are trademarks of Quazal.

  Copyright (C)2011-2018 Nintendo  All rights reserved.

  These coded instructions, statements, and computer programs contain
  proprietary information of Nintendo and/or its licensors and are
  protected by national and international copyright laws.
  They may not be disclosed to third parties or copied or duplicated
  in any form, in whole or in part, without the prior written consent
  of Nintendo.
  The content herein is highly confidential and should be handled
  accordingly.
 *---------------------------------------------------------------------------*/

#pragma once

#include <OnlineCore/src/Platform/Core/PlatformDecl.h>

BEGIN_NAMESPACE_NEX

//==============================================================================
// DDL variable types abstract base class: Any variable in the DDL context
// inherits from this class (See DOCoreTypes.h).
//==============================================================================
class OSDK_API DDLType : public RootObject
{
public:
    static qBool FormatVariableValue(const void* pVariable, String *pstrResult)
    {
        DUMMY_PARAM(pVariable);
        DUMMY_PARAM(pstrResult);
        return false;
    }

    static qBool OperationBegin(void* pVariable, void* pDOOperation)
    {
        DUMMY_PARAM(pVariable);
        DUMMY_PARAM(pDOOperation);
        return true;
    }

    static qBool OperationEnd(void* pVariable, void* pDOOperation)
    {
        DUMMY_PARAM(pVariable);
        DUMMY_PARAM(pDOOperation);
        return true;
    }
};

END_NAMESPACE_NEX

