﻿/*---------------------------------------------------------------------------*
  (C) Copyright 1998-2018, Technologies Quazal Inc.  All rights reserved.
  Quazal Net-Z, Quazal Rendez-Vous and Quazal are trademarks of Quazal.

  Copyright (C)2011-2018 Nintendo  All rights reserved.

  These coded instructions, statements, and computer programs contain
  proprietary information of Nintendo and/or its licensors and are
  protected by national and international copyright laws.
  They may not be disclosed to third parties or copied or duplicated
  in any form, in whole or in part, without the prior written consent
  of Nintendo.
  The content herein is highly confidential and should be handled
  accordingly.
 *---------------------------------------------------------------------------*/

#pragma once

#define _DO_DeclareRMCStub(RMC,ARGS)                        \
    qBool Call##RMC ARGS;                                   \
    void RMC##Wrapper(const CallMethodOperation& refOp);    \
    static void RMC##ReturnStub(RMCContext* pContext);

#define _DO_InitStub(CLASS, ACTION) \
    MethodID id; id =_METHODID(CLASS, ACTION); Message* pMsg; pMsg = CreateStubMessage(&id);

#define _DO_RMC_InitCall(CLASS, RMC)                                                            \
    if (!pContext->PrepareCallMessage(GetHandle(), _METHODID(CLASS, RMC))) {return false;}      \
    Message* pMsg; pMsg = pContext->GetCallMessage();  \
    DUMMY_PARAM(pMsg);

#define _DO_RMC_CompleteCall() return pContext->PerformCallAndWait();

#define _DO_RMC_ExtractArg(ARG) (*pMsg) >> ARG;
#define _DO_RMC_ExtractArgArray(ARG,SIZE) {qInt i; for (i=0; i<SIZE; i++) {(*pMsg)>>ARG[i];}}
#define _DO_RMC_ExtractStringArg(ARG,MAXSIZE)   pMsg->ExtractString(ARG,MAXSIZE);

#define _DO_RMC_InitReturnStub()    Message* pMsg; pMsg=pContext->GetResponseMessage();  qInt iArgIndex; iArgIndex=0; DUMMY_PARAM(iArgIndex);
#define _DO_RMC_DummyParam()    DUMMY_PARAM(pMsg); DUMMY_PARAM(iArgIndex);
#define _DO_RMC_ExtractReturnValue(METATYPE,SIZE)   \
    {                                                   \
        METATYPE::CPPType* pReturnLocation=(METATYPE::CPPType*)pContext->GetReturnValuePtr(iArgIndex++);    \
        if (pReturnLocation!=NULL) {                                        \
            _MSG_EXTRACT_VARIABLE_ARRAY(METATYPE, pReturnLocation, SIZE);   \
        } else {                                                    \
            METATYPE::CPPType oDummyVar[SIZE];                      \
            _MSG_EXTRACT_VARIABLE_ARRAY(METATYPE, oDummyVar, SIZE); \
        }                                                           \
    }

#define _DO_RMC_ExtractStringReturn(MAXSIZE)    pMsg->ExtractString((qChar*)pContext->GetReturnValuePtr(iArgIndex++),MAXSIZE);

#define _DO_RMC_AddArg(ARG) (*pMsg) << ARG;
#define _DO_RMC_AddArgArray(ARG,SIZE) {qInt i; for (i=0; i<SIZE; i++) {(*pMsg)<<ARG[i];}}
#define _DO_RMC_AddStringArg(ARG,SIZE)  if( !pMsg->AppendString(ARG,SIZE) ){ pContext->SetOutcome(QRESULT_ERROR(Core,InvalidArgument)); }

#define _DO_RMC_AddReturnValue(ARG) if (pContext!=NULL) {pContext->AddReturnValuePtr(ARG);}

// {secret}
#define _DO_RMC_InitWrapper() const CallMethodOperation* pContext; pContext = &refOp; DUMMY_PARAM(pContext); Message* pMsg=refOp.GetCallMessage(); DUMMY_PARAM(pMsg);
#define _DO_RMC_PrepareReturn() pMsg=refOp.PrepareSuccessMessage();
#define _DO_RMC_CompleteWrapper()

// Special extract, for strings.
//{secret}
#define _DO_ExtractStrArg(ARG,SIZE) pMsg->ExtractString(ARG,SIZE);
// Special extracts, for containers.
//{secret}
#define _DO_ExtractObjArg(ARG)  ARG.ExtractFrom(pMsg);
#define _DO_ExtractObjArrayArg(ARG,SIZE)    {qInt i; for (i=0; i<SIZE; i++) {_DO_ExtractObjArg(ARG[i]);}}

// Special add, for strings.
//{secret}
#define _DO_StrArg(ARG,SIZE) if(!pMsg->AppendString(ARG,SIZE)){}
// Special adds, for containers.
//{secret}
#define _DO_ObjArg(ARG) ARG.AddSourceTo(pMsg);
#define _DO_ObjArrayArg(ARG,SIZE)   {qInt i; for (i=0; i<SIZE; i++) {_DO_ObjArg(ARG[i]);}}

#define _DO_CompleteStub(D) return SendStubMessage(D, pMsg);


