﻿/*---------------------------------------------------------------------------*
  (C) Copyright 1998-2018, Technologies Quazal Inc.  All rights reserved.
  Quazal Net-Z, Quazal Rendez-Vous and Quazal are trademarks of Quazal.

  Copyright (C)2011-2018 Nintendo  All rights reserved.

  These coded instructions, statements, and computer programs contain
  proprietary information of Nintendo and/or its licensors and are
  protected by national and international copyright laws.
  They may not be disclosed to third parties or copied or duplicated
  in any form, in whole or in part, without the prior written consent
  of Nintendo.
  The content herein is highly confidential and should be handled
  accordingly.
 *---------------------------------------------------------------------------*/

#pragma once

#include <OnlineCore/src/Platform/Core/PlatformDecl.h>
#include <OnlineCore/src/ParseTree/Declaration.h>
#include <OnlineCore/src/ParseTree/NameSpaceRef.h>

BEGIN_NAMESPACE_NEX

class OSDK_API DDLUnitDeclaration: public Declaration
{
public:
    DDLUnitDeclaration(const String& strName);
    virtual ~DDLUnitDeclaration();

    DECLARE_NAMESPACE_ITEM(DDLUnitDeclaration, Declaration);

#ifdef NEX_TRACE_ENABLED
    virtual void Trace(qUnsignedInt64 uiTraceFlag) const;
#endif

    qResult StreamIn(BinaryRepresentation *pStream) const;
    qResult StreamOut(BinaryRepresentation *pStream);

    virtual qBool IsEqual(const ParseTreeItem* pOther) const;

    virtual qBool ResolveReferences();

    const String& GetUnitName() const
    {
        return m_strUnitName;
    }
    const String& GetUnitDir() const
    {
        return m_strUnitDir;
    }

    void SetUnitData(const String& strUnitName, const String& strUnitDir);

private:
    String m_strUnitName;
    String m_strUnitDir;
};

END_NAMESPACE_NEX

