﻿/*---------------------------------------------------------------------------*
  (C) Copyright 1998-2018, Technologies Quazal Inc.  All rights reserved.
  Quazal Net-Z, Quazal Rendez-Vous and Quazal are trademarks of Quazal.

  Copyright (C)2011-2018 Nintendo  All rights reserved.

  These coded instructions, statements, and computer programs contain
  proprietary information of Nintendo and/or its licensors and are
  protected by national and international copyright laws.
  They may not be disclosed to third parties or copied or duplicated
  in any form, in whole or in part, without the prior written consent
  of Nintendo.
  The content herein is highly confidential and should be handled
  accordingly.
 *---------------------------------------------------------------------------*/

#pragma once

#include <OnlineCore/src/Platform/Core/PlatformDecl.h>
#include <OnlineCore/src/ParseTree/ParseTreeItem.h>

BEGIN_NAMESPACE_NEX

class BinaryRepresentation;
class NameSpace;

#define DECLARE_NAMESPACE_ITEM(CLASS, PARENTCLASS) DECLARE_PARSETREE_ITEM(CLASS, PARENTCLASS)

class OSDK_API NameSpaceItem: public ParseTreeItem
{
public:
    NameSpaceItem(const String& strName);
    virtual ~NameSpaceItem();

    DECLARE_PARSETREE_ITEM(NameSpaceItem, ParseTreeItem);

    virtual void SetNameSpace(NameSpace *pNS);

    NameSpace* GetNameSpace() const
    {
        return m_pNS;
    }
    virtual void ForEachSubItem(void (*pf)(ParseTreeItem*))
    {
        DUMMY_PARAM(pf);
    }

private:
    NameSpace *m_pNS;
};

END_NAMESPACE_NEX

