﻿/*---------------------------------------------------------------------------*
  (C) Copyright 1998-2018, Technologies Quazal Inc.  All rights reserved.
  Quazal Net-Z, Quazal Rendez-Vous and Quazal are trademarks of Quazal.

  Copyright (C)2011-2018 Nintendo  All rights reserved.

  These coded instructions, statements, and computer programs contain
  proprietary information of Nintendo and/or its licensors and are
  protected by national and international copyright laws.
  They may not be disclosed to third parties or copied or duplicated
  in any form, in whole or in part, without the prior written consent
  of Nintendo.
  The content herein is highly confidential and should be handled
  accordingly.
 *---------------------------------------------------------------------------*/

#pragma once

#include <OnlineCore/src/Platform/Core/PlatformDecl.h>
#include <OnlineCore/src/ParseTree/NameSpaceRef.h>
#include <OnlineCore/src/ParseTree/Variable.h>

BEGIN_NAMESPACE_NEX

class Declaration;

class Parameter: public Variable
{
public:
    enum
    {
        In      = 0x01,
        Out     = 0x02
    };

    Parameter(
        const String& strName,
        Declaration* pTypeDeclaration,
        qByte byFlags                 = Parameter::In,
        qUnsignedInt uiArraySize      = 0);

    virtual ~Parameter();

    DECLARE_NAMESPACE_ITEM(Parameter, Variable);

#ifdef NEX_TRACE_ENABLED
    virtual void Trace(qUnsignedInt64 uiTraceFlag=TRACE_ALWAYS) const;
#endif

    qResult StreamIn(BinaryRepresentation *pStream) const;
    qResult StreamOut(BinaryRepresentation *pStream);

    virtual qBool IsEqual(const ParseTreeItem* pOther) const;

    qByte GetFlags() const
    {
        return m_byFlags;
    };

private:
    qByte m_byFlags;
};

END_NAMESPACE_NEX

