﻿/*---------------------------------------------------------------------------*
  (C) Copyright 1998-2018, Technologies Quazal Inc.  All rights reserved.
  Quazal Net-Z, Quazal Rendez-Vous and Quazal are trademarks of Quazal.

  Copyright (C)2011-2018 Nintendo  All rights reserved.

  These coded instructions, statements, and computer programs contain
  proprietary information of Nintendo and/or its licensors and are
  protected by national and international copyright laws.
  They may not be disclosed to third parties or copied or duplicated
  in any form, in whole or in part, without the prior written consent
  of Nintendo.
  The content herein is highly confidential and should be handled
  accordingly.
 *---------------------------------------------------------------------------*/

#pragma once

#ifdef SWIG
// Swig doesn't like the syntax
#undef OSDK_DLL_SUPPORT
#endif

// Template support option
#ifndef OSDK_DISABLE_TEMPLATE_EXPORT
#ifdef OSDK_DLL_SUPPORT
#define OSDK_EXPORT_TEMPLATE
#endif
#endif

// STL support option
#ifndef OSDK_DISABLE_STL_EXPORT
#ifdef OSDK_EXPORT_TEMPLATE
#define OSDK_EXPORT_STL
#endif
#endif

#ifdef OSDK_DLL_SUPPORT
#ifdef OSDK_LIBRARY_EXPORTS
#define OSDK_API __declspec(dllexport)
#else
#define OSDK_API __declspec(dllimport)
#endif

#define OSDK_DISABLE_EXPORT_WARNING_BEGIN  \
    __pragma(warning(push)) \
    __pragma(warning(disable: 4127 4251 4275))

#define OSDK_DISABLE_EXPORT_WARNING_END \
    __pragma(warning(pop))

#define OSDK_DISABLE_EXPORT_WARNING(...) \
    OSDK_DISABLE_EXPORT_WARNING_BEGIN \
    __VA_ARGS__; \
    OSDK_DISABLE_EXPORT_WARNING_END

#else /* !OSDK_DLL_SUPPORT */
#define OSDK_API
#define OSDK_DISABLE_EXPORT_WARNING_BEGIN
#define OSDK_DISABLE_EXPORT_WARNING_END
#define OSDK_DISABLE_EXPORT_WARNING(...) __VA_ARGS__

#endif /* OSDK_DLL_SUPPORT */

