﻿/*---------------------------------------------------------------------------*
  (C) Copyright 1998-2018, Technologies Quazal Inc.  All rights reserved.
  Quazal Net-Z, Quazal Rendez-Vous and Quazal are trademarks of Quazal.

  Copyright (C)2011-2018 Nintendo  All rights reserved.

  These coded instructions, statements, and computer programs contain
  proprietary information of Nintendo and/or its licensors and are
  protected by national and international copyright laws.
  They may not be disclosed to third parties or copied or duplicated
  in any form, in whole or in part, without the prior written consent
  of Nintendo.
  The content herein is highly confidential and should be handled
  accordingly.
 *---------------------------------------------------------------------------*/

#pragma once

#include <OnlineCore/src/Platform/Core/PlatformImpl.h>
#include <OnlineCore/src/Platform/Core/String.h>

BEGIN_NAMESPACE_NEX

#if defined(NEX_TRACE_ENABLED) || defined(NEX_JOB_TRACE_INFO_ENABLED)

//  The purpose of DebugString class is essentially to enable a String
//  object while NEX_TRACE_ENABLED flag is on
typedef String      DebugString;

#else


//  No-op class
class DebugString
{
public:
    DebugString(const qChar* )
    {
    }

    DebugString(const String& )
    {
    }

    const qChar* CStr() const
    {
        return NEX_T("");
    }

    //n1769
    bool operator==(const String&) const
    {
        return true;
    }

    bool operator!=(const String&) const
    {
        return false;
    }

};

#endif

END_NAMESPACE_NEX

