﻿/*---------------------------------------------------------------------------*
  (C) Copyright 1998-2018, Technologies Quazal Inc.  All rights reserved.
  Quazal Net-Z, Quazal Rendez-Vous and Quazal are trademarks of Quazal.

  Copyright (C)2011-2018 Nintendo  All rights reserved.

  These coded instructions, statements, and computer programs contain
  proprietary information of Nintendo and/or its licensors and are
  protected by national and international copyright laws.
  They may not be disclosed to third parties or copied or duplicated
  in any form, in whole or in part, without the prior written consent
  of Nintendo.
  The content herein is highly confidential and should be handled
  accordingly.
 *---------------------------------------------------------------------------*/
#pragma once

#include <OnlineCore/src/Platform/Core/PlatformDecl.h>

BEGIN_NAMESPACE_NEX

// 対象ファシリティを追加する場合は、RendezVous/Core/src/Server/Constants.py
// の FACILITY_NAMES_FOR_ERROR_CODE_CONVERTER にファシリティ名を追加すること
namespace ErrorCodeFacility
{
typedef enum
{
    Core = 1,
    DDL,
    RendezVous,
    PythonCore,
    Transport,
    DOCore,
    FPD,
    Authentication,
    SystemError,
    P2P,
    Ranking,
    DataStore,
    Subscription,
    Rating,
    ServiceItem,
    Shop,
    MusicRequst,
    MatchmakeReferee,
    Subscriber,
    Ranking2,
    OnlineLounge,
    Screening,
    END
} Facility;
}

namespace ErrorCodeFacilityOffset
{
typedef enum
{
    Core = 2,
    DDL = 1,
    RendezVous = 1,
    PythonCore = 1,
    Transport = 1,
    DOCore = 2,
    FPD = 2,
    Authentication = 1,
    SystemError = 1,
    P2P = 1,
    Ranking = 1,
    DataStore= 1,
    Subscription = 1,
    Rating = 1,
    ServiceItem = 0,
    Shop = 1,
    MusicRequst = 1,
    MatchmakeReferee = 1,
    Subscriber = 1,
    Ranking2 = 1,
    OnlineLounge = 1,
    Screening = 1
} FacilityOffset;
}

END_NAMESPACE_NEX
