﻿/*---------------------------------------------------------------------------*
  (C) Copyright 1998-2018, Technologies Quazal Inc.  All rights reserved.
  Quazal Net-Z, Quazal Rendez-Vous and Quazal are trademarks of Quazal.

  Copyright (C)2011-2018 Nintendo  All rights reserved.

  These coded instructions, statements, and computer programs contain
  proprietary information of Nintendo and/or its licensors and are
  protected by national and international copyright laws.
  They may not be disclosed to third parties or copied or duplicated
  in any form, in whole or in part, without the prior written consent
  of Nintendo.
  The content herein is highly confidential and should be handled
  accordingly.
 *---------------------------------------------------------------------------*/

#pragma once

#ifdef NEX_EXCEPTION_TRAPPING_ENABLED
#define NEX_BEGIN_TRAP_EXCEPTION __try {
#define NEX_END_TRAP_EXCEPTION(szInfo,bExceptionsHappened)  \
bExceptionsHappened = false; \
} __except (ExceptionHandler::ExceptionFilter(szInfo,GetExceptionInformation())) { \
    ExceptionHandler::HandleException(); \
    bExceptionsHappened  = true;     \
}
#else
#define NEX_BEGIN_TRAP_EXCEPTION
#define NEX_END_TRAP_EXCEPTION(szInfo,bExceptionsHappened)
#endif

BEGIN_NAMESPACE_NEX

class ExceptionHandler: public RootObject
{
public:
    static void Initialize();
    static void TrapBreakpoints(qBool bTrap)
    {
        s_bTrapBreakpoints = bTrap;
    }
    static void ExitOnException(qBool bTrap)
    {
        s_bExitOnExceptions = bTrap;
    }
    static qBool ExceptionWasThrown()
    {
        return s_bExceptionWasThrown;
    }
    static int ExceptionFilter( const qChar *lpszMessage, void *pExPtrs, qBool bTraceCode = true );
    static void HandleException();

#ifdef CRT_SET_REPORT_HOOK_SUPPORT
    static int __CDECL TrapCrtExceptions( int iReportType, char *szUserMsg, int *piRetVal );

    static void InvalidParameterHandler(
        const wchar_t* expr,
        const wchar_t* func,
        const wchar_t* file,
        unsigned int line,
        uintptr_t /*pReserved*/
    );
#endif

    static void TrapExceptions(qBool bTrap)
    {
        s_bTrapExceptions = bTrap;
    }

    static void CheckCrtExceptions();

public:
    static qBool s_bTrapExceptions;
    static qBool s_bTrapBreakpoints;
    static qBool s_bExitOnExceptions;
    static qBool s_bExceptionWasThrown;
};

END_NAMESPACE_NEX


