﻿/*---------------------------------------------------------------------------*
  Copyright (C)2011-2018 Nintendo Co., Ltd.  All rights reserved.

  These coded instructions, statements, and computer programs contain
  proprietary information of Nintendo of America Inc. and/or Nintendo
  Company Ltd., and are protected by Federal copyright law.  They may
  not be disclosed to third parties or copied or duplicated in any form,
  in whole or in part, without the prior written consent of Nintendo.
 *---------------------------------------------------------------------------*/

#pragma once

#include <OnlineCore/src/Platform/Core/PlatformDecl.h>
#include <OnlineCore/src/version/nex_version.h>

#if defined(CTR_TARGET) || defined(CAFE_TARGET)
#include <nn/middleware.h>
// CTR, Cafeで未定義
#define NN_DEFINE_DEBUG_API(a, b, c)
#define NN_USING_DEBUG_API(a)

#elif defined(NEX_NX_TARGET) // Windows版Sigloでは未対応
#include <nn/nn_Middleware.h>
#else // 未対応プラットフォーム用ダミー定義
#define NN_DEFINE_MIDDLEWARE(a, b, c)
#define NN_USING_MIDDLEWARE(a)
#define NN_DEFINE_DEBUG_API(a, b, c)
#define NN_USING_DEBUG_API(a)
#endif

#if defined(CTR_TARGET) || defined(CAFE_TARGET)
#define NEX_MIDDLEWARE_VERSION_STRING "NEX_" NEX_VER_STR(NEX_VERSION_MAJOR) "_" NEX_VER_STR(NEX_VERSION_MINOR) "_" NEX_VER_STR(NEX_VERSION_MICRO)NEX_VERSION_PATCH
#define NEX_MODULE_VERSION_STRING(module) "NEX_" module "_" NEX_VER_STR(NEX_VERSION_MAJOR) "_" NEX_VER_STR(NEX_VERSION_MINOR) "_" NEX_VER_STR(NEX_VERSION_MICRO)
#else
#define NEX_MIDDLEWARE_VERSION_STRING "NEX-" NEX_VER_STR(NEX_VERSION_MAJOR) "_" NEX_VER_STR(NEX_VERSION_MINOR) "_" NEX_VER_STR(NEX_VERSION_MICRO) "-" NEX_VERSION_PATCH
#define NEX_MODULE_VERSION_STRING(module) "NEX_" module "-" NEX_VER_STR(NEX_VERSION_MAJOR) "_" NEX_VER_STR(NEX_VERSION_MINOR) "_" NEX_VER_STR(NEX_VERSION_MICRO)
#endif
