﻿/*---------------------------------------------------------------------------*
  (C) Copyright 1998-2018, Technologies Quazal Inc.  All rights reserved.
  Quazal Net-Z, Quazal Rendez-Vous and Quazal are trademarks of Quazal.

  Copyright (C)2011-2018 Nintendo  All rights reserved.

  These coded instructions, statements, and computer programs contain
  proprietary information of Nintendo and/or its licensors and are
  protected by national and international copyright laws.
  They may not be disclosed to third parties or copied or duplicated
  in any form, in whole or in part, without the prior written consent
  of Nintendo.
  The content herein is highly confidential and should be handled
  accordingly.
 *---------------------------------------------------------------------------*/

#pragma once


//n1769
#ifdef NEX_CLIENT_OPTIMIZATION

// n1769: MessageBundle::GetMaximumSize()の返値はそうそう変化するものではないことに
// 着目し、常に固定値を返すようにする最適化。
#define NEX_ENABLE_FIX_BUNDLE_MAXSIZE_OPTIMIZATION 1

#define NEX_ENABLE_STRING_FORMAT_STACKSIZE_OPTIMIZATION 0
// n2370:ステーションに接続すべきか判断する部分の最適化
#define NEX_ENABLE_OBJDUP_CONNECTSTATION_OPTIMIZATION 1
// n2370:スケジューラのパフォーマンス測定を無効にすることで高速化
#define NEX_DISABLE_SCHEDULER_PERFCOUNTER_OPTIMIZATION 1
// n2370:IteratorOverDOsのGetNext関数の戻り値をSetCurrentItemするところの最適化
#define NEX_ENABLE_ITERATOR_DO_GETNEXT_OPTIMIZATION 1
// n2370:IsAKindOfDOFilterで、最大値と最小値をその都度計算せずに、キャッシュしてしまう最適化
#define NEX_ENABLE_DOFILTER_MINMAX_CACHE_OPTIMIZATION 1
// n2370:AdvanceToValidItemの中でメンバ変数に頻繁にアクセスしないようにする最適化
#define NEX_ENABLE_ADVANCETOVALIDITEM_LOOP_OPTIMIZATION 1

// n2494:文字列定数しか代入されないStringをconst qChar*に置き換えることで、MemoryManager::Allocateの呼び出しを防ぐ。
#define NEX_ENABLE_CONST_STRING_TO_QCHAR_OPTIMIZATION 1

// n2967:QLOGSTRでnewをされるのを防ぐ。ThreadUnSafeなメモリアロケーターを使っている場合に問題となる。
#define NEX_ENABLE_AVOID_NEW_IN_QLOGSTR 1

// n2967: ロガー系のバッファサイズが大きく、スタックを消費していた(4096)ので、下げられるようにした。
#define NEX_LOG_STRING_BUFFER_SIZE 256

// n2343: Time::GetTimeをキャッシュ化して高速化するフラグ
#define NEX_ENABLE_GET_TIME_CACHE_OPTIMIZATION 1

#else // n2619: NEX_CLIENT_OPTIMIZATIONではない場合は全て0にdefine

// n1769: MessageBundle::GetMaximumSize()の返値はそうそう変化するものではないことに
// 着目し、常に固定値を返すようにする最適化。
#define NEX_ENABLE_FIX_BUNDLE_MAXSIZE_OPTIMIZATION 0

// n2370: String::Formatの中で大量のスタックを消費する問題の回避(デバッグビルド時に低速になります)
#define NEX_ENABLE_STRING_FORMAT_STACKSIZE_OPTIMIZATION 0
// n2370:ステーションに接続すべきか判断する部分の最適化
#define NEX_ENABLE_OBJDUP_CONNECTSTATION_OPTIMIZATION 0
// n2370:スケジューラのパフォーマンス測定を無効にすることで高速化
#define NEX_DISABLE_SCHEDULER_PERFCOUNTER_OPTIMIZATION 0
// n2370:IteratorOverDOsのGetNext関数の戻り値をSetCurrentItemするところの最適化
#define NEX_ENABLE_ITERATOR_DO_GETNEXT_OPTIMIZATION 0
// n2370:IsAKindOfDOFilterで、最大値と最小値をその都度計算せずに、キャッシュしてしまう最適化
#define NEX_ENABLE_DOFILTER_MINMAX_CACHE_OPTIMIZATION 0
// n2370:AdvanceToValidItemの中でメンバ変数に頻繁にアクセスしないようにする最適化
#define NEX_ENABLE_ADVANCETOVALIDITEM_LOOP_OPTIMIZATION 0

// n2494:文字列定数しか代入されないStringをconst qChar*に置き換えることで、MemoryManager::Allocateの呼び出しを防ぐ。
#define NEX_ENABLE_CONST_STRING_TO_QCHAR_OPTIMIZATION 0

// n2967:QLOGSTRでnewをされるのを防ぐ。ThreadUnSafeなアロケータを使っている場合に問題となる。
#define NEX_ENABLE_AVOID_NEW_IN_QLOGSTR 0

// n2967: ロガー系のバッファサイズが大きく、スタックを消費していた(4096)ので、下げられるようにした。
// Linuxにおいて、Unittestが落ちるので、LinuxとWindowsでは、4Kを確保する
#define NEX_LOG_STRING_BUFFER_SIZE 4096

// n2343: Time::GetTimeをキャッシュ化して高速化するフラグ
#define NEX_ENABLE_GET_TIME_CACHE_OPTIMIZATION 0

#endif  // end of NEX_CLIENT_OPTIMIZATION

//n2690: NAT判定結果のキャッシュ
#if defined(CTR_TARGET)
// ac の private ヘッダが NEX-Kit に入るまでは無効化
#define NEX_ENABLE_NAT_CHECK_CACHE 0
#else
#define NEX_ENABLE_NAT_CHECK_CACHE 0
#endif

