﻿/*---------------------------------------------------------------------------*
  Copyright (C)2011-2018 Nintendo Co., Ltd.  All rights reserved.
 
  These coded instructions, statements, and computer programs contain
  proprietary information of Nintendo of America Inc. and/or Nintendo
  Company Ltd., and are protected by Federal copyright law.  They may
  not be disclosed to third parties or copied or duplicated in any form,
  in whole or in part, without the prior written consent of Nintendo.
 *---------------------------------------------------------------------------*/

#pragma once

#include <OnlineCore/src/Platform/Core/PlatformDecl.h>

namespace nn {
    namespace account {
        struct UserHandle;
    }
}

BEGIN_NAMESPACE_NEX

// Sigloのアカウントをオープン、クローズするユーティリティクラス
class SigloAccount : public RootObject
{
public:
    static qBool OpenUser();
    static void CloseUser();
    static nn::account::UserHandle* GetUserHandle();
};

// Sigloのアカウントをスコープでオープン、クローズするクラス
class ScopedSigloAccount : public RootObject
{
public:
    ScopedSigloAccount()
    {
        QVERIFY(SigloAccount::OpenUser());
    }

    ~ScopedSigloAccount()
    {
        SigloAccount::CloseUser();
    }

    nn::account::UserHandle* GetUserHandle()
    {
        return SigloAccount::GetUserHandle();
    }
};

END_NAMESPACE_NEX
