﻿/*---------------------------------------------------------------------------*
  (C) Copyright 1998-2018, Technologies Quazal Inc.  All rights reserved.
  Quazal Net-Z, Quazal Rendez-Vous and Quazal are trademarks of Quazal.

  Copyright (C)2011-2018 Nintendo  All rights reserved.

  These coded instructions, statements, and computer programs contain
  proprietary information of Nintendo and/or its licensors and are
  protected by national and international copyright laws.
  They may not be disclosed to third parties or copied or duplicated
  in any form, in whole or in part, without the prior written consent
  of Nintendo.
  The content herein is highly confidential and should be handled
  accordingly.
 *---------------------------------------------------------------------------*/


#pragma once

#include <OnlineCore/src/Platform/Core/PlatformDecl.h>
#include <OnlineCore/src/Platform/Core/TraceLog.h>


BEGIN_NAMESPACE_NEX


///< ここでは、NEX開発者向けの便利ツールを提供します。


//n1769 わざわざ QTRACE(TRACE_ALWAYS, NEX_T("Hogehoge...")) と記述するのが面倒くさかったので。
#if 1  //n1769 トレースを一斉に切りたいときは、ここを 0 にしましょう。
#define ALWAYS_TRACE(str) alwaysTraceImpl(NEX_T(str), NEX_T(__FILE__), __LINE__)
#else
#define ALWAYS_TRACE(str)
#endif

//n1769 この関数を直接呼び出すのは推奨しません。ALWAYS_TRACEマクロから呼び出されることを想定しています。
void alwaysTraceImpl(const qChar *pStr, const qChar *pFilename, unsigned int line);

END_NAMESPACE_NEX


