﻿/*---------------------------------------------------------------------------*
  (C) Copyright 1998-2018, Technologies Quazal Inc.  All rights reserved.
  Quazal Net-Z, Quazal Rendez-Vous and Quazal are trademarks of Quazal.

  Copyright (C)2011-2018 Nintendo  All rights reserved.

  These coded instructions, statements, and computer programs contain
  proprietary information of Nintendo and/or its licensors and are
  protected by national and international copyright laws.
  They may not be disclosed to third parties or copied or duplicated
  in any form, in whole or in part, without the prior written consent
  of Nintendo.
  The content herein is highly confidential and should be handled
  accordingly.
 *---------------------------------------------------------------------------*/
#pragma once

#include <types.h>
#include <OnlineCore/src/Platform/Core/PlatformDecl.h>

// TODO: wide char 以外の API も追加していきたいのでファイル名を変更する
/*
inline int abs(int v)
{
    return v > 0 ? v : -v;
}
*/

wchar_t *wcscpy(wchar_t *dest, const wchar_t *src);

size_t wcslen(const wchar_t *str);
size_t wcsnlen(const wchar_t *str, size_t n);

wchar_t *wcsstr(const wchar_t *haystack, const wchar_t *needle);
wchar_t *wcschr(const wchar_t *wcs, wchar_t wc);
wchar_t *wcsrchr(const wchar_t *wcs, wchar_t wc);
wchar_t *wcscat(wchar_t *dest, const wchar_t *src);
wchar_t *wcsncat(wchar_t *dest, const wchar_t *src, size_t n);
int wcscmp(const wchar_t *s1, const wchar_t *s2);
int wcsncmp(const wchar_t *s1, const wchar_t *s2, size_t n);

unsigned long wcstoul(const wchar_t *ptr, wchar_t **endptr, int base);

wchar_t *wcsncpy(wchar_t *dest, const wchar_t *src, size_t n);

size_t strcspn(const char *str, const char *reject);
size_t wcscspn(const wchar_t *wcs, const wchar_t *reject);

int wprintf(const wchar_t *format, ...);
int swprintf(wchar_t *wcs, size_t maxlen, const wchar_t *format, ...);

int vwprintf(const wchar_t *format, va_list args);
int vswprintf(wchar_t *wcs, size_t maxlen, const wchar_t *format, va_list args);

size_t mbstowcs(wchar_t *dest, const char *src, size_t n);
size_t wcstombs(char *dest, const wchar_t *src, size_t n);

namespace std
{
inline wchar_t *wcsncpy(wchar_t *dest, const wchar_t *src, size_t n)
{
    return wcsncpy(dest, src, n);
}
}

