﻿/*---------------------------------------------------------------------------*
  (C) Copyright 1998-2018, Technologies Quazal Inc.  All rights reserved.
  Quazal Net-Z, Quazal Rendez-Vous and Quazal are trademarks of Quazal.

  Copyright (C)2011-2018 Nintendo  All rights reserved.

  These coded instructions, statements, and computer programs contain
  proprietary information of Nintendo and/or its licensors and are
  protected by national and international copyright laws.
  They may not be disclosed to third parties or copied or duplicated
  in any form, in whole or in part, without the prior written consent
  of Nintendo.
  The content herein is highly confidential and should be handled
  accordingly.
 *---------------------------------------------------------------------------*/

#pragma once

#include <OnlineCore/src/Platform/Core/PlatformDeclInternal.h>

#include <stdlib.h>
#include <string.h>
#include <wchar.h>

#ifdef CAFEIOP_TARGET
#include <OnlineCore/src/Platform/Core/WideCharIOP.h>
#endif

// ターゲットごとの分岐
#if defined(UNIX_FAMILY) || defined(WII_TARGET) || defined(CTR_ANSI) || defined(CAFE_ANSI) || (defined(NEX_NX_TARGET) && !defined(NEX_UNICODE_VERSION))

#define nex_tmain       main
#define nex_snprintf    snprintf
#define nex_sntprintf   snprintf
#define nex_tprintf     printf
#define nex_stprintf    sprintf
#define nex_vstprintf   vsprintf
#define nex_ftprintf    fprintf
#define nex_vftprintf   vfprintf
#define nex_tcsftime    strftime
#define nex_vsntprintf  vsnprintf
#define nex_tfopen      fopen
#define nex_tcscat      strcat
#define nex_tcsncat     strncat
#define nex_tcscmp      strcmp
#define nex_tcscspn     strcspn
#define nex_tcsicmp     strcasecmp
#define nex_tcsncmp     strncmp
#define nex_tcscpy      strcpy
#define nex_tcsncpy     strncpy
#define nex_tcslen      strlen
#define nex_tcschr      strchr
#define nex_tcsrchr     strrchr
#define nex_tcsstr      strstr
#define nex_tcsdup      strdup
#define nex_tcserror    strerror
#define nex_tgetenv     getenv
#define nex_tstoi       atoi
#define nex_tstof      atof
#define nex_getts       gets
#define nex_fgetts      fgets
#define nex_tcsdup      strdup
#define nex_gettch      getch

#ifndef __const
#define __const         const
#endif

#define nex_tremove     remove
#define nex_trename     rename

#define nex_tcstoull    strtoull
#define nex_tcstoul     strtoul
#define nex_tcstoll     strtoll
#define nex_tcstol      strtol
#define nex_tcstod      strtod

//  bug:3692: printf-like string formatter spec
#define SZ_FMT          NEX_T("%s")
#define MSZ_FMT         NEX_T("%s") // マルチバイト用の書式

#if defined(CAFE_TARGET)
#define nex_stprintf_s  snprintf
#endif

#elif defined(CAFE_UNICODE) // ターゲットごとの分岐

#define nex_snprintf    snprintf
#define nex_tcscpy      wcscpy
#define nex_tcslen      wcslen
#define nex_tcsstr      wcsstr
#define nex_tcschr      wcschr
#define nex_tcsrchr     wcsrchr
#define nex_tcscat      wcscat
#define nex_tcsncat     wcsncat
#define nex_tcscmp      wcscmp
#define nex_tcsicmp     nex_tcscmp             // No non-case-sensitive version found
#define nex_tcsncmp     wcsncmp
#define nex_tcsupr      wgccupr //strupr
#define nex_tcsnicmp    nex_tcsncmp            // No non-case-sensitive version found
#define nex_tstoi(s)    wcstoul(s, 0, 10)
#define nex_tstof(s)    wcstod(s, 0)
#define nex_tcstod      wcstod
#define nex_tcsncpy     wcsncpy
#define nex_tcscspn     wcscspn
#define nex_tprintf     wprintf
#define nex_sntprintf   swprintf
#define nex_vsntprintf  vswprintf
#define nex_ftprintf    fwprintf
#define nex_fgetts      fgetws
#define nex_vstprintf   vwprintf
#define nex_tmain       main

//  bug:3692: printf-like string formatter spec
#define SZ_FMT          NEX_T("%ls")

#define nex_tremove     remove
#define nex_tfopen      fopen
#define nex_tcsftime    strftime

#define nex_tcstoull    wcstoull
#define nex_tcstoul     wcstoul
#define nex_tcstoll     wcstoll
#define nex_tcstol      wcstol
#define nex_tcstod      wcstod

// ターゲットごとの分岐
#elif defined(CTR_UNICODE) || (defined(NEX_NX_TARGET) && defined(NEX_UNICODE_VERSION))

#define nex_snprintf    snprintf
#define nex_tcscpy      wcscpy
#define nex_tcslen      wcslen
#define nex_tcsstr      wcsstr
#define nex_tcschr      wcschr
#define nex_tcsrchr     wcsrchr
#define nex_tcscat      wcscat
#define nex_tcsncat     wcsncat
#define nex_tcscmp      wcscmp
#define nex_tcsicmp     nex_tcscmp             // No non-case-sensitive version found
#define nex_tcsncmp     wcsncmp
#define nex_tcsupr      wgccupr //strupr
#define nex_tcsnicmp    nex_tcsncmp            // No non-case-sensitive version found
#define nex_tstoi(s)    wcstoul(s, 0, 10)
#define nex_tstof(s)    wcstod(s, 0)
#define nex_tcstod      wcstod
#define nex_tcsncpy     wcsncpy
#define nex_tcscspn     wcscspn
#define nex_tprintf     wprintf
#define nex_sntprintf   swprintf
#define nex_vsntprintf  vswprintf
#define nex_ftprintf    fwprintf
#define nex_fgetts      fgetws
#define nex_vstprintf   vwprintf
#define nex_tmain       main


//  bug:3692: printf-like string formatter spec
#define SZ_FMT          NEX_T("%ls")

#define nex_tcstoull    wcstoull
#define nex_tcstoul     wcstoul
#define nex_tcstoll     wcstoll
#define nex_tcstol      wcstol
#define nex_tcstod      wcstod

#elif defined(WIN_FAMILY)   // ターゲットごとの分岐

//  bug:3692: printf-like string formatter spec
#define SZ_FMT          NEX_T("%s")

#if !defined(snprintf) && !defined(HAVE_SNPRINTF)
#define HAVE_SNPRINTF
#define snprintf        _snprintf_s
#define vsnprintf       _vsnprintf
#endif
#define nex_snprintf    _snprintf

#ifdef NEX_UNICODE_VERSION

#define nex_tmain       wmain
#define nex_sntprintf   _snwprintf
#define nex_tprintf     wprintf
#define nex_stprintf    swprintf
#define nex_vstprintf   vswprintf
#define nex_ftprintf    fwprintf
#define nex_vftprintf   vfwprintf
#define nex_tcsftime    wcsftime
#define nex_vsntprintf  _vsnwprintf
#define nex_tfopen      _wfopen
#define nex_tcscat      wcscat
#define nex_tcsncat     wcsncat
#define nex_tcscmp      wcscmp
#define nex_tcscspn     wcscspn
#define nex_tcsicmp     _wcsicmp
#define nex_tcsncmp     wcsncmp
#define nex_tcscpy      wcscpy
#define nex_tcsncpy     wcsncpy
#define nex_tcslen      wcslen
#define nex_tcschr      wcschr
#define nex_tcsrchr     wcsrchr
#define nex_tcsstr      wcsstr
#define nex_tcsdup      _wcsdup
#define nex_tcserror    _wcserror
#define nex_tgetenv     _wgetenv
#define nex_tstoi      _wtoi
#define nex_tstof       _wtof
#define nex_getts       _getws
#define nex_fgetts      fgetws
#define nex_tcsdup      _wcsdup
#define nex_gettch      _getwch
#define nex_tremove     _wremove
#define nex_trename     _wrename
#define nex_tcstoull    _wcstoui64
#define nex_tcstoul     wcstoul
#define nex_tcstoll     wcstoll
#define nex_tcstol      wcstol
#define nex_tcstod      wcstod

#else //NEX_ANSI_VERSION

#define nex_tmain       main
#define nex_sntprintf   _snprintf
#define nex_tprintf     printf
#define nex_stprintf    sprintf
#define nex_vstprintf   vsprintf
#define nex_ftprintf    fprintf
#define nex_vftprintf   vfprintf
#define nex_tcsftime    strftime
#define nex_vsntprintf  vsnprintf
#define nex_tfopen      fopen
#define nex_tcscat      strcat
#define nex_tcsncat     strncat
#define nex_tcscmp      strcmp
#define nex_tcscspn     strcspn
#define nex_tcsicmp     stricmp
#define nex_tcsncmp     strncmp
#define nex_tcscpy      strcpy
#define nex_tcsncpy     strncpy
#define nex_tcslen      strlen
#define nex_tcschr      strchr
#define nex_tcsrchr     strrchr
#define nex_tcsstr      strstr
#define nex_tcsdup      _strdup
#define nex_tcserror    strerror
#define nex_tgetenv     getenv
#define nex_tstoi      atoi
#define nex_tstof      atof
#define nex_getts       gets
#define nex_fgetts      fgets
#define nex_gettch      _getch
#define nex_tremove     remove
#define nex_trename     rename
#define nex_tcstoull    _strtoui64
#define nex_tcstoul     strtoul
#define nex_tcstoll     _strtoi64
#define nex_tcstol      strtol
#define nex_tcstod      strtod


#endif // NEX_UNICODE_VERSION

#else  // ターゲットごとの分岐
#error not supported platform.
#endif // ターゲットごとの分岐


#ifdef NEX_UNICODE_VERSION
#define SZ_LOG_FMT      _TANSI("%ls")
#define MSZ_FMT         NEX_T("%S") // マルチバイト用の書式
#else
#define SZ_LOG_FMT      _TANSI("%s")
#define MSZ_FMT         NEX_T("%s") // マルチバイト用の書式
#endif

// size_tなどの書式指定子
// C99ではzuが定義されているがVS2010では使えない。代わりに独自拡張のIを使う。
#if defined(WIN_FAMILY)
#define NEX_SIZE_T_SPECIFIER    NEX_T("%Iu")
#define NEX_SSIZE_T_SPECIFIER   NEX_T("%Id")
#define NEX_PTRDIFF_T_SPECIFIER NEX_T("%Id")
#define NEX_SIZE_T_ANSI_SPECIFIER    "%Iu"
#define NEX_SSIZE_T_ANSI_SPECIFIER   "%Id"
#define NEX_PTRDIFF_T_ANSI_SPECIFIER "%Id"
#ifdef NEX_64BIT_ARCH
#define NEX_UINTPTR_T_SPECIFIER NEX_T("%016Ix")
#else
#define NEX_UINTPTR_T_SPECIFIER NEX_T("%08Ix")
#endif
#else
#define NEX_SIZE_T_SPECIFIER    NEX_T("%zu")
#define NEX_SSIZE_T_SPECIFIER   NEX_T("%zd")
#define NEX_PTRDIFF_T_SPECIFIER NEX_T("%td")
#define NEX_SIZE_T_ANSI_SPECIFIER    "%zu"
#define NEX_SSIZE_T_ANSI_SPECIFIER   "%zd"
#define NEX_PTRDIFF_T_ANSI_SPECIFIER "%td"
#ifdef NEX_64BIT_ARCH
#define NEX_UINTPTR_T_SPECIFIER NEX_T("%016zx")
#else
#define NEX_UINTPTR_T_SPECIFIER NEX_T("%08zx")
#endif
#endif

#ifdef NEX_STDINT_SUPPORT
#define NEX_INT64_SPECIFIER  NEX_T("%") NEX_T(PRId64)
#define NEX_UINT64_SPECIFIER NEX_T("%") NEX_T(PRIu64)
#else
#define NEX_INT64_SPECIFIER  NEX_T("%lld")
#define NEX_UINT64_SPECIFIER NEX_T("%llu")
#endif

#ifdef UNIX_FAMILY
BEGIN_NAMESPACE_NEX
void nex_tcsupr(qChar* strString);
END_NAMESPACE_NEX
#endif

#ifdef NEX_USE_PRINCIPALID_64BIT
#define NEX_PID_FMT      NEX_UINT64_SPECIFIER
#else
#define NEX_PID_FMT      NEX_T("%u")
#endif
