﻿/*---------------------------------------------------------------------------*
  (C) Copyright 1998-2018, Technologies Quazal Inc.  All rights reserved.
  Quazal Net-Z, Quazal Rendez-Vous and Quazal are trademarks of Quazal.

  Copyright (C)2011-2018 Nintendo  All rights reserved.

  These coded instructions, statements, and computer programs contain
  proprietary information of Nintendo and/or its licensors and are
  protected by national and international copyright laws.
  They may not be disclosed to third parties or copied or duplicated
  in any form, in whole or in part, without the prior written consent
  of Nintendo.
  The content herein is highly confidential and should be handled
  accordingly.
 *---------------------------------------------------------------------------*/

#pragma once


#include <nn/socket/socket_Types.h>
#include <nn/socket/socket_User.h>
#include <nn/socket/socket_DummyUtil.h>
#include <nn/socket/socket_Berkeley.h>
#include <nn/socket/socket_Const.h>
#include <stdlib.h>

#define SOCKADDR_IN         nn::socket::SockAddrIn
#define sockaddr_in         nn::socket::SockAddrIn
#define IN_ADDR             nn::socket::InAddr
#define sin_family          family
#define sin_port            port
#define sin_addr            addr
#define SO_AF_INET          nn::socket::AF_INET
#define INADDR_NONE         0
#define INADDR_BROADCAST    0xFFFFFFFF
#define CALL_INCOMPLETE     qUnsignedInt(nn::socket::EAGAIN)
#define hostent             nn::socket::HostEnt
#define SOCKET_WOULD_BLOCK  qUnsignedInt(nn::socket::EAGAIN)
#define SOCKET_NOTSOCK      qUnsignedInt(nn::socket::EBADF) //Socketクローズ後のFDをアクセスした場合が他と異なる
#define SOCKET_NETDOWN      qUnsignedInt(nn::socket::ENETDOWN) //CTRのAC切断時はこのエラー
#define OPERATION_IN_PROGRESS   nn::socket::EINPROGRESS
#define POLLIN_DEF          nn::socket::POLLIN
#define POLLOUT_DEF         nn::socket::POLLOUT
#define POLLERR_DEF         nn::socket::POLLERR
#define POLLHUP_DEF         nn::socket::POLLHUP
#define POLLNVAL_DEF POLLNVAL
#define POLLFD_T            nn::socket::PollFd
#define POLLSOCK(x)         x.fd
#define SOCKADDR_SIZE_TYPE  size_t

#define INADDR_ANY          ((u32) 0x00000000)

#define SOCK_STREAM         1           /**< stream socket */
#define SOCK_DGRAM          2           /**< datagram socket */

#define IPPROTO_TCP         0
#define IPPROTO_UDP         0

#define POLL                nn::socket::Poll
#define inetpton            nn::socket::InetPtoN
#define htonl               nn::socket::HtoNl
#define ntohl               nn::socket::NtoHl
#define htons               nn::socket::HtoNs
#define ntohs               nn::socket::NtoHs
#define gethostbyname       nn::socket::GetHostByName
#define gethostname         nn::socket::GetHostName
#define getpeername(a,b,c)  nn::socket::GetPeerName(a,b);(void)c
#define poll                nn::socket::Poll
#define bind                nn::socket::Bind
#define connect             nn::socket::Connect
#define listen              nn::socket::Listen
#define accept(a,b,c)       nn::socket::Accept(a,b);(void)c
#define recv                nn::socket::Recv
#define recvfrom(a,b,c,d,e,f)            nn::socket::RecvFrom(a,b,c,d,e);(void)f
#define send                nn::socket::Send
#define sendto              nn::socket::SendTo
#define setsockopt          nn::socket::SetSockOpt
#define closesocket         nn::socket::Close
#define inetntoa            nn::socket::InetNtoA
#define inetntop            nn::socket::InetNtoP
#define fcntl               nn::socket::Fcntl
#define nnSocket            nn::socket::Socket
#define shutdown            nn::socket::Shutdown

#define getsockname(socket, address, size)  GetSockName(socket, address);(void)size

// TODO: validate the ephemeral port range for CTR.
// Arbitrarily, the same values as for Wii (see jade/src/Platform/Stack/WiiCommon/WiiIpStack.h)
// have been used.
#define EPHEMERAL_PORT_RANGE_BEGIN  49152
#define EPHEMERAL_PORT_RANGE_END    65535

#define MSG_DONTWAIT nn::socket::MSG_DONTWAIT
#define SHUT_RD nn::socket::SHUT_RD
#define SHUT_WR nn::socket::SHUT_WR
#define SHUT_RDWR nn::socket::SHUT_RDWR

typedef int socket_ssize_t;
