﻿/*---------------------------------------------------------------------------*
  (C) Copyright 1998-2018, Technologies Quazal Inc.  All rights reserved.
  Quazal Net-Z, Quazal Rendez-Vous and Quazal are trademarks of Quazal.

  Copyright (C)2011-2018 Nintendo  All rights reserved.

  These coded instructions, statements, and computer programs contain
  proprietary information of Nintendo and/or its licensors and are
  protected by national and international copyright laws.
  They may not be disclosed to third parties or copied or duplicated
  in any form, in whole or in part, without the prior written consent
  of Nintendo.
  The content herein is highly confidential and should be handled
  accordingly.
 *---------------------------------------------------------------------------*/

#pragma once

#include <OnlineCore/src/Transport/Interface/TransportDecl.h>
#include <OnlineCore/src/Transport/Interface/EndPoint.h>
#include <OnlineCore/src/Transport/Interface/NetFaults.h>

BEGIN_NAMESPACE_NEX

//==============================================================================
// Abstract base class defining the interface for End-Point event handlers
//==============================================================================

//n1589:memo:ObjDupProtocolとStreamManagerから継承される
class EndPointEventHandler : public RefCountedObject
{
public:
    EndPointEventHandler() {}
    virtual ~EndPointEventHandler() {}

    virtual void Receive(EndPoint *pEndPoint, Buffer *pBuffer, qByte subStreamID) = 0;
    virtual void FaultDetection(EndPoint *pEndPoint, qUnsignedInt32 uiFault) = 0;
    virtual void PeerDisconnected(EndPoint *pEndPoint) = 0;
};

END_NAMESPACE_NEX

