﻿/*---------------------------------------------------------------------------*
  (C) Copyright 1998-2018, Technologies Quazal Inc.  All rights reserved.
  Quazal Net-Z, Quazal Rendez-Vous and Quazal are trademarks of Quazal.

  Copyright (C)2011-2018 Nintendo  All rights reserved.

  These coded instructions, statements, and computer programs contain
  proprietary information of Nintendo and/or its licensors and are
  protected by national and international copyright laws.
  They may not be disclosed to third parties or copied or duplicated
  in any form, in whole or in part, without the prior written consent
  of Nintendo.
  The content herein is highly confidential and should be handled
  accordingly.
 *---------------------------------------------------------------------------*/

#pragma once

#include <OnlineCore/src/Transport/Interface/TransportDecl.h>
#include <OnlineCore/src/Transport/Interface/StationURL.h>

BEGIN_NAMESPACE_NEX

class NATTraversalInterface: public RootObject
{
public:
    NATTraversalInterface() {}
    virtual ~NATTraversalInterface() {}

    virtual qBool PrepareNATTraversal(const StationURL& urlTargetStation)=0;
    virtual qBool GetUpdatedURL(const StationURL& urlTargetStation, StationURL *pUpdatedURL)=0;
    virtual qUnsignedInt32 GetURLPingTime(const StationURL& urlTargetStation) = 0;

    virtual void Trace(const qUnsignedInt /*uiTraceFlag*/ = TRACE_ALWAYS) {}

};


END_NAMESPACE_NEX

