﻿/*---------------------------------------------------------------------------*
  (C) Copyright 1998-2018, Technologies Quazal Inc.  All rights reserved.
  Quazal Net-Z, Quazal Rendez-Vous and Quazal are trademarks of Quazal.

  Copyright (C)2011-2018 Nintendo  All rights reserved.

  These coded instructions, statements, and computer programs contain
  proprietary information of Nintendo and/or its licensors and are
  protected by national and international copyright laws.
  They may not be disclosed to third parties or copied or duplicated
  in any form, in whole or in part, without the prior written consent
  of Nintendo.
  The content herein is highly confidential and should be handled
  accordingly.
 *---------------------------------------------------------------------------*/

#pragma once

#include <OnlineCore/src/Platform/Core/PlatformDecl.h>
#include <OnlineCore/src/Transport/Interface/HighLevelStream.h>
#include <OnlineCore/src/Transport/Interface/URLProbe.h>

BEGIN_NAMESPACE_NEX

class Buffer;
class StationURL;
class NATTraversalEngine;

class NATTraversalStream: public HighLevelStream
{
public:
    NATTraversalStream(NATTraversalEngine *pEngine, RootTransport *pTransport);
    virtual     ~NATTraversalStream();

    void        SendMsg(const StationURL &oStationURL, Buffer *pBuffer, qUnsignedInt8 uiTTL = 0);

    virtual void DoWork(const Time* currentTime);
    virtual void ReceiveIncomingMsg(const InetAddress &oSourceAddress, Stream::Type oType, Stream::ID idStream, Buffer *pBuffer, Time ioTime, qUnsignedInt16 ui16Port);
    qUnsignedInt GetNbReceived()
    {
        return m_uiNbMsgReceived;
    }

public:
    qUnsignedInt        m_uiNbMsgReceived;
    NATTraversalEngine* m_pEngine;
};

END_NAMESPACE_NEX

