﻿/*---------------------------------------------------------------------------*
  Copyright (C)2011-2018 Nintendo Co., Ltd.  All rights reserved.

  These coded instructions, statements, and computer programs contain
  proprietary information of Nintendo of America Inc. and/or Nintendo
  Company Ltd., and are protected by Federal copyright law.  They may
  not be disclosed to third parties or copied or duplicated in any form,
  in whole or in part, without the prior written consent of Nintendo.
 *---------------------------------------------------------------------------*/

#pragma once

#include <OnlineCore/src/Transport/Interface/TransportDecl.h>
#include <OnlineCore/src/Transport/Interface/EndPointInfo.h>


BEGIN_NAMESPACE_NEX

/*!
 * @brief サブストリームIDの型定義です。
 *
 * @see SubStreamIDDefine, DirectStream, DOCallContext, DataSet, CallMethodOperation
 * @see StreamSettings::SetMaxUserReliableSubStreams()
 */
typedef qByte SubStreamID;

/*!
 * @brief サブストリームIDの定義値です。
 *
 * RootObjectを継承していません。
 *
 * @see SubStreamID, DirectStream, DOCallContext, DataSet, CallMethodOperation
 * @see StreamSettings::SetMaxUserReliableSubStreams()
 */

class SubStreamIDDefine
{
public:
    static const SubStreamID SYSTEM = 0; //!< システムと共有のサブストリームID(=0)です
    static const SubStreamID FIRST_USER = 1; //!< 最小のユーザー用サブストリームID(=1)です
    static const SubStreamID LAST_USER= 255; //!< 最大のユーザー用サブストリームID(=255)です
};

END_NAMESPACE_NEX


