﻿/*---------------------------------------------------------------------------*
  (C) Copyright 1998-2018, Technologies Quazal Inc.  All rights reserved.
  Quazal Net-Z, Quazal Rendez-Vous and Quazal are trademarks of Quazal.

  Copyright (C)2011-2018 Nintendo  All rights reserved.

  These coded instructions, statements, and computer programs contain
  proprietary information of Nintendo and/or its licensors and are
  protected by national and international copyright laws.
  They may not be disclosed to third parties or copied or duplicated
  in any form, in whole or in part, without the prior written consent
  of Nintendo.
  The content herein is highly confidential and should be handled
  accordingly.
 *---------------------------------------------------------------------------*/


#pragma once

#include <OnlineCore/src/Transport/PRUDP/PRUDPDecl.h>
#include <OnlineCore/src/Transport/Interface/Stream.h>


BEGIN_NAMESPACE_NEX
class Packet;
class TransportSignatureGenerator;
class SignatureBytes;
class InetAddress;
class EndPointUniqueIDSignatureHolder;
class PRUDPMessageSelector;
class TransportPerfCounters;
class PacketEncDecInf;

class PRUDPEndPointTemplateInterface
{
public:
    virtual ~PRUDPEndPointTemplateInterface() {}

    virtual void Init(qUnsignedInt32* p_uiSupportedFunctions, qUnsignedInt16* p_iMaxUserReliableSubStreams) = 0;
    virtual qUnsignedInt64 CreateSupportedFunctionsFlags(qByte version ,qUnsignedInt32 supportedFunctions) = 0;

    virtual PacketEncDecInf* GetPacketEncDec() = 0;
};

END_NAMESPACE_NEX

