﻿/*---------------------------------------------------------------------------*
  (C) Copyright 1998-2018, Technologies Quazal Inc.  All rights reserved.
  Quazal Net-Z, Quazal Rendez-Vous and Quazal are trademarks of Quazal.

  Copyright (C)2011-2018 Nintendo  All rights reserved.

  These coded instructions, statements, and computer programs contain
  proprietary information of Nintendo and/or its licensors and are
  protected by national and international copyright laws.
  They may not be disclosed to third parties or copied or duplicated
  in any form, in whole or in part, without the prior written consent
  of Nintendo.
  The content herein is highly confidential and should be handled
  accordingly.
 *---------------------------------------------------------------------------*/


#pragma once

#include <OnlineCore/src/Transport/PRUDP/PRUDPDecl.h>
#include <OnlineCore/src/Transport/Interface/Stream.h>

BEGIN_NAMESPACE_NEX
class PRUDPMessageInterface;
class PRUDPMessageSelector;
class RelayMessage;
class PRUDPLiteMessageV1;

/**
 * @internal
 *
 * @brief メッセージの生成・解読、署名作成を行うルーチンを保持するクラス
 */
class ProtocolMessageHolder : public RootObject
{
public:
    ProtocolMessageHolder();
    virtual ~ProtocolMessageHolder();
    PRUDPMessageInterface* GetPRUDPMessageInterface(Stream::Type type);
    PRUDPMessageInterface* GetPRDUPMessageInterfaceByProtocol(TransportProtocol::Type type);
    RelayMessage* GetRelayMessage();


protected:
    PRUDPMessageSelector*    m_pPRUDPMessageSelector;
#ifdef NEX_PRUDP_LITE_SUPPORT
    PRUDPLiteMessageV1*            m_pPRUDPLiteMessage;
#endif
};
END_NAMESPACE_NEX
