﻿/*---------------------------------------------------------------------------*
  (C) Copyright 1998-2018, Technologies Quazal Inc.  All rights reserved.
  Quazal Net-Z, Quazal Rendez-Vous and Quazal are trademarks of Quazal.

  Copyright (C)2011-2018 Nintendo  All rights reserved.

  These coded instructions, statements, and computer programs contain
  proprietary information of Nintendo and/or its licensors and are
  protected by national and international copyright laws.
  They may not be disclosed to third parties or copied or duplicated
  in any form, in whole or in part, without the prior written consent
  of Nintendo.
  The content herein is highly confidential and should be handled
  accordingly.
 *---------------------------------------------------------------------------*/

#pragma once

#include <RendezVous/Core/src/Client/AccountManagement/AccountManagementCommand.h>
#include <RendezVous/Core/src/Client/SandboxConnectionInfo.h>
#include <OnlineCore/src/Platform/Core/PlatformDecl.h>

BEGIN_NAMESPACE_NEX

class ProtocolCallContext;

//==============================================================================
// Creates an account by using guest account invoking the static CreateAccount
// method from AccountManagementClient
//==============================================================================
class OSDK_API GuestCreateAccountCommand: public AccountManagementCommand
{

public:
    GuestCreateAccountCommand(
        const DebugString& strDescription,
        const SandboxConnectionInfo& sci,
        const String& strUsername, const String& strPassword,
        const String& strEmail, qUnsignedInt32 uiGroups);

    ~GuestCreateAccountCommand();

protected:
    qBool InvokeImpl(ProtocolCallContext* pCC);

    SandboxConnectionInfo m_sci;
    String m_strUsername;
    String m_strEmail;
    qUnsignedInt32 m_uiGroups;
};

END_NAMESPACE_NEX

