﻿/*---------------------------------------------------------------------------*
  (C) Copyright 1998-2018, Technologies Quazal Inc.  All rights reserved.
  Quazal Net-Z, Quazal Rendez-Vous and Quazal are trademarks of Quazal.

  Copyright (C)2011-2018 Nintendo  All rights reserved.

  These coded instructions, statements, and computer programs contain
  proprietary information of Nintendo and/or its licensors and are
  protected by national and international copyright laws.
  They may not be disclosed to third parties or copied or duplicated
  in any form, in whole or in part, without the prior written consent
  of Nintendo.
  The content herein is highly confidential and should be handled
  accordingly.
 *---------------------------------------------------------------------------*/

#pragma once

#include <OnlineCore/src/Platform/Core/PlatformDecl.h>
#include <RendezVous/Core/src/Common/StreamManager.h>

BEGIN_NAMESPACE_NEX

//==============================================================================
// Client Stream Manager End-Point Event Handler
//==============================================================================
class OSDK_API ClientStreamManager: public StreamManager
{
public:
    ClientStreamManager();
    virtual ~ClientStreamManager();

    virtual void SetCredentials(Credentials *pCredentials);
    Credentials* GetCredentials() const
    {
        return m_pCredentials;
    }

private:
    // End-point event handler virtual methods
    virtual void Receive(EndPoint *pEndPoint, Buffer *pBuffer, qByte subStreamID);
    virtual void PeerDisconnected(EndPoint *pEndPoint);
    virtual void FaultDetection(EndPoint *pEndPoint, qUnsignedInt32 uiFault);

private:
    Credentials* m_pCredentials;
};

END_NAMESPACE_NEX


