﻿/*---------------------------------------------------------------------------*
  (C) Copyright 1998-2018, Technologies Quazal Inc.  All rights reserved.
  Quazal Net-Z, Quazal Rendez-Vous and Quazal are trademarks of Quazal.

  Copyright (C)2011-2018 Nintendo  All rights reserved.

  These coded instructions, statements, and computer programs contain
  proprietary information of Nintendo and/or its licensors and are
  protected by national and international copyright laws.
  They may not be disclosed to third parties or copied or duplicated
  in any form, in whole or in part, without the prior written consent
  of Nintendo.
  The content herein is highly confidential and should be handled
  accordingly.
 *---------------------------------------------------------------------------*/

#pragma once

#include <OnlineCore/src/Platform/Core/PlatformDecl.h>
#include <OnlineCore/src/Platform/Core/qVector.h>
#include <OnlineCore/src/Platform/Core/qMap.h>

BEGIN_NAMESPACE_NEX

class RootCaReader : public RootObject
{
public:

    RootCaReader()
        : m_RootCaFileCacheEnabled(true) {}
    virtual ~RootCaReader() {};

    qBool Read(qVector<qByte>* rootCaCerts, const qChar8** fileNames, size_t num);
    void EnableRootCaFileCache(qBool enable)
    {
        m_RootCaFileCacheEnabled = enable;
    }
protected:
    qMap<String, qVector<qByte> >* GetRootCaFileCacheInstance();
    qBool ReadImpl(qVector<qByte>* rootCaCerts, const qChar8** fileNames, size_t num);

    static const qUnsignedInt32 MAX_FILE_PATH_SIZE = 64;

    qBool m_RootCaFileCacheEnabled;
    friend class GlobalVariables;

};

END_NAMESPACE_NEX

