﻿/*---------------------------------------------------------------------------*
  Copyright (C)2011-2018 Nintendo Co., Ltd.  All rights reserved.
 
  These coded instructions, statements, and computer programs contain
  proprietary information of Nintendo of America Inc. and/or Nintendo
  Company Ltd., and are protected by Federal copyright law.  They may
  not be disclosed to third parties or copied or duplicated in any form,
  in whole or in part, without the prior written consent of Nintendo.
 *---------------------------------------------------------------------------*/

#pragma once

#include <RendezVous/Core/src/Common/SwigUtility.h>

BEGIN_NAMESPACE_NEX

/*!
    @brief メンバーシップポリシーを定義する名前空間です。
*/
BEGIN_SWIG_CONSTANTS(MembershipPolicy)
/*!
    @brief メンバーシップポリシー
*/
enum MembershipPolicy
{
    NOT_REQUIRED                     = 0,   //!< メンバーシップへの加入は不要です。
    REQUIRED_FOR_ALL_FEATURES        = 1,   //!< 全ての機能についてメンバーシップへの加入が必要です。
    REQUIRED_FOR_SOME_FEATURES       = 2    //!< 一部の機能についてメンバーシップへの加入が必要です。
};

END_SWIG_CONSTANTS


/*!
    @brief メンバーシップの加入情報を定義する名前空間です。
*/
BEGIN_SWIG_CONSTANTS(MembershipStatus)
/*!
    @brief メンバーシップの加入情報
*/
enum MembershipStatus
{
    BEGIN                     = -1,   //!< メンバーシップステータスの開始値
    NOT_FOUND                 = -1,   //!< メンバーシップ加入情報が存在しません
    NO_MEMBERSHIP             =  0,   //!< メンバーシップに非加入です
    HAS_MEMBERSHIP            =  1,   //!< メンバーシップに加入しています
    END                       =  1    //!< メンバーシップステータスの終了値
};

END_SWIG_CONSTANTS



END_NAMESPACE_NEX

