﻿/*---------------------------------------------------------------------------*
  (C) Copyright 1998-2018, Technologies Quazal Inc.  All rights reserved.
  Quazal Net-Z, Quazal Rendez-Vous and Quazal are trademarks of Quazal.

  Copyright (C)2011-2018 Nintendo  All rights reserved.

  These coded instructions, statements, and computer programs contain
  proprietary information of Nintendo and/or its licensors and are
  protected by national and international copyright laws.
  They may not be disclosed to third parties or copied or duplicated
  in any form, in whole or in part, without the prior written consent
  of Nintendo.
  The content herein is highly confidential and should be handled
  accordingly.
 *---------------------------------------------------------------------------*/

#pragma once

BEGIN_NAMESPACE_NEX

/**
\brief Namespace for enum PrincipalTypes.
*/
#ifdef SWIG
class PrincipalTypes
{
public:
#else
namespace PrincipalTypes
{
#endif

    /**
    \ingroup group_rdv_core_common
    \brief Enumerates the valid Principal Account Types
    \remarks The current valid principal account types are Built-In, External and Secondary

    Principal Type indicate the expected method of validation of an account.
    It allow also to have the same name for two different accounts as long as they do not belong to the same principal types.

    \note In order to access these types you must include the RendezVous.h file.
    */
    enum PrincipalTypes
    {
        /**
        Unset Account Type
        */
        Unset = 0,
        /**
        Built-In Account Type
        */
        BuiltIn = 1,
        /**
        External Account Type
        */
        External = 2,
        /**
        Secondary Account Type
        */
        Secondary = 3
    };
};

END_NAMESPACE_NEX


