﻿/*---------------------------------------------------------------------------*
  Copyright (C)2011-2018 Nintendo Co., Ltd.  All rights reserved.

  These coded instructions, statements, and computer programs contain
  proprietary information of Nintendo of America Inc. and/or Nintendo
  Company Ltd., and are protected by Federal copyright law.  They may
  not be disclosed to third parties or copied or duplicated in any form,
  in whole or in part, without the prior written consent of Nintendo.
 *---------------------------------------------------------------------------*/

#pragma once

#include <OnlineCore/src/Platform/Core/PlatformDecl.h>
#include <OnlineCore/src/Core/JobCallContextCallback.h>

BEGIN_NAMESPACE_NEX

class ProtocolCallContext;
class CallContext;

class JobProtocolCallContextCallback : public JobCallContextCallback
{
public:
    JobProtocolCallContextCallback(const qChar* szDescription, CallContext* associatedCallContext)
        : JobCallContextCallback(Job::RV, szDescription, associatedCallContext) {}
    virtual ~JobProtocolCallContextCallback() {}

    ProtocolCallContext* GetProtocolCallContext();
protected:
    virtual CallContext* CreateCallContext();

};

END_NAMESPACE_NEX


