﻿/*---------------------------------------------------------------------------*
  (C) Copyright 1998-2018, Technologies Quazal Inc.  All rights reserved.
  Quazal Net-Z, Quazal Rendez-Vous and Quazal are trademarks of Quazal.

  Copyright (C)2011-2018 Nintendo  All rights reserved.

  These coded instructions, statements, and computer programs contain
  proprietary information of Nintendo and/or its licensors and are
  protected by national and international copyright laws.
  They may not be disclosed to third parties or copied or duplicated
  in any form, in whole or in part, without the prior written consent
  of Nintendo.
  The content herein is highly confidential and should be handled
  accordingly.
 *---------------------------------------------------------------------------*/

#pragma once

#include <OnlineCore/src/Platform/Core/PlatformDecl.h>
#include <OnlineCore/src/Platform/Core/PrincipalID.h>
#include <RendezVous/Core/src/Common/KeyDerivation.h>

#ifdef NEX_DEBUG_VERSION
#include <OnlineCore/src/Core/Key.h>
#endif


BEGIN_NAMESPACE_NEX

class Key;

class OSDK_API MD5KeyDerivation: public KeyDerivation
{

public:
    MD5KeyDerivation(qUnsignedInt32 uiClientSideIterations, qUnsignedInt32 uiPrincipalIdModulo);
    virtual ~MD5KeyDerivation();

    virtual Key CreateKey(PrincipalID id, const qChar8* szPassword);
    virtual Key InitializeKey(const qChar8* szPassword);
    virtual Key FinalizeKey(PrincipalID id, const Key & oPartialKey);

    virtual qBool CreateKey(CallContext* pCallContext, PrincipalID id, const qChar8* szPassword, Key* pkeyResult);
    virtual qBool InitializeKey(CallContext* pCallContext, const qChar8* szPassword, Key* pkeyResult);
    virtual qBool FinalizeKey(CallContext* pCallContext, PrincipalID id, const Key & oPartialKey, Key* pkeyResult);

    void SetClientSideIterations(qUnsignedInt32 uiClientSideIterations);
    void SetPrincipalIdModulo(qUnsignedInt32 uiPrincipalIdModulo);

private:
    qUnsignedInt32 m_uiClientSideIterations;
    qUnsignedInt32 m_uiPrincipalIdModulo;
};

END_NAMESPACE_NEX


