#pragma once
#if defined(__ARMCC_VERSION) && (__ARMCC_VERSION >= 5000000)
#pragma push
#pragma diag_suppress 228,381,550,1300,1301,2530
#endif // defined(__ARMCC_VERSION) && (__ARMCC_VERSION >= 5000000)
#if defined(_MSC_VER)
#pragma warning( push )
#pragma warning( disable : 4458 )
#endif // defined(_MSC_VER)


#include <OnlineCore/src/DDLTypes/CGCoreExports.h>

#include <RendezVous/Core/src/Common/ClientProtocol.h>
#include <RendezVous/Core/src/Common/ServerProtocol.h>
#include <OnlineCore/src/Core/CallContextRegister.h>
#include <RendezVous/Core/src/Common/ProtocolCGMacros.h>
#include <RendezVous/Core/src/Common/ProtocolCallContext.h>
#include <RendezVous/Core/src/Common/ProtocolRequestBrokerInterface.h>
#include <RendezVous/Core/src/Common/Protocol.h>
#include <RendezVous/Core/src/Common/ProtocolList.h>
#include <OnlineCore/src/Transport/Interface/TransportError.h>
#include <RendezVous/Core/src/Client/RVClientCore.h>
#include <RendezVous/Core/src/Client/ProtocolRegistry.h>
#include "OnlineCore/src/DDLTypes/OnlineCoreTypes.h"

BEGIN_NAMESPACE_NEX

PROTO_DEFINE_RMCID(RemoteLogDeviceProtocol, Log, 1 );
PROTO_DEFINE_NUM_RMC(RemoteLogDeviceProtocol, 1);

class RemoteLogDeviceProtocolClient : public ClientProtocol {
    public:
        typedef DDLTYPE(string) TLog_strLine;
        PROTO_RMCIMPL_RETURN(RemoteLogDeviceProtocol, Log)
        {
            PROTO_RETURNSTUB_IMPL();
            PROTO_RETURNSTUB_END();
        };
        
        RemoteLogDeviceProtocolClient(ProtocolID uiProtocolID);
        virtual ClientProtocol* CreateResponder() const { return qNew RemoteLogDeviceProtocolClient(ProtocolList::Unknown); }
        void RegisterProtocol()
        {
            SYSTEMCHECK(GetProtocolID() != ProtocolList::Unknown);
            SYSTEMCHECK(RVClientCore::GetInstance() != NULL && "You should create ServiceClient or NgsFacade(RendezVous) first.");
            RVClientCore::GetInstance()->GetProtocolRegistry()->RegisterProtocol(GetProtocolID(), CreateResponder());
        }
        virtual void ExtractCallSpecificResults(Message *pMessage, ProtocolCallContext* pContext);
        
        qBool CallLog(ProtocolCallContext *pContext, const DDLTYPE(string)::CPPType& strLine);
        static qBool Log_PrepareRequest(ProtocolCallContext *pContext, Message *pMsg, const DDLTYPE(string)::CPPType& strLine);
        
        protected:
        static ProtoReturnFunction s_protoReturnFunctions[PROTO_NUM_RMC(RemoteLogDeviceProtocol) + 1];
};

class DDLPROTOCOL(RemoteLogDeviceProtocolServer) : public ServerProtocol {
    public:
        DDLPROTOCOL(RemoteLogDeviceProtocolServer)()
            : ServerProtocol()
#if defined(LIVE_VERSION)
            , m_LogProfilingUnit(NEX_T("RemoteLogDeviceProtocol::Log"))
#endif // LIVE_VERSION
            {}
        
        typedef DDLTYPE(string) TLog_strLine;
        PROTO_RMCIMPL_STUB(RemoteLogDeviceProtocol, Log)
        {
            PROTO_PREPARE_EXTRACTION();
            DDLTYPE(string)::CPPType strLine;
            _MSG_EXTRACT_VARIABLE(TLog_strLine, strLine);
            pProtocol->Log( strLine );
            PROTO_PREPARE_RETURN(RemoteLogDeviceProtocol,Log);
        }
        
        private:
        // Call this function with a message previously generated by a
        // <RMC name>_PrepareRequest() call to have it dispatched to the correct RMC.
        virtual void DispatchProtocolMessage( Message *pMessage, Message *pReturnMessage, qBool *boReturnsMessage, EndPoint *pEndPoint);
        public:
        
        virtual void Log(const DDLTYPE(string)::CPPType& strLine) = 0;
    
#if defined(LIVE_VERSION)
    private:
        ProfilingUnit m_LogProfilingUnit;
#endif // LIVE_VERSION
    
};


END_NAMESPACE_NEX

#if defined(__ARMCC_VERSION) && (__ARMCC_VERSION >= 5000000)
#pragma pop
#endif // defined(__ARMCC_VERSION) && (__ARMCC_VERSION >= 5000000)
#if defined(_MSC_VER)
#pragma warning( pop )
#endif // defined(_MSC_VER)
