#pragma once
#if defined(__ARMCC_VERSION) && (__ARMCC_VERSION >= 5000000)
#pragma push
#pragma diag_suppress 228,381,550,1300,1301,2530
#endif // defined(__ARMCC_VERSION) && (__ARMCC_VERSION >= 5000000)
#if defined(_MSC_VER)
#pragma warning( push )
#pragma warning( disable : 4458 )
#endif // defined(_MSC_VER)

#include <OnlineCore/src/DDLTypes/CGCoreExports.h>
#include "OnlineCore/src/DDLTypes/OnlineCoreTypes.h"
#include "DataStorePermission.h"
#include "DataStoreChangeMetaCompareParam.h"
#include "DataStorePersistenceTarget.h"

BEGIN_NAMESPACE_NEX
class DataStoreChangeMetaParam;
END_NAMESPACE_NEX

BEGIN_NAMESPACE_NEX

class DDLCLASS(DataStoreChangeMetaParam): public RootObject {
public:
    DDLCLASS(DataStoreChangeMetaParam)():_mRevision_DataStoreChangeMetaParam(1)
    , tags(0)     {};
    DDLCLASS(DataStoreChangeMetaParam)(const DDLCLASS(DataStoreChangeMetaParam) &oOther):
        RootObject(oOther),
        _mRevision_DataStoreChangeMetaParam(oOther._mRevision_DataStoreChangeMetaParam),
        dataId(oOther.dataId),
        modifiesFlag(oOther.modifiesFlag),
        name(oOther.name),
        permission(oOther.permission),
        delPermission(oOther.delPermission),
        period(oOther.period),
        metaBinary(oOther.metaBinary),
        tags(oOther.tags),
        updatePassword(oOther.updatePassword),
        referredCnt(oOther.referredCnt),
        dataType(oOther.dataType),
        status(oOther.status),
        compareParam(oOther.compareParam),
        persistenceTarget(oOther.persistenceTarget)
    {
    }
    virtual ~DDLCLASS(DataStoreChangeMetaParam)() {};
    const DDLCLASS(DataStoreChangeMetaParam) &operator=(const DDLCLASS(DataStoreChangeMetaParam) &oOther);
    qBool operator==(const DDLCLASS(DataStoreChangeMetaParam) &oOther) const;
    #ifdef OSDK_DLL_SUPPORT
    qBool operator<(const DDLCLASS(DataStoreChangeMetaParam) &oOther) const;
    #endif
    static void Add(Message *pMessageToSend, const DDLCLASS(DataStoreChangeMetaParam) &oValue);
    static void Extract(Message *pReceivedMessage, DDLCLASS(DataStoreChangeMetaParam) *pValue);
    qByte _mRevision_DataStoreChangeMetaParam;
    qByte GetClassRevision_DataStoreChangeMetaParam() const {return _mRevision_DataStoreChangeMetaParam;}
    void SetClassRevision_DataStoreChangeMetaParam(qByte revision) {_mRevision_DataStoreChangeMetaParam=revision;}
    static qByte GetKnownMaxClassRevision_DataStoreChangeMetaParam() {return 1;}
    DDLTYPE(uint64)::CPPType dataId;
    NEX_CLASS_VALID_REVISION_DEF(dataId, 0);
    qBool NEX_CLASS_ISVALID(dataId) const { return true; /* The revision is 0. Always true */}
    DDLTYPE(uint32)::CPPType modifiesFlag;
    NEX_CLASS_VALID_REVISION_DEF(modifiesFlag, 0);
    qBool NEX_CLASS_ISVALID(modifiesFlag) const { return true; /* The revision is 0. Always true */}
    DDLTYPE(string)::CPPType name;
    NEX_CLASS_VALID_REVISION_DEF(name, 0);
    qBool NEX_CLASS_ISVALID(name) const { return true; /* The revision is 0. Always true */}
    DataStorePermission permission;
    NEX_CLASS_VALID_REVISION_DEF(permission, 0);
    qBool NEX_CLASS_ISVALID(permission) const { return true; /* The revision is 0. Always true */}
    DataStorePermission delPermission;
    NEX_CLASS_VALID_REVISION_DEF(delPermission, 0);
    qBool NEX_CLASS_ISVALID(delPermission) const { return true; /* The revision is 0. Always true */}
    DDLTYPE(uint16)::CPPType period;
    NEX_CLASS_VALID_REVISION_DEF(period, 0);
    qBool NEX_CLASS_ISVALID(period) const { return true; /* The revision is 0. Always true */}
    DDLTYPE(qBuffer)::CPPType metaBinary;
    NEX_CLASS_VALID_REVISION_DEF(metaBinary, 0);
    qBool NEX_CLASS_ISVALID(metaBinary) const { return true; /* The revision is 0. Always true */}
    DDLTYPE(qvector)< DDLTYPE(string) >::CPPType tags;
    NEX_CLASS_VALID_REVISION_DEF(tags, 0);
    qBool NEX_CLASS_ISVALID(tags) const { return true; /* The revision is 0. Always true */}
    DDLTYPE(uint64)::CPPType updatePassword;
    NEX_CLASS_VALID_REVISION_DEF(updatePassword, 0);
    qBool NEX_CLASS_ISVALID(updatePassword) const { return true; /* The revision is 0. Always true */}
    DDLTYPE(uint32)::CPPType referredCnt;
    NEX_CLASS_VALID_REVISION_DEF(referredCnt, 0);
    qBool NEX_CLASS_ISVALID(referredCnt) const { return true; /* The revision is 0. Always true */}
    DDLTYPE(uint16)::CPPType dataType;
    NEX_CLASS_VALID_REVISION_DEF(dataType, 0);
    qBool NEX_CLASS_ISVALID(dataType) const { return true; /* The revision is 0. Always true */}
    DDLTYPE(byte)::CPPType status;
    NEX_CLASS_VALID_REVISION_DEF(status, 0);
    qBool NEX_CLASS_ISVALID(status) const { return true; /* The revision is 0. Always true */}
    DataStoreChangeMetaCompareParam compareParam;
    NEX_CLASS_VALID_REVISION_DEF(compareParam, 0);
    qBool NEX_CLASS_ISVALID(compareParam) const { return true; /* The revision is 0. Always true */}
    DataStorePersistenceTarget persistenceTarget;
    NEX_CLASS_VALID_REVISION_DEF(persistenceTarget, 1);
    qBool NEX_CLASS_ISVALID(persistenceTarget) const { return NEX_CLASS_VALID_REVISION(persistenceTarget) <= _mRevision_DataStoreChangeMetaParam;}
};


class DDLTYPE(DataStoreChangeMetaParam): public DDLType {
public:
    typedef DataStoreChangeMetaParam CPPType;
    static void Add(Message* pMessageToSend, const DDLCLASS(DataStoreChangeMetaParam)& oDataStoreChangeMetaParam) {
        DDLCLASS(DataStoreChangeMetaParam)::Add(pMessageToSend,oDataStoreChangeMetaParam);
    }
    static void Extract(Message* pReceivedMessage, DDLCLASS(DataStoreChangeMetaParam)* pDataStoreChangeMetaParamToRefresh) {
        DDLCLASS(DataStoreChangeMetaParam)::Extract(pReceivedMessage,pDataStoreChangeMetaParamToRefresh);
    }
};


END_NAMESPACE_NEX

#if defined(__ARMCC_VERSION) && (__ARMCC_VERSION >= 5000000)
#pragma pop
#endif // defined(__ARMCC_VERSION) && (__ARMCC_VERSION >= 5000000)
#if defined(_MSC_VER)
#pragma warning( pop )
#endif // defined(_MSC_VER)
