﻿/*---------------------------------------------------------------------------*
  (C) Copyright 1998-2018, Technologies Quazal Inc.  All rights reserved.
  Quazal Net-Z, Quazal Rendez-Vous and Quazal are trademarks of Quazal.

  Copyright (C)2011-2018 Nintendo  All rights reserved.

  These coded instructions, statements, and computer programs contain
  proprietary information of Nintendo and/or its licensors and are
  protected by national and international copyright laws.
  They may not be disclosed to third parties or copied or duplicated
  in any form, in whole or in part, without the prior written consent
  of Nintendo.
  The content herein is highly confidential and should be handled
  accordingly.
 *---------------------------------------------------------------------------*/

#pragma once

#include <OnlineCore/src/Platform/Core/PlatformDecl.h>
#include "DataStoreCompletePostParamV1DDL.h"
#include "DataStorePreparePostParamV1DDL.h"

BEGIN_NAMESPACE_NEX

/*!
    @internal
    @brief      CompletePostObjectで使用するパラメータを表すクラスです。
*/
class DataStoreCompletePostParamV1: public DDLCLASS(DataStoreCompletePostParamV1)
{
public:
    /*!
        @brief      コンストラクタです。
    */
    DataStoreCompletePostParamV1()
    {
        SetDataId(DataStoreConstants::INVALID_DATAID);
        SetIsSuccess(false);
    }

    /*!
        @brief      デストラクタです。
    */
    virtual ~DataStoreCompletePostParamV1() {}

    void SetDataId(qUnsignedInt32 dataId_)
    {
        this->dataId = dataId_;
    }
    qUnsignedInt32 GetDataId() const
    {
        return this->dataId;
    }
    void SetIsSuccess(qBool isSuccess_)
    {
        this->isSuccess = isSuccess_;
    }
    qBool GetIsSuccess() const
    {
        return this->isSuccess;
    }

    /*!
        @brief      対応するPreparePostParamを受け取って必要な情報をセットする

        @param      preparePostParam 対応するPreparePostObjectで使用したオブジェクト
    */
    void SetPreparePostParam(const DataStorePreparePostParamV1& preparePostParam)
    {
        (void)preparePostParam;
    }
};

END_NAMESPACE_NEX

