﻿/*---------------------------------------------------------------------------*
  (C) Copyright 1998-2018, Technologies Quazal Inc.  All rights reserved.
  Quazal Net-Z, Quazal Rendez-Vous and Quazal are trademarks of Quazal.

  Copyright (C)2011-2018 Nintendo  All rights reserved.

  These coded instructions, statements, and computer programs contain
  proprietary information of Nintendo and/or its licensors and are
  protected by national and international copyright laws.
  They may not be disclosed to third parties or copied or duplicated
  in any form, in whole or in part, without the prior written consent
  of Nintendo.
  The content herein is highly confidential and should be handled
  accordingly.
 *---------------------------------------------------------------------------*/

#pragma once

#include <OnlineCore/src/Platform/Core/PlatformDecl.h>

BEGIN_NAMESPACE_NEX

namespace DataStoreConstants
{
// デバッグ用に認証をスキップするためのトークン文字列です。
static const qChar SKIP_TOKEN_STRING[] = NEX_T("skiptoken");

// 認証をスキップしない通常のトークン文字列です。
static const qChar NORMAL_TOKEN_STRING[] = NEX_T("normaltoken");

// HPPで使用する署名の最低Key長。文字列でKeyで与える場合この2倍必要。
static const qUnsignedInt32 MINIMUM_KEY_SIZE = 8;

// 不正な通知URL。このURLをCheckNotificationに指定すると強制的にURLを取得し直す。
static const qChar INVALID_NOTIFICATION_URL[] = NEX_T("invalidurl");
}

END_NAMESPACE_NEX

