#pragma once
#if defined(__ARMCC_VERSION) && (__ARMCC_VERSION >= 5000000)
#pragma push
#pragma diag_suppress 228,381,550,1300,1301,2530
#endif // defined(__ARMCC_VERSION) && (__ARMCC_VERSION >= 5000000)
#if defined(_MSC_VER)
#pragma warning( push )
#pragma warning( disable : 4458 )
#endif // defined(_MSC_VER)

#include <OnlineCore/src/DDLTypes/CGCoreExports.h>
#include "OnlineCore/src/DDLTypes/OnlineCoreTypes.h"
#include "DataStorePermission.h"
#include "DataStoreRatingInfoWithSlotDDL.h"

BEGIN_NAMESPACE_NEX
class DataStoreMetaInfo;
END_NAMESPACE_NEX

BEGIN_NAMESPACE_NEX

class DDLCLASS(DataStoreMetaInfo): public RootObject {
public:
    DDLCLASS(DataStoreMetaInfo)():_mRevision_DataStoreMetaInfo(0)
    , tags(0)    , ratings(0)     {};
    DDLCLASS(DataStoreMetaInfo)(const DDLCLASS(DataStoreMetaInfo) &oOther):
        RootObject(oOther),
        _mRevision_DataStoreMetaInfo(oOther._mRevision_DataStoreMetaInfo),
        dataId(oOther.dataId),
        ownerId(oOther.ownerId),
        size(oOther.size),
        name(oOther.name),
        dataType(oOther.dataType),
        metaBinary(oOther.metaBinary),
        permission(oOther.permission),
        delPermission(oOther.delPermission),
        createdTime(oOther.createdTime),
        updatedTime(oOther.updatedTime),
        period(oOther.period),
        status(oOther.status),
        referredCnt(oOther.referredCnt),
        referDataId(oOther.referDataId),
        flag(oOther.flag),
        referredTime(oOther.referredTime),
        expireTime(oOther.expireTime),
        tags(oOther.tags),
        ratings(oOther.ratings)
    {
    }
    virtual ~DDLCLASS(DataStoreMetaInfo)() {};
    const DDLCLASS(DataStoreMetaInfo) &operator=(const DDLCLASS(DataStoreMetaInfo) &oOther);
    qBool operator==(const DDLCLASS(DataStoreMetaInfo) &oOther) const;
    #ifdef OSDK_DLL_SUPPORT
    qBool operator<(const DDLCLASS(DataStoreMetaInfo) &oOther) const;
    #endif
    static void Add(Message *pMessageToSend, const DDLCLASS(DataStoreMetaInfo) &oValue);
    static void Extract(Message *pReceivedMessage, DDLCLASS(DataStoreMetaInfo) *pValue);
    qByte _mRevision_DataStoreMetaInfo;
    qByte GetClassRevision_DataStoreMetaInfo() const {return _mRevision_DataStoreMetaInfo;}
    void SetClassRevision_DataStoreMetaInfo(qByte revision) {_mRevision_DataStoreMetaInfo=revision;}
    static qByte GetKnownMaxClassRevision_DataStoreMetaInfo() {return 0;}
    DDLTYPE(uint64)::CPPType dataId;
    NEX_CLASS_VALID_REVISION_DEF(dataId, 0);
    qBool NEX_CLASS_ISVALID(dataId) const { return true; /* The revision is 0. Always true */}
    DDLTYPE(uint32)::CPPType ownerId;
    NEX_CLASS_VALID_REVISION_DEF(ownerId, 0);
    qBool NEX_CLASS_ISVALID(ownerId) const { return true; /* The revision is 0. Always true */}
    DDLTYPE(uint32)::CPPType size;
    NEX_CLASS_VALID_REVISION_DEF(size, 0);
    qBool NEX_CLASS_ISVALID(size) const { return true; /* The revision is 0. Always true */}
    DDLTYPE(string)::CPPType name;
    NEX_CLASS_VALID_REVISION_DEF(name, 0);
    qBool NEX_CLASS_ISVALID(name) const { return true; /* The revision is 0. Always true */}
    DDLTYPE(uint16)::CPPType dataType;
    NEX_CLASS_VALID_REVISION_DEF(dataType, 0);
    qBool NEX_CLASS_ISVALID(dataType) const { return true; /* The revision is 0. Always true */}
    DDLTYPE(qBuffer)::CPPType metaBinary;
    NEX_CLASS_VALID_REVISION_DEF(metaBinary, 0);
    qBool NEX_CLASS_ISVALID(metaBinary) const { return true; /* The revision is 0. Always true */}
    DataStorePermission permission;
    NEX_CLASS_VALID_REVISION_DEF(permission, 0);
    qBool NEX_CLASS_ISVALID(permission) const { return true; /* The revision is 0. Always true */}
    DataStorePermission delPermission;
    NEX_CLASS_VALID_REVISION_DEF(delPermission, 0);
    qBool NEX_CLASS_ISVALID(delPermission) const { return true; /* The revision is 0. Always true */}
    DDLTYPE(datetime)::CPPType createdTime;
    NEX_CLASS_VALID_REVISION_DEF(createdTime, 0);
    qBool NEX_CLASS_ISVALID(createdTime) const { return true; /* The revision is 0. Always true */}
    DDLTYPE(datetime)::CPPType updatedTime;
    NEX_CLASS_VALID_REVISION_DEF(updatedTime, 0);
    qBool NEX_CLASS_ISVALID(updatedTime) const { return true; /* The revision is 0. Always true */}
    DDLTYPE(uint16)::CPPType period;
    NEX_CLASS_VALID_REVISION_DEF(period, 0);
    qBool NEX_CLASS_ISVALID(period) const { return true; /* The revision is 0. Always true */}
    DDLTYPE(byte)::CPPType status;
    NEX_CLASS_VALID_REVISION_DEF(status, 0);
    qBool NEX_CLASS_ISVALID(status) const { return true; /* The revision is 0. Always true */}
    DDLTYPE(uint32)::CPPType referredCnt;
    NEX_CLASS_VALID_REVISION_DEF(referredCnt, 0);
    qBool NEX_CLASS_ISVALID(referredCnt) const { return true; /* The revision is 0. Always true */}
    DDLTYPE(uint32)::CPPType referDataId;
    NEX_CLASS_VALID_REVISION_DEF(referDataId, 0);
    qBool NEX_CLASS_ISVALID(referDataId) const { return true; /* The revision is 0. Always true */}
    DDLTYPE(uint32)::CPPType flag;
    NEX_CLASS_VALID_REVISION_DEF(flag, 0);
    qBool NEX_CLASS_ISVALID(flag) const { return true; /* The revision is 0. Always true */}
    DDLTYPE(datetime)::CPPType referredTime;
    NEX_CLASS_VALID_REVISION_DEF(referredTime, 0);
    qBool NEX_CLASS_ISVALID(referredTime) const { return true; /* The revision is 0. Always true */}
    DDLTYPE(datetime)::CPPType expireTime;
    NEX_CLASS_VALID_REVISION_DEF(expireTime, 0);
    qBool NEX_CLASS_ISVALID(expireTime) const { return true; /* The revision is 0. Always true */}
    DDLTYPE(qvector)< DDLTYPE(string) >::CPPType tags;
    NEX_CLASS_VALID_REVISION_DEF(tags, 0);
    qBool NEX_CLASS_ISVALID(tags) const { return true; /* The revision is 0. Always true */}
    DDLTYPE(qvector)< CLASSMETATYPE(DataStoreRatingInfoWithSlot) >::CPPType ratings;
    NEX_CLASS_VALID_REVISION_DEF(ratings, 0);
    qBool NEX_CLASS_ISVALID(ratings) const { return true; /* The revision is 0. Always true */}
};


class DDLTYPE(DataStoreMetaInfo): public DDLType {
public:
    typedef DataStoreMetaInfo CPPType;
    static void Add(Message* pMessageToSend, const DDLCLASS(DataStoreMetaInfo)& oDataStoreMetaInfo) {
        DDLCLASS(DataStoreMetaInfo)::Add(pMessageToSend,oDataStoreMetaInfo);
    }
    static void Extract(Message* pReceivedMessage, DDLCLASS(DataStoreMetaInfo)* pDataStoreMetaInfoToRefresh) {
        DDLCLASS(DataStoreMetaInfo)::Extract(pReceivedMessage,pDataStoreMetaInfoToRefresh);
    }
};


END_NAMESPACE_NEX

#if defined(__ARMCC_VERSION) && (__ARMCC_VERSION >= 5000000)
#pragma pop
#endif // defined(__ARMCC_VERSION) && (__ARMCC_VERSION >= 5000000)
#if defined(_MSC_VER)
#pragma warning( pop )
#endif // defined(_MSC_VER)
