﻿/*---------------------------------------------------------------------------*
  (C) Copyright 1998-2018, Technologies Quazal Inc.  All rights reserved.
  Quazal Net-Z, Quazal Rendez-Vous and Quazal are trademarks of Quazal.

  Copyright (C)2011-2018 Nintendo  All rights reserved.

  These coded instructions, statements, and computer programs contain
  proprietary information of Nintendo and/or its licensors and are
  protected by national and international copyright laws.
  They may not be disclosed to third parties or copied or duplicated
  in any form, in whole or in part, without the prior written consent
  of Nintendo.
  The content herein is highly confidential and should be handled
  accordingly.
 *---------------------------------------------------------------------------*/

#pragma once

#include <OnlineCore/src/Platform/Core/PlatformDecl.h>
#include <OnlineCore/src/Platform/Core/NonCopyable.h>
#include <RendezVous/Services/Jugem/DataStore/src/HttpClient/ServiceHttpClient.h>

BEGIN_NAMESPACE_NEX

class CallContext;
class Buffer;
class ClientProtocol;

class DataStoreHppClient : public RootObject, public NonCopyable
{
public:
    DataStoreHppClient();
    virtual ~DataStoreHppClient();

    qResult Request(CallContext* pCC, ClientProtocol* protocol, const Buffer& buffer,
                    qUnsignedInt32 hppHttpThreadPriority, PrincipalID principalId, const String& password, const String& accessKey,
                    const String& hppUrl, TimeInterval timeoutMilliSecond, ServiceHttpClient::PriorityType priorityType);
};

END_NAMESPACE_NEX

