﻿/*---------------------------------------------------------------------------*
  Copyright (C)2011-2018 Nintendo Co., Ltd.  All rights reserved.

  These coded instructions, statements, and computer programs contain
  proprietary information of Nintendo of America Inc. and/or Nintendo
  Company Ltd., and are protected by Federal copyright law.  They may
  not be disclosed to third parties or copied or duplicated in any form,
  in whole or in part, without the prior written consent of Nintendo.
 *---------------------------------------------------------------------------*/

#pragma once

#include <OnlineCore/src/Platform/Core/PlatformDecl.h>
#include <OnlineCore/src/Platform/Core/NonCopyable.h>

namespace nn {
    class Result;
    namespace account {
        struct UserHandle;
}}

BEGIN_NAMESPACE_NEX

class CallContext;

class AcquireNsaIdTokenClient : public RootObject, public NonCopyable
{
public:
    AcquireNsaIdTokenClient();
    virtual ~AcquireNsaIdTokenClient();

    qBool AcquireNsaIdToken(CallContext* pCC, const nn::account::UserHandle* pUserHandle,
        String* pNsaIdToken, uint64_t* pNsaId, nn::Result* pAccountResult);

};

END_NAMESPACE_NEX

