#pragma once
#if defined(__ARMCC_VERSION) && (__ARMCC_VERSION >= 5000000)
#pragma push
#pragma diag_suppress 228,381,550,1300,1301,2530
#endif // defined(__ARMCC_VERSION) && (__ARMCC_VERSION >= 5000000)
#if defined(_MSC_VER)
#pragma warning( push )
#pragma warning( disable : 4458 )
#endif // defined(_MSC_VER)

#include <OnlineCore/src/DDLTypes/CGCoreExports.h>
#include "RendezVous/Services/MatchMaking/src/Common/MatchMakingServiceProperties.h"
#include "RendezVous/Services/MatchMaking/src/Common/Gathering.h"
#include "OnlineCore/src/DDLTypes/OnlineCoreTypes.h"

BEGIN_NAMESPACE_NEX
class Community;
END_NAMESPACE_NEX

BEGIN_NAMESPACE_NEX

class DDLCLASS(Community): public Gathering {
public:
    DDLCLASS(Community)():_mRevision_Community(0)
    , m_Attribs(0)    , m_ApplicationBuffer(0)     {};
    DDLCLASS(Community)(const DDLCLASS(Community) &oOther):
        Gathering(oOther),
        _mRevision_Community(oOther._mRevision_Community),
        m_CommunityType(oOther.m_CommunityType),
        m_Password(oOther.m_Password),
        m_Attribs(oOther.m_Attribs),
        m_ApplicationBuffer(oOther.m_ApplicationBuffer),
        m_ParticipationStartDate(oOther.m_ParticipationStartDate),
        m_ParticipationEndDate(oOther.m_ParticipationEndDate),
        m_MatchmakeSessionCount(oOther.m_MatchmakeSessionCount),
        m_ParticipationCount(oOther.m_ParticipationCount)
    {
    }
    virtual ~DDLCLASS(Community)() {};
    const DDLCLASS(Community) &operator=(const DDLCLASS(Community) &oOther);
    qBool operator==(const DDLCLASS(Community) &oOther) const;
    #ifdef OSDK_DLL_SUPPORT
    qBool operator<(const DDLCLASS(Community) &oOther) const;
    #endif
    static void Add(Message *pMessageToSend, const DDLCLASS(Community) &oValue);
    static void Extract(Message *pReceivedMessage, DDLCLASS(Community) *pValue);
    qByte _mRevision_Community;
    qByte GetClassRevision_Community() const {return _mRevision_Community;}
    void SetClassRevision_Community(qByte revision) {_mRevision_Community=revision;}
    static qByte GetKnownMaxClassRevision_Community() {return 0;}
    DDLTYPE(uint32)::CPPType m_CommunityType;
    NEX_CLASS_VALID_REVISION_DEF(m_CommunityType, 0);
    qBool NEX_CLASS_ISVALID(m_CommunityType) const { return true; /* The revision is 0. Always true */}
    DDLTYPE(string)::CPPType m_Password;
    NEX_CLASS_VALID_REVISION_DEF(m_Password, 0);
    qBool NEX_CLASS_ISVALID(m_Password) const { return true; /* The revision is 0. Always true */}
    DDLTYPE(qvector)< DDLTYPE(uint32) >::CPPType m_Attribs;
    NEX_CLASS_VALID_REVISION_DEF(m_Attribs, 0);
    qBool NEX_CLASS_ISVALID(m_Attribs) const { return true; /* The revision is 0. Always true */}
    DDLTYPE(qvector)< DDLTYPE(byte) >::CPPType m_ApplicationBuffer;
    NEX_CLASS_VALID_REVISION_DEF(m_ApplicationBuffer, 0);
    qBool NEX_CLASS_ISVALID(m_ApplicationBuffer) const { return true; /* The revision is 0. Always true */}
    DDLTYPE(datetime)::CPPType m_ParticipationStartDate;
    NEX_CLASS_VALID_REVISION_DEF(m_ParticipationStartDate, 0);
    qBool NEX_CLASS_ISVALID(m_ParticipationStartDate) const { return true; /* The revision is 0. Always true */}
    DDLTYPE(datetime)::CPPType m_ParticipationEndDate;
    NEX_CLASS_VALID_REVISION_DEF(m_ParticipationEndDate, 0);
    qBool NEX_CLASS_ISVALID(m_ParticipationEndDate) const { return true; /* The revision is 0. Always true */}
    DDLTYPE(uint32)::CPPType m_MatchmakeSessionCount;
    NEX_CLASS_VALID_REVISION_DEF(m_MatchmakeSessionCount, 0);
    qBool NEX_CLASS_ISVALID(m_MatchmakeSessionCount) const { return true; /* The revision is 0. Always true */}
    DDLTYPE(uint32)::CPPType m_ParticipationCount;
    NEX_CLASS_VALID_REVISION_DEF(m_ParticipationCount, 0);
    qBool NEX_CLASS_ISVALID(m_ParticipationCount) const { return true; /* The revision is 0. Always true */}
    public:
	_PR_gathering_methods_pudecl()
    protected:
	_PR_gathering_methods_prdecl()
};


class DDLTYPE(Community): public DDLType {
public:
    typedef Community CPPType;
    static void Add(Message* pMessageToSend, const DDLCLASS(Community)& oCommunity) {
        DDLCLASS(Community)::Add(pMessageToSend,oCommunity);
    }
    static void Extract(Message* pReceivedMessage, DDLCLASS(Community)* pCommunityToRefresh) {
        DDLCLASS(Community)::Extract(pReceivedMessage,pCommunityToRefresh);
    }
};


END_NAMESPACE_NEX

#if defined(__ARMCC_VERSION) && (__ARMCC_VERSION >= 5000000)
#pragma pop
#endif // defined(__ARMCC_VERSION) && (__ARMCC_VERSION >= 5000000)
#if defined(_MSC_VER)
#pragma warning( pop )
#endif // defined(_MSC_VER)
