#pragma once
#if defined(__ARMCC_VERSION) && (__ARMCC_VERSION >= 5000000)
#pragma push
#pragma diag_suppress 228,381,550,1300,1301,2530
#endif // defined(__ARMCC_VERSION) && (__ARMCC_VERSION >= 5000000)
#if defined(_MSC_VER)
#pragma warning( push )
#pragma warning( disable : 4458 )
#endif // defined(_MSC_VER)


#include <OnlineCore/src/DDLTypes/CGCoreExports.h>

#include <RendezVous/Core/src/Common/ClientProtocol.h>
#include <RendezVous/Core/src/Common/ServerProtocol.h>
#include <OnlineCore/src/Core/CallContextRegister.h>
#include <RendezVous/Core/src/Common/ProtocolCGMacros.h>
#include <RendezVous/Core/src/Common/ProtocolCallContext.h>
#include <RendezVous/Core/src/Common/ProtocolRequestBrokerInterface.h>
#include <RendezVous/Core/src/Common/Protocol.h>
#include <RendezVous/Core/src/Common/ProtocolList.h>
#include <OnlineCore/src/Transport/Interface/TransportError.h>
#include <RendezVous/Core/src/Client/RVClientCore.h>
#include <RendezVous/Core/src/Client/ProtocolRegistry.h>
#include "OnlineCore/src/DDLTypes/OnlineCoreTypes.h"
#include "RendezVous/Core/src/Common/ProtocolFoundationTypes.h"
#include "RendezVous/Services/MatchMaking/src/Common/Gathering.h"
#include "MatchmakeSessionSearchCriteria.h"
#include "RendezVous/Core/src/Common/ResultRange.h"
#include "RendezVous/Services/MatchMaking/src/Common/GatheringURLs.h"
#include "RendezVous/Core/src/Common/NotificationEvent.h"
#include "PlayingSession.h"
#include "PersistentGathering.h"
#include "SimplePlayingSession.h"
#include "SimpleCommunity.h"
#include "CreateMatchmakeSessionParam.h"
#include "MatchmakeSession.h"
#include "JoinMatchmakeSessionParam.h"
#include "AutoMatchmakeParam.h"
#include "UpdateMatchmakeSessionParam.h"
#include "FindMatchmakeSessionByParticipantParam.h"
#include "FindMatchmakeSessionByParticipantResult.h"

BEGIN_NAMESPACE_NEX

PROTO_DEFINE_RMCID(MatchmakeExtensionProtocol, CloseParticipation, 1 );
PROTO_DEFINE_RMCID(MatchmakeExtensionProtocol, OpenParticipation, 2 );
PROTO_DEFINE_RMCID(MatchmakeExtensionProtocol, AutoMatchmake_Postpone, 3 );
PROTO_DEFINE_RMCID(MatchmakeExtensionProtocol, BrowseMatchmakeSession, 4 );
PROTO_DEFINE_RMCID(MatchmakeExtensionProtocol, BrowseMatchmakeSessionWithHostUrls, 5 );
PROTO_DEFINE_RMCID(MatchmakeExtensionProtocol, CreateMatchmakeSession, 6 );
PROTO_DEFINE_RMCID(MatchmakeExtensionProtocol, JoinMatchmakeSession, 7 );
PROTO_DEFINE_RMCID(MatchmakeExtensionProtocol, ModifyCurrentGameAttribute, 8 );
PROTO_DEFINE_RMCID(MatchmakeExtensionProtocol, UpdateNotificationData, 9 );
PROTO_DEFINE_RMCID(MatchmakeExtensionProtocol, GetFriendNotificationData, 10 );
PROTO_DEFINE_RMCID(MatchmakeExtensionProtocol, UpdateApplicationBuffer, 11 );
PROTO_DEFINE_RMCID(MatchmakeExtensionProtocol, UpdateMatchmakeSessionAttribute, 12 );
PROTO_DEFINE_RMCID(MatchmakeExtensionProtocol, GetlstFriendNotificationData, 13 );
PROTO_DEFINE_RMCID(MatchmakeExtensionProtocol, UpdateMatchmakeSession, 14 );
PROTO_DEFINE_RMCID(MatchmakeExtensionProtocol, AutoMatchmakeWithSearchCriteria_Postpone, 15 );
PROTO_DEFINE_RMCID(MatchmakeExtensionProtocol, GetPlayingSession, 16 );
PROTO_DEFINE_RMCID(MatchmakeExtensionProtocol, CreateCommunity, 17 );
PROTO_DEFINE_RMCID(MatchmakeExtensionProtocol, UpdateCommunity, 18 );
PROTO_DEFINE_RMCID(MatchmakeExtensionProtocol, JoinCommunity, 19 );
PROTO_DEFINE_RMCID(MatchmakeExtensionProtocol, FindCommunityByGatheringId, 20 );
PROTO_DEFINE_RMCID(MatchmakeExtensionProtocol, FindOfficialCommunity, 21 );
PROTO_DEFINE_RMCID(MatchmakeExtensionProtocol, FindCommunityByParticipant, 22 );
PROTO_DEFINE_RMCID(MatchmakeExtensionProtocol, UpdatePrivacySetting, 23 );
PROTO_DEFINE_RMCID(MatchmakeExtensionProtocol, GetMyBlockList, 24 );
PROTO_DEFINE_RMCID(MatchmakeExtensionProtocol, AddToBlockList, 25 );
PROTO_DEFINE_RMCID(MatchmakeExtensionProtocol, RemoveFromBlockList, 26 );
PROTO_DEFINE_RMCID(MatchmakeExtensionProtocol, ClearMyBlockList, 27 );
PROTO_DEFINE_RMCID(MatchmakeExtensionProtocol, ReportViolation, 28 );
PROTO_DEFINE_RMCID(MatchmakeExtensionProtocol, IsViolationUser, 29 );
PROTO_DEFINE_RMCID(MatchmakeExtensionProtocol, JoinMatchmakeSessionEx, 30 );
PROTO_DEFINE_RMCID(MatchmakeExtensionProtocol, GetSimplePlayingSession, 31 );
PROTO_DEFINE_RMCID(MatchmakeExtensionProtocol, GetSimpleCommunity, 32 );
PROTO_DEFINE_RMCID(MatchmakeExtensionProtocol, AutoMatchmakeWithGatheringId_Postpone, 33 );
PROTO_DEFINE_RMCID(MatchmakeExtensionProtocol, UpdateProgressScore, 34 );
PROTO_DEFINE_RMCID(MatchmakeExtensionProtocol, DebugNotifyEvent, 35 );
PROTO_DEFINE_RMCID(MatchmakeExtensionProtocol, GenerateMatchmakeSessionSystemPassword, 36 );
PROTO_DEFINE_RMCID(MatchmakeExtensionProtocol, ClearMatchmakeSessionSystemPassword, 37 );
PROTO_DEFINE_RMCID(MatchmakeExtensionProtocol, CreateMatchmakeSessionWithParam, 38 );
PROTO_DEFINE_RMCID(MatchmakeExtensionProtocol, JoinMatchmakeSessionWithParam, 39 );
PROTO_DEFINE_RMCID(MatchmakeExtensionProtocol, AutoMatchmakeWithParam_Postpone, 40 );
PROTO_DEFINE_RMCID(MatchmakeExtensionProtocol, FindMatchmakeSessionByGatheringIdDetail, 41 );
PROTO_DEFINE_RMCID(MatchmakeExtensionProtocol, BrowseMatchmakeSessionNoHolder, 42 );
PROTO_DEFINE_RMCID(MatchmakeExtensionProtocol, BrowseMatchmakeSessionWithHostUrlsNoHolder, 43 );
PROTO_DEFINE_RMCID(MatchmakeExtensionProtocol, UpdateMatchmakeSessionPart, 44 );
PROTO_DEFINE_RMCID(MatchmakeExtensionProtocol, RequestMatchmaking, 45 );
PROTO_DEFINE_RMCID(MatchmakeExtensionProtocol, WithdrawMatchmaking, 46 );
PROTO_DEFINE_RMCID(MatchmakeExtensionProtocol, WithdrawMatchmakingAll, 47 );
PROTO_DEFINE_RMCID(MatchmakeExtensionProtocol, FindMatchmakeSessionByGatheringId, 48 );
PROTO_DEFINE_RMCID(MatchmakeExtensionProtocol, FindMatchmakeSessionBySingleGatheringId, 49 );
PROTO_DEFINE_RMCID(MatchmakeExtensionProtocol, FindMatchmakeSessionByOwner, 50 );
PROTO_DEFINE_RMCID(MatchmakeExtensionProtocol, FindMatchmakeSessionByParticipant, 51 );
PROTO_DEFINE_RMCID(MatchmakeExtensionProtocol, BrowseMatchmakeSessionNoHolderNoResultRange, 52 );
PROTO_DEFINE_RMCID(MatchmakeExtensionProtocol, BrowseMatchmakeSessionWithHostUrlsNoHolderNoResultRange, 53 );
PROTO_DEFINE_RMCID(MatchmakeExtensionProtocol, FindCommunityByOwner, 54 );
PROTO_DEFINE_NUM_RMC(MatchmakeExtensionProtocol, 54);

class MatchmakeExtensionProtocolClient : public ClientProtocol {
    public:
        typedef DDLTYPE(uint32) TCloseParticipation_gid;
        PROTO_RMCIMPL_RETURN(MatchmakeExtensionProtocol, CloseParticipation)
        {
            PROTO_RETURNSTUB_IMPL();
            PROTO_RETURNSTUB_END();
        };
        
        typedef DDLTYPE(uint32) TOpenParticipation_gid;
        PROTO_RMCIMPL_RETURN(MatchmakeExtensionProtocol, OpenParticipation)
        {
            PROTO_RETURNSTUB_IMPL();
            PROTO_RETURNSTUB_END();
        };
        
        typedef DDLTYPE(any)< CLASSMETATYPE(Gathering), DDLTYPE(string) > TAutoMatchmake_Postpone_anyGathering;
        typedef DDLTYPE(any)< CLASSMETATYPE(Gathering), DDLTYPE(string) > TAutoMatchmake_Postpone_joinedGathering;
        typedef DDLTYPE(string) TAutoMatchmake_Postpone_strMessage;
        PROTO_RMCIMPL_RETURN(MatchmakeExtensionProtocol, AutoMatchmake_Postpone)
        {
            PROTO_RETURNSTUB_IMPL();
            _DO_RMC_ExtractReturnValue(TAutoMatchmake_Postpone_joinedGathering,1);
            PROTO_RETURNSTUB_END();
        };
        
        typedef CLASSMETATYPE(MatchmakeSessionSearchCriteria) TBrowseMatchmakeSession_searchCriteria;
        typedef CLASSMETATYPE(ResultRange) TBrowseMatchmakeSession_resultRange;
        typedef DDLTYPE(qlist)< DDLTYPE(any)< CLASSMETATYPE(Gathering), DDLTYPE(string) > > TBrowseMatchmakeSession_lstGathering;
        PROTO_RMCIMPL_RETURN(MatchmakeExtensionProtocol, BrowseMatchmakeSession)
        {
            PROTO_RETURNSTUB_IMPL();
            _DO_RMC_ExtractReturnValue(TBrowseMatchmakeSession_lstGathering,1);
            PROTO_RETURNSTUB_END();
        };
        
        typedef CLASSMETATYPE(MatchmakeSessionSearchCriteria) TBrowseMatchmakeSessionWithHostUrls_searchCriteria;
        typedef CLASSMETATYPE(ResultRange) TBrowseMatchmakeSessionWithHostUrls_resultRange;
        typedef DDLTYPE(qlist)< DDLTYPE(any)< CLASSMETATYPE(Gathering), DDLTYPE(string) > > TBrowseMatchmakeSessionWithHostUrls_lstGathering;
        typedef DDLTYPE(qlist)< CLASSMETATYPE(GatheringURLs) > TBrowseMatchmakeSessionWithHostUrls_lstGatheringUrls;
        PROTO_RMCIMPL_RETURN(MatchmakeExtensionProtocol, BrowseMatchmakeSessionWithHostUrls)
        {
            PROTO_RETURNSTUB_IMPL();
            _DO_RMC_ExtractReturnValue(TBrowseMatchmakeSessionWithHostUrls_lstGathering,1);
            _DO_RMC_ExtractReturnValue(TBrowseMatchmakeSessionWithHostUrls_lstGatheringUrls,1);
            PROTO_RETURNSTUB_END();
        };
        
        typedef DDLTYPE(any)< CLASSMETATYPE(Gathering), DDLTYPE(string) > TCreateMatchmakeSession_anyGathering;
        typedef DDLTYPE(uint32) TCreateMatchmakeSession_gid;
        typedef DDLTYPE(string) TCreateMatchmakeSession_strMessage;
        typedef DDLTYPE(qvector)< DDLTYPE(byte) > TCreateMatchmakeSession_sessionKey;
        typedef DDLTYPE(uint16) TCreateMatchmakeSession_participationCount;
        PROTO_RMCIMPL_RETURN(MatchmakeExtensionProtocol, CreateMatchmakeSession)
        {
            PROTO_RETURNSTUB_IMPL();
            _DO_RMC_ExtractReturnValue(TCreateMatchmakeSession_gid,1);
            _DO_RMC_ExtractReturnValue(TCreateMatchmakeSession_sessionKey,1);
            PROTO_RETURNSTUB_END();
        };
        
        typedef DDLTYPE(uint32) TJoinMatchmakeSession_gid;
        typedef DDLTYPE(string) TJoinMatchmakeSession_strMessage;
        typedef DDLTYPE(qvector)< DDLTYPE(byte) > TJoinMatchmakeSession_sessionKey;
        PROTO_RMCIMPL_RETURN(MatchmakeExtensionProtocol, JoinMatchmakeSession)
        {
            PROTO_RETURNSTUB_IMPL();
            _DO_RMC_ExtractReturnValue(TJoinMatchmakeSession_sessionKey,1);
            PROTO_RETURNSTUB_END();
        };
        
        typedef DDLTYPE(uint32) TModifyCurrentGameAttribute_gid;
        typedef DDLTYPE(uint32) TModifyCurrentGameAttribute_attribIndex;
        typedef DDLTYPE(uint32) TModifyCurrentGameAttribute_newValue;
        PROTO_RMCIMPL_RETURN(MatchmakeExtensionProtocol, ModifyCurrentGameAttribute)
        {
            PROTO_RETURNSTUB_IMPL();
            PROTO_RETURNSTUB_END();
        };
        
        typedef DDLTYPE(uint32) TUpdateNotificationData_uiType;
        typedef DDLTYPE(uint64) TUpdateNotificationData_uiParam1;
        typedef DDLTYPE(uint64) TUpdateNotificationData_uiParam2;
        typedef DDLTYPE(string) TUpdateNotificationData_strParam;
        PROTO_RMCIMPL_RETURN(MatchmakeExtensionProtocol, UpdateNotificationData)
        {
            PROTO_RETURNSTUB_IMPL();
            PROTO_RETURNSTUB_END();
        };
        
        typedef DDLTYPE(qlist)< CLASSMETATYPE(NotificationEvent) > TGetFriendNotificationData_dataList;
        typedef DDLTYPE(int32) TGetFriendNotificationData_uiType;
        PROTO_RMCIMPL_RETURN(MatchmakeExtensionProtocol, GetFriendNotificationData)
        {
            PROTO_RETURNSTUB_IMPL();
            _DO_RMC_ExtractReturnValue(TGetFriendNotificationData_dataList,1);
            PROTO_RETURNSTUB_END();
        };
        
        typedef DDLTYPE(uint32) TUpdateApplicationBuffer_gid;
        typedef DDLTYPE(qvector)< DDLTYPE(byte) > TUpdateApplicationBuffer_applicationBuffer;
        PROTO_RMCIMPL_RETURN(MatchmakeExtensionProtocol, UpdateApplicationBuffer)
        {
            PROTO_RETURNSTUB_IMPL();
            PROTO_RETURNSTUB_END();
        };
        
        typedef DDLTYPE(uint32) TUpdateMatchmakeSessionAttribute_gid;
        typedef DDLTYPE(qvector)< DDLTYPE(uint32) > TUpdateMatchmakeSessionAttribute_attribs;
        PROTO_RMCIMPL_RETURN(MatchmakeExtensionProtocol, UpdateMatchmakeSessionAttribute)
        {
            PROTO_RETURNSTUB_IMPL();
            PROTO_RETURNSTUB_END();
        };
        
        typedef DDLTYPE(qlist)< CLASSMETATYPE(NotificationEvent) > TGetlstFriendNotificationData_dataList;
        typedef DDLTYPE(qlist)< DDLTYPE(uint32) > TGetlstFriendNotificationData_lstTypes;
        PROTO_RMCIMPL_RETURN(MatchmakeExtensionProtocol, GetlstFriendNotificationData)
        {
            PROTO_RETURNSTUB_IMPL();
            _DO_RMC_ExtractReturnValue(TGetlstFriendNotificationData_dataList,1);
            PROTO_RETURNSTUB_END();
        };
        
        typedef DDLTYPE(any)< CLASSMETATYPE(Gathering), DDLTYPE(string) > TUpdateMatchmakeSession_anyGathering;
        PROTO_RMCIMPL_RETURN(MatchmakeExtensionProtocol, UpdateMatchmakeSession)
        {
            PROTO_RETURNSTUB_IMPL();
            PROTO_RETURNSTUB_END();
        };
        
        typedef DDLTYPE(qlist)< CLASSMETATYPE(MatchmakeSessionSearchCriteria) > TAutoMatchmakeWithSearchCriteria_Postpone_lstSearchCriteria;
        typedef DDLTYPE(any)< CLASSMETATYPE(Gathering), DDLTYPE(string) > TAutoMatchmakeWithSearchCriteria_Postpone_anyGathering;
        typedef DDLTYPE(any)< CLASSMETATYPE(Gathering), DDLTYPE(string) > TAutoMatchmakeWithSearchCriteria_Postpone_joinedGathering;
        typedef DDLTYPE(string) TAutoMatchmakeWithSearchCriteria_Postpone_strMessage;
        PROTO_RMCIMPL_RETURN(MatchmakeExtensionProtocol, AutoMatchmakeWithSearchCriteria_Postpone)
        {
            PROTO_RETURNSTUB_IMPL();
            _DO_RMC_ExtractReturnValue(TAutoMatchmakeWithSearchCriteria_Postpone_joinedGathering,1);
            PROTO_RETURNSTUB_END();
        };
        
        typedef DDLTYPE(qlist)< DDLTYPE(uint32) > TGetPlayingSession_lstPid;
        typedef DDLTYPE(qlist)< CLASSMETATYPE(PlayingSession) > TGetPlayingSession_lstPlayingSession;
        PROTO_RMCIMPL_RETURN(MatchmakeExtensionProtocol, GetPlayingSession)
        {
            PROTO_RETURNSTUB_IMPL();
            _DO_RMC_ExtractReturnValue(TGetPlayingSession_lstPlayingSession,1);
            PROTO_RETURNSTUB_END();
        };
        
        typedef CLASSMETATYPE(PersistentGathering) TCreateCommunity_community;
        typedef DDLTYPE(uint32) TCreateCommunity_gid;
        typedef DDLTYPE(string) TCreateCommunity_strMessage;
        PROTO_RMCIMPL_RETURN(MatchmakeExtensionProtocol, CreateCommunity)
        {
            PROTO_RETURNSTUB_IMPL();
            _DO_RMC_ExtractReturnValue(TCreateCommunity_gid,1);
            PROTO_RETURNSTUB_END();
        };
        
        typedef CLASSMETATYPE(PersistentGathering) TUpdateCommunity_community;
        PROTO_RMCIMPL_RETURN(MatchmakeExtensionProtocol, UpdateCommunity)
        {
            PROTO_RETURNSTUB_IMPL();
            PROTO_RETURNSTUB_END();
        };
        
        typedef DDLTYPE(uint32) TJoinCommunity_gid;
        typedef DDLTYPE(string) TJoinCommunity_strMessage;
        typedef DDLTYPE(string) TJoinCommunity_strPassword;
        PROTO_RMCIMPL_RETURN(MatchmakeExtensionProtocol, JoinCommunity)
        {
            PROTO_RETURNSTUB_IMPL();
            PROTO_RETURNSTUB_END();
        };
        
        typedef DDLTYPE(qlist)< DDLTYPE(uint32) > TFindCommunityByGatheringId_lstGid;
        typedef DDLTYPE(qlist)< CLASSMETATYPE(PersistentGathering) > TFindCommunityByGatheringId_lstCommunity;
        PROTO_RMCIMPL_RETURN(MatchmakeExtensionProtocol, FindCommunityByGatheringId)
        {
            PROTO_RETURNSTUB_IMPL();
            _DO_RMC_ExtractReturnValue(TFindCommunityByGatheringId_lstCommunity,1);
            PROTO_RETURNSTUB_END();
        };
        
        typedef DDLTYPE(qlist)< CLASSMETATYPE(PersistentGathering) > TFindOfficialCommunity_lstCommunity;
        typedef DDLTYPE(bool) TFindOfficialCommunity_isAvailableOnly;
        typedef CLASSMETATYPE(ResultRange) TFindOfficialCommunity_resultRange;
        PROTO_RMCIMPL_RETURN(MatchmakeExtensionProtocol, FindOfficialCommunity)
        {
            PROTO_RETURNSTUB_IMPL();
            _DO_RMC_ExtractReturnValue(TFindOfficialCommunity_lstCommunity,1);
            PROTO_RETURNSTUB_END();
        };
        
        typedef DDLTYPE(qlist)< CLASSMETATYPE(PersistentGathering) > TFindCommunityByParticipant_lstCommunity;
        typedef DDLTYPE(uint32) TFindCommunityByParticipant_pid;
        typedef CLASSMETATYPE(ResultRange) TFindCommunityByParticipant_resultRange;
        PROTO_RMCIMPL_RETURN(MatchmakeExtensionProtocol, FindCommunityByParticipant)
        {
            PROTO_RETURNSTUB_IMPL();
            _DO_RMC_ExtractReturnValue(TFindCommunityByParticipant_lstCommunity,1);
            PROTO_RETURNSTUB_END();
        };
        
        typedef DDLTYPE(bool) TUpdatePrivacySetting_onlineStatus;
        typedef DDLTYPE(bool) TUpdatePrivacySetting_participationCommunity;
        PROTO_RMCIMPL_RETURN(MatchmakeExtensionProtocol, UpdatePrivacySetting)
        {
            PROTO_RETURNSTUB_IMPL();
            PROTO_RETURNSTUB_END();
        };
        
        typedef DDLTYPE(qlist)< DDLTYPE(uint32) > TGetMyBlockList_lstPrincipalId;
        PROTO_RMCIMPL_RETURN(MatchmakeExtensionProtocol, GetMyBlockList)
        {
            PROTO_RETURNSTUB_IMPL();
            _DO_RMC_ExtractReturnValue(TGetMyBlockList_lstPrincipalId,1);
            PROTO_RETURNSTUB_END();
        };
        
        typedef DDLTYPE(qlist)< DDLTYPE(uint32) > TAddToBlockList_lstPrincipalId;
        PROTO_RMCIMPL_RETURN(MatchmakeExtensionProtocol, AddToBlockList)
        {
            PROTO_RETURNSTUB_IMPL();
            PROTO_RETURNSTUB_END();
        };
        
        typedef DDLTYPE(qlist)< DDLTYPE(uint32) > TRemoveFromBlockList_lstPrincipalId;
        PROTO_RMCIMPL_RETURN(MatchmakeExtensionProtocol, RemoveFromBlockList)
        {
            PROTO_RETURNSTUB_IMPL();
            PROTO_RETURNSTUB_END();
        };
        
        PROTO_RMCIMPL_RETURN(MatchmakeExtensionProtocol, ClearMyBlockList)
        {
            PROTO_RETURNSTUB_IMPL();
            PROTO_RETURNSTUB_END();
        };
        
        typedef DDLTYPE(uint32) TReportViolation_pid;
        typedef DDLTYPE(string) TReportViolation_userName;
        typedef DDLTYPE(uint32) TReportViolation_violationCode;
        PROTO_RMCIMPL_RETURN(MatchmakeExtensionProtocol, ReportViolation)
        {
            PROTO_RETURNSTUB_IMPL();
            PROTO_RETURNSTUB_END();
        };
        
        typedef DDLTYPE(bool) TIsViolationUser_flag;
        typedef DDLTYPE(uint32) TIsViolationUser_score;
        PROTO_RMCIMPL_RETURN(MatchmakeExtensionProtocol, IsViolationUser)
        {
            PROTO_RETURNSTUB_IMPL();
            _DO_RMC_ExtractReturnValue(TIsViolationUser_flag,1);
            _DO_RMC_ExtractReturnValue(TIsViolationUser_score,1);
            PROTO_RETURNSTUB_END();
        };
        
        typedef DDLTYPE(uint32) TJoinMatchmakeSessionEx_gid;
        typedef DDLTYPE(string) TJoinMatchmakeSessionEx_strMessage;
        typedef DDLTYPE(bool) TJoinMatchmakeSessionEx_dontCareMyBlockList;
        typedef DDLTYPE(qvector)< DDLTYPE(byte) > TJoinMatchmakeSessionEx_sessionKey;
        typedef DDLTYPE(uint16) TJoinMatchmakeSessionEx_participationCount;
        PROTO_RMCIMPL_RETURN(MatchmakeExtensionProtocol, JoinMatchmakeSessionEx)
        {
            PROTO_RETURNSTUB_IMPL();
            _DO_RMC_ExtractReturnValue(TJoinMatchmakeSessionEx_sessionKey,1);
            PROTO_RETURNSTUB_END();
        };
        
        typedef DDLTYPE(qlist)< DDLTYPE(uint32) > TGetSimplePlayingSession_lstPrincipalId;
        typedef DDLTYPE(bool) TGetSimplePlayingSession_includeLoginUser;
        typedef DDLTYPE(qlist)< CLASSMETATYPE(SimplePlayingSession) > TGetSimplePlayingSession_lstSimplePlayingSession;
        PROTO_RMCIMPL_RETURN(MatchmakeExtensionProtocol, GetSimplePlayingSession)
        {
            PROTO_RETURNSTUB_IMPL();
            _DO_RMC_ExtractReturnValue(TGetSimplePlayingSession_lstSimplePlayingSession,1);
            PROTO_RETURNSTUB_END();
        };
        
        typedef DDLTYPE(qlist)< DDLTYPE(uint32) > TGetSimpleCommunity_gatheringIdList;
        typedef DDLTYPE(qlist)< CLASSMETATYPE(SimpleCommunity) > TGetSimpleCommunity_lstSimpleCommunityList;
        PROTO_RMCIMPL_RETURN(MatchmakeExtensionProtocol, GetSimpleCommunity)
        {
            PROTO_RETURNSTUB_IMPL();
            _DO_RMC_ExtractReturnValue(TGetSimpleCommunity_lstSimpleCommunityList,1);
            PROTO_RETURNSTUB_END();
        };
        
        typedef DDLTYPE(qlist)< DDLTYPE(uint32) > TAutoMatchmakeWithGatheringId_Postpone_lstGid;
        typedef DDLTYPE(any)< CLASSMETATYPE(Gathering), DDLTYPE(string) > TAutoMatchmakeWithGatheringId_Postpone_anyGathering;
        typedef DDLTYPE(any)< CLASSMETATYPE(Gathering), DDLTYPE(string) > TAutoMatchmakeWithGatheringId_Postpone_joinedGathering;
        typedef DDLTYPE(string) TAutoMatchmakeWithGatheringId_Postpone_strMessage;
        PROTO_RMCIMPL_RETURN(MatchmakeExtensionProtocol, AutoMatchmakeWithGatheringId_Postpone)
        {
            PROTO_RETURNSTUB_IMPL();
            _DO_RMC_ExtractReturnValue(TAutoMatchmakeWithGatheringId_Postpone_joinedGathering,1);
            PROTO_RETURNSTUB_END();
        };
        
        typedef DDLTYPE(uint32) TUpdateProgressScore_gid;
        typedef DDLTYPE(byte) TUpdateProgressScore_progressScore;
        PROTO_RMCIMPL_RETURN(MatchmakeExtensionProtocol, UpdateProgressScore)
        {
            PROTO_RETURNSTUB_IMPL();
            PROTO_RETURNSTUB_END();
        };
        
        typedef DDLTYPE(uint32) TDebugNotifyEvent_pid;
        typedef DDLTYPE(uint32) TDebugNotifyEvent_mainType;
        typedef DDLTYPE(uint32) TDebugNotifyEvent_subType;
        typedef DDLTYPE(uint64) TDebugNotifyEvent_param1;
        typedef DDLTYPE(uint64) TDebugNotifyEvent_param2;
        typedef DDLTYPE(string) TDebugNotifyEvent_stringParam;
        PROTO_RMCIMPL_RETURN(MatchmakeExtensionProtocol, DebugNotifyEvent)
        {
            PROTO_RETURNSTUB_IMPL();
            PROTO_RETURNSTUB_END();
        };
        
        typedef DDLTYPE(uint32) TGenerateMatchmakeSessionSystemPassword_gid;
        typedef DDLTYPE(string) TGenerateMatchmakeSessionSystemPassword_password;
        PROTO_RMCIMPL_RETURN(MatchmakeExtensionProtocol, GenerateMatchmakeSessionSystemPassword)
        {
            PROTO_RETURNSTUB_IMPL();
            _DO_RMC_ExtractReturnValue(TGenerateMatchmakeSessionSystemPassword_password,1);
            PROTO_RETURNSTUB_END();
        };
        
        typedef DDLTYPE(uint32) TClearMatchmakeSessionSystemPassword_gid;
        PROTO_RMCIMPL_RETURN(MatchmakeExtensionProtocol, ClearMatchmakeSessionSystemPassword)
        {
            PROTO_RETURNSTUB_IMPL();
            PROTO_RETURNSTUB_END();
        };
        
        typedef CLASSMETATYPE(CreateMatchmakeSessionParam) TCreateMatchmakeSessionWithParam_createMatchmakeSessionParam;
        typedef CLASSMETATYPE(MatchmakeSession) TCreateMatchmakeSessionWithParam_joinedMatchmakeSession;
        PROTO_RMCIMPL_RETURN(MatchmakeExtensionProtocol, CreateMatchmakeSessionWithParam)
        {
            PROTO_RETURNSTUB_IMPL();
            _DO_RMC_ExtractReturnValue(TCreateMatchmakeSessionWithParam_joinedMatchmakeSession,1);
            PROTO_RETURNSTUB_END();
        };
        
        typedef CLASSMETATYPE(JoinMatchmakeSessionParam) TJoinMatchmakeSessionWithParam_joinMatchmakeSessionParam;
        typedef CLASSMETATYPE(MatchmakeSession) TJoinMatchmakeSessionWithParam_joinedMatchmakeSession;
        PROTO_RMCIMPL_RETURN(MatchmakeExtensionProtocol, JoinMatchmakeSessionWithParam)
        {
            PROTO_RETURNSTUB_IMPL();
            _DO_RMC_ExtractReturnValue(TJoinMatchmakeSessionWithParam_joinedMatchmakeSession,1);
            PROTO_RETURNSTUB_END();
        };
        
        typedef CLASSMETATYPE(AutoMatchmakeParam) TAutoMatchmakeWithParam_Postpone_autoMatchmakeParam;
        typedef CLASSMETATYPE(MatchmakeSession) TAutoMatchmakeWithParam_Postpone_joinedMatchmakeSession;
        PROTO_RMCIMPL_RETURN(MatchmakeExtensionProtocol, AutoMatchmakeWithParam_Postpone)
        {
            PROTO_RETURNSTUB_IMPL();
            _DO_RMC_ExtractReturnValue(TAutoMatchmakeWithParam_Postpone_joinedMatchmakeSession,1);
            PROTO_RETURNSTUB_END();
        };
        
        typedef DDLTYPE(uint32) TFindMatchmakeSessionByGatheringIdDetail_gid;
        typedef CLASSMETATYPE(MatchmakeSession) TFindMatchmakeSessionByGatheringIdDetail_matchmakeSession;
        PROTO_RMCIMPL_RETURN(MatchmakeExtensionProtocol, FindMatchmakeSessionByGatheringIdDetail)
        {
            PROTO_RETURNSTUB_IMPL();
            _DO_RMC_ExtractReturnValue(TFindMatchmakeSessionByGatheringIdDetail_matchmakeSession,1);
            PROTO_RETURNSTUB_END();
        };
        
        typedef CLASSMETATYPE(MatchmakeSessionSearchCriteria) TBrowseMatchmakeSessionNoHolder_searchCriteria;
        typedef CLASSMETATYPE(ResultRange) TBrowseMatchmakeSessionNoHolder_resultRange;
        typedef DDLTYPE(qlist)< CLASSMETATYPE(MatchmakeSession) > TBrowseMatchmakeSessionNoHolder_lstMatchmakeSession;
        PROTO_RMCIMPL_RETURN(MatchmakeExtensionProtocol, BrowseMatchmakeSessionNoHolder)
        {
            PROTO_RETURNSTUB_IMPL();
            _DO_RMC_ExtractReturnValue(TBrowseMatchmakeSessionNoHolder_lstMatchmakeSession,1);
            PROTO_RETURNSTUB_END();
        };
        
        typedef CLASSMETATYPE(MatchmakeSessionSearchCriteria) TBrowseMatchmakeSessionWithHostUrlsNoHolder_searchCriteria;
        typedef CLASSMETATYPE(ResultRange) TBrowseMatchmakeSessionWithHostUrlsNoHolder_resultRange;
        typedef DDLTYPE(qlist)< CLASSMETATYPE(MatchmakeSession) > TBrowseMatchmakeSessionWithHostUrlsNoHolder_lstMatchmakeSession;
        typedef DDLTYPE(qlist)< CLASSMETATYPE(GatheringURLs) > TBrowseMatchmakeSessionWithHostUrlsNoHolder_lstGatheringUrls;
        PROTO_RMCIMPL_RETURN(MatchmakeExtensionProtocol, BrowseMatchmakeSessionWithHostUrlsNoHolder)
        {
            PROTO_RETURNSTUB_IMPL();
            _DO_RMC_ExtractReturnValue(TBrowseMatchmakeSessionWithHostUrlsNoHolder_lstMatchmakeSession,1);
            _DO_RMC_ExtractReturnValue(TBrowseMatchmakeSessionWithHostUrlsNoHolder_lstGatheringUrls,1);
            PROTO_RETURNSTUB_END();
        };
        
        typedef CLASSMETATYPE(UpdateMatchmakeSessionParam) TUpdateMatchmakeSessionPart_updateMatchmakeSessionParam;
        PROTO_RMCIMPL_RETURN(MatchmakeExtensionProtocol, UpdateMatchmakeSessionPart)
        {
            PROTO_RETURNSTUB_IMPL();
            PROTO_RETURNSTUB_END();
        };
        
        typedef CLASSMETATYPE(AutoMatchmakeParam) TRequestMatchmaking_autoMatchmakeParam;
        typedef DDLTYPE(uint64) TRequestMatchmaking_requestId;
        PROTO_RMCIMPL_RETURN(MatchmakeExtensionProtocol, RequestMatchmaking)
        {
            PROTO_RETURNSTUB_IMPL();
            _DO_RMC_ExtractReturnValue(TRequestMatchmaking_requestId,1);
            PROTO_RETURNSTUB_END();
        };
        
        typedef DDLTYPE(uint64) TWithdrawMatchmaking_requestId;
        PROTO_RMCIMPL_RETURN(MatchmakeExtensionProtocol, WithdrawMatchmaking)
        {
            PROTO_RETURNSTUB_IMPL();
            PROTO_RETURNSTUB_END();
        };
        
        PROTO_RMCIMPL_RETURN(MatchmakeExtensionProtocol, WithdrawMatchmakingAll)
        {
            PROTO_RETURNSTUB_IMPL();
            PROTO_RETURNSTUB_END();
        };
        
        typedef DDLTYPE(qlist)< DDLTYPE(uint32) > TFindMatchmakeSessionByGatheringId_lstGid;
        typedef DDLTYPE(qlist)< CLASSMETATYPE(MatchmakeSession) > TFindMatchmakeSessionByGatheringId_lstMatchmakeSession;
        PROTO_RMCIMPL_RETURN(MatchmakeExtensionProtocol, FindMatchmakeSessionByGatheringId)
        {
            PROTO_RETURNSTUB_IMPL();
            _DO_RMC_ExtractReturnValue(TFindMatchmakeSessionByGatheringId_lstMatchmakeSession,1);
            PROTO_RETURNSTUB_END();
        };
        
        typedef DDLTYPE(uint32) TFindMatchmakeSessionBySingleGatheringId_gid;
        typedef CLASSMETATYPE(MatchmakeSession) TFindMatchmakeSessionBySingleGatheringId_matchmakeSession;
        PROTO_RMCIMPL_RETURN(MatchmakeExtensionProtocol, FindMatchmakeSessionBySingleGatheringId)
        {
            PROTO_RETURNSTUB_IMPL();
            _DO_RMC_ExtractReturnValue(TFindMatchmakeSessionBySingleGatheringId_matchmakeSession,1);
            PROTO_RETURNSTUB_END();
        };
        
        typedef DDLTYPE(uint32) TFindMatchmakeSessionByOwner_id;
        typedef CLASSMETATYPE(ResultRange) TFindMatchmakeSessionByOwner_resultRange;
        typedef DDLTYPE(qlist)< CLASSMETATYPE(MatchmakeSession) > TFindMatchmakeSessionByOwner_lstMatchmakeSession;
        PROTO_RMCIMPL_RETURN(MatchmakeExtensionProtocol, FindMatchmakeSessionByOwner)
        {
            PROTO_RETURNSTUB_IMPL();
            _DO_RMC_ExtractReturnValue(TFindMatchmakeSessionByOwner_lstMatchmakeSession,1);
            PROTO_RETURNSTUB_END();
        };
        
        typedef CLASSMETATYPE(FindMatchmakeSessionByParticipantParam) TFindMatchmakeSessionByParticipant_param;
        typedef DDLTYPE(qlist)< CLASSMETATYPE(FindMatchmakeSessionByParticipantResult) > TFindMatchmakeSessionByParticipant_lstSession;
        PROTO_RMCIMPL_RETURN(MatchmakeExtensionProtocol, FindMatchmakeSessionByParticipant)
        {
            PROTO_RETURNSTUB_IMPL();
            _DO_RMC_ExtractReturnValue(TFindMatchmakeSessionByParticipant_lstSession,1);
            PROTO_RETURNSTUB_END();
        };
        
        typedef CLASSMETATYPE(MatchmakeSessionSearchCriteria) TBrowseMatchmakeSessionNoHolderNoResultRange_searchCriteria;
        typedef DDLTYPE(qlist)< CLASSMETATYPE(MatchmakeSession) > TBrowseMatchmakeSessionNoHolderNoResultRange_lstMatchmakeSession;
        PROTO_RMCIMPL_RETURN(MatchmakeExtensionProtocol, BrowseMatchmakeSessionNoHolderNoResultRange)
        {
            PROTO_RETURNSTUB_IMPL();
            _DO_RMC_ExtractReturnValue(TBrowseMatchmakeSessionNoHolderNoResultRange_lstMatchmakeSession,1);
            PROTO_RETURNSTUB_END();
        };
        
        typedef CLASSMETATYPE(MatchmakeSessionSearchCriteria) TBrowseMatchmakeSessionWithHostUrlsNoHolderNoResultRange_searchCriteria;
        typedef DDLTYPE(qlist)< CLASSMETATYPE(MatchmakeSession) > TBrowseMatchmakeSessionWithHostUrlsNoHolderNoResultRange_lstMatchmakeSession;
        typedef DDLTYPE(qlist)< CLASSMETATYPE(GatheringURLs) > TBrowseMatchmakeSessionWithHostUrlsNoHolderNoResultRange_lstGatheringUrls;
        PROTO_RMCIMPL_RETURN(MatchmakeExtensionProtocol, BrowseMatchmakeSessionWithHostUrlsNoHolderNoResultRange)
        {
            PROTO_RETURNSTUB_IMPL();
            _DO_RMC_ExtractReturnValue(TBrowseMatchmakeSessionWithHostUrlsNoHolderNoResultRange_lstMatchmakeSession,1);
            _DO_RMC_ExtractReturnValue(TBrowseMatchmakeSessionWithHostUrlsNoHolderNoResultRange_lstGatheringUrls,1);
            PROTO_RETURNSTUB_END();
        };
        
        typedef DDLTYPE(qlist)< CLASSMETATYPE(PersistentGathering) > TFindCommunityByOwner_lstCommunity;
        typedef DDLTYPE(uint32) TFindCommunityByOwner_id;
        typedef CLASSMETATYPE(ResultRange) TFindCommunityByOwner_resultRange;
        PROTO_RMCIMPL_RETURN(MatchmakeExtensionProtocol, FindCommunityByOwner)
        {
            PROTO_RETURNSTUB_IMPL();
            _DO_RMC_ExtractReturnValue(TFindCommunityByOwner_lstCommunity,1);
            PROTO_RETURNSTUB_END();
        };
        
        MatchmakeExtensionProtocolClient(ProtocolID uiProtocolID);
        virtual ClientProtocol* CreateResponder() const { return qNew MatchmakeExtensionProtocolClient(ProtocolList::Unknown); }
        void RegisterProtocol()
        {
            SYSTEMCHECK(GetProtocolID() != ProtocolList::Unknown);
            SYSTEMCHECK(RVClientCore::GetInstance() != NULL && "You should create ServiceClient or NgsFacade(RendezVous) first.");
            RVClientCore::GetInstance()->GetProtocolRegistry()->RegisterProtocol(GetProtocolID(), CreateResponder());
        }
        virtual void ExtractCallSpecificResults(Message *pMessage, ProtocolCallContext* pContext);
        
        qBool CallCloseParticipation(ProtocolCallContext *pContext, const DDLTYPE(uint32)::CPPType& gid);
        static qBool CloseParticipation_PrepareRequest(ProtocolCallContext *pContext, Message *pMsg, const DDLTYPE(uint32)::CPPType& gid);
        qBool CallOpenParticipation(ProtocolCallContext *pContext, const DDLTYPE(uint32)::CPPType& gid);
        static qBool OpenParticipation_PrepareRequest(ProtocolCallContext *pContext, Message *pMsg, const DDLTYPE(uint32)::CPPType& gid);
        qBool CallAutoMatchmake_Postpone(ProtocolCallContext *pContext, const DDLTYPE(any)< CLASSMETATYPE(Gathering), DDLTYPE(string) >::CPPType& anyGathering, DDLTYPE(any)< CLASSMETATYPE(Gathering), DDLTYPE(string) >::CPPType* joinedGathering, const DDLTYPE(string)::CPPType& strMessage);
        static qBool AutoMatchmake_Postpone_PrepareRequest(ProtocolCallContext *pContext, Message *pMsg, const DDLTYPE(any)< CLASSMETATYPE(Gathering), DDLTYPE(string) >::CPPType& anyGathering, DDLTYPE(any)< CLASSMETATYPE(Gathering), DDLTYPE(string) >::CPPType* joinedGathering, const DDLTYPE(string)::CPPType& strMessage);
        qBool CallBrowseMatchmakeSession(ProtocolCallContext *pContext, const MatchmakeSessionSearchCriteria& searchCriteria, const ResultRange& resultRange, DDLTYPE(qlist)< DDLTYPE(any)< CLASSMETATYPE(Gathering), DDLTYPE(string) > >::CPPType* lstGathering);
        static qBool BrowseMatchmakeSession_PrepareRequest(ProtocolCallContext *pContext, Message *pMsg, const MatchmakeSessionSearchCriteria& searchCriteria, const ResultRange& resultRange, DDLTYPE(qlist)< DDLTYPE(any)< CLASSMETATYPE(Gathering), DDLTYPE(string) > >::CPPType* lstGathering);
        qBool CallBrowseMatchmakeSessionWithHostUrls(ProtocolCallContext *pContext, const MatchmakeSessionSearchCriteria& searchCriteria, const ResultRange& resultRange, DDLTYPE(qlist)< DDLTYPE(any)< CLASSMETATYPE(Gathering), DDLTYPE(string) > >::CPPType* lstGathering, DDLTYPE(qlist)< CLASSMETATYPE(GatheringURLs) >::CPPType* lstGatheringUrls);
        static qBool BrowseMatchmakeSessionWithHostUrls_PrepareRequest(ProtocolCallContext *pContext, Message *pMsg, const MatchmakeSessionSearchCriteria& searchCriteria, const ResultRange& resultRange, DDLTYPE(qlist)< DDLTYPE(any)< CLASSMETATYPE(Gathering), DDLTYPE(string) > >::CPPType* lstGathering, DDLTYPE(qlist)< CLASSMETATYPE(GatheringURLs) >::CPPType* lstGatheringUrls);
        qBool CallCreateMatchmakeSession(ProtocolCallContext *pContext, const DDLTYPE(any)< CLASSMETATYPE(Gathering), DDLTYPE(string) >::CPPType& anyGathering, DDLTYPE(uint32)::CPPType* gid, const DDLTYPE(string)::CPPType& strMessage, DDLTYPE(qvector)< DDLTYPE(byte) >::CPPType* sessionKey, const DDLTYPE(uint16)::CPPType& participationCount);
        static qBool CreateMatchmakeSession_PrepareRequest(ProtocolCallContext *pContext, Message *pMsg, const DDLTYPE(any)< CLASSMETATYPE(Gathering), DDLTYPE(string) >::CPPType& anyGathering, DDLTYPE(uint32)::CPPType* gid, const DDLTYPE(string)::CPPType& strMessage, DDLTYPE(qvector)< DDLTYPE(byte) >::CPPType* sessionKey, const DDLTYPE(uint16)::CPPType& participationCount);
        qBool CallJoinMatchmakeSession(ProtocolCallContext *pContext, const DDLTYPE(uint32)::CPPType& gid, const DDLTYPE(string)::CPPType& strMessage, DDLTYPE(qvector)< DDLTYPE(byte) >::CPPType* sessionKey);
        static qBool JoinMatchmakeSession_PrepareRequest(ProtocolCallContext *pContext, Message *pMsg, const DDLTYPE(uint32)::CPPType& gid, const DDLTYPE(string)::CPPType& strMessage, DDLTYPE(qvector)< DDLTYPE(byte) >::CPPType* sessionKey);
        qBool CallModifyCurrentGameAttribute(ProtocolCallContext *pContext, const DDLTYPE(uint32)::CPPType& gid, const DDLTYPE(uint32)::CPPType& attribIndex, const DDLTYPE(uint32)::CPPType& newValue);
        static qBool ModifyCurrentGameAttribute_PrepareRequest(ProtocolCallContext *pContext, Message *pMsg, const DDLTYPE(uint32)::CPPType& gid, const DDLTYPE(uint32)::CPPType& attribIndex, const DDLTYPE(uint32)::CPPType& newValue);
        qBool CallUpdateNotificationData(ProtocolCallContext *pContext, const DDLTYPE(uint32)::CPPType& uiType, const DDLTYPE(uint64)::CPPType& uiParam1, const DDLTYPE(uint64)::CPPType& uiParam2, const DDLTYPE(string)::CPPType& strParam);
        static qBool UpdateNotificationData_PrepareRequest(ProtocolCallContext *pContext, Message *pMsg, const DDLTYPE(uint32)::CPPType& uiType, const DDLTYPE(uint64)::CPPType& uiParam1, const DDLTYPE(uint64)::CPPType& uiParam2, const DDLTYPE(string)::CPPType& strParam);
        qBool CallGetFriendNotificationData(ProtocolCallContext *pContext, DDLTYPE(qlist)< CLASSMETATYPE(NotificationEvent) >::CPPType* dataList, const DDLTYPE(int32)::CPPType& uiType);
        static qBool GetFriendNotificationData_PrepareRequest(ProtocolCallContext *pContext, Message *pMsg, DDLTYPE(qlist)< CLASSMETATYPE(NotificationEvent) >::CPPType* dataList, const DDLTYPE(int32)::CPPType& uiType);
        qBool CallUpdateApplicationBuffer(ProtocolCallContext *pContext, const DDLTYPE(uint32)::CPPType& gid, const DDLTYPE(qvector)< DDLTYPE(byte) >::CPPType& applicationBuffer);
        static qBool UpdateApplicationBuffer_PrepareRequest(ProtocolCallContext *pContext, Message *pMsg, const DDLTYPE(uint32)::CPPType& gid, const DDLTYPE(qvector)< DDLTYPE(byte) >::CPPType& applicationBuffer);
        qBool CallUpdateMatchmakeSessionAttribute(ProtocolCallContext *pContext, const DDLTYPE(uint32)::CPPType& gid, const DDLTYPE(qvector)< DDLTYPE(uint32) >::CPPType& attribs);
        static qBool UpdateMatchmakeSessionAttribute_PrepareRequest(ProtocolCallContext *pContext, Message *pMsg, const DDLTYPE(uint32)::CPPType& gid, const DDLTYPE(qvector)< DDLTYPE(uint32) >::CPPType& attribs);
        qBool CallGetlstFriendNotificationData(ProtocolCallContext *pContext, DDLTYPE(qlist)< CLASSMETATYPE(NotificationEvent) >::CPPType* dataList, const DDLTYPE(qlist)< DDLTYPE(uint32) >::CPPType& lstTypes);
        static qBool GetlstFriendNotificationData_PrepareRequest(ProtocolCallContext *pContext, Message *pMsg, DDLTYPE(qlist)< CLASSMETATYPE(NotificationEvent) >::CPPType* dataList, const DDLTYPE(qlist)< DDLTYPE(uint32) >::CPPType& lstTypes);
        qBool CallUpdateMatchmakeSession(ProtocolCallContext *pContext, const DDLTYPE(any)< CLASSMETATYPE(Gathering), DDLTYPE(string) >::CPPType& anyGathering);
        static qBool UpdateMatchmakeSession_PrepareRequest(ProtocolCallContext *pContext, Message *pMsg, const DDLTYPE(any)< CLASSMETATYPE(Gathering), DDLTYPE(string) >::CPPType& anyGathering);
        qBool CallAutoMatchmakeWithSearchCriteria_Postpone(ProtocolCallContext *pContext, const DDLTYPE(qlist)< CLASSMETATYPE(MatchmakeSessionSearchCriteria) >::CPPType& lstSearchCriteria, const DDLTYPE(any)< CLASSMETATYPE(Gathering), DDLTYPE(string) >::CPPType& anyGathering, DDLTYPE(any)< CLASSMETATYPE(Gathering), DDLTYPE(string) >::CPPType* joinedGathering, const DDLTYPE(string)::CPPType& strMessage);
        static qBool AutoMatchmakeWithSearchCriteria_Postpone_PrepareRequest(ProtocolCallContext *pContext, Message *pMsg, const DDLTYPE(qlist)< CLASSMETATYPE(MatchmakeSessionSearchCriteria) >::CPPType& lstSearchCriteria, const DDLTYPE(any)< CLASSMETATYPE(Gathering), DDLTYPE(string) >::CPPType& anyGathering, DDLTYPE(any)< CLASSMETATYPE(Gathering), DDLTYPE(string) >::CPPType* joinedGathering, const DDLTYPE(string)::CPPType& strMessage);
        qBool CallGetPlayingSession(ProtocolCallContext *pContext, const DDLTYPE(qlist)< DDLTYPE(uint32) >::CPPType& lstPid, DDLTYPE(qlist)< CLASSMETATYPE(PlayingSession) >::CPPType* lstPlayingSession);
        static qBool GetPlayingSession_PrepareRequest(ProtocolCallContext *pContext, Message *pMsg, const DDLTYPE(qlist)< DDLTYPE(uint32) >::CPPType& lstPid, DDLTYPE(qlist)< CLASSMETATYPE(PlayingSession) >::CPPType* lstPlayingSession);
        qBool CallCreateCommunity(ProtocolCallContext *pContext, const PersistentGathering& community, DDLTYPE(uint32)::CPPType* gid, const DDLTYPE(string)::CPPType& strMessage);
        static qBool CreateCommunity_PrepareRequest(ProtocolCallContext *pContext, Message *pMsg, const PersistentGathering& community, DDLTYPE(uint32)::CPPType* gid, const DDLTYPE(string)::CPPType& strMessage);
        qBool CallUpdateCommunity(ProtocolCallContext *pContext, const PersistentGathering& community);
        static qBool UpdateCommunity_PrepareRequest(ProtocolCallContext *pContext, Message *pMsg, const PersistentGathering& community);
        qBool CallJoinCommunity(ProtocolCallContext *pContext, const DDLTYPE(uint32)::CPPType& gid, const DDLTYPE(string)::CPPType& strMessage, const DDLTYPE(string)::CPPType& strPassword);
        static qBool JoinCommunity_PrepareRequest(ProtocolCallContext *pContext, Message *pMsg, const DDLTYPE(uint32)::CPPType& gid, const DDLTYPE(string)::CPPType& strMessage, const DDLTYPE(string)::CPPType& strPassword);
        qBool CallFindCommunityByGatheringId(ProtocolCallContext *pContext, const DDLTYPE(qlist)< DDLTYPE(uint32) >::CPPType& lstGid, DDLTYPE(qlist)< CLASSMETATYPE(PersistentGathering) >::CPPType* lstCommunity);
        static qBool FindCommunityByGatheringId_PrepareRequest(ProtocolCallContext *pContext, Message *pMsg, const DDLTYPE(qlist)< DDLTYPE(uint32) >::CPPType& lstGid, DDLTYPE(qlist)< CLASSMETATYPE(PersistentGathering) >::CPPType* lstCommunity);
        qBool CallFindOfficialCommunity(ProtocolCallContext *pContext, DDLTYPE(qlist)< CLASSMETATYPE(PersistentGathering) >::CPPType* lstCommunity, const DDLTYPE(bool)::CPPType& isAvailableOnly, const ResultRange& resultRange);
        static qBool FindOfficialCommunity_PrepareRequest(ProtocolCallContext *pContext, Message *pMsg, DDLTYPE(qlist)< CLASSMETATYPE(PersistentGathering) >::CPPType* lstCommunity, const DDLTYPE(bool)::CPPType& isAvailableOnly, const ResultRange& resultRange);
        qBool CallFindCommunityByParticipant(ProtocolCallContext *pContext, DDLTYPE(qlist)< CLASSMETATYPE(PersistentGathering) >::CPPType* lstCommunity, const DDLTYPE(uint32)::CPPType& pid, const ResultRange& resultRange);
        static qBool FindCommunityByParticipant_PrepareRequest(ProtocolCallContext *pContext, Message *pMsg, DDLTYPE(qlist)< CLASSMETATYPE(PersistentGathering) >::CPPType* lstCommunity, const DDLTYPE(uint32)::CPPType& pid, const ResultRange& resultRange);
        qBool CallUpdatePrivacySetting(ProtocolCallContext *pContext, const DDLTYPE(bool)::CPPType& onlineStatus, const DDLTYPE(bool)::CPPType& participationCommunity);
        static qBool UpdatePrivacySetting_PrepareRequest(ProtocolCallContext *pContext, Message *pMsg, const DDLTYPE(bool)::CPPType& onlineStatus, const DDLTYPE(bool)::CPPType& participationCommunity);
        qBool CallGetMyBlockList(ProtocolCallContext *pContext, DDLTYPE(qlist)< DDLTYPE(uint32) >::CPPType* lstPrincipalId);
        static qBool GetMyBlockList_PrepareRequest(ProtocolCallContext *pContext, Message *pMsg, DDLTYPE(qlist)< DDLTYPE(uint32) >::CPPType* lstPrincipalId);
        qBool CallAddToBlockList(ProtocolCallContext *pContext, const DDLTYPE(qlist)< DDLTYPE(uint32) >::CPPType& lstPrincipalId);
        static qBool AddToBlockList_PrepareRequest(ProtocolCallContext *pContext, Message *pMsg, const DDLTYPE(qlist)< DDLTYPE(uint32) >::CPPType& lstPrincipalId);
        qBool CallRemoveFromBlockList(ProtocolCallContext *pContext, const DDLTYPE(qlist)< DDLTYPE(uint32) >::CPPType& lstPrincipalId);
        static qBool RemoveFromBlockList_PrepareRequest(ProtocolCallContext *pContext, Message *pMsg, const DDLTYPE(qlist)< DDLTYPE(uint32) >::CPPType& lstPrincipalId);
        qBool CallClearMyBlockList(ProtocolCallContext *pContext);
        static qBool ClearMyBlockList_PrepareRequest(ProtocolCallContext *pContext, Message *pMsg);
        qBool CallReportViolation(ProtocolCallContext *pContext, const DDLTYPE(uint32)::CPPType& pid, const DDLTYPE(string)::CPPType& userName, const DDLTYPE(uint32)::CPPType& violationCode);
        static qBool ReportViolation_PrepareRequest(ProtocolCallContext *pContext, Message *pMsg, const DDLTYPE(uint32)::CPPType& pid, const DDLTYPE(string)::CPPType& userName, const DDLTYPE(uint32)::CPPType& violationCode);
        qBool CallIsViolationUser(ProtocolCallContext *pContext, DDLTYPE(bool)::CPPType* flag, DDLTYPE(uint32)::CPPType* score);
        static qBool IsViolationUser_PrepareRequest(ProtocolCallContext *pContext, Message *pMsg, DDLTYPE(bool)::CPPType* flag, DDLTYPE(uint32)::CPPType* score);
        qBool CallJoinMatchmakeSessionEx(ProtocolCallContext *pContext, const DDLTYPE(uint32)::CPPType& gid, const DDLTYPE(string)::CPPType& strMessage, const DDLTYPE(bool)::CPPType& dontCareMyBlockList, DDLTYPE(qvector)< DDLTYPE(byte) >::CPPType* sessionKey, const DDLTYPE(uint16)::CPPType& participationCount);
        static qBool JoinMatchmakeSessionEx_PrepareRequest(ProtocolCallContext *pContext, Message *pMsg, const DDLTYPE(uint32)::CPPType& gid, const DDLTYPE(string)::CPPType& strMessage, const DDLTYPE(bool)::CPPType& dontCareMyBlockList, DDLTYPE(qvector)< DDLTYPE(byte) >::CPPType* sessionKey, const DDLTYPE(uint16)::CPPType& participationCount);
        qBool CallGetSimplePlayingSession(ProtocolCallContext *pContext, const DDLTYPE(qlist)< DDLTYPE(uint32) >::CPPType& lstPrincipalId, const DDLTYPE(bool)::CPPType& includeLoginUser, DDLTYPE(qlist)< CLASSMETATYPE(SimplePlayingSession) >::CPPType* lstSimplePlayingSession);
        static qBool GetSimplePlayingSession_PrepareRequest(ProtocolCallContext *pContext, Message *pMsg, const DDLTYPE(qlist)< DDLTYPE(uint32) >::CPPType& lstPrincipalId, const DDLTYPE(bool)::CPPType& includeLoginUser, DDLTYPE(qlist)< CLASSMETATYPE(SimplePlayingSession) >::CPPType* lstSimplePlayingSession);
        qBool CallGetSimpleCommunity(ProtocolCallContext *pContext, const DDLTYPE(qlist)< DDLTYPE(uint32) >::CPPType& gatheringIdList, DDLTYPE(qlist)< CLASSMETATYPE(SimpleCommunity) >::CPPType* lstSimpleCommunityList);
        static qBool GetSimpleCommunity_PrepareRequest(ProtocolCallContext *pContext, Message *pMsg, const DDLTYPE(qlist)< DDLTYPE(uint32) >::CPPType& gatheringIdList, DDLTYPE(qlist)< CLASSMETATYPE(SimpleCommunity) >::CPPType* lstSimpleCommunityList);
        qBool CallAutoMatchmakeWithGatheringId_Postpone(ProtocolCallContext *pContext, const DDLTYPE(qlist)< DDLTYPE(uint32) >::CPPType& lstGid, const DDLTYPE(any)< CLASSMETATYPE(Gathering), DDLTYPE(string) >::CPPType& anyGathering, DDLTYPE(any)< CLASSMETATYPE(Gathering), DDLTYPE(string) >::CPPType* joinedGathering, const DDLTYPE(string)::CPPType& strMessage);
        static qBool AutoMatchmakeWithGatheringId_Postpone_PrepareRequest(ProtocolCallContext *pContext, Message *pMsg, const DDLTYPE(qlist)< DDLTYPE(uint32) >::CPPType& lstGid, const DDLTYPE(any)< CLASSMETATYPE(Gathering), DDLTYPE(string) >::CPPType& anyGathering, DDLTYPE(any)< CLASSMETATYPE(Gathering), DDLTYPE(string) >::CPPType* joinedGathering, const DDLTYPE(string)::CPPType& strMessage);
        qBool CallUpdateProgressScore(ProtocolCallContext *pContext, const DDLTYPE(uint32)::CPPType& gid, const DDLTYPE(byte)::CPPType& progressScore);
        static qBool UpdateProgressScore_PrepareRequest(ProtocolCallContext *pContext, Message *pMsg, const DDLTYPE(uint32)::CPPType& gid, const DDLTYPE(byte)::CPPType& progressScore);
        qBool CallDebugNotifyEvent(ProtocolCallContext *pContext, const DDLTYPE(uint32)::CPPType& pid, const DDLTYPE(uint32)::CPPType& mainType, const DDLTYPE(uint32)::CPPType& subType, const DDLTYPE(uint64)::CPPType& param1, const DDLTYPE(uint64)::CPPType& param2, const DDLTYPE(string)::CPPType& stringParam);
        static qBool DebugNotifyEvent_PrepareRequest(ProtocolCallContext *pContext, Message *pMsg, const DDLTYPE(uint32)::CPPType& pid, const DDLTYPE(uint32)::CPPType& mainType, const DDLTYPE(uint32)::CPPType& subType, const DDLTYPE(uint64)::CPPType& param1, const DDLTYPE(uint64)::CPPType& param2, const DDLTYPE(string)::CPPType& stringParam);
        qBool CallGenerateMatchmakeSessionSystemPassword(ProtocolCallContext *pContext, const DDLTYPE(uint32)::CPPType& gid, DDLTYPE(string)::CPPType* password);
        static qBool GenerateMatchmakeSessionSystemPassword_PrepareRequest(ProtocolCallContext *pContext, Message *pMsg, const DDLTYPE(uint32)::CPPType& gid, DDLTYPE(string)::CPPType* password);
        qBool CallClearMatchmakeSessionSystemPassword(ProtocolCallContext *pContext, const DDLTYPE(uint32)::CPPType& gid);
        static qBool ClearMatchmakeSessionSystemPassword_PrepareRequest(ProtocolCallContext *pContext, Message *pMsg, const DDLTYPE(uint32)::CPPType& gid);
        qBool CallCreateMatchmakeSessionWithParam(ProtocolCallContext *pContext, const CreateMatchmakeSessionParam& createMatchmakeSessionParam, MatchmakeSession* joinedMatchmakeSession);
        static qBool CreateMatchmakeSessionWithParam_PrepareRequest(ProtocolCallContext *pContext, Message *pMsg, const CreateMatchmakeSessionParam& createMatchmakeSessionParam, MatchmakeSession* joinedMatchmakeSession);
        qBool CallJoinMatchmakeSessionWithParam(ProtocolCallContext *pContext, const JoinMatchmakeSessionParam& joinMatchmakeSessionParam, MatchmakeSession* joinedMatchmakeSession);
        static qBool JoinMatchmakeSessionWithParam_PrepareRequest(ProtocolCallContext *pContext, Message *pMsg, const JoinMatchmakeSessionParam& joinMatchmakeSessionParam, MatchmakeSession* joinedMatchmakeSession);
        qBool CallAutoMatchmakeWithParam_Postpone(ProtocolCallContext *pContext, const AutoMatchmakeParam& autoMatchmakeParam, MatchmakeSession* joinedMatchmakeSession);
        static qBool AutoMatchmakeWithParam_Postpone_PrepareRequest(ProtocolCallContext *pContext, Message *pMsg, const AutoMatchmakeParam& autoMatchmakeParam, MatchmakeSession* joinedMatchmakeSession);
        qBool CallFindMatchmakeSessionByGatheringIdDetail(ProtocolCallContext *pContext, const DDLTYPE(uint32)::CPPType& gid, MatchmakeSession* matchmakeSession);
        static qBool FindMatchmakeSessionByGatheringIdDetail_PrepareRequest(ProtocolCallContext *pContext, Message *pMsg, const DDLTYPE(uint32)::CPPType& gid, MatchmakeSession* matchmakeSession);
        qBool CallBrowseMatchmakeSessionNoHolder(ProtocolCallContext *pContext, const MatchmakeSessionSearchCriteria& searchCriteria, const ResultRange& resultRange, DDLTYPE(qlist)< CLASSMETATYPE(MatchmakeSession) >::CPPType* lstMatchmakeSession);
        static qBool BrowseMatchmakeSessionNoHolder_PrepareRequest(ProtocolCallContext *pContext, Message *pMsg, const MatchmakeSessionSearchCriteria& searchCriteria, const ResultRange& resultRange, DDLTYPE(qlist)< CLASSMETATYPE(MatchmakeSession) >::CPPType* lstMatchmakeSession);
        qBool CallBrowseMatchmakeSessionWithHostUrlsNoHolder(ProtocolCallContext *pContext, const MatchmakeSessionSearchCriteria& searchCriteria, const ResultRange& resultRange, DDLTYPE(qlist)< CLASSMETATYPE(MatchmakeSession) >::CPPType* lstMatchmakeSession, DDLTYPE(qlist)< CLASSMETATYPE(GatheringURLs) >::CPPType* lstGatheringUrls);
        static qBool BrowseMatchmakeSessionWithHostUrlsNoHolder_PrepareRequest(ProtocolCallContext *pContext, Message *pMsg, const MatchmakeSessionSearchCriteria& searchCriteria, const ResultRange& resultRange, DDLTYPE(qlist)< CLASSMETATYPE(MatchmakeSession) >::CPPType* lstMatchmakeSession, DDLTYPE(qlist)< CLASSMETATYPE(GatheringURLs) >::CPPType* lstGatheringUrls);
        qBool CallUpdateMatchmakeSessionPart(ProtocolCallContext *pContext, const UpdateMatchmakeSessionParam& updateMatchmakeSessionParam);
        static qBool UpdateMatchmakeSessionPart_PrepareRequest(ProtocolCallContext *pContext, Message *pMsg, const UpdateMatchmakeSessionParam& updateMatchmakeSessionParam);
        qBool CallRequestMatchmaking(ProtocolCallContext *pContext, const AutoMatchmakeParam& autoMatchmakeParam, DDLTYPE(uint64)::CPPType* requestId);
        static qBool RequestMatchmaking_PrepareRequest(ProtocolCallContext *pContext, Message *pMsg, const AutoMatchmakeParam& autoMatchmakeParam, DDLTYPE(uint64)::CPPType* requestId);
        qBool CallWithdrawMatchmaking(ProtocolCallContext *pContext, const DDLTYPE(uint64)::CPPType& requestId);
        static qBool WithdrawMatchmaking_PrepareRequest(ProtocolCallContext *pContext, Message *pMsg, const DDLTYPE(uint64)::CPPType& requestId);
        qBool CallWithdrawMatchmakingAll(ProtocolCallContext *pContext);
        static qBool WithdrawMatchmakingAll_PrepareRequest(ProtocolCallContext *pContext, Message *pMsg);
        qBool CallFindMatchmakeSessionByGatheringId(ProtocolCallContext *pContext, const DDLTYPE(qlist)< DDLTYPE(uint32) >::CPPType& lstGid, DDLTYPE(qlist)< CLASSMETATYPE(MatchmakeSession) >::CPPType* lstMatchmakeSession);
        static qBool FindMatchmakeSessionByGatheringId_PrepareRequest(ProtocolCallContext *pContext, Message *pMsg, const DDLTYPE(qlist)< DDLTYPE(uint32) >::CPPType& lstGid, DDLTYPE(qlist)< CLASSMETATYPE(MatchmakeSession) >::CPPType* lstMatchmakeSession);
        qBool CallFindMatchmakeSessionBySingleGatheringId(ProtocolCallContext *pContext, const DDLTYPE(uint32)::CPPType& gid, MatchmakeSession* matchmakeSession);
        static qBool FindMatchmakeSessionBySingleGatheringId_PrepareRequest(ProtocolCallContext *pContext, Message *pMsg, const DDLTYPE(uint32)::CPPType& gid, MatchmakeSession* matchmakeSession);
        qBool CallFindMatchmakeSessionByOwner(ProtocolCallContext *pContext, const DDLTYPE(uint32)::CPPType& id, const ResultRange& resultRange, DDLTYPE(qlist)< CLASSMETATYPE(MatchmakeSession) >::CPPType* lstMatchmakeSession);
        static qBool FindMatchmakeSessionByOwner_PrepareRequest(ProtocolCallContext *pContext, Message *pMsg, const DDLTYPE(uint32)::CPPType& id, const ResultRange& resultRange, DDLTYPE(qlist)< CLASSMETATYPE(MatchmakeSession) >::CPPType* lstMatchmakeSession);
        qBool CallFindMatchmakeSessionByParticipant(ProtocolCallContext *pContext, const FindMatchmakeSessionByParticipantParam& param, DDLTYPE(qlist)< CLASSMETATYPE(FindMatchmakeSessionByParticipantResult) >::CPPType* lstSession);
        static qBool FindMatchmakeSessionByParticipant_PrepareRequest(ProtocolCallContext *pContext, Message *pMsg, const FindMatchmakeSessionByParticipantParam& param, DDLTYPE(qlist)< CLASSMETATYPE(FindMatchmakeSessionByParticipantResult) >::CPPType* lstSession);
        qBool CallBrowseMatchmakeSessionNoHolderNoResultRange(ProtocolCallContext *pContext, const MatchmakeSessionSearchCriteria& searchCriteria, DDLTYPE(qlist)< CLASSMETATYPE(MatchmakeSession) >::CPPType* lstMatchmakeSession);
        static qBool BrowseMatchmakeSessionNoHolderNoResultRange_PrepareRequest(ProtocolCallContext *pContext, Message *pMsg, const MatchmakeSessionSearchCriteria& searchCriteria, DDLTYPE(qlist)< CLASSMETATYPE(MatchmakeSession) >::CPPType* lstMatchmakeSession);
        qBool CallBrowseMatchmakeSessionWithHostUrlsNoHolderNoResultRange(ProtocolCallContext *pContext, const MatchmakeSessionSearchCriteria& searchCriteria, DDLTYPE(qlist)< CLASSMETATYPE(MatchmakeSession) >::CPPType* lstMatchmakeSession, DDLTYPE(qlist)< CLASSMETATYPE(GatheringURLs) >::CPPType* lstGatheringUrls);
        static qBool BrowseMatchmakeSessionWithHostUrlsNoHolderNoResultRange_PrepareRequest(ProtocolCallContext *pContext, Message *pMsg, const MatchmakeSessionSearchCriteria& searchCriteria, DDLTYPE(qlist)< CLASSMETATYPE(MatchmakeSession) >::CPPType* lstMatchmakeSession, DDLTYPE(qlist)< CLASSMETATYPE(GatheringURLs) >::CPPType* lstGatheringUrls);
        qBool CallFindCommunityByOwner(ProtocolCallContext *pContext, DDLTYPE(qlist)< CLASSMETATYPE(PersistentGathering) >::CPPType* lstCommunity, const DDLTYPE(uint32)::CPPType& id, const ResultRange& resultRange);
        static qBool FindCommunityByOwner_PrepareRequest(ProtocolCallContext *pContext, Message *pMsg, DDLTYPE(qlist)< CLASSMETATYPE(PersistentGathering) >::CPPType* lstCommunity, const DDLTYPE(uint32)::CPPType& id, const ResultRange& resultRange);
        
        protected:
        static ProtoReturnFunction s_protoReturnFunctions[PROTO_NUM_RMC(MatchmakeExtensionProtocol) + 1];
};

class DDLPROTOCOL(MatchmakeExtensionProtocolServer) : public ServerProtocol {
    public:
        DDLPROTOCOL(MatchmakeExtensionProtocolServer)()
            : ServerProtocol()
#if defined(LIVE_VERSION)
            , m_CloseParticipationProfilingUnit(NEX_T("MatchmakeExtensionProtocol::CloseParticipation"))
            , m_OpenParticipationProfilingUnit(NEX_T("MatchmakeExtensionProtocol::OpenParticipation"))
            , m_AutoMatchmake_PostponeProfilingUnit(NEX_T("MatchmakeExtensionProtocol::AutoMatchmake_Postpone"))
            , m_BrowseMatchmakeSessionProfilingUnit(NEX_T("MatchmakeExtensionProtocol::BrowseMatchmakeSession"))
            , m_BrowseMatchmakeSessionWithHostUrlsProfilingUnit(NEX_T("MatchmakeExtensionProtocol::BrowseMatchmakeSessionWithHostUrls"))
            , m_CreateMatchmakeSessionProfilingUnit(NEX_T("MatchmakeExtensionProtocol::CreateMatchmakeSession"))
            , m_JoinMatchmakeSessionProfilingUnit(NEX_T("MatchmakeExtensionProtocol::JoinMatchmakeSession"))
            , m_ModifyCurrentGameAttributeProfilingUnit(NEX_T("MatchmakeExtensionProtocol::ModifyCurrentGameAttribute"))
            , m_UpdateNotificationDataProfilingUnit(NEX_T("MatchmakeExtensionProtocol::UpdateNotificationData"))
            , m_GetFriendNotificationDataProfilingUnit(NEX_T("MatchmakeExtensionProtocol::GetFriendNotificationData"))
            , m_UpdateApplicationBufferProfilingUnit(NEX_T("MatchmakeExtensionProtocol::UpdateApplicationBuffer"))
            , m_UpdateMatchmakeSessionAttributeProfilingUnit(NEX_T("MatchmakeExtensionProtocol::UpdateMatchmakeSessionAttribute"))
            , m_GetlstFriendNotificationDataProfilingUnit(NEX_T("MatchmakeExtensionProtocol::GetlstFriendNotificationData"))
            , m_UpdateMatchmakeSessionProfilingUnit(NEX_T("MatchmakeExtensionProtocol::UpdateMatchmakeSession"))
            , m_AutoMatchmakeWithSearchCriteria_PostponeProfilingUnit(NEX_T("MatchmakeExtensionProtocol::AutoMatchmakeWithSearchCriteria_Postpone"))
            , m_GetPlayingSessionProfilingUnit(NEX_T("MatchmakeExtensionProtocol::GetPlayingSession"))
            , m_CreateCommunityProfilingUnit(NEX_T("MatchmakeExtensionProtocol::CreateCommunity"))
            , m_UpdateCommunityProfilingUnit(NEX_T("MatchmakeExtensionProtocol::UpdateCommunity"))
            , m_JoinCommunityProfilingUnit(NEX_T("MatchmakeExtensionProtocol::JoinCommunity"))
            , m_FindCommunityByGatheringIdProfilingUnit(NEX_T("MatchmakeExtensionProtocol::FindCommunityByGatheringId"))
            , m_FindOfficialCommunityProfilingUnit(NEX_T("MatchmakeExtensionProtocol::FindOfficialCommunity"))
            , m_FindCommunityByParticipantProfilingUnit(NEX_T("MatchmakeExtensionProtocol::FindCommunityByParticipant"))
            , m_UpdatePrivacySettingProfilingUnit(NEX_T("MatchmakeExtensionProtocol::UpdatePrivacySetting"))
            , m_GetMyBlockListProfilingUnit(NEX_T("MatchmakeExtensionProtocol::GetMyBlockList"))
            , m_AddToBlockListProfilingUnit(NEX_T("MatchmakeExtensionProtocol::AddToBlockList"))
            , m_RemoveFromBlockListProfilingUnit(NEX_T("MatchmakeExtensionProtocol::RemoveFromBlockList"))
            , m_ClearMyBlockListProfilingUnit(NEX_T("MatchmakeExtensionProtocol::ClearMyBlockList"))
            , m_ReportViolationProfilingUnit(NEX_T("MatchmakeExtensionProtocol::ReportViolation"))
            , m_IsViolationUserProfilingUnit(NEX_T("MatchmakeExtensionProtocol::IsViolationUser"))
            , m_JoinMatchmakeSessionExProfilingUnit(NEX_T("MatchmakeExtensionProtocol::JoinMatchmakeSessionEx"))
            , m_GetSimplePlayingSessionProfilingUnit(NEX_T("MatchmakeExtensionProtocol::GetSimplePlayingSession"))
            , m_GetSimpleCommunityProfilingUnit(NEX_T("MatchmakeExtensionProtocol::GetSimpleCommunity"))
            , m_AutoMatchmakeWithGatheringId_PostponeProfilingUnit(NEX_T("MatchmakeExtensionProtocol::AutoMatchmakeWithGatheringId_Postpone"))
            , m_UpdateProgressScoreProfilingUnit(NEX_T("MatchmakeExtensionProtocol::UpdateProgressScore"))
            , m_DebugNotifyEventProfilingUnit(NEX_T("MatchmakeExtensionProtocol::DebugNotifyEvent"))
            , m_GenerateMatchmakeSessionSystemPasswordProfilingUnit(NEX_T("MatchmakeExtensionProtocol::GenerateMatchmakeSessionSystemPassword"))
            , m_ClearMatchmakeSessionSystemPasswordProfilingUnit(NEX_T("MatchmakeExtensionProtocol::ClearMatchmakeSessionSystemPassword"))
            , m_CreateMatchmakeSessionWithParamProfilingUnit(NEX_T("MatchmakeExtensionProtocol::CreateMatchmakeSessionWithParam"))
            , m_JoinMatchmakeSessionWithParamProfilingUnit(NEX_T("MatchmakeExtensionProtocol::JoinMatchmakeSessionWithParam"))
            , m_AutoMatchmakeWithParam_PostponeProfilingUnit(NEX_T("MatchmakeExtensionProtocol::AutoMatchmakeWithParam_Postpone"))
            , m_FindMatchmakeSessionByGatheringIdDetailProfilingUnit(NEX_T("MatchmakeExtensionProtocol::FindMatchmakeSessionByGatheringIdDetail"))
            , m_BrowseMatchmakeSessionNoHolderProfilingUnit(NEX_T("MatchmakeExtensionProtocol::BrowseMatchmakeSessionNoHolder"))
            , m_BrowseMatchmakeSessionWithHostUrlsNoHolderProfilingUnit(NEX_T("MatchmakeExtensionProtocol::BrowseMatchmakeSessionWithHostUrlsNoHolder"))
            , m_UpdateMatchmakeSessionPartProfilingUnit(NEX_T("MatchmakeExtensionProtocol::UpdateMatchmakeSessionPart"))
            , m_RequestMatchmakingProfilingUnit(NEX_T("MatchmakeExtensionProtocol::RequestMatchmaking"))
            , m_WithdrawMatchmakingProfilingUnit(NEX_T("MatchmakeExtensionProtocol::WithdrawMatchmaking"))
            , m_WithdrawMatchmakingAllProfilingUnit(NEX_T("MatchmakeExtensionProtocol::WithdrawMatchmakingAll"))
            , m_FindMatchmakeSessionByGatheringIdProfilingUnit(NEX_T("MatchmakeExtensionProtocol::FindMatchmakeSessionByGatheringId"))
            , m_FindMatchmakeSessionBySingleGatheringIdProfilingUnit(NEX_T("MatchmakeExtensionProtocol::FindMatchmakeSessionBySingleGatheringId"))
            , m_FindMatchmakeSessionByOwnerProfilingUnit(NEX_T("MatchmakeExtensionProtocol::FindMatchmakeSessionByOwner"))
            , m_FindMatchmakeSessionByParticipantProfilingUnit(NEX_T("MatchmakeExtensionProtocol::FindMatchmakeSessionByParticipant"))
            , m_BrowseMatchmakeSessionNoHolderNoResultRangeProfilingUnit(NEX_T("MatchmakeExtensionProtocol::BrowseMatchmakeSessionNoHolderNoResultRange"))
            , m_BrowseMatchmakeSessionWithHostUrlsNoHolderNoResultRangeProfilingUnit(NEX_T("MatchmakeExtensionProtocol::BrowseMatchmakeSessionWithHostUrlsNoHolderNoResultRange"))
            , m_FindCommunityByOwnerProfilingUnit(NEX_T("MatchmakeExtensionProtocol::FindCommunityByOwner"))
#endif // LIVE_VERSION
            {}
        
        typedef DDLTYPE(uint32) TCloseParticipation_gid;
        PROTO_RMCIMPL_STUB(MatchmakeExtensionProtocol, CloseParticipation)
        {
            PROTO_PREPARE_EXTRACTION();
            DDLTYPE(uint32)::CPPType gid;
            _MSG_EXTRACT_VARIABLE(TCloseParticipation_gid, gid);
            pProtocol->CloseParticipation( gid );
            PROTO_PREPARE_RETURN(MatchmakeExtensionProtocol,CloseParticipation);
        }
        
        typedef DDLTYPE(uint32) TOpenParticipation_gid;
        PROTO_RMCIMPL_STUB(MatchmakeExtensionProtocol, OpenParticipation)
        {
            PROTO_PREPARE_EXTRACTION();
            DDLTYPE(uint32)::CPPType gid;
            _MSG_EXTRACT_VARIABLE(TOpenParticipation_gid, gid);
            pProtocol->OpenParticipation( gid );
            PROTO_PREPARE_RETURN(MatchmakeExtensionProtocol,OpenParticipation);
        }
        
        typedef DDLTYPE(any)< CLASSMETATYPE(Gathering), DDLTYPE(string) > TAutoMatchmake_Postpone_anyGathering;
        typedef DDLTYPE(any)< CLASSMETATYPE(Gathering), DDLTYPE(string) > TAutoMatchmake_Postpone_joinedGathering;
        typedef DDLTYPE(string) TAutoMatchmake_Postpone_strMessage;
        PROTO_RMCIMPL_STUB(MatchmakeExtensionProtocol, AutoMatchmake_Postpone)
        {
            PROTO_PREPARE_EXTRACTION();
            DDLTYPE(any)< CLASSMETATYPE(Gathering), DDLTYPE(string) >::CPPType anyGathering;
            _MSG_EXTRACT_VARIABLE(TAutoMatchmake_Postpone_anyGathering, anyGathering);
            DDLTYPE(any)< CLASSMETATYPE(Gathering), DDLTYPE(string) >::CPPType joinedGathering;
            DDLTYPE(string)::CPPType strMessage;
            _MSG_EXTRACT_VARIABLE(TAutoMatchmake_Postpone_strMessage, strMessage);
            pProtocol->AutoMatchmake_Postpone( anyGathering, &joinedGathering, strMessage );
            PROTO_PREPARE_RETURN(MatchmakeExtensionProtocol,AutoMatchmake_Postpone);
            _MSG_ADD_VARIABLE(TAutoMatchmake_Postpone_joinedGathering, joinedGathering);
        }
        
        typedef CLASSMETATYPE(MatchmakeSessionSearchCriteria) TBrowseMatchmakeSession_searchCriteria;
        typedef CLASSMETATYPE(ResultRange) TBrowseMatchmakeSession_resultRange;
        typedef DDLTYPE(qlist)< DDLTYPE(any)< CLASSMETATYPE(Gathering), DDLTYPE(string) > > TBrowseMatchmakeSession_lstGathering;
        PROTO_RMCIMPL_STUB(MatchmakeExtensionProtocol, BrowseMatchmakeSession)
        {
            PROTO_PREPARE_EXTRACTION();
            MatchmakeSessionSearchCriteria searchCriteria;
            _MSG_EXTRACT_VARIABLE(TBrowseMatchmakeSession_searchCriteria, searchCriteria);
            ResultRange resultRange;
            _MSG_EXTRACT_VARIABLE(TBrowseMatchmakeSession_resultRange, resultRange);
            DDLTYPE(qlist)< DDLTYPE(any)< CLASSMETATYPE(Gathering), DDLTYPE(string) > >::CPPType lstGathering;
            pProtocol->BrowseMatchmakeSession( searchCriteria, resultRange, &lstGathering );
            PROTO_PREPARE_RETURN(MatchmakeExtensionProtocol,BrowseMatchmakeSession);
            _MSG_ADD_VARIABLE(TBrowseMatchmakeSession_lstGathering, lstGathering);
        }
        
        typedef CLASSMETATYPE(MatchmakeSessionSearchCriteria) TBrowseMatchmakeSessionWithHostUrls_searchCriteria;
        typedef CLASSMETATYPE(ResultRange) TBrowseMatchmakeSessionWithHostUrls_resultRange;
        typedef DDLTYPE(qlist)< DDLTYPE(any)< CLASSMETATYPE(Gathering), DDLTYPE(string) > > TBrowseMatchmakeSessionWithHostUrls_lstGathering;
        typedef DDLTYPE(qlist)< CLASSMETATYPE(GatheringURLs) > TBrowseMatchmakeSessionWithHostUrls_lstGatheringUrls;
        PROTO_RMCIMPL_STUB(MatchmakeExtensionProtocol, BrowseMatchmakeSessionWithHostUrls)
        {
            PROTO_PREPARE_EXTRACTION();
            MatchmakeSessionSearchCriteria searchCriteria;
            _MSG_EXTRACT_VARIABLE(TBrowseMatchmakeSessionWithHostUrls_searchCriteria, searchCriteria);
            ResultRange resultRange;
            _MSG_EXTRACT_VARIABLE(TBrowseMatchmakeSessionWithHostUrls_resultRange, resultRange);
            DDLTYPE(qlist)< DDLTYPE(any)< CLASSMETATYPE(Gathering), DDLTYPE(string) > >::CPPType lstGathering;
            DDLTYPE(qlist)< CLASSMETATYPE(GatheringURLs) >::CPPType lstGatheringUrls;
            pProtocol->BrowseMatchmakeSessionWithHostUrls( searchCriteria, resultRange, &lstGathering, &lstGatheringUrls );
            PROTO_PREPARE_RETURN(MatchmakeExtensionProtocol,BrowseMatchmakeSessionWithHostUrls);
            _MSG_ADD_VARIABLE(TBrowseMatchmakeSessionWithHostUrls_lstGathering, lstGathering);
            _MSG_ADD_VARIABLE(TBrowseMatchmakeSessionWithHostUrls_lstGatheringUrls, lstGatheringUrls);
        }
        
        typedef DDLTYPE(any)< CLASSMETATYPE(Gathering), DDLTYPE(string) > TCreateMatchmakeSession_anyGathering;
        typedef DDLTYPE(uint32) TCreateMatchmakeSession_gid;
        typedef DDLTYPE(string) TCreateMatchmakeSession_strMessage;
        typedef DDLTYPE(qvector)< DDLTYPE(byte) > TCreateMatchmakeSession_sessionKey;
        typedef DDLTYPE(uint16) TCreateMatchmakeSession_participationCount;
        PROTO_RMCIMPL_STUB(MatchmakeExtensionProtocol, CreateMatchmakeSession)
        {
            PROTO_PREPARE_EXTRACTION();
            DDLTYPE(any)< CLASSMETATYPE(Gathering), DDLTYPE(string) >::CPPType anyGathering;
            _MSG_EXTRACT_VARIABLE(TCreateMatchmakeSession_anyGathering, anyGathering);
            DDLTYPE(uint32)::CPPType gid;
            DDLTYPE(string)::CPPType strMessage;
            _MSG_EXTRACT_VARIABLE(TCreateMatchmakeSession_strMessage, strMessage);
            DDLTYPE(qvector)< DDLTYPE(byte) >::CPPType sessionKey;
            DDLTYPE(uint16)::CPPType participationCount;
            _MSG_EXTRACT_VARIABLE(TCreateMatchmakeSession_participationCount, participationCount);
            pProtocol->CreateMatchmakeSession( anyGathering, &gid, strMessage, &sessionKey, participationCount );
            PROTO_PREPARE_RETURN(MatchmakeExtensionProtocol,CreateMatchmakeSession);
            _MSG_ADD_VARIABLE(TCreateMatchmakeSession_gid, gid);
            _MSG_ADD_VARIABLE(TCreateMatchmakeSession_sessionKey, sessionKey);
        }
        
        typedef DDLTYPE(uint32) TJoinMatchmakeSession_gid;
        typedef DDLTYPE(string) TJoinMatchmakeSession_strMessage;
        typedef DDLTYPE(qvector)< DDLTYPE(byte) > TJoinMatchmakeSession_sessionKey;
        PROTO_RMCIMPL_STUB(MatchmakeExtensionProtocol, JoinMatchmakeSession)
        {
            PROTO_PREPARE_EXTRACTION();
            DDLTYPE(uint32)::CPPType gid;
            _MSG_EXTRACT_VARIABLE(TJoinMatchmakeSession_gid, gid);
            DDLTYPE(string)::CPPType strMessage;
            _MSG_EXTRACT_VARIABLE(TJoinMatchmakeSession_strMessage, strMessage);
            DDLTYPE(qvector)< DDLTYPE(byte) >::CPPType sessionKey;
            pProtocol->JoinMatchmakeSession( gid, strMessage, &sessionKey );
            PROTO_PREPARE_RETURN(MatchmakeExtensionProtocol,JoinMatchmakeSession);
            _MSG_ADD_VARIABLE(TJoinMatchmakeSession_sessionKey, sessionKey);
        }
        
        typedef DDLTYPE(uint32) TModifyCurrentGameAttribute_gid;
        typedef DDLTYPE(uint32) TModifyCurrentGameAttribute_attribIndex;
        typedef DDLTYPE(uint32) TModifyCurrentGameAttribute_newValue;
        PROTO_RMCIMPL_STUB(MatchmakeExtensionProtocol, ModifyCurrentGameAttribute)
        {
            PROTO_PREPARE_EXTRACTION();
            DDLTYPE(uint32)::CPPType gid;
            _MSG_EXTRACT_VARIABLE(TModifyCurrentGameAttribute_gid, gid);
            DDLTYPE(uint32)::CPPType attribIndex;
            _MSG_EXTRACT_VARIABLE(TModifyCurrentGameAttribute_attribIndex, attribIndex);
            DDLTYPE(uint32)::CPPType newValue;
            _MSG_EXTRACT_VARIABLE(TModifyCurrentGameAttribute_newValue, newValue);
            pProtocol->ModifyCurrentGameAttribute( gid, attribIndex, newValue );
            PROTO_PREPARE_RETURN(MatchmakeExtensionProtocol,ModifyCurrentGameAttribute);
        }
        
        typedef DDLTYPE(uint32) TUpdateNotificationData_uiType;
        typedef DDLTYPE(uint64) TUpdateNotificationData_uiParam1;
        typedef DDLTYPE(uint64) TUpdateNotificationData_uiParam2;
        typedef DDLTYPE(string) TUpdateNotificationData_strParam;
        PROTO_RMCIMPL_STUB(MatchmakeExtensionProtocol, UpdateNotificationData)
        {
            PROTO_PREPARE_EXTRACTION();
            DDLTYPE(uint32)::CPPType uiType;
            _MSG_EXTRACT_VARIABLE(TUpdateNotificationData_uiType, uiType);
            DDLTYPE(uint64)::CPPType uiParam1;
            _MSG_EXTRACT_VARIABLE(TUpdateNotificationData_uiParam1, uiParam1);
            DDLTYPE(uint64)::CPPType uiParam2;
            _MSG_EXTRACT_VARIABLE(TUpdateNotificationData_uiParam2, uiParam2);
            DDLTYPE(string)::CPPType strParam;
            _MSG_EXTRACT_VARIABLE(TUpdateNotificationData_strParam, strParam);
            pProtocol->UpdateNotificationData( uiType, uiParam1, uiParam2, strParam );
            PROTO_PREPARE_RETURN(MatchmakeExtensionProtocol,UpdateNotificationData);
        }
        
        typedef DDLTYPE(qlist)< CLASSMETATYPE(NotificationEvent) > TGetFriendNotificationData_dataList;
        typedef DDLTYPE(int32) TGetFriendNotificationData_uiType;
        PROTO_RMCIMPL_STUB(MatchmakeExtensionProtocol, GetFriendNotificationData)
        {
            PROTO_PREPARE_EXTRACTION();
            DDLTYPE(qlist)< CLASSMETATYPE(NotificationEvent) >::CPPType dataList;
            DDLTYPE(int32)::CPPType uiType;
            _MSG_EXTRACT_VARIABLE(TGetFriendNotificationData_uiType, uiType);
            pProtocol->GetFriendNotificationData( &dataList, uiType );
            PROTO_PREPARE_RETURN(MatchmakeExtensionProtocol,GetFriendNotificationData);
            _MSG_ADD_VARIABLE(TGetFriendNotificationData_dataList, dataList);
        }
        
        typedef DDLTYPE(uint32) TUpdateApplicationBuffer_gid;
        typedef DDLTYPE(qvector)< DDLTYPE(byte) > TUpdateApplicationBuffer_applicationBuffer;
        PROTO_RMCIMPL_STUB(MatchmakeExtensionProtocol, UpdateApplicationBuffer)
        {
            PROTO_PREPARE_EXTRACTION();
            DDLTYPE(uint32)::CPPType gid;
            _MSG_EXTRACT_VARIABLE(TUpdateApplicationBuffer_gid, gid);
            DDLTYPE(qvector)< DDLTYPE(byte) >::CPPType applicationBuffer;
            _MSG_EXTRACT_VARIABLE(TUpdateApplicationBuffer_applicationBuffer, applicationBuffer);
            pProtocol->UpdateApplicationBuffer( gid, applicationBuffer );
            PROTO_PREPARE_RETURN(MatchmakeExtensionProtocol,UpdateApplicationBuffer);
        }
        
        typedef DDLTYPE(uint32) TUpdateMatchmakeSessionAttribute_gid;
        typedef DDLTYPE(qvector)< DDLTYPE(uint32) > TUpdateMatchmakeSessionAttribute_attribs;
        PROTO_RMCIMPL_STUB(MatchmakeExtensionProtocol, UpdateMatchmakeSessionAttribute)
        {
            PROTO_PREPARE_EXTRACTION();
            DDLTYPE(uint32)::CPPType gid;
            _MSG_EXTRACT_VARIABLE(TUpdateMatchmakeSessionAttribute_gid, gid);
            DDLTYPE(qvector)< DDLTYPE(uint32) >::CPPType attribs;
            _MSG_EXTRACT_VARIABLE(TUpdateMatchmakeSessionAttribute_attribs, attribs);
            pProtocol->UpdateMatchmakeSessionAttribute( gid, attribs );
            PROTO_PREPARE_RETURN(MatchmakeExtensionProtocol,UpdateMatchmakeSessionAttribute);
        }
        
        typedef DDLTYPE(qlist)< CLASSMETATYPE(NotificationEvent) > TGetlstFriendNotificationData_dataList;
        typedef DDLTYPE(qlist)< DDLTYPE(uint32) > TGetlstFriendNotificationData_lstTypes;
        PROTO_RMCIMPL_STUB(MatchmakeExtensionProtocol, GetlstFriendNotificationData)
        {
            PROTO_PREPARE_EXTRACTION();
            DDLTYPE(qlist)< CLASSMETATYPE(NotificationEvent) >::CPPType dataList;
            DDLTYPE(qlist)< DDLTYPE(uint32) >::CPPType lstTypes;
            _MSG_EXTRACT_VARIABLE(TGetlstFriendNotificationData_lstTypes, lstTypes);
            pProtocol->GetlstFriendNotificationData( &dataList, lstTypes );
            PROTO_PREPARE_RETURN(MatchmakeExtensionProtocol,GetlstFriendNotificationData);
            _MSG_ADD_VARIABLE(TGetlstFriendNotificationData_dataList, dataList);
        }
        
        typedef DDLTYPE(any)< CLASSMETATYPE(Gathering), DDLTYPE(string) > TUpdateMatchmakeSession_anyGathering;
        PROTO_RMCIMPL_STUB(MatchmakeExtensionProtocol, UpdateMatchmakeSession)
        {
            PROTO_PREPARE_EXTRACTION();
            DDLTYPE(any)< CLASSMETATYPE(Gathering), DDLTYPE(string) >::CPPType anyGathering;
            _MSG_EXTRACT_VARIABLE(TUpdateMatchmakeSession_anyGathering, anyGathering);
            pProtocol->UpdateMatchmakeSession( anyGathering );
            PROTO_PREPARE_RETURN(MatchmakeExtensionProtocol,UpdateMatchmakeSession);
        }
        
        typedef DDLTYPE(qlist)< CLASSMETATYPE(MatchmakeSessionSearchCriteria) > TAutoMatchmakeWithSearchCriteria_Postpone_lstSearchCriteria;
        typedef DDLTYPE(any)< CLASSMETATYPE(Gathering), DDLTYPE(string) > TAutoMatchmakeWithSearchCriteria_Postpone_anyGathering;
        typedef DDLTYPE(any)< CLASSMETATYPE(Gathering), DDLTYPE(string) > TAutoMatchmakeWithSearchCriteria_Postpone_joinedGathering;
        typedef DDLTYPE(string) TAutoMatchmakeWithSearchCriteria_Postpone_strMessage;
        PROTO_RMCIMPL_STUB(MatchmakeExtensionProtocol, AutoMatchmakeWithSearchCriteria_Postpone)
        {
            PROTO_PREPARE_EXTRACTION();
            DDLTYPE(qlist)< CLASSMETATYPE(MatchmakeSessionSearchCriteria) >::CPPType lstSearchCriteria;
            _MSG_EXTRACT_VARIABLE(TAutoMatchmakeWithSearchCriteria_Postpone_lstSearchCriteria, lstSearchCriteria);
            DDLTYPE(any)< CLASSMETATYPE(Gathering), DDLTYPE(string) >::CPPType anyGathering;
            _MSG_EXTRACT_VARIABLE(TAutoMatchmakeWithSearchCriteria_Postpone_anyGathering, anyGathering);
            DDLTYPE(any)< CLASSMETATYPE(Gathering), DDLTYPE(string) >::CPPType joinedGathering;
            DDLTYPE(string)::CPPType strMessage;
            _MSG_EXTRACT_VARIABLE(TAutoMatchmakeWithSearchCriteria_Postpone_strMessage, strMessage);
            pProtocol->AutoMatchmakeWithSearchCriteria_Postpone( lstSearchCriteria, anyGathering, &joinedGathering, strMessage );
            PROTO_PREPARE_RETURN(MatchmakeExtensionProtocol,AutoMatchmakeWithSearchCriteria_Postpone);
            _MSG_ADD_VARIABLE(TAutoMatchmakeWithSearchCriteria_Postpone_joinedGathering, joinedGathering);
        }
        
        typedef DDLTYPE(qlist)< DDLTYPE(uint32) > TGetPlayingSession_lstPid;
        typedef DDLTYPE(qlist)< CLASSMETATYPE(PlayingSession) > TGetPlayingSession_lstPlayingSession;
        PROTO_RMCIMPL_STUB(MatchmakeExtensionProtocol, GetPlayingSession)
        {
            PROTO_PREPARE_EXTRACTION();
            DDLTYPE(qlist)< DDLTYPE(uint32) >::CPPType lstPid;
            _MSG_EXTRACT_VARIABLE(TGetPlayingSession_lstPid, lstPid);
            DDLTYPE(qlist)< CLASSMETATYPE(PlayingSession) >::CPPType lstPlayingSession;
            pProtocol->GetPlayingSession( lstPid, &lstPlayingSession );
            PROTO_PREPARE_RETURN(MatchmakeExtensionProtocol,GetPlayingSession);
            _MSG_ADD_VARIABLE(TGetPlayingSession_lstPlayingSession, lstPlayingSession);
        }
        
        typedef CLASSMETATYPE(PersistentGathering) TCreateCommunity_community;
        typedef DDLTYPE(uint32) TCreateCommunity_gid;
        typedef DDLTYPE(string) TCreateCommunity_strMessage;
        PROTO_RMCIMPL_STUB(MatchmakeExtensionProtocol, CreateCommunity)
        {
            PROTO_PREPARE_EXTRACTION();
            PersistentGathering community;
            _MSG_EXTRACT_VARIABLE(TCreateCommunity_community, community);
            DDLTYPE(uint32)::CPPType gid;
            DDLTYPE(string)::CPPType strMessage;
            _MSG_EXTRACT_VARIABLE(TCreateCommunity_strMessage, strMessage);
            pProtocol->CreateCommunity( community, &gid, strMessage );
            PROTO_PREPARE_RETURN(MatchmakeExtensionProtocol,CreateCommunity);
            _MSG_ADD_VARIABLE(TCreateCommunity_gid, gid);
        }
        
        typedef CLASSMETATYPE(PersistentGathering) TUpdateCommunity_community;
        PROTO_RMCIMPL_STUB(MatchmakeExtensionProtocol, UpdateCommunity)
        {
            PROTO_PREPARE_EXTRACTION();
            PersistentGathering community;
            _MSG_EXTRACT_VARIABLE(TUpdateCommunity_community, community);
            pProtocol->UpdateCommunity( community );
            PROTO_PREPARE_RETURN(MatchmakeExtensionProtocol,UpdateCommunity);
        }
        
        typedef DDLTYPE(uint32) TJoinCommunity_gid;
        typedef DDLTYPE(string) TJoinCommunity_strMessage;
        typedef DDLTYPE(string) TJoinCommunity_strPassword;
        PROTO_RMCIMPL_STUB(MatchmakeExtensionProtocol, JoinCommunity)
        {
            PROTO_PREPARE_EXTRACTION();
            DDLTYPE(uint32)::CPPType gid;
            _MSG_EXTRACT_VARIABLE(TJoinCommunity_gid, gid);
            DDLTYPE(string)::CPPType strMessage;
            _MSG_EXTRACT_VARIABLE(TJoinCommunity_strMessage, strMessage);
            DDLTYPE(string)::CPPType strPassword;
            _MSG_EXTRACT_VARIABLE(TJoinCommunity_strPassword, strPassword);
            pProtocol->JoinCommunity( gid, strMessage, strPassword );
            PROTO_PREPARE_RETURN(MatchmakeExtensionProtocol,JoinCommunity);
        }
        
        typedef DDLTYPE(qlist)< DDLTYPE(uint32) > TFindCommunityByGatheringId_lstGid;
        typedef DDLTYPE(qlist)< CLASSMETATYPE(PersistentGathering) > TFindCommunityByGatheringId_lstCommunity;
        PROTO_RMCIMPL_STUB(MatchmakeExtensionProtocol, FindCommunityByGatheringId)
        {
            PROTO_PREPARE_EXTRACTION();
            DDLTYPE(qlist)< DDLTYPE(uint32) >::CPPType lstGid;
            _MSG_EXTRACT_VARIABLE(TFindCommunityByGatheringId_lstGid, lstGid);
            DDLTYPE(qlist)< CLASSMETATYPE(PersistentGathering) >::CPPType lstCommunity;
            pProtocol->FindCommunityByGatheringId( lstGid, &lstCommunity );
            PROTO_PREPARE_RETURN(MatchmakeExtensionProtocol,FindCommunityByGatheringId);
            _MSG_ADD_VARIABLE(TFindCommunityByGatheringId_lstCommunity, lstCommunity);
        }
        
        typedef DDLTYPE(qlist)< CLASSMETATYPE(PersistentGathering) > TFindOfficialCommunity_lstCommunity;
        typedef DDLTYPE(bool) TFindOfficialCommunity_isAvailableOnly;
        typedef CLASSMETATYPE(ResultRange) TFindOfficialCommunity_resultRange;
        PROTO_RMCIMPL_STUB(MatchmakeExtensionProtocol, FindOfficialCommunity)
        {
            PROTO_PREPARE_EXTRACTION();
            DDLTYPE(qlist)< CLASSMETATYPE(PersistentGathering) >::CPPType lstCommunity;
            DDLTYPE(bool)::CPPType isAvailableOnly;
            _MSG_EXTRACT_VARIABLE(TFindOfficialCommunity_isAvailableOnly, isAvailableOnly);
            ResultRange resultRange;
            _MSG_EXTRACT_VARIABLE(TFindOfficialCommunity_resultRange, resultRange);
            pProtocol->FindOfficialCommunity( &lstCommunity, isAvailableOnly, resultRange );
            PROTO_PREPARE_RETURN(MatchmakeExtensionProtocol,FindOfficialCommunity);
            _MSG_ADD_VARIABLE(TFindOfficialCommunity_lstCommunity, lstCommunity);
        }
        
        typedef DDLTYPE(qlist)< CLASSMETATYPE(PersistentGathering) > TFindCommunityByParticipant_lstCommunity;
        typedef DDLTYPE(uint32) TFindCommunityByParticipant_pid;
        typedef CLASSMETATYPE(ResultRange) TFindCommunityByParticipant_resultRange;
        PROTO_RMCIMPL_STUB(MatchmakeExtensionProtocol, FindCommunityByParticipant)
        {
            PROTO_PREPARE_EXTRACTION();
            DDLTYPE(qlist)< CLASSMETATYPE(PersistentGathering) >::CPPType lstCommunity;
            DDLTYPE(uint32)::CPPType pid;
            _MSG_EXTRACT_VARIABLE(TFindCommunityByParticipant_pid, pid);
            ResultRange resultRange;
            _MSG_EXTRACT_VARIABLE(TFindCommunityByParticipant_resultRange, resultRange);
            pProtocol->FindCommunityByParticipant( &lstCommunity, pid, resultRange );
            PROTO_PREPARE_RETURN(MatchmakeExtensionProtocol,FindCommunityByParticipant);
            _MSG_ADD_VARIABLE(TFindCommunityByParticipant_lstCommunity, lstCommunity);
        }
        
        typedef DDLTYPE(bool) TUpdatePrivacySetting_onlineStatus;
        typedef DDLTYPE(bool) TUpdatePrivacySetting_participationCommunity;
        PROTO_RMCIMPL_STUB(MatchmakeExtensionProtocol, UpdatePrivacySetting)
        {
            PROTO_PREPARE_EXTRACTION();
            DDLTYPE(bool)::CPPType onlineStatus;
            _MSG_EXTRACT_VARIABLE(TUpdatePrivacySetting_onlineStatus, onlineStatus);
            DDLTYPE(bool)::CPPType participationCommunity;
            _MSG_EXTRACT_VARIABLE(TUpdatePrivacySetting_participationCommunity, participationCommunity);
            pProtocol->UpdatePrivacySetting( onlineStatus, participationCommunity );
            PROTO_PREPARE_RETURN(MatchmakeExtensionProtocol,UpdatePrivacySetting);
        }
        
        typedef DDLTYPE(qlist)< DDLTYPE(uint32) > TGetMyBlockList_lstPrincipalId;
        PROTO_RMCIMPL_STUB(MatchmakeExtensionProtocol, GetMyBlockList)
        {
            PROTO_PREPARE_EXTRACTION();
            DDLTYPE(qlist)< DDLTYPE(uint32) >::CPPType lstPrincipalId;
            pProtocol->GetMyBlockList( &lstPrincipalId );
            PROTO_PREPARE_RETURN(MatchmakeExtensionProtocol,GetMyBlockList);
            _MSG_ADD_VARIABLE(TGetMyBlockList_lstPrincipalId, lstPrincipalId);
        }
        
        typedef DDLTYPE(qlist)< DDLTYPE(uint32) > TAddToBlockList_lstPrincipalId;
        PROTO_RMCIMPL_STUB(MatchmakeExtensionProtocol, AddToBlockList)
        {
            PROTO_PREPARE_EXTRACTION();
            DDLTYPE(qlist)< DDLTYPE(uint32) >::CPPType lstPrincipalId;
            _MSG_EXTRACT_VARIABLE(TAddToBlockList_lstPrincipalId, lstPrincipalId);
            pProtocol->AddToBlockList( lstPrincipalId );
            PROTO_PREPARE_RETURN(MatchmakeExtensionProtocol,AddToBlockList);
        }
        
        typedef DDLTYPE(qlist)< DDLTYPE(uint32) > TRemoveFromBlockList_lstPrincipalId;
        PROTO_RMCIMPL_STUB(MatchmakeExtensionProtocol, RemoveFromBlockList)
        {
            PROTO_PREPARE_EXTRACTION();
            DDLTYPE(qlist)< DDLTYPE(uint32) >::CPPType lstPrincipalId;
            _MSG_EXTRACT_VARIABLE(TRemoveFromBlockList_lstPrincipalId, lstPrincipalId);
            pProtocol->RemoveFromBlockList( lstPrincipalId );
            PROTO_PREPARE_RETURN(MatchmakeExtensionProtocol,RemoveFromBlockList);
        }
        
        PROTO_RMCIMPL_STUB(MatchmakeExtensionProtocol, ClearMyBlockList)
        {
            PROTO_PREPARE_EXTRACTION();
            pProtocol->ClearMyBlockList(  );
            PROTO_PREPARE_RETURN(MatchmakeExtensionProtocol,ClearMyBlockList);
        }
        
        typedef DDLTYPE(uint32) TReportViolation_pid;
        typedef DDLTYPE(string) TReportViolation_userName;
        typedef DDLTYPE(uint32) TReportViolation_violationCode;
        PROTO_RMCIMPL_STUB(MatchmakeExtensionProtocol, ReportViolation)
        {
            PROTO_PREPARE_EXTRACTION();
            DDLTYPE(uint32)::CPPType pid;
            _MSG_EXTRACT_VARIABLE(TReportViolation_pid, pid);
            DDLTYPE(string)::CPPType userName;
            _MSG_EXTRACT_VARIABLE(TReportViolation_userName, userName);
            DDLTYPE(uint32)::CPPType violationCode;
            _MSG_EXTRACT_VARIABLE(TReportViolation_violationCode, violationCode);
            pProtocol->ReportViolation( pid, userName, violationCode );
            PROTO_PREPARE_RETURN(MatchmakeExtensionProtocol,ReportViolation);
        }
        
        typedef DDLTYPE(bool) TIsViolationUser_flag;
        typedef DDLTYPE(uint32) TIsViolationUser_score;
        PROTO_RMCIMPL_STUB(MatchmakeExtensionProtocol, IsViolationUser)
        {
            PROTO_PREPARE_EXTRACTION();
            DDLTYPE(bool)::CPPType flag;
            DDLTYPE(uint32)::CPPType score;
            pProtocol->IsViolationUser( &flag, &score );
            PROTO_PREPARE_RETURN(MatchmakeExtensionProtocol,IsViolationUser);
            _MSG_ADD_VARIABLE(TIsViolationUser_flag, flag);
            _MSG_ADD_VARIABLE(TIsViolationUser_score, score);
        }
        
        typedef DDLTYPE(uint32) TJoinMatchmakeSessionEx_gid;
        typedef DDLTYPE(string) TJoinMatchmakeSessionEx_strMessage;
        typedef DDLTYPE(bool) TJoinMatchmakeSessionEx_dontCareMyBlockList;
        typedef DDLTYPE(qvector)< DDLTYPE(byte) > TJoinMatchmakeSessionEx_sessionKey;
        typedef DDLTYPE(uint16) TJoinMatchmakeSessionEx_participationCount;
        PROTO_RMCIMPL_STUB(MatchmakeExtensionProtocol, JoinMatchmakeSessionEx)
        {
            PROTO_PREPARE_EXTRACTION();
            DDLTYPE(uint32)::CPPType gid;
            _MSG_EXTRACT_VARIABLE(TJoinMatchmakeSessionEx_gid, gid);
            DDLTYPE(string)::CPPType strMessage;
            _MSG_EXTRACT_VARIABLE(TJoinMatchmakeSessionEx_strMessage, strMessage);
            DDLTYPE(bool)::CPPType dontCareMyBlockList;
            _MSG_EXTRACT_VARIABLE(TJoinMatchmakeSessionEx_dontCareMyBlockList, dontCareMyBlockList);
            DDLTYPE(qvector)< DDLTYPE(byte) >::CPPType sessionKey;
            DDLTYPE(uint16)::CPPType participationCount;
            _MSG_EXTRACT_VARIABLE(TJoinMatchmakeSessionEx_participationCount, participationCount);
            pProtocol->JoinMatchmakeSessionEx( gid, strMessage, dontCareMyBlockList, &sessionKey, participationCount );
            PROTO_PREPARE_RETURN(MatchmakeExtensionProtocol,JoinMatchmakeSessionEx);
            _MSG_ADD_VARIABLE(TJoinMatchmakeSessionEx_sessionKey, sessionKey);
        }
        
        typedef DDLTYPE(qlist)< DDLTYPE(uint32) > TGetSimplePlayingSession_lstPrincipalId;
        typedef DDLTYPE(bool) TGetSimplePlayingSession_includeLoginUser;
        typedef DDLTYPE(qlist)< CLASSMETATYPE(SimplePlayingSession) > TGetSimplePlayingSession_lstSimplePlayingSession;
        PROTO_RMCIMPL_STUB(MatchmakeExtensionProtocol, GetSimplePlayingSession)
        {
            PROTO_PREPARE_EXTRACTION();
            DDLTYPE(qlist)< DDLTYPE(uint32) >::CPPType lstPrincipalId;
            _MSG_EXTRACT_VARIABLE(TGetSimplePlayingSession_lstPrincipalId, lstPrincipalId);
            DDLTYPE(bool)::CPPType includeLoginUser;
            _MSG_EXTRACT_VARIABLE(TGetSimplePlayingSession_includeLoginUser, includeLoginUser);
            DDLTYPE(qlist)< CLASSMETATYPE(SimplePlayingSession) >::CPPType lstSimplePlayingSession;
            pProtocol->GetSimplePlayingSession( lstPrincipalId, includeLoginUser, &lstSimplePlayingSession );
            PROTO_PREPARE_RETURN(MatchmakeExtensionProtocol,GetSimplePlayingSession);
            _MSG_ADD_VARIABLE(TGetSimplePlayingSession_lstSimplePlayingSession, lstSimplePlayingSession);
        }
        
        typedef DDLTYPE(qlist)< DDLTYPE(uint32) > TGetSimpleCommunity_gatheringIdList;
        typedef DDLTYPE(qlist)< CLASSMETATYPE(SimpleCommunity) > TGetSimpleCommunity_lstSimpleCommunityList;
        PROTO_RMCIMPL_STUB(MatchmakeExtensionProtocol, GetSimpleCommunity)
        {
            PROTO_PREPARE_EXTRACTION();
            DDLTYPE(qlist)< DDLTYPE(uint32) >::CPPType gatheringIdList;
            _MSG_EXTRACT_VARIABLE(TGetSimpleCommunity_gatheringIdList, gatheringIdList);
            DDLTYPE(qlist)< CLASSMETATYPE(SimpleCommunity) >::CPPType lstSimpleCommunityList;
            pProtocol->GetSimpleCommunity( gatheringIdList, &lstSimpleCommunityList );
            PROTO_PREPARE_RETURN(MatchmakeExtensionProtocol,GetSimpleCommunity);
            _MSG_ADD_VARIABLE(TGetSimpleCommunity_lstSimpleCommunityList, lstSimpleCommunityList);
        }
        
        typedef DDLTYPE(qlist)< DDLTYPE(uint32) > TAutoMatchmakeWithGatheringId_Postpone_lstGid;
        typedef DDLTYPE(any)< CLASSMETATYPE(Gathering), DDLTYPE(string) > TAutoMatchmakeWithGatheringId_Postpone_anyGathering;
        typedef DDLTYPE(any)< CLASSMETATYPE(Gathering), DDLTYPE(string) > TAutoMatchmakeWithGatheringId_Postpone_joinedGathering;
        typedef DDLTYPE(string) TAutoMatchmakeWithGatheringId_Postpone_strMessage;
        PROTO_RMCIMPL_STUB(MatchmakeExtensionProtocol, AutoMatchmakeWithGatheringId_Postpone)
        {
            PROTO_PREPARE_EXTRACTION();
            DDLTYPE(qlist)< DDLTYPE(uint32) >::CPPType lstGid;
            _MSG_EXTRACT_VARIABLE(TAutoMatchmakeWithGatheringId_Postpone_lstGid, lstGid);
            DDLTYPE(any)< CLASSMETATYPE(Gathering), DDLTYPE(string) >::CPPType anyGathering;
            _MSG_EXTRACT_VARIABLE(TAutoMatchmakeWithGatheringId_Postpone_anyGathering, anyGathering);
            DDLTYPE(any)< CLASSMETATYPE(Gathering), DDLTYPE(string) >::CPPType joinedGathering;
            DDLTYPE(string)::CPPType strMessage;
            _MSG_EXTRACT_VARIABLE(TAutoMatchmakeWithGatheringId_Postpone_strMessage, strMessage);
            pProtocol->AutoMatchmakeWithGatheringId_Postpone( lstGid, anyGathering, &joinedGathering, strMessage );
            PROTO_PREPARE_RETURN(MatchmakeExtensionProtocol,AutoMatchmakeWithGatheringId_Postpone);
            _MSG_ADD_VARIABLE(TAutoMatchmakeWithGatheringId_Postpone_joinedGathering, joinedGathering);
        }
        
        typedef DDLTYPE(uint32) TUpdateProgressScore_gid;
        typedef DDLTYPE(byte) TUpdateProgressScore_progressScore;
        PROTO_RMCIMPL_STUB(MatchmakeExtensionProtocol, UpdateProgressScore)
        {
            PROTO_PREPARE_EXTRACTION();
            DDLTYPE(uint32)::CPPType gid;
            _MSG_EXTRACT_VARIABLE(TUpdateProgressScore_gid, gid);
            DDLTYPE(byte)::CPPType progressScore;
            _MSG_EXTRACT_VARIABLE(TUpdateProgressScore_progressScore, progressScore);
            pProtocol->UpdateProgressScore( gid, progressScore );
            PROTO_PREPARE_RETURN(MatchmakeExtensionProtocol,UpdateProgressScore);
        }
        
        typedef DDLTYPE(uint32) TDebugNotifyEvent_pid;
        typedef DDLTYPE(uint32) TDebugNotifyEvent_mainType;
        typedef DDLTYPE(uint32) TDebugNotifyEvent_subType;
        typedef DDLTYPE(uint64) TDebugNotifyEvent_param1;
        typedef DDLTYPE(uint64) TDebugNotifyEvent_param2;
        typedef DDLTYPE(string) TDebugNotifyEvent_stringParam;
        PROTO_RMCIMPL_STUB(MatchmakeExtensionProtocol, DebugNotifyEvent)
        {
            PROTO_PREPARE_EXTRACTION();
            DDLTYPE(uint32)::CPPType pid;
            _MSG_EXTRACT_VARIABLE(TDebugNotifyEvent_pid, pid);
            DDLTYPE(uint32)::CPPType mainType;
            _MSG_EXTRACT_VARIABLE(TDebugNotifyEvent_mainType, mainType);
            DDLTYPE(uint32)::CPPType subType;
            _MSG_EXTRACT_VARIABLE(TDebugNotifyEvent_subType, subType);
            DDLTYPE(uint64)::CPPType param1;
            _MSG_EXTRACT_VARIABLE(TDebugNotifyEvent_param1, param1);
            DDLTYPE(uint64)::CPPType param2;
            _MSG_EXTRACT_VARIABLE(TDebugNotifyEvent_param2, param2);
            DDLTYPE(string)::CPPType stringParam;
            _MSG_EXTRACT_VARIABLE(TDebugNotifyEvent_stringParam, stringParam);
            pProtocol->DebugNotifyEvent( pid, mainType, subType, param1, param2, stringParam );
            PROTO_PREPARE_RETURN(MatchmakeExtensionProtocol,DebugNotifyEvent);
        }
        
        typedef DDLTYPE(uint32) TGenerateMatchmakeSessionSystemPassword_gid;
        typedef DDLTYPE(string) TGenerateMatchmakeSessionSystemPassword_password;
        PROTO_RMCIMPL_STUB(MatchmakeExtensionProtocol, GenerateMatchmakeSessionSystemPassword)
        {
            PROTO_PREPARE_EXTRACTION();
            DDLTYPE(uint32)::CPPType gid;
            _MSG_EXTRACT_VARIABLE(TGenerateMatchmakeSessionSystemPassword_gid, gid);
            DDLTYPE(string)::CPPType password;
            pProtocol->GenerateMatchmakeSessionSystemPassword( gid, &password );
            PROTO_PREPARE_RETURN(MatchmakeExtensionProtocol,GenerateMatchmakeSessionSystemPassword);
            _MSG_ADD_VARIABLE(TGenerateMatchmakeSessionSystemPassword_password, password);
        }
        
        typedef DDLTYPE(uint32) TClearMatchmakeSessionSystemPassword_gid;
        PROTO_RMCIMPL_STUB(MatchmakeExtensionProtocol, ClearMatchmakeSessionSystemPassword)
        {
            PROTO_PREPARE_EXTRACTION();
            DDLTYPE(uint32)::CPPType gid;
            _MSG_EXTRACT_VARIABLE(TClearMatchmakeSessionSystemPassword_gid, gid);
            pProtocol->ClearMatchmakeSessionSystemPassword( gid );
            PROTO_PREPARE_RETURN(MatchmakeExtensionProtocol,ClearMatchmakeSessionSystemPassword);
        }
        
        typedef CLASSMETATYPE(CreateMatchmakeSessionParam) TCreateMatchmakeSessionWithParam_createMatchmakeSessionParam;
        typedef CLASSMETATYPE(MatchmakeSession) TCreateMatchmakeSessionWithParam_joinedMatchmakeSession;
        PROTO_RMCIMPL_STUB(MatchmakeExtensionProtocol, CreateMatchmakeSessionWithParam)
        {
            PROTO_PREPARE_EXTRACTION();
            CreateMatchmakeSessionParam createMatchmakeSessionParam;
            _MSG_EXTRACT_VARIABLE(TCreateMatchmakeSessionWithParam_createMatchmakeSessionParam, createMatchmakeSessionParam);
            MatchmakeSession joinedMatchmakeSession;
            pProtocol->CreateMatchmakeSessionWithParam( createMatchmakeSessionParam, &joinedMatchmakeSession );
            PROTO_PREPARE_RETURN(MatchmakeExtensionProtocol,CreateMatchmakeSessionWithParam);
            _MSG_ADD_VARIABLE(TCreateMatchmakeSessionWithParam_joinedMatchmakeSession, joinedMatchmakeSession);
        }
        
        typedef CLASSMETATYPE(JoinMatchmakeSessionParam) TJoinMatchmakeSessionWithParam_joinMatchmakeSessionParam;
        typedef CLASSMETATYPE(MatchmakeSession) TJoinMatchmakeSessionWithParam_joinedMatchmakeSession;
        PROTO_RMCIMPL_STUB(MatchmakeExtensionProtocol, JoinMatchmakeSessionWithParam)
        {
            PROTO_PREPARE_EXTRACTION();
            JoinMatchmakeSessionParam joinMatchmakeSessionParam;
            _MSG_EXTRACT_VARIABLE(TJoinMatchmakeSessionWithParam_joinMatchmakeSessionParam, joinMatchmakeSessionParam);
            MatchmakeSession joinedMatchmakeSession;
            pProtocol->JoinMatchmakeSessionWithParam( joinMatchmakeSessionParam, &joinedMatchmakeSession );
            PROTO_PREPARE_RETURN(MatchmakeExtensionProtocol,JoinMatchmakeSessionWithParam);
            _MSG_ADD_VARIABLE(TJoinMatchmakeSessionWithParam_joinedMatchmakeSession, joinedMatchmakeSession);
        }
        
        typedef CLASSMETATYPE(AutoMatchmakeParam) TAutoMatchmakeWithParam_Postpone_autoMatchmakeParam;
        typedef CLASSMETATYPE(MatchmakeSession) TAutoMatchmakeWithParam_Postpone_joinedMatchmakeSession;
        PROTO_RMCIMPL_STUB(MatchmakeExtensionProtocol, AutoMatchmakeWithParam_Postpone)
        {
            PROTO_PREPARE_EXTRACTION();
            AutoMatchmakeParam autoMatchmakeParam;
            _MSG_EXTRACT_VARIABLE(TAutoMatchmakeWithParam_Postpone_autoMatchmakeParam, autoMatchmakeParam);
            MatchmakeSession joinedMatchmakeSession;
            pProtocol->AutoMatchmakeWithParam_Postpone( autoMatchmakeParam, &joinedMatchmakeSession );
            PROTO_PREPARE_RETURN(MatchmakeExtensionProtocol,AutoMatchmakeWithParam_Postpone);
            _MSG_ADD_VARIABLE(TAutoMatchmakeWithParam_Postpone_joinedMatchmakeSession, joinedMatchmakeSession);
        }
        
        typedef DDLTYPE(uint32) TFindMatchmakeSessionByGatheringIdDetail_gid;
        typedef CLASSMETATYPE(MatchmakeSession) TFindMatchmakeSessionByGatheringIdDetail_matchmakeSession;
        PROTO_RMCIMPL_STUB(MatchmakeExtensionProtocol, FindMatchmakeSessionByGatheringIdDetail)
        {
            PROTO_PREPARE_EXTRACTION();
            DDLTYPE(uint32)::CPPType gid;
            _MSG_EXTRACT_VARIABLE(TFindMatchmakeSessionByGatheringIdDetail_gid, gid);
            MatchmakeSession matchmakeSession;
            pProtocol->FindMatchmakeSessionByGatheringIdDetail( gid, &matchmakeSession );
            PROTO_PREPARE_RETURN(MatchmakeExtensionProtocol,FindMatchmakeSessionByGatheringIdDetail);
            _MSG_ADD_VARIABLE(TFindMatchmakeSessionByGatheringIdDetail_matchmakeSession, matchmakeSession);
        }
        
        typedef CLASSMETATYPE(MatchmakeSessionSearchCriteria) TBrowseMatchmakeSessionNoHolder_searchCriteria;
        typedef CLASSMETATYPE(ResultRange) TBrowseMatchmakeSessionNoHolder_resultRange;
        typedef DDLTYPE(qlist)< CLASSMETATYPE(MatchmakeSession) > TBrowseMatchmakeSessionNoHolder_lstMatchmakeSession;
        PROTO_RMCIMPL_STUB(MatchmakeExtensionProtocol, BrowseMatchmakeSessionNoHolder)
        {
            PROTO_PREPARE_EXTRACTION();
            MatchmakeSessionSearchCriteria searchCriteria;
            _MSG_EXTRACT_VARIABLE(TBrowseMatchmakeSessionNoHolder_searchCriteria, searchCriteria);
            ResultRange resultRange;
            _MSG_EXTRACT_VARIABLE(TBrowseMatchmakeSessionNoHolder_resultRange, resultRange);
            DDLTYPE(qlist)< CLASSMETATYPE(MatchmakeSession) >::CPPType lstMatchmakeSession;
            pProtocol->BrowseMatchmakeSessionNoHolder( searchCriteria, resultRange, &lstMatchmakeSession );
            PROTO_PREPARE_RETURN(MatchmakeExtensionProtocol,BrowseMatchmakeSessionNoHolder);
            _MSG_ADD_VARIABLE(TBrowseMatchmakeSessionNoHolder_lstMatchmakeSession, lstMatchmakeSession);
        }
        
        typedef CLASSMETATYPE(MatchmakeSessionSearchCriteria) TBrowseMatchmakeSessionWithHostUrlsNoHolder_searchCriteria;
        typedef CLASSMETATYPE(ResultRange) TBrowseMatchmakeSessionWithHostUrlsNoHolder_resultRange;
        typedef DDLTYPE(qlist)< CLASSMETATYPE(MatchmakeSession) > TBrowseMatchmakeSessionWithHostUrlsNoHolder_lstMatchmakeSession;
        typedef DDLTYPE(qlist)< CLASSMETATYPE(GatheringURLs) > TBrowseMatchmakeSessionWithHostUrlsNoHolder_lstGatheringUrls;
        PROTO_RMCIMPL_STUB(MatchmakeExtensionProtocol, BrowseMatchmakeSessionWithHostUrlsNoHolder)
        {
            PROTO_PREPARE_EXTRACTION();
            MatchmakeSessionSearchCriteria searchCriteria;
            _MSG_EXTRACT_VARIABLE(TBrowseMatchmakeSessionWithHostUrlsNoHolder_searchCriteria, searchCriteria);
            ResultRange resultRange;
            _MSG_EXTRACT_VARIABLE(TBrowseMatchmakeSessionWithHostUrlsNoHolder_resultRange, resultRange);
            DDLTYPE(qlist)< CLASSMETATYPE(MatchmakeSession) >::CPPType lstMatchmakeSession;
            DDLTYPE(qlist)< CLASSMETATYPE(GatheringURLs) >::CPPType lstGatheringUrls;
            pProtocol->BrowseMatchmakeSessionWithHostUrlsNoHolder( searchCriteria, resultRange, &lstMatchmakeSession, &lstGatheringUrls );
            PROTO_PREPARE_RETURN(MatchmakeExtensionProtocol,BrowseMatchmakeSessionWithHostUrlsNoHolder);
            _MSG_ADD_VARIABLE(TBrowseMatchmakeSessionWithHostUrlsNoHolder_lstMatchmakeSession, lstMatchmakeSession);
            _MSG_ADD_VARIABLE(TBrowseMatchmakeSessionWithHostUrlsNoHolder_lstGatheringUrls, lstGatheringUrls);
        }
        
        typedef CLASSMETATYPE(UpdateMatchmakeSessionParam) TUpdateMatchmakeSessionPart_updateMatchmakeSessionParam;
        PROTO_RMCIMPL_STUB(MatchmakeExtensionProtocol, UpdateMatchmakeSessionPart)
        {
            PROTO_PREPARE_EXTRACTION();
            UpdateMatchmakeSessionParam updateMatchmakeSessionParam;
            _MSG_EXTRACT_VARIABLE(TUpdateMatchmakeSessionPart_updateMatchmakeSessionParam, updateMatchmakeSessionParam);
            pProtocol->UpdateMatchmakeSessionPart( updateMatchmakeSessionParam );
            PROTO_PREPARE_RETURN(MatchmakeExtensionProtocol,UpdateMatchmakeSessionPart);
        }
        
        typedef CLASSMETATYPE(AutoMatchmakeParam) TRequestMatchmaking_autoMatchmakeParam;
        typedef DDLTYPE(uint64) TRequestMatchmaking_requestId;
        PROTO_RMCIMPL_STUB(MatchmakeExtensionProtocol, RequestMatchmaking)
        {
            PROTO_PREPARE_EXTRACTION();
            AutoMatchmakeParam autoMatchmakeParam;
            _MSG_EXTRACT_VARIABLE(TRequestMatchmaking_autoMatchmakeParam, autoMatchmakeParam);
            DDLTYPE(uint64)::CPPType requestId;
            pProtocol->RequestMatchmaking( autoMatchmakeParam, &requestId );
            PROTO_PREPARE_RETURN(MatchmakeExtensionProtocol,RequestMatchmaking);
            _MSG_ADD_VARIABLE(TRequestMatchmaking_requestId, requestId);
        }
        
        typedef DDLTYPE(uint64) TWithdrawMatchmaking_requestId;
        PROTO_RMCIMPL_STUB(MatchmakeExtensionProtocol, WithdrawMatchmaking)
        {
            PROTO_PREPARE_EXTRACTION();
            DDLTYPE(uint64)::CPPType requestId;
            _MSG_EXTRACT_VARIABLE(TWithdrawMatchmaking_requestId, requestId);
            pProtocol->WithdrawMatchmaking( requestId );
            PROTO_PREPARE_RETURN(MatchmakeExtensionProtocol,WithdrawMatchmaking);
        }
        
        PROTO_RMCIMPL_STUB(MatchmakeExtensionProtocol, WithdrawMatchmakingAll)
        {
            PROTO_PREPARE_EXTRACTION();
            pProtocol->WithdrawMatchmakingAll(  );
            PROTO_PREPARE_RETURN(MatchmakeExtensionProtocol,WithdrawMatchmakingAll);
        }
        
        typedef DDLTYPE(qlist)< DDLTYPE(uint32) > TFindMatchmakeSessionByGatheringId_lstGid;
        typedef DDLTYPE(qlist)< CLASSMETATYPE(MatchmakeSession) > TFindMatchmakeSessionByGatheringId_lstMatchmakeSession;
        PROTO_RMCIMPL_STUB(MatchmakeExtensionProtocol, FindMatchmakeSessionByGatheringId)
        {
            PROTO_PREPARE_EXTRACTION();
            DDLTYPE(qlist)< DDLTYPE(uint32) >::CPPType lstGid;
            _MSG_EXTRACT_VARIABLE(TFindMatchmakeSessionByGatheringId_lstGid, lstGid);
            DDLTYPE(qlist)< CLASSMETATYPE(MatchmakeSession) >::CPPType lstMatchmakeSession;
            pProtocol->FindMatchmakeSessionByGatheringId( lstGid, &lstMatchmakeSession );
            PROTO_PREPARE_RETURN(MatchmakeExtensionProtocol,FindMatchmakeSessionByGatheringId);
            _MSG_ADD_VARIABLE(TFindMatchmakeSessionByGatheringId_lstMatchmakeSession, lstMatchmakeSession);
        }
        
        typedef DDLTYPE(uint32) TFindMatchmakeSessionBySingleGatheringId_gid;
        typedef CLASSMETATYPE(MatchmakeSession) TFindMatchmakeSessionBySingleGatheringId_matchmakeSession;
        PROTO_RMCIMPL_STUB(MatchmakeExtensionProtocol, FindMatchmakeSessionBySingleGatheringId)
        {
            PROTO_PREPARE_EXTRACTION();
            DDLTYPE(uint32)::CPPType gid;
            _MSG_EXTRACT_VARIABLE(TFindMatchmakeSessionBySingleGatheringId_gid, gid);
            MatchmakeSession matchmakeSession;
            pProtocol->FindMatchmakeSessionBySingleGatheringId( gid, &matchmakeSession );
            PROTO_PREPARE_RETURN(MatchmakeExtensionProtocol,FindMatchmakeSessionBySingleGatheringId);
            _MSG_ADD_VARIABLE(TFindMatchmakeSessionBySingleGatheringId_matchmakeSession, matchmakeSession);
        }
        
        typedef DDLTYPE(uint32) TFindMatchmakeSessionByOwner_id;
        typedef CLASSMETATYPE(ResultRange) TFindMatchmakeSessionByOwner_resultRange;
        typedef DDLTYPE(qlist)< CLASSMETATYPE(MatchmakeSession) > TFindMatchmakeSessionByOwner_lstMatchmakeSession;
        PROTO_RMCIMPL_STUB(MatchmakeExtensionProtocol, FindMatchmakeSessionByOwner)
        {
            PROTO_PREPARE_EXTRACTION();
            DDLTYPE(uint32)::CPPType id;
            _MSG_EXTRACT_VARIABLE(TFindMatchmakeSessionByOwner_id, id);
            ResultRange resultRange;
            _MSG_EXTRACT_VARIABLE(TFindMatchmakeSessionByOwner_resultRange, resultRange);
            DDLTYPE(qlist)< CLASSMETATYPE(MatchmakeSession) >::CPPType lstMatchmakeSession;
            pProtocol->FindMatchmakeSessionByOwner( id, resultRange, &lstMatchmakeSession );
            PROTO_PREPARE_RETURN(MatchmakeExtensionProtocol,FindMatchmakeSessionByOwner);
            _MSG_ADD_VARIABLE(TFindMatchmakeSessionByOwner_lstMatchmakeSession, lstMatchmakeSession);
        }
        
        typedef CLASSMETATYPE(FindMatchmakeSessionByParticipantParam) TFindMatchmakeSessionByParticipant_param;
        typedef DDLTYPE(qlist)< CLASSMETATYPE(FindMatchmakeSessionByParticipantResult) > TFindMatchmakeSessionByParticipant_lstSession;
        PROTO_RMCIMPL_STUB(MatchmakeExtensionProtocol, FindMatchmakeSessionByParticipant)
        {
            PROTO_PREPARE_EXTRACTION();
            FindMatchmakeSessionByParticipantParam param;
            _MSG_EXTRACT_VARIABLE(TFindMatchmakeSessionByParticipant_param, param);
            DDLTYPE(qlist)< CLASSMETATYPE(FindMatchmakeSessionByParticipantResult) >::CPPType lstSession;
            pProtocol->FindMatchmakeSessionByParticipant( param, &lstSession );
            PROTO_PREPARE_RETURN(MatchmakeExtensionProtocol,FindMatchmakeSessionByParticipant);
            _MSG_ADD_VARIABLE(TFindMatchmakeSessionByParticipant_lstSession, lstSession);
        }
        
        typedef CLASSMETATYPE(MatchmakeSessionSearchCriteria) TBrowseMatchmakeSessionNoHolderNoResultRange_searchCriteria;
        typedef DDLTYPE(qlist)< CLASSMETATYPE(MatchmakeSession) > TBrowseMatchmakeSessionNoHolderNoResultRange_lstMatchmakeSession;
        PROTO_RMCIMPL_STUB(MatchmakeExtensionProtocol, BrowseMatchmakeSessionNoHolderNoResultRange)
        {
            PROTO_PREPARE_EXTRACTION();
            MatchmakeSessionSearchCriteria searchCriteria;
            _MSG_EXTRACT_VARIABLE(TBrowseMatchmakeSessionNoHolderNoResultRange_searchCriteria, searchCriteria);
            DDLTYPE(qlist)< CLASSMETATYPE(MatchmakeSession) >::CPPType lstMatchmakeSession;
            pProtocol->BrowseMatchmakeSessionNoHolderNoResultRange( searchCriteria, &lstMatchmakeSession );
            PROTO_PREPARE_RETURN(MatchmakeExtensionProtocol,BrowseMatchmakeSessionNoHolderNoResultRange);
            _MSG_ADD_VARIABLE(TBrowseMatchmakeSessionNoHolderNoResultRange_lstMatchmakeSession, lstMatchmakeSession);
        }
        
        typedef CLASSMETATYPE(MatchmakeSessionSearchCriteria) TBrowseMatchmakeSessionWithHostUrlsNoHolderNoResultRange_searchCriteria;
        typedef DDLTYPE(qlist)< CLASSMETATYPE(MatchmakeSession) > TBrowseMatchmakeSessionWithHostUrlsNoHolderNoResultRange_lstMatchmakeSession;
        typedef DDLTYPE(qlist)< CLASSMETATYPE(GatheringURLs) > TBrowseMatchmakeSessionWithHostUrlsNoHolderNoResultRange_lstGatheringUrls;
        PROTO_RMCIMPL_STUB(MatchmakeExtensionProtocol, BrowseMatchmakeSessionWithHostUrlsNoHolderNoResultRange)
        {
            PROTO_PREPARE_EXTRACTION();
            MatchmakeSessionSearchCriteria searchCriteria;
            _MSG_EXTRACT_VARIABLE(TBrowseMatchmakeSessionWithHostUrlsNoHolderNoResultRange_searchCriteria, searchCriteria);
            DDLTYPE(qlist)< CLASSMETATYPE(MatchmakeSession) >::CPPType lstMatchmakeSession;
            DDLTYPE(qlist)< CLASSMETATYPE(GatheringURLs) >::CPPType lstGatheringUrls;
            pProtocol->BrowseMatchmakeSessionWithHostUrlsNoHolderNoResultRange( searchCriteria, &lstMatchmakeSession, &lstGatheringUrls );
            PROTO_PREPARE_RETURN(MatchmakeExtensionProtocol,BrowseMatchmakeSessionWithHostUrlsNoHolderNoResultRange);
            _MSG_ADD_VARIABLE(TBrowseMatchmakeSessionWithHostUrlsNoHolderNoResultRange_lstMatchmakeSession, lstMatchmakeSession);
            _MSG_ADD_VARIABLE(TBrowseMatchmakeSessionWithHostUrlsNoHolderNoResultRange_lstGatheringUrls, lstGatheringUrls);
        }
        
        typedef DDLTYPE(qlist)< CLASSMETATYPE(PersistentGathering) > TFindCommunityByOwner_lstCommunity;
        typedef DDLTYPE(uint32) TFindCommunityByOwner_id;
        typedef CLASSMETATYPE(ResultRange) TFindCommunityByOwner_resultRange;
        PROTO_RMCIMPL_STUB(MatchmakeExtensionProtocol, FindCommunityByOwner)
        {
            PROTO_PREPARE_EXTRACTION();
            DDLTYPE(qlist)< CLASSMETATYPE(PersistentGathering) >::CPPType lstCommunity;
            DDLTYPE(uint32)::CPPType id;
            _MSG_EXTRACT_VARIABLE(TFindCommunityByOwner_id, id);
            ResultRange resultRange;
            _MSG_EXTRACT_VARIABLE(TFindCommunityByOwner_resultRange, resultRange);
            pProtocol->FindCommunityByOwner( &lstCommunity, id, resultRange );
            PROTO_PREPARE_RETURN(MatchmakeExtensionProtocol,FindCommunityByOwner);
            _MSG_ADD_VARIABLE(TFindCommunityByOwner_lstCommunity, lstCommunity);
        }
        
        private:
        // Call this function with a message previously generated by a
        // <RMC name>_PrepareRequest() call to have it dispatched to the correct RMC.
        virtual void DispatchProtocolMessage( Message *pMessage, Message *pReturnMessage, qBool *boReturnsMessage, EndPoint *pEndPoint);
        public:
        
        virtual void CloseParticipation(const DDLTYPE(uint32)::CPPType& gid) = 0;
        virtual void OpenParticipation(const DDLTYPE(uint32)::CPPType& gid) = 0;
        virtual void AutoMatchmake_Postpone(const DDLTYPE(any)< CLASSMETATYPE(Gathering), DDLTYPE(string) >::CPPType& anyGathering, DDLTYPE(any)< CLASSMETATYPE(Gathering), DDLTYPE(string) >::CPPType* joinedGathering, const DDLTYPE(string)::CPPType& strMessage) = 0;
        virtual void BrowseMatchmakeSession(const MatchmakeSessionSearchCriteria& searchCriteria, const ResultRange& resultRange, DDLTYPE(qlist)< DDLTYPE(any)< CLASSMETATYPE(Gathering), DDLTYPE(string) > >::CPPType* lstGathering) = 0;
        virtual void BrowseMatchmakeSessionWithHostUrls(const MatchmakeSessionSearchCriteria& searchCriteria, const ResultRange& resultRange, DDLTYPE(qlist)< DDLTYPE(any)< CLASSMETATYPE(Gathering), DDLTYPE(string) > >::CPPType* lstGathering, DDLTYPE(qlist)< CLASSMETATYPE(GatheringURLs) >::CPPType* lstGatheringUrls) = 0;
        virtual void CreateMatchmakeSession(const DDLTYPE(any)< CLASSMETATYPE(Gathering), DDLTYPE(string) >::CPPType& anyGathering, DDLTYPE(uint32)::CPPType* gid, const DDLTYPE(string)::CPPType& strMessage, DDLTYPE(qvector)< DDLTYPE(byte) >::CPPType* sessionKey, const DDLTYPE(uint16)::CPPType& participationCount) = 0;
        virtual void JoinMatchmakeSession(const DDLTYPE(uint32)::CPPType& gid, const DDLTYPE(string)::CPPType& strMessage, DDLTYPE(qvector)< DDLTYPE(byte) >::CPPType* sessionKey) = 0;
        virtual void ModifyCurrentGameAttribute(const DDLTYPE(uint32)::CPPType& gid, const DDLTYPE(uint32)::CPPType& attribIndex, const DDLTYPE(uint32)::CPPType& newValue) = 0;
        virtual void UpdateNotificationData(const DDLTYPE(uint32)::CPPType& uiType, const DDLTYPE(uint64)::CPPType& uiParam1, const DDLTYPE(uint64)::CPPType& uiParam2, const DDLTYPE(string)::CPPType& strParam) = 0;
        virtual void GetFriendNotificationData(DDLTYPE(qlist)< CLASSMETATYPE(NotificationEvent) >::CPPType* dataList, const DDLTYPE(int32)::CPPType& uiType) = 0;
        virtual void UpdateApplicationBuffer(const DDLTYPE(uint32)::CPPType& gid, const DDLTYPE(qvector)< DDLTYPE(byte) >::CPPType& applicationBuffer) = 0;
        virtual void UpdateMatchmakeSessionAttribute(const DDLTYPE(uint32)::CPPType& gid, const DDLTYPE(qvector)< DDLTYPE(uint32) >::CPPType& attribs) = 0;
        virtual void GetlstFriendNotificationData(DDLTYPE(qlist)< CLASSMETATYPE(NotificationEvent) >::CPPType* dataList, const DDLTYPE(qlist)< DDLTYPE(uint32) >::CPPType& lstTypes) = 0;
        virtual void UpdateMatchmakeSession(const DDLTYPE(any)< CLASSMETATYPE(Gathering), DDLTYPE(string) >::CPPType& anyGathering) = 0;
        virtual void AutoMatchmakeWithSearchCriteria_Postpone(const DDLTYPE(qlist)< CLASSMETATYPE(MatchmakeSessionSearchCriteria) >::CPPType& lstSearchCriteria, const DDLTYPE(any)< CLASSMETATYPE(Gathering), DDLTYPE(string) >::CPPType& anyGathering, DDLTYPE(any)< CLASSMETATYPE(Gathering), DDLTYPE(string) >::CPPType* joinedGathering, const DDLTYPE(string)::CPPType& strMessage) = 0;
        virtual void GetPlayingSession(const DDLTYPE(qlist)< DDLTYPE(uint32) >::CPPType& lstPid, DDLTYPE(qlist)< CLASSMETATYPE(PlayingSession) >::CPPType* lstPlayingSession) = 0;
        virtual void CreateCommunity(const PersistentGathering& community, DDLTYPE(uint32)::CPPType* gid, const DDLTYPE(string)::CPPType& strMessage) = 0;
        virtual void UpdateCommunity(const PersistentGathering& community) = 0;
        virtual void JoinCommunity(const DDLTYPE(uint32)::CPPType& gid, const DDLTYPE(string)::CPPType& strMessage, const DDLTYPE(string)::CPPType& strPassword) = 0;
        virtual void FindCommunityByGatheringId(const DDLTYPE(qlist)< DDLTYPE(uint32) >::CPPType& lstGid, DDLTYPE(qlist)< CLASSMETATYPE(PersistentGathering) >::CPPType* lstCommunity) = 0;
        virtual void FindOfficialCommunity(DDLTYPE(qlist)< CLASSMETATYPE(PersistentGathering) >::CPPType* lstCommunity, const DDLTYPE(bool)::CPPType& isAvailableOnly, const ResultRange& resultRange) = 0;
        virtual void FindCommunityByParticipant(DDLTYPE(qlist)< CLASSMETATYPE(PersistentGathering) >::CPPType* lstCommunity, const DDLTYPE(uint32)::CPPType& pid, const ResultRange& resultRange) = 0;
        virtual void UpdatePrivacySetting(const DDLTYPE(bool)::CPPType& onlineStatus, const DDLTYPE(bool)::CPPType& participationCommunity) = 0;
        virtual void GetMyBlockList(DDLTYPE(qlist)< DDLTYPE(uint32) >::CPPType* lstPrincipalId) = 0;
        virtual void AddToBlockList(const DDLTYPE(qlist)< DDLTYPE(uint32) >::CPPType& lstPrincipalId) = 0;
        virtual void RemoveFromBlockList(const DDLTYPE(qlist)< DDLTYPE(uint32) >::CPPType& lstPrincipalId) = 0;
        virtual void ClearMyBlockList() = 0;
        virtual void ReportViolation(const DDLTYPE(uint32)::CPPType& pid, const DDLTYPE(string)::CPPType& userName, const DDLTYPE(uint32)::CPPType& violationCode) = 0;
        virtual void IsViolationUser(DDLTYPE(bool)::CPPType* flag, DDLTYPE(uint32)::CPPType* score) = 0;
        virtual void JoinMatchmakeSessionEx(const DDLTYPE(uint32)::CPPType& gid, const DDLTYPE(string)::CPPType& strMessage, const DDLTYPE(bool)::CPPType& dontCareMyBlockList, DDLTYPE(qvector)< DDLTYPE(byte) >::CPPType* sessionKey, const DDLTYPE(uint16)::CPPType& participationCount) = 0;
        virtual void GetSimplePlayingSession(const DDLTYPE(qlist)< DDLTYPE(uint32) >::CPPType& lstPrincipalId, const DDLTYPE(bool)::CPPType& includeLoginUser, DDLTYPE(qlist)< CLASSMETATYPE(SimplePlayingSession) >::CPPType* lstSimplePlayingSession) = 0;
        virtual void GetSimpleCommunity(const DDLTYPE(qlist)< DDLTYPE(uint32) >::CPPType& gatheringIdList, DDLTYPE(qlist)< CLASSMETATYPE(SimpleCommunity) >::CPPType* lstSimpleCommunityList) = 0;
        virtual void AutoMatchmakeWithGatheringId_Postpone(const DDLTYPE(qlist)< DDLTYPE(uint32) >::CPPType& lstGid, const DDLTYPE(any)< CLASSMETATYPE(Gathering), DDLTYPE(string) >::CPPType& anyGathering, DDLTYPE(any)< CLASSMETATYPE(Gathering), DDLTYPE(string) >::CPPType* joinedGathering, const DDLTYPE(string)::CPPType& strMessage) = 0;
        virtual void UpdateProgressScore(const DDLTYPE(uint32)::CPPType& gid, const DDLTYPE(byte)::CPPType& progressScore) = 0;
        virtual void DebugNotifyEvent(const DDLTYPE(uint32)::CPPType& pid, const DDLTYPE(uint32)::CPPType& mainType, const DDLTYPE(uint32)::CPPType& subType, const DDLTYPE(uint64)::CPPType& param1, const DDLTYPE(uint64)::CPPType& param2, const DDLTYPE(string)::CPPType& stringParam) = 0;
        virtual void GenerateMatchmakeSessionSystemPassword(const DDLTYPE(uint32)::CPPType& gid, DDLTYPE(string)::CPPType* password) = 0;
        virtual void ClearMatchmakeSessionSystemPassword(const DDLTYPE(uint32)::CPPType& gid) = 0;
        virtual void CreateMatchmakeSessionWithParam(const CreateMatchmakeSessionParam& createMatchmakeSessionParam, MatchmakeSession* joinedMatchmakeSession) = 0;
        virtual void JoinMatchmakeSessionWithParam(const JoinMatchmakeSessionParam& joinMatchmakeSessionParam, MatchmakeSession* joinedMatchmakeSession) = 0;
        virtual void AutoMatchmakeWithParam_Postpone(const AutoMatchmakeParam& autoMatchmakeParam, MatchmakeSession* joinedMatchmakeSession) = 0;
        virtual void FindMatchmakeSessionByGatheringIdDetail(const DDLTYPE(uint32)::CPPType& gid, MatchmakeSession* matchmakeSession) = 0;
        virtual void BrowseMatchmakeSessionNoHolder(const MatchmakeSessionSearchCriteria& searchCriteria, const ResultRange& resultRange, DDLTYPE(qlist)< CLASSMETATYPE(MatchmakeSession) >::CPPType* lstMatchmakeSession) = 0;
        virtual void BrowseMatchmakeSessionWithHostUrlsNoHolder(const MatchmakeSessionSearchCriteria& searchCriteria, const ResultRange& resultRange, DDLTYPE(qlist)< CLASSMETATYPE(MatchmakeSession) >::CPPType* lstMatchmakeSession, DDLTYPE(qlist)< CLASSMETATYPE(GatheringURLs) >::CPPType* lstGatheringUrls) = 0;
        virtual void UpdateMatchmakeSessionPart(const UpdateMatchmakeSessionParam& updateMatchmakeSessionParam) = 0;
        virtual void RequestMatchmaking(const AutoMatchmakeParam& autoMatchmakeParam, DDLTYPE(uint64)::CPPType* requestId) = 0;
        virtual void WithdrawMatchmaking(const DDLTYPE(uint64)::CPPType& requestId) = 0;
        virtual void WithdrawMatchmakingAll() = 0;
        virtual void FindMatchmakeSessionByGatheringId(const DDLTYPE(qlist)< DDLTYPE(uint32) >::CPPType& lstGid, DDLTYPE(qlist)< CLASSMETATYPE(MatchmakeSession) >::CPPType* lstMatchmakeSession) = 0;
        virtual void FindMatchmakeSessionBySingleGatheringId(const DDLTYPE(uint32)::CPPType& gid, MatchmakeSession* matchmakeSession) = 0;
        virtual void FindMatchmakeSessionByOwner(const DDLTYPE(uint32)::CPPType& id, const ResultRange& resultRange, DDLTYPE(qlist)< CLASSMETATYPE(MatchmakeSession) >::CPPType* lstMatchmakeSession) = 0;
        virtual void FindMatchmakeSessionByParticipant(const FindMatchmakeSessionByParticipantParam& param, DDLTYPE(qlist)< CLASSMETATYPE(FindMatchmakeSessionByParticipantResult) >::CPPType* lstSession) = 0;
        virtual void BrowseMatchmakeSessionNoHolderNoResultRange(const MatchmakeSessionSearchCriteria& searchCriteria, DDLTYPE(qlist)< CLASSMETATYPE(MatchmakeSession) >::CPPType* lstMatchmakeSession) = 0;
        virtual void BrowseMatchmakeSessionWithHostUrlsNoHolderNoResultRange(const MatchmakeSessionSearchCriteria& searchCriteria, DDLTYPE(qlist)< CLASSMETATYPE(MatchmakeSession) >::CPPType* lstMatchmakeSession, DDLTYPE(qlist)< CLASSMETATYPE(GatheringURLs) >::CPPType* lstGatheringUrls) = 0;
        virtual void FindCommunityByOwner(DDLTYPE(qlist)< CLASSMETATYPE(PersistentGathering) >::CPPType* lstCommunity, const DDLTYPE(uint32)::CPPType& id, const ResultRange& resultRange) = 0;
    
#if defined(LIVE_VERSION)
    private:
        ProfilingUnit m_CloseParticipationProfilingUnit;
        ProfilingUnit m_OpenParticipationProfilingUnit;
        ProfilingUnit m_AutoMatchmake_PostponeProfilingUnit;
        ProfilingUnit m_BrowseMatchmakeSessionProfilingUnit;
        ProfilingUnit m_BrowseMatchmakeSessionWithHostUrlsProfilingUnit;
        ProfilingUnit m_CreateMatchmakeSessionProfilingUnit;
        ProfilingUnit m_JoinMatchmakeSessionProfilingUnit;
        ProfilingUnit m_ModifyCurrentGameAttributeProfilingUnit;
        ProfilingUnit m_UpdateNotificationDataProfilingUnit;
        ProfilingUnit m_GetFriendNotificationDataProfilingUnit;
        ProfilingUnit m_UpdateApplicationBufferProfilingUnit;
        ProfilingUnit m_UpdateMatchmakeSessionAttributeProfilingUnit;
        ProfilingUnit m_GetlstFriendNotificationDataProfilingUnit;
        ProfilingUnit m_UpdateMatchmakeSessionProfilingUnit;
        ProfilingUnit m_AutoMatchmakeWithSearchCriteria_PostponeProfilingUnit;
        ProfilingUnit m_GetPlayingSessionProfilingUnit;
        ProfilingUnit m_CreateCommunityProfilingUnit;
        ProfilingUnit m_UpdateCommunityProfilingUnit;
        ProfilingUnit m_JoinCommunityProfilingUnit;
        ProfilingUnit m_FindCommunityByGatheringIdProfilingUnit;
        ProfilingUnit m_FindOfficialCommunityProfilingUnit;
        ProfilingUnit m_FindCommunityByParticipantProfilingUnit;
        ProfilingUnit m_UpdatePrivacySettingProfilingUnit;
        ProfilingUnit m_GetMyBlockListProfilingUnit;
        ProfilingUnit m_AddToBlockListProfilingUnit;
        ProfilingUnit m_RemoveFromBlockListProfilingUnit;
        ProfilingUnit m_ClearMyBlockListProfilingUnit;
        ProfilingUnit m_ReportViolationProfilingUnit;
        ProfilingUnit m_IsViolationUserProfilingUnit;
        ProfilingUnit m_JoinMatchmakeSessionExProfilingUnit;
        ProfilingUnit m_GetSimplePlayingSessionProfilingUnit;
        ProfilingUnit m_GetSimpleCommunityProfilingUnit;
        ProfilingUnit m_AutoMatchmakeWithGatheringId_PostponeProfilingUnit;
        ProfilingUnit m_UpdateProgressScoreProfilingUnit;
        ProfilingUnit m_DebugNotifyEventProfilingUnit;
        ProfilingUnit m_GenerateMatchmakeSessionSystemPasswordProfilingUnit;
        ProfilingUnit m_ClearMatchmakeSessionSystemPasswordProfilingUnit;
        ProfilingUnit m_CreateMatchmakeSessionWithParamProfilingUnit;
        ProfilingUnit m_JoinMatchmakeSessionWithParamProfilingUnit;
        ProfilingUnit m_AutoMatchmakeWithParam_PostponeProfilingUnit;
        ProfilingUnit m_FindMatchmakeSessionByGatheringIdDetailProfilingUnit;
        ProfilingUnit m_BrowseMatchmakeSessionNoHolderProfilingUnit;
        ProfilingUnit m_BrowseMatchmakeSessionWithHostUrlsNoHolderProfilingUnit;
        ProfilingUnit m_UpdateMatchmakeSessionPartProfilingUnit;
        ProfilingUnit m_RequestMatchmakingProfilingUnit;
        ProfilingUnit m_WithdrawMatchmakingProfilingUnit;
        ProfilingUnit m_WithdrawMatchmakingAllProfilingUnit;
        ProfilingUnit m_FindMatchmakeSessionByGatheringIdProfilingUnit;
        ProfilingUnit m_FindMatchmakeSessionBySingleGatheringIdProfilingUnit;
        ProfilingUnit m_FindMatchmakeSessionByOwnerProfilingUnit;
        ProfilingUnit m_FindMatchmakeSessionByParticipantProfilingUnit;
        ProfilingUnit m_BrowseMatchmakeSessionNoHolderNoResultRangeProfilingUnit;
        ProfilingUnit m_BrowseMatchmakeSessionWithHostUrlsNoHolderNoResultRangeProfilingUnit;
        ProfilingUnit m_FindCommunityByOwnerProfilingUnit;
#endif // LIVE_VERSION
    
};


END_NAMESPACE_NEX

#if defined(__ARMCC_VERSION) && (__ARMCC_VERSION >= 5000000)
#pragma pop
#endif // defined(__ARMCC_VERSION) && (__ARMCC_VERSION >= 5000000)
#if defined(_MSC_VER)
#pragma warning( pop )
#endif // defined(_MSC_VER)
