#pragma once
#if defined(__ARMCC_VERSION) && (__ARMCC_VERSION >= 5000000)
#pragma push
#pragma diag_suppress 228,381,550,1300,1301,2530
#endif // defined(__ARMCC_VERSION) && (__ARMCC_VERSION >= 5000000)
#if defined(_MSC_VER)
#pragma warning( push )
#pragma warning( disable : 4458 )
#endif // defined(_MSC_VER)

#include <OnlineCore/src/DDLTypes/CGCoreExports.h>
#include "OnlineCore/src/DDLTypes/OnlineCoreTypes.h"
#include "MatchmakeParam.h"
#include "RendezVous/Core/src/Common/ResultRange.h"

BEGIN_NAMESPACE_NEX
class MatchmakeSessionSearchCriteria;
END_NAMESPACE_NEX

BEGIN_NAMESPACE_NEX

class DDLCLASS(MatchmakeSessionSearchCriteria): public RootObject {
public:
    DDLCLASS(MatchmakeSessionSearchCriteria)():_mRevision_MatchmakeSessionSearchCriteria(0)
    , m_Attribs(0)     {};
    DDLCLASS(MatchmakeSessionSearchCriteria)(const DDLCLASS(MatchmakeSessionSearchCriteria) &oOther):
        RootObject(oOther),
        _mRevision_MatchmakeSessionSearchCriteria(oOther._mRevision_MatchmakeSessionSearchCriteria),
        m_Attribs(oOther.m_Attribs),
        m_GameMode(oOther.m_GameMode),
        m_MinParticipants(oOther.m_MinParticipants),
        m_MaxParticipants(oOther.m_MaxParticipants),
        m_MatchmakeSystemType(oOther.m_MatchmakeSystemType),
        m_VacantOnly(oOther.m_VacantOnly),
        m_ExcludeLocked(oOther.m_ExcludeLocked),
        m_ExcludeNonHostPid(oOther.m_ExcludeNonHostPid),
        m_SelectionMethod(oOther.m_SelectionMethod),
        m_VacantParticipants(oOther.m_VacantParticipants),
        m_MatchmakeParam(oOther.m_MatchmakeParam),
        m_ExcludeUserPasswordSet(oOther.m_ExcludeUserPasswordSet),
        m_ExcludeSystemPasswordSet(oOther.m_ExcludeSystemPasswordSet),
        m_ReferGid(oOther.m_ReferGid),
        m_Codeword(oOther.m_Codeword),
        m_ResultRange(oOther.m_ResultRange)
    {
    }
    virtual ~DDLCLASS(MatchmakeSessionSearchCriteria)() {};
    const DDLCLASS(MatchmakeSessionSearchCriteria) &operator=(const DDLCLASS(MatchmakeSessionSearchCriteria) &oOther);
    qBool operator==(const DDLCLASS(MatchmakeSessionSearchCriteria) &oOther) const;
    #ifdef OSDK_DLL_SUPPORT
    qBool operator<(const DDLCLASS(MatchmakeSessionSearchCriteria) &oOther) const;
    #endif
    static void Add(Message *pMessageToSend, const DDLCLASS(MatchmakeSessionSearchCriteria) &oValue);
    static void Extract(Message *pReceivedMessage, DDLCLASS(MatchmakeSessionSearchCriteria) *pValue);
    qByte _mRevision_MatchmakeSessionSearchCriteria;
    qByte GetClassRevision_MatchmakeSessionSearchCriteria() const {return _mRevision_MatchmakeSessionSearchCriteria;}
    void SetClassRevision_MatchmakeSessionSearchCriteria(qByte revision) {_mRevision_MatchmakeSessionSearchCriteria=revision;}
    static qByte GetKnownMaxClassRevision_MatchmakeSessionSearchCriteria() {return 0;}
    DDLTYPE(qvector)< DDLTYPE(string) >::CPPType m_Attribs;
    NEX_CLASS_VALID_REVISION_DEF(m_Attribs, 0);
    qBool NEX_CLASS_ISVALID(m_Attribs) const { return true; /* The revision is 0. Always true */}
    DDLTYPE(string)::CPPType m_GameMode;
    NEX_CLASS_VALID_REVISION_DEF(m_GameMode, 0);
    qBool NEX_CLASS_ISVALID(m_GameMode) const { return true; /* The revision is 0. Always true */}
    DDLTYPE(string)::CPPType m_MinParticipants;
    NEX_CLASS_VALID_REVISION_DEF(m_MinParticipants, 0);
    qBool NEX_CLASS_ISVALID(m_MinParticipants) const { return true; /* The revision is 0. Always true */}
    DDLTYPE(string)::CPPType m_MaxParticipants;
    NEX_CLASS_VALID_REVISION_DEF(m_MaxParticipants, 0);
    qBool NEX_CLASS_ISVALID(m_MaxParticipants) const { return true; /* The revision is 0. Always true */}
    DDLTYPE(string)::CPPType m_MatchmakeSystemType;
    NEX_CLASS_VALID_REVISION_DEF(m_MatchmakeSystemType, 0);
    qBool NEX_CLASS_ISVALID(m_MatchmakeSystemType) const { return true; /* The revision is 0. Always true */}
    DDLTYPE(bool)::CPPType m_VacantOnly;
    NEX_CLASS_VALID_REVISION_DEF(m_VacantOnly, 0);
    qBool NEX_CLASS_ISVALID(m_VacantOnly) const { return true; /* The revision is 0. Always true */}
    DDLTYPE(bool)::CPPType m_ExcludeLocked;
    NEX_CLASS_VALID_REVISION_DEF(m_ExcludeLocked, 0);
    qBool NEX_CLASS_ISVALID(m_ExcludeLocked) const { return true; /* The revision is 0. Always true */}
    DDLTYPE(bool)::CPPType m_ExcludeNonHostPid;
    NEX_CLASS_VALID_REVISION_DEF(m_ExcludeNonHostPid, 0);
    qBool NEX_CLASS_ISVALID(m_ExcludeNonHostPid) const { return true; /* The revision is 0. Always true */}
    DDLTYPE(uint32)::CPPType m_SelectionMethod;
    NEX_CLASS_VALID_REVISION_DEF(m_SelectionMethod, 0);
    qBool NEX_CLASS_ISVALID(m_SelectionMethod) const { return true; /* The revision is 0. Always true */}
    DDLTYPE(uint16)::CPPType m_VacantParticipants;
    NEX_CLASS_VALID_REVISION_DEF(m_VacantParticipants, 0);
    qBool NEX_CLASS_ISVALID(m_VacantParticipants) const { return true; /* The revision is 0. Always true */}
    MatchmakeParam m_MatchmakeParam;
    NEX_CLASS_VALID_REVISION_DEF(m_MatchmakeParam, 0);
    qBool NEX_CLASS_ISVALID(m_MatchmakeParam) const { return true; /* The revision is 0. Always true */}
    DDLTYPE(bool)::CPPType m_ExcludeUserPasswordSet;
    NEX_CLASS_VALID_REVISION_DEF(m_ExcludeUserPasswordSet, 0);
    qBool NEX_CLASS_ISVALID(m_ExcludeUserPasswordSet) const { return true; /* The revision is 0. Always true */}
    DDLTYPE(bool)::CPPType m_ExcludeSystemPasswordSet;
    NEX_CLASS_VALID_REVISION_DEF(m_ExcludeSystemPasswordSet, 0);
    qBool NEX_CLASS_ISVALID(m_ExcludeSystemPasswordSet) const { return true; /* The revision is 0. Always true */}
    DDLTYPE(uint32)::CPPType m_ReferGid;
    NEX_CLASS_VALID_REVISION_DEF(m_ReferGid, 0);
    qBool NEX_CLASS_ISVALID(m_ReferGid) const { return true; /* The revision is 0. Always true */}
    DDLTYPE(string)::CPPType m_Codeword;
    NEX_CLASS_VALID_REVISION_DEF(m_Codeword, 0);
    qBool NEX_CLASS_ISVALID(m_Codeword) const { return true; /* The revision is 0. Always true */}
    ResultRange m_ResultRange;
    NEX_CLASS_VALID_REVISION_DEF(m_ResultRange, 0);
    qBool NEX_CLASS_ISVALID(m_ResultRange) const { return true; /* The revision is 0. Always true */}
};


class DDLTYPE(MatchmakeSessionSearchCriteria): public DDLType {
public:
    typedef MatchmakeSessionSearchCriteria CPPType;
    static void Add(Message* pMessageToSend, const DDLCLASS(MatchmakeSessionSearchCriteria)& oMatchmakeSessionSearchCriteria) {
        DDLCLASS(MatchmakeSessionSearchCriteria)::Add(pMessageToSend,oMatchmakeSessionSearchCriteria);
    }
    static void Extract(Message* pReceivedMessage, DDLCLASS(MatchmakeSessionSearchCriteria)* pMatchmakeSessionSearchCriteriaToRefresh) {
        DDLCLASS(MatchmakeSessionSearchCriteria)::Extract(pReceivedMessage,pMatchmakeSessionSearchCriteriaToRefresh);
    }
};


END_NAMESPACE_NEX

#if defined(__ARMCC_VERSION) && (__ARMCC_VERSION >= 5000000)
#pragma pop
#endif // defined(__ARMCC_VERSION) && (__ARMCC_VERSION >= 5000000)
#if defined(_MSC_VER)
#pragma warning( pop )
#endif // defined(_MSC_VER)
