﻿/*---------------------------------------------------------------------------*
  Copyright (C)2011-2018 Nintendo Co., Ltd.  All rights reserved.

  These coded instructions, statements, and computer programs contain
  proprietary information of Nintendo of America Inc. and/or Nintendo
  Company Ltd., and are protected by Federal copyright law.  They may
  not be disclosed to third parties or copied or duplicated in any form,
  in whole or in part, without the prior written consent of Nintendo.
 *---------------------------------------------------------------------------*/

#pragma once

#include <OnlineCore/src/Platform/Core/PlatformDecl.h>

BEGIN_NAMESPACE_NEX

#ifdef SWIG
class MatchmakingCompletionResult
{
public:
#else
/*!
 @brief MatchmakingCompletionResult の 名前空間です。
*/
namespace MatchmakingCompletionResult
{
#endif

/*!
 @brief サーバーサイドマッチメイクの結果
*/
enum MatchmakingCompletionResult
{
    /*!
     @brief 使用されません
     */
    NONE                    = 0x00000000L,
    /*!
     @brief 成功。
     */
    SUCCESS                 = 0x00000001L,
    /*!
     @brief 不明なエラー。
     */
    ERROR_UNKNOWN           = 0x00000002L,
    /*!
     @brief 取り下げられた。
     */
    ERROR_WITHDRAW          = 0x00000003L,
    /*!
     @brief 不正なリクエスト。
     */
    ERROR_INVALID_REQUEST   = 0x00000004L,
    /*!
     @brief すでにマッチメイクのリクエスト中のカテゴリにリクエストを行った。
     */
    ERROR_DUPLICATE_ENTRY   = 0x00000005L,
    /*!
     @brief マッチメイクセッションに参加する段階での失敗。
     */
    ERROR_FAIL_JOINING      = 0x00000006L
};

#ifdef SWIG
};
#else
}
#endif

END_NAMESPACE_NEX

