﻿/*---------------------------------------------------------------------------*
  Copyright (C)2011-2018 Nintendo Co., Ltd.  All rights reserved.
 
  These coded instructions, statements, and computer programs contain
  proprietary information of Nintendo of America Inc. and/or Nintendo
  Company Ltd., and are protected by Federal copyright law.  They may
  not be disclosed to third parties or copied or duplicated in any form,
  in whole or in part, without the prior written consent of Nintendo.
 *---------------------------------------------------------------------------*/

#pragma once

#include <OnlineCore/src/Platform/Core/PlatformDecl.h>

BEGIN_NAMESPACE_NEX

/*!
    @brief MatchmakeReferee に関する定数が定義された名前空間です。
*/
namespace MatchmakeRefereeConstants
{

/// MatchmakeRefereePersonalRoundResult に設定できるbufferの最大長です。
static const qUnsignedInt32 STATS_BUFFER_MAX_SIZE = 128;

/*!
    @brief MatchmakeRefereeRound の状態です。
*/
enum RoundState
{
    ROUND_STATE_FIGHT             = 0, //!< 対戦中。
    ROUND_STATE_ARBITRATION       = 1, //!< 最初の( MatchmakeRefereeClient::EndRound() による )レポートを受信済み 。
    ROUND_STATE_RESULT_AVAILABLE  = 2, //!< レポート集計・正規化完了。
    ROUND_STATE_NO_CONTEST        = 3  //!< レポート不一致等により無効なラウンドとされた状態。
};

/*!
    @brief ラウンドのプレイヤー情報を示すビットフラグです。
*/
enum PersonalRoundResultFlag
{
    PERSONAL_ROUND_RESULT_FLAG_NONE       = 0x0000, //!< 設定無し。
    PERSONAL_ROUND_RESULT_FLAG_DISCONNECT = 0x0001, //!< 切断。
    PERSONAL_ROUND_RESULT_FLAG_VIOLATION  = 0x0002  //!< マナー違反。
};

/*!
    @brief ラウンドの勝敗です。
*/
enum RoundResult
{
    ROUND_RESULT_LOSS  = 0, //!< 負け。
    ROUND_RESULT_WIN   = 1, //!< 勝ち。
    ROUND_RESULT_DRAW  = 2  //!< 引き分け。
};

}

END_NAMESPACE_NEX

