#pragma once
#if defined(__ARMCC_VERSION) && (__ARMCC_VERSION >= 5000000)
#pragma push
#pragma diag_suppress 228,381,550,1300,1301,2530
#endif // defined(__ARMCC_VERSION) && (__ARMCC_VERSION >= 5000000)
#if defined(_MSC_VER)
#pragma warning( push )
#pragma warning( disable : 4458 )
#endif // defined(_MSC_VER)


#include <OnlineCore/src/DDLTypes/CGCoreExports.h>

#include <RendezVous/Core/src/Common/ClientProtocol.h>
#include <RendezVous/Core/src/Common/ServerProtocol.h>
#include <OnlineCore/src/Core/CallContextRegister.h>
#include <RendezVous/Core/src/Common/ProtocolCGMacros.h>
#include <RendezVous/Core/src/Common/ProtocolCallContext.h>
#include <RendezVous/Core/src/Common/ProtocolRequestBrokerInterface.h>
#include <RendezVous/Core/src/Common/Protocol.h>
#include <RendezVous/Core/src/Common/ProtocolList.h>
#include <OnlineCore/src/Transport/Interface/TransportError.h>
#include <RendezVous/Core/src/Client/RVClientCore.h>
#include <RendezVous/Core/src/Client/ProtocolRegistry.h>
#include "RankingScoreData.h"
#include "OnlineCore/src/DDLTypes/OnlineCoreTypes.h"
#include "RankingChangeAttributesParam.h"
#include "RankingOrderParam.h"
#include "RankingResult.h"
#include "RankingStats.h"
#include "RankingCachedResult.h"

BEGIN_NAMESPACE_NEX

PROTO_DEFINE_RMCID(RankingProtocol, UploadScore, 1 );
PROTO_DEFINE_RMCID(RankingProtocol, DeleteScore, 2 );
PROTO_DEFINE_RMCID(RankingProtocol, DeleteAllScores, 3 );
PROTO_DEFINE_RMCID(RankingProtocol, UploadCommonData, 4 );
PROTO_DEFINE_RMCID(RankingProtocol, DeleteCommonData, 5 );
PROTO_DEFINE_RMCID(RankingProtocol, GetCommonData, 6 );
PROTO_DEFINE_RMCID(RankingProtocol, ChangeAttributes, 7 );
PROTO_DEFINE_RMCID(RankingProtocol, ChangeAllAttributes, 8 );
PROTO_DEFINE_RMCID(RankingProtocol, GetRanking, 9 );
PROTO_DEFINE_RMCID(RankingProtocol, GetApproxOrder, 10 );
PROTO_DEFINE_RMCID(RankingProtocol, GetStats, 11 );
PROTO_DEFINE_RMCID(RankingProtocol, GetRankingByPIDList, 12 );
PROTO_DEFINE_RMCID(RankingProtocol, GetRankingByUniqueIdList, 13 );
PROTO_DEFINE_RMCID(RankingProtocol, GetCachedTopXRanking, 14 );
PROTO_DEFINE_RMCID(RankingProtocol, GetCachedTopXRankings, 15 );
PROTO_DEFINE_NUM_RMC(RankingProtocol, 15);

class RankingProtocolClient : public ClientProtocol {
    public:
        typedef CLASSMETATYPE(RankingScoreData) TUploadScore_scoreData;
        typedef DDLTYPE(uint64) TUploadScore_uniqueId;
        PROTO_RMCIMPL_RETURN(RankingProtocol, UploadScore)
        {
            PROTO_RETURNSTUB_IMPL();
            PROTO_RETURNSTUB_END();
        };
        
        typedef DDLTYPE(uint32) TDeleteScore_category;
        typedef DDLTYPE(uint64) TDeleteScore_uniqueId;
        PROTO_RMCIMPL_RETURN(RankingProtocol, DeleteScore)
        {
            PROTO_RETURNSTUB_IMPL();
            PROTO_RETURNSTUB_END();
        };
        
        typedef DDLTYPE(uint64) TDeleteAllScores_uniqueId;
        PROTO_RMCIMPL_RETURN(RankingProtocol, DeleteAllScores)
        {
            PROTO_RETURNSTUB_IMPL();
            PROTO_RETURNSTUB_END();
        };
        
        typedef DDLTYPE(qvector)< DDLTYPE(byte) > TUploadCommonData_commonData;
        typedef DDLTYPE(uint64) TUploadCommonData_uniqueId;
        PROTO_RMCIMPL_RETURN(RankingProtocol, UploadCommonData)
        {
            PROTO_RETURNSTUB_IMPL();
            PROTO_RETURNSTUB_END();
        };
        
        typedef DDLTYPE(uint64) TDeleteCommonData_uniqueId;
        PROTO_RMCIMPL_RETURN(RankingProtocol, DeleteCommonData)
        {
            PROTO_RETURNSTUB_IMPL();
            PROTO_RETURNSTUB_END();
        };
        
        typedef DDLTYPE(qvector)< DDLTYPE(byte) > TGetCommonData_commonData;
        typedef DDLTYPE(uint64) TGetCommonData_uniqueId;
        PROTO_RMCIMPL_RETURN(RankingProtocol, GetCommonData)
        {
            PROTO_RETURNSTUB_IMPL();
            _DO_RMC_ExtractReturnValue(TGetCommonData_commonData,1);
            PROTO_RETURNSTUB_END();
        };
        
        typedef DDLTYPE(uint32) TChangeAttributes_category;
        typedef CLASSMETATYPE(RankingChangeAttributesParam) TChangeAttributes_changeParam;
        typedef DDLTYPE(uint64) TChangeAttributes_uniqueId;
        PROTO_RMCIMPL_RETURN(RankingProtocol, ChangeAttributes)
        {
            PROTO_RETURNSTUB_IMPL();
            PROTO_RETURNSTUB_END();
        };
        
        typedef CLASSMETATYPE(RankingChangeAttributesParam) TChangeAllAttributes_changeParam;
        typedef DDLTYPE(uint64) TChangeAllAttributes_uniqueId;
        PROTO_RMCIMPL_RETURN(RankingProtocol, ChangeAllAttributes)
        {
            PROTO_RETURNSTUB_IMPL();
            PROTO_RETURNSTUB_END();
        };
        
        typedef DDLTYPE(byte) TGetRanking_rankingMode;
        typedef DDLTYPE(uint32) TGetRanking_category;
        typedef CLASSMETATYPE(RankingOrderParam) TGetRanking_orderParam;
        typedef CLASSMETATYPE(RankingResult) TGetRanking_pResult;
        typedef DDLTYPE(uint64) TGetRanking_uniqueId;
        typedef DDLTYPE(uint32) TGetRanking_principalId;
        PROTO_RMCIMPL_RETURN(RankingProtocol, GetRanking)
        {
            PROTO_RETURNSTUB_IMPL();
            _DO_RMC_ExtractReturnValue(TGetRanking_pResult,1);
            PROTO_RETURNSTUB_END();
        };
        
        typedef DDLTYPE(uint32) TGetApproxOrder_category;
        typedef CLASSMETATYPE(RankingOrderParam) TGetApproxOrder_orderParam;
        typedef DDLTYPE(uint32) TGetApproxOrder_score;
        typedef DDLTYPE(uint32) TGetApproxOrder_pOrder;
        typedef DDLTYPE(uint64) TGetApproxOrder_uniqueId;
        typedef DDLTYPE(uint32) TGetApproxOrder_principalId;
        PROTO_RMCIMPL_RETURN(RankingProtocol, GetApproxOrder)
        {
            PROTO_RETURNSTUB_IMPL();
            _DO_RMC_ExtractReturnValue(TGetApproxOrder_pOrder,1);
            PROTO_RETURNSTUB_END();
        };
        
        typedef DDLTYPE(uint32) TGetStats_category;
        typedef CLASSMETATYPE(RankingOrderParam) TGetStats_orderParam;
        typedef DDLTYPE(uint32) TGetStats_flags;
        typedef CLASSMETATYPE(RankingStats) TGetStats_pStats;
        PROTO_RMCIMPL_RETURN(RankingProtocol, GetStats)
        {
            PROTO_RETURNSTUB_IMPL();
            _DO_RMC_ExtractReturnValue(TGetStats_pStats,1);
            PROTO_RETURNSTUB_END();
        };
        
        typedef DDLTYPE(qvector)< DDLTYPE(uint32) > TGetRankingByPIDList_principalIdList;
        typedef DDLTYPE(byte) TGetRankingByPIDList_rankingMode;
        typedef DDLTYPE(uint32) TGetRankingByPIDList_category;
        typedef CLASSMETATYPE(RankingOrderParam) TGetRankingByPIDList_orderParam;
        typedef CLASSMETATYPE(RankingResult) TGetRankingByPIDList_pResult;
        typedef DDLTYPE(uint64) TGetRankingByPIDList_uniqueId;
        PROTO_RMCIMPL_RETURN(RankingProtocol, GetRankingByPIDList)
        {
            PROTO_RETURNSTUB_IMPL();
            _DO_RMC_ExtractReturnValue(TGetRankingByPIDList_pResult,1);
            PROTO_RETURNSTUB_END();
        };
        
        typedef DDLTYPE(qvector)< DDLTYPE(uint64) > TGetRankingByUniqueIdList_nexUniqueIdList;
        typedef DDLTYPE(byte) TGetRankingByUniqueIdList_rankingMode;
        typedef DDLTYPE(uint32) TGetRankingByUniqueIdList_category;
        typedef CLASSMETATYPE(RankingOrderParam) TGetRankingByUniqueIdList_orderParam;
        typedef CLASSMETATYPE(RankingResult) TGetRankingByUniqueIdList_pResult;
        typedef DDLTYPE(uint64) TGetRankingByUniqueIdList_uniqueId;
        PROTO_RMCIMPL_RETURN(RankingProtocol, GetRankingByUniqueIdList)
        {
            PROTO_RETURNSTUB_IMPL();
            _DO_RMC_ExtractReturnValue(TGetRankingByUniqueIdList_pResult,1);
            PROTO_RETURNSTUB_END();
        };
        
        typedef DDLTYPE(uint32) TGetCachedTopXRanking_category;
        typedef CLASSMETATYPE(RankingOrderParam) TGetCachedTopXRanking_orderParam;
        typedef CLASSMETATYPE(RankingCachedResult) TGetCachedTopXRanking_pResult;
        PROTO_RMCIMPL_RETURN(RankingProtocol, GetCachedTopXRanking)
        {
            PROTO_RETURNSTUB_IMPL();
            _DO_RMC_ExtractReturnValue(TGetCachedTopXRanking_pResult,1);
            PROTO_RETURNSTUB_END();
        };
        
        typedef DDLTYPE(qvector)< DDLTYPE(uint32) > TGetCachedTopXRankings_categories;
        typedef DDLTYPE(qvector)< CLASSMETATYPE(RankingOrderParam) > TGetCachedTopXRankings_orderParams;
        typedef DDLTYPE(qvector)< CLASSMETATYPE(RankingCachedResult) > TGetCachedTopXRankings_pResults;
        PROTO_RMCIMPL_RETURN(RankingProtocol, GetCachedTopXRankings)
        {
            PROTO_RETURNSTUB_IMPL();
            _DO_RMC_ExtractReturnValue(TGetCachedTopXRankings_pResults,1);
            PROTO_RETURNSTUB_END();
        };
        
        RankingProtocolClient(ProtocolID uiProtocolID);
        virtual ClientProtocol* CreateResponder() const { return qNew RankingProtocolClient(ProtocolList::Unknown); }
        void RegisterProtocol()
        {
            SYSTEMCHECK(GetProtocolID() != ProtocolList::Unknown);
            SYSTEMCHECK(RVClientCore::GetInstance() != NULL && "You should create ServiceClient or NgsFacade(RendezVous) first.");
            RVClientCore::GetInstance()->GetProtocolRegistry()->RegisterProtocol(GetProtocolID(), CreateResponder());
        }
        virtual void ExtractCallSpecificResults(Message *pMessage, ProtocolCallContext* pContext);
        
        qBool CallUploadScore(ProtocolCallContext *pContext, const RankingScoreData& scoreData, const DDLTYPE(uint64)::CPPType& uniqueId);
        static qBool UploadScore_PrepareRequest(ProtocolCallContext *pContext, Message *pMsg, const RankingScoreData& scoreData, const DDLTYPE(uint64)::CPPType& uniqueId);
        qBool CallDeleteScore(ProtocolCallContext *pContext, const DDLTYPE(uint32)::CPPType& category, const DDLTYPE(uint64)::CPPType& uniqueId);
        static qBool DeleteScore_PrepareRequest(ProtocolCallContext *pContext, Message *pMsg, const DDLTYPE(uint32)::CPPType& category, const DDLTYPE(uint64)::CPPType& uniqueId);
        qBool CallDeleteAllScores(ProtocolCallContext *pContext, const DDLTYPE(uint64)::CPPType& uniqueId);
        static qBool DeleteAllScores_PrepareRequest(ProtocolCallContext *pContext, Message *pMsg, const DDLTYPE(uint64)::CPPType& uniqueId);
        qBool CallUploadCommonData(ProtocolCallContext *pContext, const DDLTYPE(qvector)< DDLTYPE(byte) >::CPPType& commonData, const DDLTYPE(uint64)::CPPType& uniqueId);
        static qBool UploadCommonData_PrepareRequest(ProtocolCallContext *pContext, Message *pMsg, const DDLTYPE(qvector)< DDLTYPE(byte) >::CPPType& commonData, const DDLTYPE(uint64)::CPPType& uniqueId);
        qBool CallDeleteCommonData(ProtocolCallContext *pContext, const DDLTYPE(uint64)::CPPType& uniqueId);
        static qBool DeleteCommonData_PrepareRequest(ProtocolCallContext *pContext, Message *pMsg, const DDLTYPE(uint64)::CPPType& uniqueId);
        qBool CallGetCommonData(ProtocolCallContext *pContext, DDLTYPE(qvector)< DDLTYPE(byte) >::CPPType* commonData, const DDLTYPE(uint64)::CPPType& uniqueId);
        static qBool GetCommonData_PrepareRequest(ProtocolCallContext *pContext, Message *pMsg, DDLTYPE(qvector)< DDLTYPE(byte) >::CPPType* commonData, const DDLTYPE(uint64)::CPPType& uniqueId);
        qBool CallChangeAttributes(ProtocolCallContext *pContext, const DDLTYPE(uint32)::CPPType& category, const RankingChangeAttributesParam& changeParam, const DDLTYPE(uint64)::CPPType& uniqueId);
        static qBool ChangeAttributes_PrepareRequest(ProtocolCallContext *pContext, Message *pMsg, const DDLTYPE(uint32)::CPPType& category, const RankingChangeAttributesParam& changeParam, const DDLTYPE(uint64)::CPPType& uniqueId);
        qBool CallChangeAllAttributes(ProtocolCallContext *pContext, const RankingChangeAttributesParam& changeParam, const DDLTYPE(uint64)::CPPType& uniqueId);
        static qBool ChangeAllAttributes_PrepareRequest(ProtocolCallContext *pContext, Message *pMsg, const RankingChangeAttributesParam& changeParam, const DDLTYPE(uint64)::CPPType& uniqueId);
        qBool CallGetRanking(ProtocolCallContext *pContext, const DDLTYPE(byte)::CPPType& rankingMode, const DDLTYPE(uint32)::CPPType& category, const RankingOrderParam& orderParam, RankingResult* pResult, const DDLTYPE(uint64)::CPPType& uniqueId, const DDLTYPE(uint32)::CPPType& principalId);
        static qBool GetRanking_PrepareRequest(ProtocolCallContext *pContext, Message *pMsg, const DDLTYPE(byte)::CPPType& rankingMode, const DDLTYPE(uint32)::CPPType& category, const RankingOrderParam& orderParam, RankingResult* pResult, const DDLTYPE(uint64)::CPPType& uniqueId, const DDLTYPE(uint32)::CPPType& principalId);
        qBool CallGetApproxOrder(ProtocolCallContext *pContext, const DDLTYPE(uint32)::CPPType& category, const RankingOrderParam& orderParam, const DDLTYPE(uint32)::CPPType& score, DDLTYPE(uint32)::CPPType* pOrder, const DDLTYPE(uint64)::CPPType& uniqueId, const DDLTYPE(uint32)::CPPType& principalId);
        static qBool GetApproxOrder_PrepareRequest(ProtocolCallContext *pContext, Message *pMsg, const DDLTYPE(uint32)::CPPType& category, const RankingOrderParam& orderParam, const DDLTYPE(uint32)::CPPType& score, DDLTYPE(uint32)::CPPType* pOrder, const DDLTYPE(uint64)::CPPType& uniqueId, const DDLTYPE(uint32)::CPPType& principalId);
        qBool CallGetStats(ProtocolCallContext *pContext, const DDLTYPE(uint32)::CPPType& category, const RankingOrderParam& orderParam, const DDLTYPE(uint32)::CPPType& flags, RankingStats* pStats);
        static qBool GetStats_PrepareRequest(ProtocolCallContext *pContext, Message *pMsg, const DDLTYPE(uint32)::CPPType& category, const RankingOrderParam& orderParam, const DDLTYPE(uint32)::CPPType& flags, RankingStats* pStats);
        qBool CallGetRankingByPIDList(ProtocolCallContext *pContext, const DDLTYPE(qvector)< DDLTYPE(uint32) >::CPPType& principalIdList, const DDLTYPE(byte)::CPPType& rankingMode, const DDLTYPE(uint32)::CPPType& category, const RankingOrderParam& orderParam, RankingResult* pResult, const DDLTYPE(uint64)::CPPType& uniqueId);
        static qBool GetRankingByPIDList_PrepareRequest(ProtocolCallContext *pContext, Message *pMsg, const DDLTYPE(qvector)< DDLTYPE(uint32) >::CPPType& principalIdList, const DDLTYPE(byte)::CPPType& rankingMode, const DDLTYPE(uint32)::CPPType& category, const RankingOrderParam& orderParam, RankingResult* pResult, const DDLTYPE(uint64)::CPPType& uniqueId);
        qBool CallGetRankingByUniqueIdList(ProtocolCallContext *pContext, const DDLTYPE(qvector)< DDLTYPE(uint64) >::CPPType& nexUniqueIdList, const DDLTYPE(byte)::CPPType& rankingMode, const DDLTYPE(uint32)::CPPType& category, const RankingOrderParam& orderParam, RankingResult* pResult, const DDLTYPE(uint64)::CPPType& uniqueId);
        static qBool GetRankingByUniqueIdList_PrepareRequest(ProtocolCallContext *pContext, Message *pMsg, const DDLTYPE(qvector)< DDLTYPE(uint64) >::CPPType& nexUniqueIdList, const DDLTYPE(byte)::CPPType& rankingMode, const DDLTYPE(uint32)::CPPType& category, const RankingOrderParam& orderParam, RankingResult* pResult, const DDLTYPE(uint64)::CPPType& uniqueId);
        qBool CallGetCachedTopXRanking(ProtocolCallContext *pContext, const DDLTYPE(uint32)::CPPType& category, const RankingOrderParam& orderParam, RankingCachedResult* pResult);
        static qBool GetCachedTopXRanking_PrepareRequest(ProtocolCallContext *pContext, Message *pMsg, const DDLTYPE(uint32)::CPPType& category, const RankingOrderParam& orderParam, RankingCachedResult* pResult);
        qBool CallGetCachedTopXRankings(ProtocolCallContext *pContext, const DDLTYPE(qvector)< DDLTYPE(uint32) >::CPPType& categories, const DDLTYPE(qvector)< CLASSMETATYPE(RankingOrderParam) >::CPPType& orderParams, DDLTYPE(qvector)< CLASSMETATYPE(RankingCachedResult) >::CPPType* pResults);
        static qBool GetCachedTopXRankings_PrepareRequest(ProtocolCallContext *pContext, Message *pMsg, const DDLTYPE(qvector)< DDLTYPE(uint32) >::CPPType& categories, const DDLTYPE(qvector)< CLASSMETATYPE(RankingOrderParam) >::CPPType& orderParams, DDLTYPE(qvector)< CLASSMETATYPE(RankingCachedResult) >::CPPType* pResults);
        
        protected:
        static ProtoReturnFunction s_protoReturnFunctions[PROTO_NUM_RMC(RankingProtocol) + 1];
};

class DDLPROTOCOL(RankingProtocolServer) : public ServerProtocol {
    public:
        DDLPROTOCOL(RankingProtocolServer)()
            : ServerProtocol()
#if defined(LIVE_VERSION)
            , m_UploadScoreProfilingUnit(NEX_T("RankingProtocol::UploadScore"))
            , m_DeleteScoreProfilingUnit(NEX_T("RankingProtocol::DeleteScore"))
            , m_DeleteAllScoresProfilingUnit(NEX_T("RankingProtocol::DeleteAllScores"))
            , m_UploadCommonDataProfilingUnit(NEX_T("RankingProtocol::UploadCommonData"))
            , m_DeleteCommonDataProfilingUnit(NEX_T("RankingProtocol::DeleteCommonData"))
            , m_GetCommonDataProfilingUnit(NEX_T("RankingProtocol::GetCommonData"))
            , m_ChangeAttributesProfilingUnit(NEX_T("RankingProtocol::ChangeAttributes"))
            , m_ChangeAllAttributesProfilingUnit(NEX_T("RankingProtocol::ChangeAllAttributes"))
            , m_GetRankingProfilingUnit(NEX_T("RankingProtocol::GetRanking"))
            , m_GetApproxOrderProfilingUnit(NEX_T("RankingProtocol::GetApproxOrder"))
            , m_GetStatsProfilingUnit(NEX_T("RankingProtocol::GetStats"))
            , m_GetRankingByPIDListProfilingUnit(NEX_T("RankingProtocol::GetRankingByPIDList"))
            , m_GetRankingByUniqueIdListProfilingUnit(NEX_T("RankingProtocol::GetRankingByUniqueIdList"))
            , m_GetCachedTopXRankingProfilingUnit(NEX_T("RankingProtocol::GetCachedTopXRanking"))
            , m_GetCachedTopXRankingsProfilingUnit(NEX_T("RankingProtocol::GetCachedTopXRankings"))
#endif // LIVE_VERSION
            {}
        
        typedef CLASSMETATYPE(RankingScoreData) TUploadScore_scoreData;
        typedef DDLTYPE(uint64) TUploadScore_uniqueId;
        PROTO_RMCIMPL_STUB(RankingProtocol, UploadScore)
        {
            PROTO_PREPARE_EXTRACTION();
            RankingScoreData scoreData;
            _MSG_EXTRACT_VARIABLE(TUploadScore_scoreData, scoreData);
            DDLTYPE(uint64)::CPPType uniqueId;
            _MSG_EXTRACT_VARIABLE(TUploadScore_uniqueId, uniqueId);
            pProtocol->UploadScore( scoreData, uniqueId );
            PROTO_PREPARE_RETURN(RankingProtocol,UploadScore);
        }
        
        typedef DDLTYPE(uint32) TDeleteScore_category;
        typedef DDLTYPE(uint64) TDeleteScore_uniqueId;
        PROTO_RMCIMPL_STUB(RankingProtocol, DeleteScore)
        {
            PROTO_PREPARE_EXTRACTION();
            DDLTYPE(uint32)::CPPType category;
            _MSG_EXTRACT_VARIABLE(TDeleteScore_category, category);
            DDLTYPE(uint64)::CPPType uniqueId;
            _MSG_EXTRACT_VARIABLE(TDeleteScore_uniqueId, uniqueId);
            pProtocol->DeleteScore( category, uniqueId );
            PROTO_PREPARE_RETURN(RankingProtocol,DeleteScore);
        }
        
        typedef DDLTYPE(uint64) TDeleteAllScores_uniqueId;
        PROTO_RMCIMPL_STUB(RankingProtocol, DeleteAllScores)
        {
            PROTO_PREPARE_EXTRACTION();
            DDLTYPE(uint64)::CPPType uniqueId;
            _MSG_EXTRACT_VARIABLE(TDeleteAllScores_uniqueId, uniqueId);
            pProtocol->DeleteAllScores( uniqueId );
            PROTO_PREPARE_RETURN(RankingProtocol,DeleteAllScores);
        }
        
        typedef DDLTYPE(qvector)< DDLTYPE(byte) > TUploadCommonData_commonData;
        typedef DDLTYPE(uint64) TUploadCommonData_uniqueId;
        PROTO_RMCIMPL_STUB(RankingProtocol, UploadCommonData)
        {
            PROTO_PREPARE_EXTRACTION();
            DDLTYPE(qvector)< DDLTYPE(byte) >::CPPType commonData;
            _MSG_EXTRACT_VARIABLE(TUploadCommonData_commonData, commonData);
            DDLTYPE(uint64)::CPPType uniqueId;
            _MSG_EXTRACT_VARIABLE(TUploadCommonData_uniqueId, uniqueId);
            pProtocol->UploadCommonData( commonData, uniqueId );
            PROTO_PREPARE_RETURN(RankingProtocol,UploadCommonData);
        }
        
        typedef DDLTYPE(uint64) TDeleteCommonData_uniqueId;
        PROTO_RMCIMPL_STUB(RankingProtocol, DeleteCommonData)
        {
            PROTO_PREPARE_EXTRACTION();
            DDLTYPE(uint64)::CPPType uniqueId;
            _MSG_EXTRACT_VARIABLE(TDeleteCommonData_uniqueId, uniqueId);
            pProtocol->DeleteCommonData( uniqueId );
            PROTO_PREPARE_RETURN(RankingProtocol,DeleteCommonData);
        }
        
        typedef DDLTYPE(qvector)< DDLTYPE(byte) > TGetCommonData_commonData;
        typedef DDLTYPE(uint64) TGetCommonData_uniqueId;
        PROTO_RMCIMPL_STUB(RankingProtocol, GetCommonData)
        {
            PROTO_PREPARE_EXTRACTION();
            DDLTYPE(qvector)< DDLTYPE(byte) >::CPPType commonData;
            DDLTYPE(uint64)::CPPType uniqueId;
            _MSG_EXTRACT_VARIABLE(TGetCommonData_uniqueId, uniqueId);
            pProtocol->GetCommonData( &commonData, uniqueId );
            PROTO_PREPARE_RETURN(RankingProtocol,GetCommonData);
            _MSG_ADD_VARIABLE(TGetCommonData_commonData, commonData);
        }
        
        typedef DDLTYPE(uint32) TChangeAttributes_category;
        typedef CLASSMETATYPE(RankingChangeAttributesParam) TChangeAttributes_changeParam;
        typedef DDLTYPE(uint64) TChangeAttributes_uniqueId;
        PROTO_RMCIMPL_STUB(RankingProtocol, ChangeAttributes)
        {
            PROTO_PREPARE_EXTRACTION();
            DDLTYPE(uint32)::CPPType category;
            _MSG_EXTRACT_VARIABLE(TChangeAttributes_category, category);
            RankingChangeAttributesParam changeParam;
            _MSG_EXTRACT_VARIABLE(TChangeAttributes_changeParam, changeParam);
            DDLTYPE(uint64)::CPPType uniqueId;
            _MSG_EXTRACT_VARIABLE(TChangeAttributes_uniqueId, uniqueId);
            pProtocol->ChangeAttributes( category, changeParam, uniqueId );
            PROTO_PREPARE_RETURN(RankingProtocol,ChangeAttributes);
        }
        
        typedef CLASSMETATYPE(RankingChangeAttributesParam) TChangeAllAttributes_changeParam;
        typedef DDLTYPE(uint64) TChangeAllAttributes_uniqueId;
        PROTO_RMCIMPL_STUB(RankingProtocol, ChangeAllAttributes)
        {
            PROTO_PREPARE_EXTRACTION();
            RankingChangeAttributesParam changeParam;
            _MSG_EXTRACT_VARIABLE(TChangeAllAttributes_changeParam, changeParam);
            DDLTYPE(uint64)::CPPType uniqueId;
            _MSG_EXTRACT_VARIABLE(TChangeAllAttributes_uniqueId, uniqueId);
            pProtocol->ChangeAllAttributes( changeParam, uniqueId );
            PROTO_PREPARE_RETURN(RankingProtocol,ChangeAllAttributes);
        }
        
        typedef DDLTYPE(byte) TGetRanking_rankingMode;
        typedef DDLTYPE(uint32) TGetRanking_category;
        typedef CLASSMETATYPE(RankingOrderParam) TGetRanking_orderParam;
        typedef CLASSMETATYPE(RankingResult) TGetRanking_pResult;
        typedef DDLTYPE(uint64) TGetRanking_uniqueId;
        typedef DDLTYPE(uint32) TGetRanking_principalId;
        PROTO_RMCIMPL_STUB(RankingProtocol, GetRanking)
        {
            PROTO_PREPARE_EXTRACTION();
            DDLTYPE(byte)::CPPType rankingMode;
            _MSG_EXTRACT_VARIABLE(TGetRanking_rankingMode, rankingMode);
            DDLTYPE(uint32)::CPPType category;
            _MSG_EXTRACT_VARIABLE(TGetRanking_category, category);
            RankingOrderParam orderParam;
            _MSG_EXTRACT_VARIABLE(TGetRanking_orderParam, orderParam);
            RankingResult pResult;
            DDLTYPE(uint64)::CPPType uniqueId;
            _MSG_EXTRACT_VARIABLE(TGetRanking_uniqueId, uniqueId);
            DDLTYPE(uint32)::CPPType principalId;
            _MSG_EXTRACT_VARIABLE(TGetRanking_principalId, principalId);
            pProtocol->GetRanking( rankingMode, category, orderParam, &pResult, uniqueId, principalId );
            PROTO_PREPARE_RETURN(RankingProtocol,GetRanking);
            _MSG_ADD_VARIABLE(TGetRanking_pResult, pResult);
        }
        
        typedef DDLTYPE(uint32) TGetApproxOrder_category;
        typedef CLASSMETATYPE(RankingOrderParam) TGetApproxOrder_orderParam;
        typedef DDLTYPE(uint32) TGetApproxOrder_score;
        typedef DDLTYPE(uint32) TGetApproxOrder_pOrder;
        typedef DDLTYPE(uint64) TGetApproxOrder_uniqueId;
        typedef DDLTYPE(uint32) TGetApproxOrder_principalId;
        PROTO_RMCIMPL_STUB(RankingProtocol, GetApproxOrder)
        {
            PROTO_PREPARE_EXTRACTION();
            DDLTYPE(uint32)::CPPType category;
            _MSG_EXTRACT_VARIABLE(TGetApproxOrder_category, category);
            RankingOrderParam orderParam;
            _MSG_EXTRACT_VARIABLE(TGetApproxOrder_orderParam, orderParam);
            DDLTYPE(uint32)::CPPType score;
            _MSG_EXTRACT_VARIABLE(TGetApproxOrder_score, score);
            DDLTYPE(uint32)::CPPType pOrder;
            DDLTYPE(uint64)::CPPType uniqueId;
            _MSG_EXTRACT_VARIABLE(TGetApproxOrder_uniqueId, uniqueId);
            DDLTYPE(uint32)::CPPType principalId;
            _MSG_EXTRACT_VARIABLE(TGetApproxOrder_principalId, principalId);
            pProtocol->GetApproxOrder( category, orderParam, score, &pOrder, uniqueId, principalId );
            PROTO_PREPARE_RETURN(RankingProtocol,GetApproxOrder);
            _MSG_ADD_VARIABLE(TGetApproxOrder_pOrder, pOrder);
        }
        
        typedef DDLTYPE(uint32) TGetStats_category;
        typedef CLASSMETATYPE(RankingOrderParam) TGetStats_orderParam;
        typedef DDLTYPE(uint32) TGetStats_flags;
        typedef CLASSMETATYPE(RankingStats) TGetStats_pStats;
        PROTO_RMCIMPL_STUB(RankingProtocol, GetStats)
        {
            PROTO_PREPARE_EXTRACTION();
            DDLTYPE(uint32)::CPPType category;
            _MSG_EXTRACT_VARIABLE(TGetStats_category, category);
            RankingOrderParam orderParam;
            _MSG_EXTRACT_VARIABLE(TGetStats_orderParam, orderParam);
            DDLTYPE(uint32)::CPPType flags;
            _MSG_EXTRACT_VARIABLE(TGetStats_flags, flags);
            RankingStats pStats;
            pProtocol->GetStats( category, orderParam, flags, &pStats );
            PROTO_PREPARE_RETURN(RankingProtocol,GetStats);
            _MSG_ADD_VARIABLE(TGetStats_pStats, pStats);
        }
        
        typedef DDLTYPE(qvector)< DDLTYPE(uint32) > TGetRankingByPIDList_principalIdList;
        typedef DDLTYPE(byte) TGetRankingByPIDList_rankingMode;
        typedef DDLTYPE(uint32) TGetRankingByPIDList_category;
        typedef CLASSMETATYPE(RankingOrderParam) TGetRankingByPIDList_orderParam;
        typedef CLASSMETATYPE(RankingResult) TGetRankingByPIDList_pResult;
        typedef DDLTYPE(uint64) TGetRankingByPIDList_uniqueId;
        PROTO_RMCIMPL_STUB(RankingProtocol, GetRankingByPIDList)
        {
            PROTO_PREPARE_EXTRACTION();
            DDLTYPE(qvector)< DDLTYPE(uint32) >::CPPType principalIdList;
            _MSG_EXTRACT_VARIABLE(TGetRankingByPIDList_principalIdList, principalIdList);
            DDLTYPE(byte)::CPPType rankingMode;
            _MSG_EXTRACT_VARIABLE(TGetRankingByPIDList_rankingMode, rankingMode);
            DDLTYPE(uint32)::CPPType category;
            _MSG_EXTRACT_VARIABLE(TGetRankingByPIDList_category, category);
            RankingOrderParam orderParam;
            _MSG_EXTRACT_VARIABLE(TGetRankingByPIDList_orderParam, orderParam);
            RankingResult pResult;
            DDLTYPE(uint64)::CPPType uniqueId;
            _MSG_EXTRACT_VARIABLE(TGetRankingByPIDList_uniqueId, uniqueId);
            pProtocol->GetRankingByPIDList( principalIdList, rankingMode, category, orderParam, &pResult, uniqueId );
            PROTO_PREPARE_RETURN(RankingProtocol,GetRankingByPIDList);
            _MSG_ADD_VARIABLE(TGetRankingByPIDList_pResult, pResult);
        }
        
        typedef DDLTYPE(qvector)< DDLTYPE(uint64) > TGetRankingByUniqueIdList_nexUniqueIdList;
        typedef DDLTYPE(byte) TGetRankingByUniqueIdList_rankingMode;
        typedef DDLTYPE(uint32) TGetRankingByUniqueIdList_category;
        typedef CLASSMETATYPE(RankingOrderParam) TGetRankingByUniqueIdList_orderParam;
        typedef CLASSMETATYPE(RankingResult) TGetRankingByUniqueIdList_pResult;
        typedef DDLTYPE(uint64) TGetRankingByUniqueIdList_uniqueId;
        PROTO_RMCIMPL_STUB(RankingProtocol, GetRankingByUniqueIdList)
        {
            PROTO_PREPARE_EXTRACTION();
            DDLTYPE(qvector)< DDLTYPE(uint64) >::CPPType nexUniqueIdList;
            _MSG_EXTRACT_VARIABLE(TGetRankingByUniqueIdList_nexUniqueIdList, nexUniqueIdList);
            DDLTYPE(byte)::CPPType rankingMode;
            _MSG_EXTRACT_VARIABLE(TGetRankingByUniqueIdList_rankingMode, rankingMode);
            DDLTYPE(uint32)::CPPType category;
            _MSG_EXTRACT_VARIABLE(TGetRankingByUniqueIdList_category, category);
            RankingOrderParam orderParam;
            _MSG_EXTRACT_VARIABLE(TGetRankingByUniqueIdList_orderParam, orderParam);
            RankingResult pResult;
            DDLTYPE(uint64)::CPPType uniqueId;
            _MSG_EXTRACT_VARIABLE(TGetRankingByUniqueIdList_uniqueId, uniqueId);
            pProtocol->GetRankingByUniqueIdList( nexUniqueIdList, rankingMode, category, orderParam, &pResult, uniqueId );
            PROTO_PREPARE_RETURN(RankingProtocol,GetRankingByUniqueIdList);
            _MSG_ADD_VARIABLE(TGetRankingByUniqueIdList_pResult, pResult);
        }
        
        typedef DDLTYPE(uint32) TGetCachedTopXRanking_category;
        typedef CLASSMETATYPE(RankingOrderParam) TGetCachedTopXRanking_orderParam;
        typedef CLASSMETATYPE(RankingCachedResult) TGetCachedTopXRanking_pResult;
        PROTO_RMCIMPL_STUB(RankingProtocol, GetCachedTopXRanking)
        {
            PROTO_PREPARE_EXTRACTION();
            DDLTYPE(uint32)::CPPType category;
            _MSG_EXTRACT_VARIABLE(TGetCachedTopXRanking_category, category);
            RankingOrderParam orderParam;
            _MSG_EXTRACT_VARIABLE(TGetCachedTopXRanking_orderParam, orderParam);
            RankingCachedResult pResult;
            pProtocol->GetCachedTopXRanking( category, orderParam, &pResult );
            PROTO_PREPARE_RETURN(RankingProtocol,GetCachedTopXRanking);
            _MSG_ADD_VARIABLE(TGetCachedTopXRanking_pResult, pResult);
        }
        
        typedef DDLTYPE(qvector)< DDLTYPE(uint32) > TGetCachedTopXRankings_categories;
        typedef DDLTYPE(qvector)< CLASSMETATYPE(RankingOrderParam) > TGetCachedTopXRankings_orderParams;
        typedef DDLTYPE(qvector)< CLASSMETATYPE(RankingCachedResult) > TGetCachedTopXRankings_pResults;
        PROTO_RMCIMPL_STUB(RankingProtocol, GetCachedTopXRankings)
        {
            PROTO_PREPARE_EXTRACTION();
            DDLTYPE(qvector)< DDLTYPE(uint32) >::CPPType categories;
            _MSG_EXTRACT_VARIABLE(TGetCachedTopXRankings_categories, categories);
            DDLTYPE(qvector)< CLASSMETATYPE(RankingOrderParam) >::CPPType orderParams;
            _MSG_EXTRACT_VARIABLE(TGetCachedTopXRankings_orderParams, orderParams);
            DDLTYPE(qvector)< CLASSMETATYPE(RankingCachedResult) >::CPPType pResults;
            pProtocol->GetCachedTopXRankings( categories, orderParams, &pResults );
            PROTO_PREPARE_RETURN(RankingProtocol,GetCachedTopXRankings);
            _MSG_ADD_VARIABLE(TGetCachedTopXRankings_pResults, pResults);
        }
        
        private:
        // Call this function with a message previously generated by a
        // <RMC name>_PrepareRequest() call to have it dispatched to the correct RMC.
        virtual void DispatchProtocolMessage( Message *pMessage, Message *pReturnMessage, qBool *boReturnsMessage, EndPoint *pEndPoint);
        public:
        
        virtual void UploadScore(const RankingScoreData& scoreData, const DDLTYPE(uint64)::CPPType& uniqueId) = 0;
        virtual void DeleteScore(const DDLTYPE(uint32)::CPPType& category, const DDLTYPE(uint64)::CPPType& uniqueId) = 0;
        virtual void DeleteAllScores(const DDLTYPE(uint64)::CPPType& uniqueId) = 0;
        virtual void UploadCommonData(const DDLTYPE(qvector)< DDLTYPE(byte) >::CPPType& commonData, const DDLTYPE(uint64)::CPPType& uniqueId) = 0;
        virtual void DeleteCommonData(const DDLTYPE(uint64)::CPPType& uniqueId) = 0;
        virtual void GetCommonData(DDLTYPE(qvector)< DDLTYPE(byte) >::CPPType* commonData, const DDLTYPE(uint64)::CPPType& uniqueId) = 0;
        virtual void ChangeAttributes(const DDLTYPE(uint32)::CPPType& category, const RankingChangeAttributesParam& changeParam, const DDLTYPE(uint64)::CPPType& uniqueId) = 0;
        virtual void ChangeAllAttributes(const RankingChangeAttributesParam& changeParam, const DDLTYPE(uint64)::CPPType& uniqueId) = 0;
        virtual void GetRanking(const DDLTYPE(byte)::CPPType& rankingMode, const DDLTYPE(uint32)::CPPType& category, const RankingOrderParam& orderParam, RankingResult* pResult, const DDLTYPE(uint64)::CPPType& uniqueId, const DDLTYPE(uint32)::CPPType& principalId) = 0;
        virtual void GetApproxOrder(const DDLTYPE(uint32)::CPPType& category, const RankingOrderParam& orderParam, const DDLTYPE(uint32)::CPPType& score, DDLTYPE(uint32)::CPPType* pOrder, const DDLTYPE(uint64)::CPPType& uniqueId, const DDLTYPE(uint32)::CPPType& principalId) = 0;
        virtual void GetStats(const DDLTYPE(uint32)::CPPType& category, const RankingOrderParam& orderParam, const DDLTYPE(uint32)::CPPType& flags, RankingStats* pStats) = 0;
        virtual void GetRankingByPIDList(const DDLTYPE(qvector)< DDLTYPE(uint32) >::CPPType& principalIdList, const DDLTYPE(byte)::CPPType& rankingMode, const DDLTYPE(uint32)::CPPType& category, const RankingOrderParam& orderParam, RankingResult* pResult, const DDLTYPE(uint64)::CPPType& uniqueId) = 0;
        virtual void GetRankingByUniqueIdList(const DDLTYPE(qvector)< DDLTYPE(uint64) >::CPPType& nexUniqueIdList, const DDLTYPE(byte)::CPPType& rankingMode, const DDLTYPE(uint32)::CPPType& category, const RankingOrderParam& orderParam, RankingResult* pResult, const DDLTYPE(uint64)::CPPType& uniqueId) = 0;
        virtual void GetCachedTopXRanking(const DDLTYPE(uint32)::CPPType& category, const RankingOrderParam& orderParam, RankingCachedResult* pResult) = 0;
        virtual void GetCachedTopXRankings(const DDLTYPE(qvector)< DDLTYPE(uint32) >::CPPType& categories, const DDLTYPE(qvector)< CLASSMETATYPE(RankingOrderParam) >::CPPType& orderParams, DDLTYPE(qvector)< CLASSMETATYPE(RankingCachedResult) >::CPPType* pResults) = 0;
    
#if defined(LIVE_VERSION)
    private:
        ProfilingUnit m_UploadScoreProfilingUnit;
        ProfilingUnit m_DeleteScoreProfilingUnit;
        ProfilingUnit m_DeleteAllScoresProfilingUnit;
        ProfilingUnit m_UploadCommonDataProfilingUnit;
        ProfilingUnit m_DeleteCommonDataProfilingUnit;
        ProfilingUnit m_GetCommonDataProfilingUnit;
        ProfilingUnit m_ChangeAttributesProfilingUnit;
        ProfilingUnit m_ChangeAllAttributesProfilingUnit;
        ProfilingUnit m_GetRankingProfilingUnit;
        ProfilingUnit m_GetApproxOrderProfilingUnit;
        ProfilingUnit m_GetStatsProfilingUnit;
        ProfilingUnit m_GetRankingByPIDListProfilingUnit;
        ProfilingUnit m_GetRankingByUniqueIdListProfilingUnit;
        ProfilingUnit m_GetCachedTopXRankingProfilingUnit;
        ProfilingUnit m_GetCachedTopXRankingsProfilingUnit;
#endif // LIVE_VERSION
    
};


END_NAMESPACE_NEX

#if defined(__ARMCC_VERSION) && (__ARMCC_VERSION >= 5000000)
#pragma pop
#endif // defined(__ARMCC_VERSION) && (__ARMCC_VERSION >= 5000000)
#if defined(_MSC_VER)
#pragma warning( pop )
#endif // defined(_MSC_VER)
