﻿/*---------------------------------------------------------------------------*
  Copyright (C)2011-2018 Nintendo Co., Ltd.  All rights reserved.

  These coded instructions, statements, and computer programs contain
  proprietary information of Nintendo of America Inc. and/or Nintendo
  Company Ltd., and are protected by Federal copyright law.  They may
  not be disclosed to third parties or copied or duplicated in any form,
  in whole or in part, without the prior written consent of Nintendo.
 *---------------------------------------------------------------------------*/
#pragma once

#include <OnlineCore/src/Platform/Core/PlatformDecl.h>
#include "Ranking2EstimateScoreRankInputDDL.h"

BEGIN_NAMESPACE_NEX

/*!
    @brief      スコアのランク推定用の入力値クラスです。
*/
class Ranking2EstimateScoreRankInput: public DDLCLASS(Ranking2EstimateScoreRankInput)
{
public:
    /*!
        @brief      コンストラクタ。

        すべて 0 で初期化されます。
    */
    Ranking2EstimateScoreRankInput()
    {
        category = 0;
        numSeasonsToGoBack = 0;
        score = 0;
    }

    /*!
        @brief カテゴリを設定します。

        @param c カテゴリ
     */
    void SetCategory(qUnsignedInt32 c)
    {
        category = c;
    }
    /*!
        @brief カテゴリを取得します。

        @return カテゴリ
     */
    qUnsignedInt32 GetCategory() const
    {
        return category;
    }

    /*!
        @brief さかのぼるシーズンの数を設定します。

        @param n さかのぼるシーズンの数
     */
    void SetNumSeasonsToGoBack(qByte n)
    {
        numSeasonsToGoBack = n;
    }
    /*!
        @brief さかのぼるシーズンの数を取得します。

        @return さかのぼるシーズンの数
     */
    qByte GetNumSeasonsToGoBack() const
    {
        return numSeasonsToGoBack;
    }

    /*!
        @brief スコアを設定します。

        @param s スコア
     */
    void SetScore(qUnsignedInt32 s)
    {
        score = s;
    }

    /*!
        @brief スコアを取得します。

        @return スコア
     */
    qUnsignedInt32 GetScore() const
    {
        return score;
    }
};

END_NAMESPACE_NEX
