﻿/*---------------------------------------------------------------------------*
  Copyright (C)2011-2018 Nintendo Co., Ltd.  All rights reserved.
 
  These coded instructions, statements, and computer programs contain
  proprietary information of Nintendo of America Inc. and/or Nintendo
  Company Ltd., and are protected by Federal copyright law.  They may
  not be disclosed to third parties or copied or duplicated in any form,
  in whole or in part, without the prior written consent of Nintendo.
 *---------------------------------------------------------------------------*/

#pragma once

#include <OnlineCore/src/Platform/Core/PlatformDecl.h>

BEGIN_NAMESPACE_NEX

#ifdef SWIG
class Ranking2GetOptionFlags
{
public:
#else  // Not SWIG
/*!
    @brief Ranking2 の取得オプションフラグを定義する名前空間です。
*/
namespace Ranking2GetOptionFlags
{
#endif // End of SWIG
/*!
    @brief ランキングの取得オプションフラグ。
*/
enum Ranking2GetOptionFlags
{
#if defined(NEX_GET_MII_SUPPORT)
    NOTHING      = 0x00000000,  //!< フラグを指定しません。
    MII_REQUIRED = 0x00000001   //!< このフラグが指定されている場合、Mii データを取得します。
#else
#if defined(FOR_DOC_PURPOSE)
    NOTHING      = 0x00000000  //!< フラグを指定しません。
#else
    NOTHING      = 0x00000000,  //!< フラグを指定しません。
    MII_REQUIRED = 0x00000001   //!< このフラグが指定されている場合、Mii データを取得します。
#endif
#endif
};

#ifdef SWIG
};
#else
}
#endif

END_NAMESPACE_NEX

