﻿/*---------------------------------------------------------------------------*
  Copyright (C)2011-2018 Nintendo Co., Ltd.  All rights reserved.
 
  These coded instructions, statements, and computer programs contain
  proprietary information of Nintendo of America Inc. and/or Nintendo
  Company Ltd., and are protected by Federal copyright law.  They may
  not be disclosed to third parties or copied or duplicated in any form,
  in whole or in part, without the prior written consent of Nintendo.
 *---------------------------------------------------------------------------*/

#pragma once

#include <OnlineCore/src/Platform/Core/PlatformDecl.h>

BEGIN_NAMESPACE_NEX

#ifdef SWIG
class Ranking2Mode
{
public:
#else  // Not SWIG
/*!
    @brief Ranking2 の取得モードを定義する名前空間です。
*/
namespace Ranking2Mode
{
#endif // End of SWIG
/*!
    @brief ランキングの取得モード。
*/
enum Ranking2Mode
{
    USER_RANKING   = 0, //!< 個人ランキング。
    NEAR_RANKING   = 1, //!< 周辺ランキング。
    RANGE_RANKING  = 2, //!< 範囲ランキング。
    FRIEND_RANKING = 3, //!< フレンドランキング。
    MIN                 = USER_RANKING,
    MAX                 = FRIEND_RANKING
};

#ifdef SWIG
};
#else
}
#endif

END_NAMESPACE_NEX

