﻿/*---------------------------------------------------------------------------*
  Copyright (C)2011-2018 Nintendo Co., Ltd.  All rights reserved.
 
  These coded instructions, statements, and computer programs contain
  proprietary information of Nintendo of America Inc. and/or Nintendo
  Company Ltd., and are protected by Federal copyright law.  They may
  not be disclosed to third parties or copied or duplicated in any form,
  in whole or in part, without the prior written consent of Nintendo.
 *---------------------------------------------------------------------------*/

#pragma once

#include <OnlineCore/src/Platform/Core/PlatformDecl.h>

BEGIN_NAMESPACE_NEX

#ifdef SWIG
class Ranking2SortFlags
{
public:
#else  // Not SWIG
/*!
    @brief Ranking2 のソート条件を定義する名前空間です。
*/
namespace Ranking2SortFlags
{
#endif // End of SWIG
/*!
    @brief ランキングのソート条件。
*/
enum Ranking2SortFlags
{
    NOTHING                 = 0x00000000,   //!< フラグを指定しません。 

#ifndef FOR_DOC_PURPOSE
    /*! @internal
        @brief このフラグが指定されている場合、同順位をタイムスタンプで昇順ソートします。
               未実装です。
    */
    ORDER_BY_TIMESTAMP      = 0x00000002,
#endif
#ifndef FOR_DOC_PURPOSE
    /*! @internal
        @brief このフラグが指定されている場合、同順位をタイムスタンプで降順ソートします。
               必ず OrderByTimestamp と同時に指定する必要があります。
               未実装です。
    */
    ORDER_BY_TIMESTAMP_DESC = 0x00000001,
#endif

    /*!
        @brief このフラグが指定されている場合、取得したユーザーを同順位の中で先頭にします。
    */
    MOVE_TO_TOP_IN_TIE      = 0x00000004
};

#ifdef SWIG
};
#else
}
#endif

END_NAMESPACE_NEX

