﻿/*---------------------------------------------------------------------------*
  Copyright (C)2011-2018 Nintendo Co., Ltd.  All rights reserved.

  These coded instructions, statements, and computer programs contain
  proprietary information of Nintendo of America Inc. and/or Nintendo
  Company Ltd., and are protected by Federal copyright law.  They may
  not be disclosed to third parties or copied or duplicated in any form,
  in whole or in part, without the prior written consent of Nintendo.
 *---------------------------------------------------------------------------*/

#pragma once

#include <RendezVous/Core/src/Common/SwigUtility.h>

BEGIN_NAMESPACE_NEX

/*!
    @internal
    @brief Screening モジュールに関する定数が定義された名前空間です。
 */
BEGIN_SWIG_CONSTANTS(ScreeningConstants)
    /// 通報理由の最大長（文字数）
    static const size_t REPORT_REASON_MAXLEN = 400;

    /*!
        @brief 通報カテゴリです。
     */
    enum ReportCategory
    {
        REPORT_CATEGORY_INVALID = 0,              //!< 無効な値
        REPORT_CATEGORY_MIN = 1,                  //!< 有効な最小の値
        REPORT_CATEGORY_PERSONAL          = 1,    //!< 個人情報、出会い
        REPORT_CATEGORY_CRIMINAL,                 //!< 暴力的な内容
        REPORT_CATEGORY_IMMORAL,                  //!< 公序良俗に反する内容
        REPORT_CATEGORY_HARASSMENT,               //!< 他人への嫌がらせ、悪口
        REPORT_CATEGORY_COMMERCIAL,               //!< 営利宣伝目的
        REPORT_CATEGORY_SEXUALLY_EXPLICIT,        //!< わいせつな内容
        REPORT_CATEGORY_OTHER,                    //!< その他
        REPORT_CATEGORY_MAX = REPORT_CATEGORY_OTHER //!< 有効な最大の値
    };
END_SWIG_CONSTANTS

END_NAMESPACE_NEX
