﻿/*---------------------------------------------------------------------------*
  Copyright (C)2011-2018 Nintendo Co., Ltd.  All rights reserved.
 
  These coded instructions, statements, and computer programs contain
  proprietary information of Nintendo of America Inc. and/or Nintendo
  Company Ltd., and are protected by Federal copyright law.  They may
  not be disclosed to third parties or copied or duplicated in any form,
  in whole or in part, without the prior written consent of Nintendo.
 *---------------------------------------------------------------------------*/

#pragma once

#include <RendezVous/Core/src/Common/SwigUtility.h>

BEGIN_NAMESPACE_NEX

/*!
    @brief Screening モジュールのエラーコードを定義する名前空間です。
*/
BEGIN_SWIG_CONSTANTS(ScreeningErrorCode)
    /*!
        @brief    Subscriber モジュールのエラーコード。
    */
    enum ErrorCode
    {
        START = 1,
        Unknown                   =  1,  //!<   不明なエラーです。
        InvalidArgument           =  2,  //!<   引数が不正です。
        NotFound                  =  3   //!<   指定のデータがない。
    };
END_SWIG_CONSTANTS

END_NAMESPACE_NEX
