#pragma once
#if defined(__ARMCC_VERSION) && (__ARMCC_VERSION >= 5000000)
#pragma push
#pragma diag_suppress 228,381,550,1300,1301,2530
#endif // defined(__ARMCC_VERSION) && (__ARMCC_VERSION >= 5000000)
#if defined(_MSC_VER)
#pragma warning( push )
#pragma warning( disable : 4458 )
#endif // defined(_MSC_VER)


#include <OnlineCore/src/DDLTypes/CGCoreExports.h>

#include <RendezVous/Core/src/Common/ClientProtocol.h>
#include <RendezVous/Core/src/Common/ServerProtocol.h>
#include <OnlineCore/src/Core/CallContextRegister.h>
#include <RendezVous/Core/src/Common/ProtocolCGMacros.h>
#include <RendezVous/Core/src/Common/ProtocolCallContext.h>
#include <RendezVous/Core/src/Common/ProtocolRequestBrokerInterface.h>
#include <RendezVous/Core/src/Common/Protocol.h>
#include <RendezVous/Core/src/Common/ProtocolList.h>
#include <OnlineCore/src/Transport/Interface/TransportError.h>
#include <RendezVous/Core/src/Client/RVClientCore.h>
#include <RendezVous/Core/src/Client/ProtocolRegistry.h>
#include "ScreeningDataStoreContentParam.h"
#include "ScreeningUgcViolationParam.h"

BEGIN_NAMESPACE_NEX

PROTO_DEFINE_RMCID(ScreeningProtocol, ReportDataStoreContent, 1 );
PROTO_DEFINE_NUM_RMC(ScreeningProtocol, 1);

class ScreeningProtocolClient : public ClientProtocol {
    public:
        typedef CLASSMETATYPE(ScreeningDataStoreContentParam) TReportDataStoreContent_contentParam;
        typedef CLASSMETATYPE(ScreeningUgcViolationParam) TReportDataStoreContent_violationParam;
        PROTO_RMCIMPL_RETURN(ScreeningProtocol, ReportDataStoreContent)
        {
            PROTO_RETURNSTUB_IMPL();
            PROTO_RETURNSTUB_END();
        };
        
        ScreeningProtocolClient(ProtocolID uiProtocolID);
        virtual ClientProtocol* CreateResponder() const { return qNew ScreeningProtocolClient(ProtocolList::Unknown); }
        void RegisterProtocol()
        {
            SYSTEMCHECK(GetProtocolID() != ProtocolList::Unknown);
            SYSTEMCHECK(RVClientCore::GetInstance() != NULL && "You should create ServiceClient or NgsFacade(RendezVous) first.");
            RVClientCore::GetInstance()->GetProtocolRegistry()->RegisterProtocol(GetProtocolID(), CreateResponder());
        }
        virtual void ExtractCallSpecificResults(Message *pMessage, ProtocolCallContext* pContext);
        
        qBool CallReportDataStoreContent(ProtocolCallContext *pContext, const ScreeningDataStoreContentParam& contentParam, const ScreeningUgcViolationParam& violationParam);
        static qBool ReportDataStoreContent_PrepareRequest(ProtocolCallContext *pContext, Message *pMsg, const ScreeningDataStoreContentParam& contentParam, const ScreeningUgcViolationParam& violationParam);
        
        protected:
        static ProtoReturnFunction s_protoReturnFunctions[PROTO_NUM_RMC(ScreeningProtocol) + 1];
};

class DDLPROTOCOL(ScreeningProtocolServer) : public ServerProtocol {
    public:
        DDLPROTOCOL(ScreeningProtocolServer)()
            : ServerProtocol()
#if defined(LIVE_VERSION)
            , m_ReportDataStoreContentProfilingUnit(NEX_T("ScreeningProtocol::ReportDataStoreContent"))
#endif // LIVE_VERSION
            {}
        
        typedef CLASSMETATYPE(ScreeningDataStoreContentParam) TReportDataStoreContent_contentParam;
        typedef CLASSMETATYPE(ScreeningUgcViolationParam) TReportDataStoreContent_violationParam;
        PROTO_RMCIMPL_STUB(ScreeningProtocol, ReportDataStoreContent)
        {
            PROTO_PREPARE_EXTRACTION();
            ScreeningDataStoreContentParam contentParam;
            _MSG_EXTRACT_VARIABLE(TReportDataStoreContent_contentParam, contentParam);
            ScreeningUgcViolationParam violationParam;
            _MSG_EXTRACT_VARIABLE(TReportDataStoreContent_violationParam, violationParam);
            pProtocol->ReportDataStoreContent( contentParam, violationParam );
            PROTO_PREPARE_RETURN(ScreeningProtocol,ReportDataStoreContent);
        }
        
        private:
        // Call this function with a message previously generated by a
        // <RMC name>_PrepareRequest() call to have it dispatched to the correct RMC.
        virtual void DispatchProtocolMessage( Message *pMessage, Message *pReturnMessage, qBool *boReturnsMessage, EndPoint *pEndPoint);
        public:
        
        virtual void ReportDataStoreContent(const ScreeningDataStoreContentParam& contentParam, const ScreeningUgcViolationParam& violationParam) = 0;
    
#if defined(LIVE_VERSION)
    private:
        ProfilingUnit m_ReportDataStoreContentProfilingUnit;
#endif // LIVE_VERSION
    
};


END_NAMESPACE_NEX

#if defined(__ARMCC_VERSION) && (__ARMCC_VERSION >= 5000000)
#pragma pop
#endif // defined(__ARMCC_VERSION) && (__ARMCC_VERSION >= 5000000)
#if defined(_MSC_VER)
#pragma warning( pop )
#endif // defined(_MSC_VER)
