﻿/*---------------------------------------------------------------------------*
  (C) Copyright 1998-2018, Technologies Quazal Inc.  All rights reserved.
  Quazal Net-Z, Quazal Rendez-Vous and Quazal are trademarks of Quazal.

  Copyright (C)2011-2018 Nintendo  All rights reserved.

  These coded instructions, statements, and computer programs contain
  proprietary information of Nintendo and/or its licensors and are
  protected by national and international copyright laws.
  They may not be disclosed to third parties or copied or duplicated
  in any form, in whole or in part, without the prior written consent
  of Nintendo.
  The content herein is highly confidential and should be handled
  accordingly.
 *---------------------------------------------------------------------------*/

#pragma once

#include <OnlineCore/src/Platform/Core/PlatformDecl.h>
#include "ServiceItemConstants.h"

BEGIN_NAMESPACE_NEX

namespace ServiceItemConstants
{
    static const qUnsignedInt64 INVALID_REQUEST_ID = 0;

/*!
    @brief プラットフォーム種別です。
*/
enum PlatformType
{
    PLATFORM_TYPE_UNKNOWN   = 0,    //!< 不明です。
    PLATFORM_TYPE_LINUX     = 1,    //!< Linuxです。
    PLATFORM_TYPE_WIN       = 2,    //!< Windowsです。
    PLATFORM_TYPE_CTR       = 3,    //!< CTRです。
    PLATFORM_TYPE_WUP       = 4     //!< WUPです。
};

/// ダミーのECサービストークン。
extern const qChar* DUMMY_EC_SERVICE_TOKEN;

}

#if defined(LINUX_TARGET)
#define NEX_SERVICEITEM_GET_PLATFORM    ServiceItemConstants::PLATFORM_TYPE_LINUX
#elif defined(WIN_FAMILY)
#define NEX_SERVICEITEM_GET_PLATFORM    ServiceItemConstants::PLATFORM_TYPE_WIN
#elif defined(CTR_TARGET)
#define NEX_SERVICEITEM_GET_PLATFORM    ServiceItemConstants::PLATFORM_TYPE_CTR
#elif defined(CAFE_TARGET)
#define NEX_SERVICEITEM_GET_PLATFORM    ServiceItemConstants::PLATFORM_TYPE_WUP
#else
#define NEX_SERVICEITEM_GET_PLATFORM    ServiceItemConstants::PLATFORM_TYPE_UNKNOWN
#endif

END_NAMESPACE_NEX

