﻿/*---------------------------------------------------------------------------*
  (C) Copyright 1998-2018, Technologies Quazal Inc.  All rights reserved.
  Quazal Net-Z, Quazal Rendez-Vous and Quazal are trademarks of Quazal.

  Copyright (C)2011-2018 Nintendo  All rights reserved.

  These coded instructions, statements, and computer programs contain
  proprietary information of Nintendo and/or its licensors and are
  protected by national and international copyright laws.
  They may not be disclosed to third parties or copied or duplicated
  in any form, in whole or in part, without the prior written consent
  of Nintendo.
  The content herein is highly confidential and should be handled
  accordingly.
 *---------------------------------------------------------------------------*/

#pragma once

BEGIN_NAMESPACE_NEX


/*!
    @brief ServiceItem モジュールのエラーコードを定義する名前空間です。
*/
#ifdef SWIG
class ServiceItemErrorCode
{
public:
#else
namespace ServiceItemErrorCode
{
#endif
    /*!
        @brief    ServiceItem モジュールのエラーコード。
    */
    enum ErrorCode
    {
        START = 1,
        Unknown                     =  1,  //!<    不明なエラーです。
        InvalidArgument             =  2,  //!<    引数が不正です。
        EShopUnknownHttpError       =  3,  //!<    eShop サーバー へのHTTPアクセスで不明なエラーが発生しました。
        EShopResponseParseError     =  4,  //!<    eShop サーバー からのレスポンスのパースに失敗しました。
        NotOwned                    =  5,  //!<    権利を所持していません。
        InvalidLimitationType       =  6,  //!<    権利種別が不正です。
        ConsumptionRightShortage    =  7   //!<    消費型サービス利用券の残り個数が足りません。
    };
#ifdef SWIG
};
#else
}
#endif


END_NAMESPACE_NEX

