#pragma once
#if defined(__ARMCC_VERSION) && (__ARMCC_VERSION >= 5000000)
#pragma push
#pragma diag_suppress 228,381,550,1300,1301,2530
#endif // defined(__ARMCC_VERSION) && (__ARMCC_VERSION >= 5000000)
#if defined(_MSC_VER)
#pragma warning( push )
#pragma warning( disable : 4458 )
#endif // defined(_MSC_VER)

#include <OnlineCore/src/DDLTypes/CGCoreExports.h>
#include "OnlineCore/src/DDLTypes/OnlineCoreTypes.h"
#include "ServiceItemAmount.h"
#include "ServiceItemLimitation.h"
#include "ServiceItemAttribute.h"

BEGIN_NAMESPACE_NEX
class ServiceItemListItem;
END_NAMESPACE_NEX

BEGIN_NAMESPACE_NEX

class DDLCLASS(ServiceItemListItem): public RootObject {
public:
    DDLCLASS(ServiceItemListItem)():_mRevision_ServiceItemListItem(0)
    , attributes(0)     {};
    DDLCLASS(ServiceItemListItem)(const DDLCLASS(ServiceItemListItem) &oOther):
        RootObject(oOther),
        _mRevision_ServiceItemListItem(oOther._mRevision_ServiceItemListItem),
        itemCode(oOther.itemCode),
        regularPrice(oOther.regularPrice),
        taxExcluded(oOther.taxExcluded),
        initialPurchaseOnly(oOther.initialPurchaseOnly),
        limitation(oOther.limitation),
        attributes(oOther.attributes)
    {
    }
    virtual ~DDLCLASS(ServiceItemListItem)() {};
    const DDLCLASS(ServiceItemListItem) &operator=(const DDLCLASS(ServiceItemListItem) &oOther);
    qBool operator==(const DDLCLASS(ServiceItemListItem) &oOther) const;
    #ifdef OSDK_DLL_SUPPORT
    qBool operator<(const DDLCLASS(ServiceItemListItem) &oOther) const;
    #endif
    static void Add(Message *pMessageToSend, const DDLCLASS(ServiceItemListItem) &oValue);
    static void Extract(Message *pReceivedMessage, DDLCLASS(ServiceItemListItem) *pValue);
    qByte _mRevision_ServiceItemListItem;
    qByte GetClassRevision_ServiceItemListItem() const {return _mRevision_ServiceItemListItem;}
    void SetClassRevision_ServiceItemListItem(qByte revision) {_mRevision_ServiceItemListItem=revision;}
    static qByte GetKnownMaxClassRevision_ServiceItemListItem() {return 0;}
    DDLTYPE(string)::CPPType itemCode;
    NEX_CLASS_VALID_REVISION_DEF(itemCode, 0);
    qBool NEX_CLASS_ISVALID(itemCode) const { return true; /* The revision is 0. Always true */}
    ServiceItemAmount regularPrice;
    NEX_CLASS_VALID_REVISION_DEF(regularPrice, 0);
    qBool NEX_CLASS_ISVALID(regularPrice) const { return true; /* The revision is 0. Always true */}
    DDLTYPE(bool)::CPPType taxExcluded;
    NEX_CLASS_VALID_REVISION_DEF(taxExcluded, 0);
    qBool NEX_CLASS_ISVALID(taxExcluded) const { return true; /* The revision is 0. Always true */}
    DDLTYPE(bool)::CPPType initialPurchaseOnly;
    NEX_CLASS_VALID_REVISION_DEF(initialPurchaseOnly, 0);
    qBool NEX_CLASS_ISVALID(initialPurchaseOnly) const { return true; /* The revision is 0. Always true */}
    ServiceItemLimitation limitation;
    NEX_CLASS_VALID_REVISION_DEF(limitation, 0);
    qBool NEX_CLASS_ISVALID(limitation) const { return true; /* The revision is 0. Always true */}
    DDLTYPE(qvector)< CLASSMETATYPE(ServiceItemAttribute) >::CPPType attributes;
    NEX_CLASS_VALID_REVISION_DEF(attributes, 0);
    qBool NEX_CLASS_ISVALID(attributes) const { return true; /* The revision is 0. Always true */}
};


class DDLTYPE(ServiceItemListItem): public DDLType {
public:
    typedef ServiceItemListItem CPPType;
    static void Add(Message* pMessageToSend, const DDLCLASS(ServiceItemListItem)& oServiceItemListItem) {
        DDLCLASS(ServiceItemListItem)::Add(pMessageToSend,oServiceItemListItem);
    }
    static void Extract(Message* pReceivedMessage, DDLCLASS(ServiceItemListItem)* pServiceItemListItemToRefresh) {
        DDLCLASS(ServiceItemListItem)::Extract(pReceivedMessage,pServiceItemListItemToRefresh);
    }
};


END_NAMESPACE_NEX

#if defined(__ARMCC_VERSION) && (__ARMCC_VERSION >= 5000000)
#pragma pop
#endif // defined(__ARMCC_VERSION) && (__ARMCC_VERSION >= 5000000)
#if defined(_MSC_VER)
#pragma warning( pop )
#endif // defined(_MSC_VER)
