#pragma once
#if defined(__ARMCC_VERSION) && (__ARMCC_VERSION >= 5000000)
#pragma push
#pragma diag_suppress 228,381,550,1300,1301,2530
#endif // defined(__ARMCC_VERSION) && (__ARMCC_VERSION >= 5000000)
#if defined(_MSC_VER)
#pragma warning( push )
#pragma warning( disable : 4458 )
#endif // defined(_MSC_VER)


#include <OnlineCore/src/DDLTypes/CGCoreExports.h>

#include <RendezVous/Core/src/Common/ClientProtocol.h>
#include <RendezVous/Core/src/Common/ServerProtocol.h>
#include <OnlineCore/src/Core/CallContextRegister.h>
#include <RendezVous/Core/src/Common/ProtocolCGMacros.h>
#include <RendezVous/Core/src/Common/ProtocolCallContext.h>
#include <RendezVous/Core/src/Common/ProtocolRequestBrokerInterface.h>
#include <RendezVous/Core/src/Common/Protocol.h>
#include <RendezVous/Core/src/Common/ProtocolList.h>
#include <OnlineCore/src/Transport/Interface/TransportError.h>
#include <RendezVous/Core/src/Client/RVClientCore.h>
#include <RendezVous/Core/src/Client/ProtocolRegistry.h>
#include "OnlineCore/src/DDLTypes/OnlineCoreTypes.h"
#include "ServiceItemHttpGetParamDDL.h"
#include "ServiceItemHttpGetResponseDDL.h"
#include "ServiceItemPurchaseServiceItemParam.h"
#include "ServiceItemPurchaseServiceItemResponse.h"
#include "ServiceItemListServiceItemParam.h"
#include "ServiceItemListServiceItemResponse.h"
#include "ServiceItemGetBalanceParam.h"
#include "ServiceItemGetBalanceResponse.h"
#include "ServiceItemGetPrepurchaseInfoParam.h"
#include "ServiceItemGetPrepurchaseInfoResponse.h"
#include "ServiceItemGetServiceItemRightParam.h"
#include "ServiceItemGetServiceItemRightResponse.h"
#include "ServiceItemGetPurchaseHistoryParam.h"
#include "ServiceItemGetPurchaseHistoryResponse.h"
#include "ServiceItemPostRightBinaryByAccountParam.h"
#include "ServiceItemPostRightBinaryResponse.h"
#include "ServiceItemUseServiceItemByAccountParam.h"
#include "ServiceItemUseServiceItemResponse.h"
#include "ServiceItemAcquireServiceItemByAccountParam.h"
#include "ServiceItemAcquireServiceItemResponse.h"
#include "ServiceItemGetSupportIdParam.h"
#include "ServiceItemGetLawMessageParam.h"
#include "ServiceItemGetLawMessageResponse.h"
#include "ServiceItemListAutoBillingServiceItemParam.h"
#include "ServiceItemListAutoBillingServiceItemResponse.h"
#include "ServiceItemGetAutoBillingContractParam.h"
#include "ServiceItemGetAutoBillingContractResponse.h"
#include "ServiceItemCancelAutoBillingParam.h"
#include "ServiceItemCancelAutoBillingResponse.h"
#include "ServiceItemListRedemptionServiceItemParam.h"
#include "ServiceItemListRedemptionServiceItemResponse.h"
#include "ServiceItemRedeemServiceItemParam.h"
#include "ServiceItemRedeemServiceItemResponse.h"

BEGIN_NAMESPACE_NEX

PROTO_DEFINE_RMCID(ServiceItemProtocol, GetEnvironment, 1 );
PROTO_DEFINE_RMCID(ServiceItemProtocol, HttpGetRequest, 2 );
PROTO_DEFINE_RMCID(ServiceItemProtocol, HttpGetResponse, 3 );
PROTO_DEFINE_RMCID(ServiceItemProtocol, PurchaseServiceItemRequest, 4 );
PROTO_DEFINE_RMCID(ServiceItemProtocol, PurchaseServiceItemResponse, 5 );
PROTO_DEFINE_RMCID(ServiceItemProtocol, ListServiceItemRequest, 6 );
PROTO_DEFINE_RMCID(ServiceItemProtocol, ListServiceItemResponse, 7 );
PROTO_DEFINE_RMCID(ServiceItemProtocol, GetBalanceRequest, 8 );
PROTO_DEFINE_RMCID(ServiceItemProtocol, GetBalanceResponse, 9 );
PROTO_DEFINE_RMCID(ServiceItemProtocol, GetPrepurchaseInfoRequest, 10 );
PROTO_DEFINE_RMCID(ServiceItemProtocol, GetPrepurchaseInfoResponse, 11 );
PROTO_DEFINE_RMCID(ServiceItemProtocol, GetServiceItemRightRequest, 12 );
PROTO_DEFINE_RMCID(ServiceItemProtocol, GetServiceItemRightResponse, 13 );
PROTO_DEFINE_RMCID(ServiceItemProtocol, GetPurchaseHistoryRequest, 14 );
PROTO_DEFINE_RMCID(ServiceItemProtocol, GetPurchaseHistoryResponse, 15 );
PROTO_DEFINE_RMCID(ServiceItemProtocol, PostRightBinaryByAccount, 16 );
PROTO_DEFINE_RMCID(ServiceItemProtocol, UseServiceItemByAccountRequest, 17 );
PROTO_DEFINE_RMCID(ServiceItemProtocol, UseServiceItemByAccountResponse, 18 );
PROTO_DEFINE_RMCID(ServiceItemProtocol, AcquireServiceItemByAccount, 19 );
PROTO_DEFINE_RMCID(ServiceItemProtocol, GetSupportId, 20 );
PROTO_DEFINE_RMCID(ServiceItemProtocol, GetLawMessageRequest, 21 );
PROTO_DEFINE_RMCID(ServiceItemProtocol, GetLawMessageResponse, 22 );
PROTO_DEFINE_RMCID(ServiceItemProtocol, ListAutoBillingServiceItemRequest, 23 );
PROTO_DEFINE_RMCID(ServiceItemProtocol, ListAutoBillingServiceItemResponse, 24 );
PROTO_DEFINE_RMCID(ServiceItemProtocol, GetAutoBillingContractRequest, 25 );
PROTO_DEFINE_RMCID(ServiceItemProtocol, GetAutoBillingContractResponse, 26 );
PROTO_DEFINE_RMCID(ServiceItemProtocol, CancelAutoBillingRequest, 27 );
PROTO_DEFINE_RMCID(ServiceItemProtocol, CancelAutoBillingResponse, 28 );
PROTO_DEFINE_RMCID(ServiceItemProtocol, ListRedemptionServiceItemRequest, 29 );
PROTO_DEFINE_RMCID(ServiceItemProtocol, ListRedemptionServiceItemResponse, 30 );
PROTO_DEFINE_RMCID(ServiceItemProtocol, RedeemServiceItemRequest, 31 );
PROTO_DEFINE_RMCID(ServiceItemProtocol, RedeemServiceItemResponse, 32 );
PROTO_DEFINE_NUM_RMC(ServiceItemProtocol, 32);

class ServiceItemProtocolClient : public ClientProtocol {
    public:
        typedef DDLTYPE(string) TGetEnvironment_uniqueId;
        typedef DDLTYPE(string) TGetEnvironment_str;
        typedef DDLTYPE(byte) TGetEnvironment_platform;
        PROTO_RMCIMPL_RETURN(ServiceItemProtocol, GetEnvironment)
        {
            PROTO_RETURNSTUB_IMPL();
            _DO_RMC_ExtractReturnValue(TGetEnvironment_str,1);
            PROTO_RETURNSTUB_END();
        };
        
        typedef DDLTYPE(uint32) THttpGetRequest_requestId;
        typedef CLASSMETATYPE(ServiceItemHttpGetParam) THttpGetRequest_url;
        PROTO_RMCIMPL_RETURN(ServiceItemProtocol, HttpGetRequest)
        {
            PROTO_RETURNSTUB_IMPL();
            _DO_RMC_ExtractReturnValue(THttpGetRequest_requestId,1);
            PROTO_RETURNSTUB_END();
        };
        
        typedef DDLTYPE(uint32) THttpGetResponse_requestId;
        typedef CLASSMETATYPE(ServiceItemHttpGetResponse) THttpGetResponse_response;
        PROTO_RMCIMPL_RETURN(ServiceItemProtocol, HttpGetResponse)
        {
            PROTO_RETURNSTUB_IMPL();
            _DO_RMC_ExtractReturnValue(THttpGetResponse_response,1);
            PROTO_RETURNSTUB_END();
        };
        
        typedef DDLTYPE(uint32) TPurchaseServiceItemRequest_requestId;
        typedef CLASSMETATYPE(ServiceItemPurchaseServiceItemParam) TPurchaseServiceItemRequest_purchaseServiceItemParam;
        PROTO_RMCIMPL_RETURN(ServiceItemProtocol, PurchaseServiceItemRequest)
        {
            PROTO_RETURNSTUB_IMPL();
            _DO_RMC_ExtractReturnValue(TPurchaseServiceItemRequest_requestId,1);
            PROTO_RETURNSTUB_END();
        };
        
        typedef DDLTYPE(uint32) TPurchaseServiceItemResponse_requestId;
        typedef CLASSMETATYPE(ServiceItemPurchaseServiceItemResponse) TPurchaseServiceItemResponse_purchaseServiceItemResponse;
        PROTO_RMCIMPL_RETURN(ServiceItemProtocol, PurchaseServiceItemResponse)
        {
            PROTO_RETURNSTUB_IMPL();
            _DO_RMC_ExtractReturnValue(TPurchaseServiceItemResponse_purchaseServiceItemResponse,1);
            PROTO_RETURNSTUB_END();
        };
        
        typedef DDLTYPE(uint32) TListServiceItemRequest_requestId;
        typedef CLASSMETATYPE(ServiceItemListServiceItemParam) TListServiceItemRequest_listServiceItemParam;
        PROTO_RMCIMPL_RETURN(ServiceItemProtocol, ListServiceItemRequest)
        {
            PROTO_RETURNSTUB_IMPL();
            _DO_RMC_ExtractReturnValue(TListServiceItemRequest_requestId,1);
            PROTO_RETURNSTUB_END();
        };
        
        typedef DDLTYPE(uint32) TListServiceItemResponse_requestId;
        typedef CLASSMETATYPE(ServiceItemListServiceItemResponse) TListServiceItemResponse_listServiceItemResponse;
        PROTO_RMCIMPL_RETURN(ServiceItemProtocol, ListServiceItemResponse)
        {
            PROTO_RETURNSTUB_IMPL();
            _DO_RMC_ExtractReturnValue(TListServiceItemResponse_listServiceItemResponse,1);
            PROTO_RETURNSTUB_END();
        };
        
        typedef DDLTYPE(uint32) TGetBalanceRequest_requestId;
        typedef CLASSMETATYPE(ServiceItemGetBalanceParam) TGetBalanceRequest_getBalanceParam;
        PROTO_RMCIMPL_RETURN(ServiceItemProtocol, GetBalanceRequest)
        {
            PROTO_RETURNSTUB_IMPL();
            _DO_RMC_ExtractReturnValue(TGetBalanceRequest_requestId,1);
            PROTO_RETURNSTUB_END();
        };
        
        typedef DDLTYPE(uint32) TGetBalanceResponse_requestId;
        typedef CLASSMETATYPE(ServiceItemGetBalanceResponse) TGetBalanceResponse_getBalanceResponse;
        PROTO_RMCIMPL_RETURN(ServiceItemProtocol, GetBalanceResponse)
        {
            PROTO_RETURNSTUB_IMPL();
            _DO_RMC_ExtractReturnValue(TGetBalanceResponse_getBalanceResponse,1);
            PROTO_RETURNSTUB_END();
        };
        
        typedef DDLTYPE(uint32) TGetPrepurchaseInfoRequest_requestId;
        typedef CLASSMETATYPE(ServiceItemGetPrepurchaseInfoParam) TGetPrepurchaseInfoRequest_getPrepurchaseInfoParam;
        PROTO_RMCIMPL_RETURN(ServiceItemProtocol, GetPrepurchaseInfoRequest)
        {
            PROTO_RETURNSTUB_IMPL();
            _DO_RMC_ExtractReturnValue(TGetPrepurchaseInfoRequest_requestId,1);
            PROTO_RETURNSTUB_END();
        };
        
        typedef DDLTYPE(uint32) TGetPrepurchaseInfoResponse_requestId;
        typedef CLASSMETATYPE(ServiceItemGetPrepurchaseInfoResponse) TGetPrepurchaseInfoResponse_getPrepurchaseInfoResponse;
        PROTO_RMCIMPL_RETURN(ServiceItemProtocol, GetPrepurchaseInfoResponse)
        {
            PROTO_RETURNSTUB_IMPL();
            _DO_RMC_ExtractReturnValue(TGetPrepurchaseInfoResponse_getPrepurchaseInfoResponse,1);
            PROTO_RETURNSTUB_END();
        };
        
        typedef DDLTYPE(uint32) TGetServiceItemRightRequest_requestId;
        typedef CLASSMETATYPE(ServiceItemGetServiceItemRightParam) TGetServiceItemRightRequest_getServiceItemRightParam;
        typedef DDLTYPE(bool) TGetServiceItemRightRequest_withoutRightBinary;
        PROTO_RMCIMPL_RETURN(ServiceItemProtocol, GetServiceItemRightRequest)
        {
            PROTO_RETURNSTUB_IMPL();
            _DO_RMC_ExtractReturnValue(TGetServiceItemRightRequest_requestId,1);
            PROTO_RETURNSTUB_END();
        };
        
        typedef DDLTYPE(uint32) TGetServiceItemRightResponse_requestId;
        typedef CLASSMETATYPE(ServiceItemGetServiceItemRightResponse) TGetServiceItemRightResponse_getServiceItemRightResponse;
        PROTO_RMCIMPL_RETURN(ServiceItemProtocol, GetServiceItemRightResponse)
        {
            PROTO_RETURNSTUB_IMPL();
            _DO_RMC_ExtractReturnValue(TGetServiceItemRightResponse_getServiceItemRightResponse,1);
            PROTO_RETURNSTUB_END();
        };
        
        typedef DDLTYPE(uint32) TGetPurchaseHistoryRequest_requestId;
        typedef CLASSMETATYPE(ServiceItemGetPurchaseHistoryParam) TGetPurchaseHistoryRequest_getPurchaseHistoryParam;
        PROTO_RMCIMPL_RETURN(ServiceItemProtocol, GetPurchaseHistoryRequest)
        {
            PROTO_RETURNSTUB_IMPL();
            _DO_RMC_ExtractReturnValue(TGetPurchaseHistoryRequest_requestId,1);
            PROTO_RETURNSTUB_END();
        };
        
        typedef DDLTYPE(uint32) TGetPurchaseHistoryResponse_requestId;
        typedef CLASSMETATYPE(ServiceItemGetPurchaseHistoryResponse) TGetPurchaseHistoryResponse_getPurchaseHistoryResponse;
        PROTO_RMCIMPL_RETURN(ServiceItemProtocol, GetPurchaseHistoryResponse)
        {
            PROTO_RETURNSTUB_IMPL();
            _DO_RMC_ExtractReturnValue(TGetPurchaseHistoryResponse_getPurchaseHistoryResponse,1);
            PROTO_RETURNSTUB_END();
        };
        
        typedef CLASSMETATYPE(ServiceItemPostRightBinaryByAccountParam) TPostRightBinaryByAccount_postRightBinaryByAccountParam;
        typedef CLASSMETATYPE(ServiceItemPostRightBinaryResponse) TPostRightBinaryByAccount_postRightBinaryResponse;
        PROTO_RMCIMPL_RETURN(ServiceItemProtocol, PostRightBinaryByAccount)
        {
            PROTO_RETURNSTUB_IMPL();
            _DO_RMC_ExtractReturnValue(TPostRightBinaryByAccount_postRightBinaryResponse,1);
            PROTO_RETURNSTUB_END();
        };
        
        typedef DDLTYPE(uint32) TUseServiceItemByAccountRequest_requestId;
        typedef CLASSMETATYPE(ServiceItemUseServiceItemByAccountParam) TUseServiceItemByAccountRequest_useServiceItemByAccountParam;
        PROTO_RMCIMPL_RETURN(ServiceItemProtocol, UseServiceItemByAccountRequest)
        {
            PROTO_RETURNSTUB_IMPL();
            _DO_RMC_ExtractReturnValue(TUseServiceItemByAccountRequest_requestId,1);
            PROTO_RETURNSTUB_END();
        };
        
        typedef DDLTYPE(uint32) TUseServiceItemByAccountResponse_requestId;
        typedef CLASSMETATYPE(ServiceItemUseServiceItemResponse) TUseServiceItemByAccountResponse_useServiceItemResponse;
        PROTO_RMCIMPL_RETURN(ServiceItemProtocol, UseServiceItemByAccountResponse)
        {
            PROTO_RETURNSTUB_IMPL();
            _DO_RMC_ExtractReturnValue(TUseServiceItemByAccountResponse_useServiceItemResponse,1);
            PROTO_RETURNSTUB_END();
        };
        
        typedef CLASSMETATYPE(ServiceItemAcquireServiceItemByAccountParam) TAcquireServiceItemByAccount_acquireServiceItemByAccountParam;
        typedef CLASSMETATYPE(ServiceItemAcquireServiceItemResponse) TAcquireServiceItemByAccount_acquireServiceItemResponse;
        PROTO_RMCIMPL_RETURN(ServiceItemProtocol, AcquireServiceItemByAccount)
        {
            PROTO_RETURNSTUB_IMPL();
            _DO_RMC_ExtractReturnValue(TAcquireServiceItemByAccount_acquireServiceItemResponse,1);
            PROTO_RETURNSTUB_END();
        };
        
        typedef DDLTYPE(string) TGetSupportId_supportId;
        typedef CLASSMETATYPE(ServiceItemGetSupportIdParam) TGetSupportId_getSuppordIdParam;
        PROTO_RMCIMPL_RETURN(ServiceItemProtocol, GetSupportId)
        {
            PROTO_RETURNSTUB_IMPL();
            _DO_RMC_ExtractReturnValue(TGetSupportId_supportId,1);
            PROTO_RETURNSTUB_END();
        };
        
        typedef DDLTYPE(uint32) TGetLawMessageRequest_requestId;
        typedef CLASSMETATYPE(ServiceItemGetLawMessageParam) TGetLawMessageRequest_getLawMessageParam;
        PROTO_RMCIMPL_RETURN(ServiceItemProtocol, GetLawMessageRequest)
        {
            PROTO_RETURNSTUB_IMPL();
            _DO_RMC_ExtractReturnValue(TGetLawMessageRequest_requestId,1);
            PROTO_RETURNSTUB_END();
        };
        
        typedef DDLTYPE(uint32) TGetLawMessageResponse_requestId;
        typedef CLASSMETATYPE(ServiceItemGetLawMessageResponse) TGetLawMessageResponse_getLawMessageResponse;
        PROTO_RMCIMPL_RETURN(ServiceItemProtocol, GetLawMessageResponse)
        {
            PROTO_RETURNSTUB_IMPL();
            _DO_RMC_ExtractReturnValue(TGetLawMessageResponse_getLawMessageResponse,1);
            PROTO_RETURNSTUB_END();
        };
        
        typedef DDLTYPE(uint32) TListAutoBillingServiceItemRequest_requestId;
        typedef CLASSMETATYPE(ServiceItemListAutoBillingServiceItemParam) TListAutoBillingServiceItemRequest_serviceItemListAutoBillingServiceItemParam;
        PROTO_RMCIMPL_RETURN(ServiceItemProtocol, ListAutoBillingServiceItemRequest)
        {
            PROTO_RETURNSTUB_IMPL();
            _DO_RMC_ExtractReturnValue(TListAutoBillingServiceItemRequest_requestId,1);
            PROTO_RETURNSTUB_END();
        };
        
        typedef DDLTYPE(uint32) TListAutoBillingServiceItemResponse_requestId;
        typedef CLASSMETATYPE(ServiceItemListAutoBillingServiceItemResponse) TListAutoBillingServiceItemResponse_serviceItemListAutoBillingServiceItemResponse;
        PROTO_RMCIMPL_RETURN(ServiceItemProtocol, ListAutoBillingServiceItemResponse)
        {
            PROTO_RETURNSTUB_IMPL();
            _DO_RMC_ExtractReturnValue(TListAutoBillingServiceItemResponse_serviceItemListAutoBillingServiceItemResponse,1);
            PROTO_RETURNSTUB_END();
        };
        
        typedef DDLTYPE(uint32) TGetAutoBillingContractRequest_requestId;
        typedef CLASSMETATYPE(ServiceItemGetAutoBillingContractParam) TGetAutoBillingContractRequest_serviceItemGetAutoBillingContractParam;
        PROTO_RMCIMPL_RETURN(ServiceItemProtocol, GetAutoBillingContractRequest)
        {
            PROTO_RETURNSTUB_IMPL();
            _DO_RMC_ExtractReturnValue(TGetAutoBillingContractRequest_requestId,1);
            PROTO_RETURNSTUB_END();
        };
        
        typedef DDLTYPE(uint32) TGetAutoBillingContractResponse_requestId;
        typedef CLASSMETATYPE(ServiceItemGetAutoBillingContractResponse) TGetAutoBillingContractResponse_serviceItemGetAutoBillingContractResponse;
        PROTO_RMCIMPL_RETURN(ServiceItemProtocol, GetAutoBillingContractResponse)
        {
            PROTO_RETURNSTUB_IMPL();
            _DO_RMC_ExtractReturnValue(TGetAutoBillingContractResponse_serviceItemGetAutoBillingContractResponse,1);
            PROTO_RETURNSTUB_END();
        };
        
        typedef DDLTYPE(uint32) TCancelAutoBillingRequest_requestId;
        typedef CLASSMETATYPE(ServiceItemCancelAutoBillingParam) TCancelAutoBillingRequest_serviceItemCancelAutoBillingParam;
        PROTO_RMCIMPL_RETURN(ServiceItemProtocol, CancelAutoBillingRequest)
        {
            PROTO_RETURNSTUB_IMPL();
            _DO_RMC_ExtractReturnValue(TCancelAutoBillingRequest_requestId,1);
            PROTO_RETURNSTUB_END();
        };
        
        typedef DDLTYPE(uint32) TCancelAutoBillingResponse_requestId;
        typedef CLASSMETATYPE(ServiceItemCancelAutoBillingResponse) TCancelAutoBillingResponse_serviceItemCancelAutoBillingResponse;
        PROTO_RMCIMPL_RETURN(ServiceItemProtocol, CancelAutoBillingResponse)
        {
            PROTO_RETURNSTUB_IMPL();
            _DO_RMC_ExtractReturnValue(TCancelAutoBillingResponse_serviceItemCancelAutoBillingResponse,1);
            PROTO_RETURNSTUB_END();
        };
        
        typedef DDLTYPE(uint32) TListRedemptionServiceItemRequest_requestId;
        typedef CLASSMETATYPE(ServiceItemListRedemptionServiceItemParam) TListRedemptionServiceItemRequest_listServiceItemParam;
        PROTO_RMCIMPL_RETURN(ServiceItemProtocol, ListRedemptionServiceItemRequest)
        {
            PROTO_RETURNSTUB_IMPL();
            _DO_RMC_ExtractReturnValue(TListRedemptionServiceItemRequest_requestId,1);
            PROTO_RETURNSTUB_END();
        };
        
        typedef DDLTYPE(uint32) TListRedemptionServiceItemResponse_requestId;
        typedef CLASSMETATYPE(ServiceItemListRedemptionServiceItemResponse) TListRedemptionServiceItemResponse_listServiceItemResponse;
        PROTO_RMCIMPL_RETURN(ServiceItemProtocol, ListRedemptionServiceItemResponse)
        {
            PROTO_RETURNSTUB_IMPL();
            _DO_RMC_ExtractReturnValue(TListRedemptionServiceItemResponse_listServiceItemResponse,1);
            PROTO_RETURNSTUB_END();
        };
        
        typedef DDLTYPE(uint32) TRedeemServiceItemRequest_requestId;
        typedef CLASSMETATYPE(ServiceItemRedeemServiceItemParam) TRedeemServiceItemRequest_redeemServiceItemParam;
        PROTO_RMCIMPL_RETURN(ServiceItemProtocol, RedeemServiceItemRequest)
        {
            PROTO_RETURNSTUB_IMPL();
            _DO_RMC_ExtractReturnValue(TRedeemServiceItemRequest_requestId,1);
            PROTO_RETURNSTUB_END();
        };
        
        typedef DDLTYPE(uint32) TRedeemServiceItemResponse_requestId;
        typedef CLASSMETATYPE(ServiceItemRedeemServiceItemResponse) TRedeemServiceItemResponse_redeemServiceItemResponse;
        PROTO_RMCIMPL_RETURN(ServiceItemProtocol, RedeemServiceItemResponse)
        {
            PROTO_RETURNSTUB_IMPL();
            _DO_RMC_ExtractReturnValue(TRedeemServiceItemResponse_redeemServiceItemResponse,1);
            PROTO_RETURNSTUB_END();
        };
        
        ServiceItemProtocolClient(ProtocolID uiProtocolID);
        virtual ClientProtocol* CreateResponder() const { return qNew ServiceItemProtocolClient(ProtocolList::Unknown); }
        void RegisterProtocol()
        {
            SYSTEMCHECK(GetProtocolID() != ProtocolList::Unknown);
            SYSTEMCHECK(RVClientCore::GetInstance() != NULL && "You should create ServiceClient or NgsFacade(RendezVous) first.");
            RVClientCore::GetInstance()->GetProtocolRegistry()->RegisterProtocol(GetProtocolID(), CreateResponder());
        }
        virtual void ExtractCallSpecificResults(Message *pMessage, ProtocolCallContext* pContext);
        
        qBool CallGetEnvironment(ProtocolCallContext *pContext, const DDLTYPE(string)::CPPType& uniqueId, DDLTYPE(string)::CPPType* str, const DDLTYPE(byte)::CPPType& platform);
        static qBool GetEnvironment_PrepareRequest(ProtocolCallContext *pContext, Message *pMsg, const DDLTYPE(string)::CPPType& uniqueId, DDLTYPE(string)::CPPType* str, const DDLTYPE(byte)::CPPType& platform);
        qBool CallHttpGetRequest(ProtocolCallContext *pContext, DDLTYPE(uint32)::CPPType* requestId, const ServiceItemHttpGetParam& url);
        static qBool HttpGetRequest_PrepareRequest(ProtocolCallContext *pContext, Message *pMsg, DDLTYPE(uint32)::CPPType* requestId, const ServiceItemHttpGetParam& url);
        qBool CallHttpGetResponse(ProtocolCallContext *pContext, const DDLTYPE(uint32)::CPPType& requestId, ServiceItemHttpGetResponse* response);
        static qBool HttpGetResponse_PrepareRequest(ProtocolCallContext *pContext, Message *pMsg, const DDLTYPE(uint32)::CPPType& requestId, ServiceItemHttpGetResponse* response);
        qBool CallPurchaseServiceItemRequest(ProtocolCallContext *pContext, DDLTYPE(uint32)::CPPType* requestId, const ServiceItemPurchaseServiceItemParam& purchaseServiceItemParam);
        static qBool PurchaseServiceItemRequest_PrepareRequest(ProtocolCallContext *pContext, Message *pMsg, DDLTYPE(uint32)::CPPType* requestId, const ServiceItemPurchaseServiceItemParam& purchaseServiceItemParam);
        qBool CallPurchaseServiceItemResponse(ProtocolCallContext *pContext, const DDLTYPE(uint32)::CPPType& requestId, ServiceItemPurchaseServiceItemResponse* purchaseServiceItemResponse);
        static qBool PurchaseServiceItemResponse_PrepareRequest(ProtocolCallContext *pContext, Message *pMsg, const DDLTYPE(uint32)::CPPType& requestId, ServiceItemPurchaseServiceItemResponse* purchaseServiceItemResponse);
        qBool CallListServiceItemRequest(ProtocolCallContext *pContext, DDLTYPE(uint32)::CPPType* requestId, const ServiceItemListServiceItemParam& listServiceItemParam);
        static qBool ListServiceItemRequest_PrepareRequest(ProtocolCallContext *pContext, Message *pMsg, DDLTYPE(uint32)::CPPType* requestId, const ServiceItemListServiceItemParam& listServiceItemParam);
        qBool CallListServiceItemResponse(ProtocolCallContext *pContext, const DDLTYPE(uint32)::CPPType& requestId, ServiceItemListServiceItemResponse* listServiceItemResponse);
        static qBool ListServiceItemResponse_PrepareRequest(ProtocolCallContext *pContext, Message *pMsg, const DDLTYPE(uint32)::CPPType& requestId, ServiceItemListServiceItemResponse* listServiceItemResponse);
        qBool CallGetBalanceRequest(ProtocolCallContext *pContext, DDLTYPE(uint32)::CPPType* requestId, const ServiceItemGetBalanceParam& getBalanceParam);
        static qBool GetBalanceRequest_PrepareRequest(ProtocolCallContext *pContext, Message *pMsg, DDLTYPE(uint32)::CPPType* requestId, const ServiceItemGetBalanceParam& getBalanceParam);
        qBool CallGetBalanceResponse(ProtocolCallContext *pContext, const DDLTYPE(uint32)::CPPType& requestId, ServiceItemGetBalanceResponse* getBalanceResponse);
        static qBool GetBalanceResponse_PrepareRequest(ProtocolCallContext *pContext, Message *pMsg, const DDLTYPE(uint32)::CPPType& requestId, ServiceItemGetBalanceResponse* getBalanceResponse);
        qBool CallGetPrepurchaseInfoRequest(ProtocolCallContext *pContext, DDLTYPE(uint32)::CPPType* requestId, const ServiceItemGetPrepurchaseInfoParam& getPrepurchaseInfoParam);
        static qBool GetPrepurchaseInfoRequest_PrepareRequest(ProtocolCallContext *pContext, Message *pMsg, DDLTYPE(uint32)::CPPType* requestId, const ServiceItemGetPrepurchaseInfoParam& getPrepurchaseInfoParam);
        qBool CallGetPrepurchaseInfoResponse(ProtocolCallContext *pContext, const DDLTYPE(uint32)::CPPType& requestId, ServiceItemGetPrepurchaseInfoResponse* getPrepurchaseInfoResponse);
        static qBool GetPrepurchaseInfoResponse_PrepareRequest(ProtocolCallContext *pContext, Message *pMsg, const DDLTYPE(uint32)::CPPType& requestId, ServiceItemGetPrepurchaseInfoResponse* getPrepurchaseInfoResponse);
        qBool CallGetServiceItemRightRequest(ProtocolCallContext *pContext, DDLTYPE(uint32)::CPPType* requestId, const ServiceItemGetServiceItemRightParam& getServiceItemRightParam, const DDLTYPE(bool)::CPPType& withoutRightBinary);
        static qBool GetServiceItemRightRequest_PrepareRequest(ProtocolCallContext *pContext, Message *pMsg, DDLTYPE(uint32)::CPPType* requestId, const ServiceItemGetServiceItemRightParam& getServiceItemRightParam, const DDLTYPE(bool)::CPPType& withoutRightBinary);
        qBool CallGetServiceItemRightResponse(ProtocolCallContext *pContext, const DDLTYPE(uint32)::CPPType& requestId, ServiceItemGetServiceItemRightResponse* getServiceItemRightResponse);
        static qBool GetServiceItemRightResponse_PrepareRequest(ProtocolCallContext *pContext, Message *pMsg, const DDLTYPE(uint32)::CPPType& requestId, ServiceItemGetServiceItemRightResponse* getServiceItemRightResponse);
        qBool CallGetPurchaseHistoryRequest(ProtocolCallContext *pContext, DDLTYPE(uint32)::CPPType* requestId, const ServiceItemGetPurchaseHistoryParam& getPurchaseHistoryParam);
        static qBool GetPurchaseHistoryRequest_PrepareRequest(ProtocolCallContext *pContext, Message *pMsg, DDLTYPE(uint32)::CPPType* requestId, const ServiceItemGetPurchaseHistoryParam& getPurchaseHistoryParam);
        qBool CallGetPurchaseHistoryResponse(ProtocolCallContext *pContext, const DDLTYPE(uint32)::CPPType& requestId, ServiceItemGetPurchaseHistoryResponse* getPurchaseHistoryResponse);
        static qBool GetPurchaseHistoryResponse_PrepareRequest(ProtocolCallContext *pContext, Message *pMsg, const DDLTYPE(uint32)::CPPType& requestId, ServiceItemGetPurchaseHistoryResponse* getPurchaseHistoryResponse);
        qBool CallPostRightBinaryByAccount(ProtocolCallContext *pContext, const ServiceItemPostRightBinaryByAccountParam& postRightBinaryByAccountParam, ServiceItemPostRightBinaryResponse* postRightBinaryResponse);
        static qBool PostRightBinaryByAccount_PrepareRequest(ProtocolCallContext *pContext, Message *pMsg, const ServiceItemPostRightBinaryByAccountParam& postRightBinaryByAccountParam, ServiceItemPostRightBinaryResponse* postRightBinaryResponse);
        qBool CallUseServiceItemByAccountRequest(ProtocolCallContext *pContext, DDLTYPE(uint32)::CPPType* requestId, const ServiceItemUseServiceItemByAccountParam& useServiceItemByAccountParam);
        static qBool UseServiceItemByAccountRequest_PrepareRequest(ProtocolCallContext *pContext, Message *pMsg, DDLTYPE(uint32)::CPPType* requestId, const ServiceItemUseServiceItemByAccountParam& useServiceItemByAccountParam);
        qBool CallUseServiceItemByAccountResponse(ProtocolCallContext *pContext, const DDLTYPE(uint32)::CPPType& requestId, ServiceItemUseServiceItemResponse* useServiceItemResponse);
        static qBool UseServiceItemByAccountResponse_PrepareRequest(ProtocolCallContext *pContext, Message *pMsg, const DDLTYPE(uint32)::CPPType& requestId, ServiceItemUseServiceItemResponse* useServiceItemResponse);
        qBool CallAcquireServiceItemByAccount(ProtocolCallContext *pContext, const ServiceItemAcquireServiceItemByAccountParam& acquireServiceItemByAccountParam, ServiceItemAcquireServiceItemResponse* acquireServiceItemResponse);
        static qBool AcquireServiceItemByAccount_PrepareRequest(ProtocolCallContext *pContext, Message *pMsg, const ServiceItemAcquireServiceItemByAccountParam& acquireServiceItemByAccountParam, ServiceItemAcquireServiceItemResponse* acquireServiceItemResponse);
        qBool CallGetSupportId(ProtocolCallContext *pContext, DDLTYPE(string)::CPPType* supportId, const ServiceItemGetSupportIdParam& getSuppordIdParam);
        static qBool GetSupportId_PrepareRequest(ProtocolCallContext *pContext, Message *pMsg, DDLTYPE(string)::CPPType* supportId, const ServiceItemGetSupportIdParam& getSuppordIdParam);
        qBool CallGetLawMessageRequest(ProtocolCallContext *pContext, DDLTYPE(uint32)::CPPType* requestId, const ServiceItemGetLawMessageParam& getLawMessageParam);
        static qBool GetLawMessageRequest_PrepareRequest(ProtocolCallContext *pContext, Message *pMsg, DDLTYPE(uint32)::CPPType* requestId, const ServiceItemGetLawMessageParam& getLawMessageParam);
        qBool CallGetLawMessageResponse(ProtocolCallContext *pContext, const DDLTYPE(uint32)::CPPType& requestId, ServiceItemGetLawMessageResponse* getLawMessageResponse);
        static qBool GetLawMessageResponse_PrepareRequest(ProtocolCallContext *pContext, Message *pMsg, const DDLTYPE(uint32)::CPPType& requestId, ServiceItemGetLawMessageResponse* getLawMessageResponse);
        qBool CallListAutoBillingServiceItemRequest(ProtocolCallContext *pContext, DDLTYPE(uint32)::CPPType* requestId, const ServiceItemListAutoBillingServiceItemParam& serviceItemListAutoBillingServiceItemParam);
        static qBool ListAutoBillingServiceItemRequest_PrepareRequest(ProtocolCallContext *pContext, Message *pMsg, DDLTYPE(uint32)::CPPType* requestId, const ServiceItemListAutoBillingServiceItemParam& serviceItemListAutoBillingServiceItemParam);
        qBool CallListAutoBillingServiceItemResponse(ProtocolCallContext *pContext, const DDLTYPE(uint32)::CPPType& requestId, ServiceItemListAutoBillingServiceItemResponse* serviceItemListAutoBillingServiceItemResponse);
        static qBool ListAutoBillingServiceItemResponse_PrepareRequest(ProtocolCallContext *pContext, Message *pMsg, const DDLTYPE(uint32)::CPPType& requestId, ServiceItemListAutoBillingServiceItemResponse* serviceItemListAutoBillingServiceItemResponse);
        qBool CallGetAutoBillingContractRequest(ProtocolCallContext *pContext, DDLTYPE(uint32)::CPPType* requestId, const ServiceItemGetAutoBillingContractParam& serviceItemGetAutoBillingContractParam);
        static qBool GetAutoBillingContractRequest_PrepareRequest(ProtocolCallContext *pContext, Message *pMsg, DDLTYPE(uint32)::CPPType* requestId, const ServiceItemGetAutoBillingContractParam& serviceItemGetAutoBillingContractParam);
        qBool CallGetAutoBillingContractResponse(ProtocolCallContext *pContext, const DDLTYPE(uint32)::CPPType& requestId, ServiceItemGetAutoBillingContractResponse* serviceItemGetAutoBillingContractResponse);
        static qBool GetAutoBillingContractResponse_PrepareRequest(ProtocolCallContext *pContext, Message *pMsg, const DDLTYPE(uint32)::CPPType& requestId, ServiceItemGetAutoBillingContractResponse* serviceItemGetAutoBillingContractResponse);
        qBool CallCancelAutoBillingRequest(ProtocolCallContext *pContext, DDLTYPE(uint32)::CPPType* requestId, const ServiceItemCancelAutoBillingParam& serviceItemCancelAutoBillingParam);
        static qBool CancelAutoBillingRequest_PrepareRequest(ProtocolCallContext *pContext, Message *pMsg, DDLTYPE(uint32)::CPPType* requestId, const ServiceItemCancelAutoBillingParam& serviceItemCancelAutoBillingParam);
        qBool CallCancelAutoBillingResponse(ProtocolCallContext *pContext, const DDLTYPE(uint32)::CPPType& requestId, ServiceItemCancelAutoBillingResponse* serviceItemCancelAutoBillingResponse);
        static qBool CancelAutoBillingResponse_PrepareRequest(ProtocolCallContext *pContext, Message *pMsg, const DDLTYPE(uint32)::CPPType& requestId, ServiceItemCancelAutoBillingResponse* serviceItemCancelAutoBillingResponse);
        qBool CallListRedemptionServiceItemRequest(ProtocolCallContext *pContext, DDLTYPE(uint32)::CPPType* requestId, const ServiceItemListRedemptionServiceItemParam& listServiceItemParam);
        static qBool ListRedemptionServiceItemRequest_PrepareRequest(ProtocolCallContext *pContext, Message *pMsg, DDLTYPE(uint32)::CPPType* requestId, const ServiceItemListRedemptionServiceItemParam& listServiceItemParam);
        qBool CallListRedemptionServiceItemResponse(ProtocolCallContext *pContext, const DDLTYPE(uint32)::CPPType& requestId, ServiceItemListRedemptionServiceItemResponse* listServiceItemResponse);
        static qBool ListRedemptionServiceItemResponse_PrepareRequest(ProtocolCallContext *pContext, Message *pMsg, const DDLTYPE(uint32)::CPPType& requestId, ServiceItemListRedemptionServiceItemResponse* listServiceItemResponse);
        qBool CallRedeemServiceItemRequest(ProtocolCallContext *pContext, DDLTYPE(uint32)::CPPType* requestId, const ServiceItemRedeemServiceItemParam& redeemServiceItemParam);
        static qBool RedeemServiceItemRequest_PrepareRequest(ProtocolCallContext *pContext, Message *pMsg, DDLTYPE(uint32)::CPPType* requestId, const ServiceItemRedeemServiceItemParam& redeemServiceItemParam);
        qBool CallRedeemServiceItemResponse(ProtocolCallContext *pContext, const DDLTYPE(uint32)::CPPType& requestId, ServiceItemRedeemServiceItemResponse* redeemServiceItemResponse);
        static qBool RedeemServiceItemResponse_PrepareRequest(ProtocolCallContext *pContext, Message *pMsg, const DDLTYPE(uint32)::CPPType& requestId, ServiceItemRedeemServiceItemResponse* redeemServiceItemResponse);
        
        protected:
        static ProtoReturnFunction s_protoReturnFunctions[PROTO_NUM_RMC(ServiceItemProtocol) + 1];
};

class DDLPROTOCOL(ServiceItemProtocolServer) : public ServerProtocol {
    public:
        DDLPROTOCOL(ServiceItemProtocolServer)()
            : ServerProtocol()
#if defined(LIVE_VERSION)
            , m_GetEnvironmentProfilingUnit(NEX_T("ServiceItemProtocol::GetEnvironment"))
            , m_HttpGetRequestProfilingUnit(NEX_T("ServiceItemProtocol::HttpGetRequest"))
            , m_HttpGetResponseProfilingUnit(NEX_T("ServiceItemProtocol::HttpGetResponse"))
            , m_PurchaseServiceItemRequestProfilingUnit(NEX_T("ServiceItemProtocol::PurchaseServiceItemRequest"))
            , m_PurchaseServiceItemResponseProfilingUnit(NEX_T("ServiceItemProtocol::PurchaseServiceItemResponse"))
            , m_ListServiceItemRequestProfilingUnit(NEX_T("ServiceItemProtocol::ListServiceItemRequest"))
            , m_ListServiceItemResponseProfilingUnit(NEX_T("ServiceItemProtocol::ListServiceItemResponse"))
            , m_GetBalanceRequestProfilingUnit(NEX_T("ServiceItemProtocol::GetBalanceRequest"))
            , m_GetBalanceResponseProfilingUnit(NEX_T("ServiceItemProtocol::GetBalanceResponse"))
            , m_GetPrepurchaseInfoRequestProfilingUnit(NEX_T("ServiceItemProtocol::GetPrepurchaseInfoRequest"))
            , m_GetPrepurchaseInfoResponseProfilingUnit(NEX_T("ServiceItemProtocol::GetPrepurchaseInfoResponse"))
            , m_GetServiceItemRightRequestProfilingUnit(NEX_T("ServiceItemProtocol::GetServiceItemRightRequest"))
            , m_GetServiceItemRightResponseProfilingUnit(NEX_T("ServiceItemProtocol::GetServiceItemRightResponse"))
            , m_GetPurchaseHistoryRequestProfilingUnit(NEX_T("ServiceItemProtocol::GetPurchaseHistoryRequest"))
            , m_GetPurchaseHistoryResponseProfilingUnit(NEX_T("ServiceItemProtocol::GetPurchaseHistoryResponse"))
            , m_PostRightBinaryByAccountProfilingUnit(NEX_T("ServiceItemProtocol::PostRightBinaryByAccount"))
            , m_UseServiceItemByAccountRequestProfilingUnit(NEX_T("ServiceItemProtocol::UseServiceItemByAccountRequest"))
            , m_UseServiceItemByAccountResponseProfilingUnit(NEX_T("ServiceItemProtocol::UseServiceItemByAccountResponse"))
            , m_AcquireServiceItemByAccountProfilingUnit(NEX_T("ServiceItemProtocol::AcquireServiceItemByAccount"))
            , m_GetSupportIdProfilingUnit(NEX_T("ServiceItemProtocol::GetSupportId"))
            , m_GetLawMessageRequestProfilingUnit(NEX_T("ServiceItemProtocol::GetLawMessageRequest"))
            , m_GetLawMessageResponseProfilingUnit(NEX_T("ServiceItemProtocol::GetLawMessageResponse"))
            , m_ListAutoBillingServiceItemRequestProfilingUnit(NEX_T("ServiceItemProtocol::ListAutoBillingServiceItemRequest"))
            , m_ListAutoBillingServiceItemResponseProfilingUnit(NEX_T("ServiceItemProtocol::ListAutoBillingServiceItemResponse"))
            , m_GetAutoBillingContractRequestProfilingUnit(NEX_T("ServiceItemProtocol::GetAutoBillingContractRequest"))
            , m_GetAutoBillingContractResponseProfilingUnit(NEX_T("ServiceItemProtocol::GetAutoBillingContractResponse"))
            , m_CancelAutoBillingRequestProfilingUnit(NEX_T("ServiceItemProtocol::CancelAutoBillingRequest"))
            , m_CancelAutoBillingResponseProfilingUnit(NEX_T("ServiceItemProtocol::CancelAutoBillingResponse"))
            , m_ListRedemptionServiceItemRequestProfilingUnit(NEX_T("ServiceItemProtocol::ListRedemptionServiceItemRequest"))
            , m_ListRedemptionServiceItemResponseProfilingUnit(NEX_T("ServiceItemProtocol::ListRedemptionServiceItemResponse"))
            , m_RedeemServiceItemRequestProfilingUnit(NEX_T("ServiceItemProtocol::RedeemServiceItemRequest"))
            , m_RedeemServiceItemResponseProfilingUnit(NEX_T("ServiceItemProtocol::RedeemServiceItemResponse"))
#endif // LIVE_VERSION
            {}
        
        typedef DDLTYPE(string) TGetEnvironment_uniqueId;
        typedef DDLTYPE(string) TGetEnvironment_str;
        typedef DDLTYPE(byte) TGetEnvironment_platform;
        PROTO_RMCIMPL_STUB(ServiceItemProtocol, GetEnvironment)
        {
            PROTO_PREPARE_EXTRACTION();
            DDLTYPE(string)::CPPType uniqueId;
            _MSG_EXTRACT_VARIABLE(TGetEnvironment_uniqueId, uniqueId);
            DDLTYPE(string)::CPPType str;
            DDLTYPE(byte)::CPPType platform;
            _MSG_EXTRACT_VARIABLE(TGetEnvironment_platform, platform);
            pProtocol->GetEnvironment( uniqueId, &str, platform );
            PROTO_PREPARE_RETURN(ServiceItemProtocol,GetEnvironment);
            _MSG_ADD_VARIABLE(TGetEnvironment_str, str);
        }
        
        typedef DDLTYPE(uint32) THttpGetRequest_requestId;
        typedef CLASSMETATYPE(ServiceItemHttpGetParam) THttpGetRequest_url;
        PROTO_RMCIMPL_STUB(ServiceItemProtocol, HttpGetRequest)
        {
            PROTO_PREPARE_EXTRACTION();
            DDLTYPE(uint32)::CPPType requestId;
            ServiceItemHttpGetParam url;
            _MSG_EXTRACT_VARIABLE(THttpGetRequest_url, url);
            pProtocol->HttpGetRequest( &requestId, url );
            PROTO_PREPARE_RETURN(ServiceItemProtocol,HttpGetRequest);
            _MSG_ADD_VARIABLE(THttpGetRequest_requestId, requestId);
        }
        
        typedef DDLTYPE(uint32) THttpGetResponse_requestId;
        typedef CLASSMETATYPE(ServiceItemHttpGetResponse) THttpGetResponse_response;
        PROTO_RMCIMPL_STUB(ServiceItemProtocol, HttpGetResponse)
        {
            PROTO_PREPARE_EXTRACTION();
            DDLTYPE(uint32)::CPPType requestId;
            _MSG_EXTRACT_VARIABLE(THttpGetResponse_requestId, requestId);
            ServiceItemHttpGetResponse response;
            pProtocol->HttpGetResponse( requestId, &response );
            PROTO_PREPARE_RETURN(ServiceItemProtocol,HttpGetResponse);
            _MSG_ADD_VARIABLE(THttpGetResponse_response, response);
        }
        
        typedef DDLTYPE(uint32) TPurchaseServiceItemRequest_requestId;
        typedef CLASSMETATYPE(ServiceItemPurchaseServiceItemParam) TPurchaseServiceItemRequest_purchaseServiceItemParam;
        PROTO_RMCIMPL_STUB(ServiceItemProtocol, PurchaseServiceItemRequest)
        {
            PROTO_PREPARE_EXTRACTION();
            DDLTYPE(uint32)::CPPType requestId;
            ServiceItemPurchaseServiceItemParam purchaseServiceItemParam;
            _MSG_EXTRACT_VARIABLE(TPurchaseServiceItemRequest_purchaseServiceItemParam, purchaseServiceItemParam);
            pProtocol->PurchaseServiceItemRequest( &requestId, purchaseServiceItemParam );
            PROTO_PREPARE_RETURN(ServiceItemProtocol,PurchaseServiceItemRequest);
            _MSG_ADD_VARIABLE(TPurchaseServiceItemRequest_requestId, requestId);
        }
        
        typedef DDLTYPE(uint32) TPurchaseServiceItemResponse_requestId;
        typedef CLASSMETATYPE(ServiceItemPurchaseServiceItemResponse) TPurchaseServiceItemResponse_purchaseServiceItemResponse;
        PROTO_RMCIMPL_STUB(ServiceItemProtocol, PurchaseServiceItemResponse)
        {
            PROTO_PREPARE_EXTRACTION();
            DDLTYPE(uint32)::CPPType requestId;
            _MSG_EXTRACT_VARIABLE(TPurchaseServiceItemResponse_requestId, requestId);
            ServiceItemPurchaseServiceItemResponse purchaseServiceItemResponse;
            pProtocol->PurchaseServiceItemResponse( requestId, &purchaseServiceItemResponse );
            PROTO_PREPARE_RETURN(ServiceItemProtocol,PurchaseServiceItemResponse);
            _MSG_ADD_VARIABLE(TPurchaseServiceItemResponse_purchaseServiceItemResponse, purchaseServiceItemResponse);
        }
        
        typedef DDLTYPE(uint32) TListServiceItemRequest_requestId;
        typedef CLASSMETATYPE(ServiceItemListServiceItemParam) TListServiceItemRequest_listServiceItemParam;
        PROTO_RMCIMPL_STUB(ServiceItemProtocol, ListServiceItemRequest)
        {
            PROTO_PREPARE_EXTRACTION();
            DDLTYPE(uint32)::CPPType requestId;
            ServiceItemListServiceItemParam listServiceItemParam;
            _MSG_EXTRACT_VARIABLE(TListServiceItemRequest_listServiceItemParam, listServiceItemParam);
            pProtocol->ListServiceItemRequest( &requestId, listServiceItemParam );
            PROTO_PREPARE_RETURN(ServiceItemProtocol,ListServiceItemRequest);
            _MSG_ADD_VARIABLE(TListServiceItemRequest_requestId, requestId);
        }
        
        typedef DDLTYPE(uint32) TListServiceItemResponse_requestId;
        typedef CLASSMETATYPE(ServiceItemListServiceItemResponse) TListServiceItemResponse_listServiceItemResponse;
        PROTO_RMCIMPL_STUB(ServiceItemProtocol, ListServiceItemResponse)
        {
            PROTO_PREPARE_EXTRACTION();
            DDLTYPE(uint32)::CPPType requestId;
            _MSG_EXTRACT_VARIABLE(TListServiceItemResponse_requestId, requestId);
            ServiceItemListServiceItemResponse listServiceItemResponse;
            pProtocol->ListServiceItemResponse( requestId, &listServiceItemResponse );
            PROTO_PREPARE_RETURN(ServiceItemProtocol,ListServiceItemResponse);
            _MSG_ADD_VARIABLE(TListServiceItemResponse_listServiceItemResponse, listServiceItemResponse);
        }
        
        typedef DDLTYPE(uint32) TGetBalanceRequest_requestId;
        typedef CLASSMETATYPE(ServiceItemGetBalanceParam) TGetBalanceRequest_getBalanceParam;
        PROTO_RMCIMPL_STUB(ServiceItemProtocol, GetBalanceRequest)
        {
            PROTO_PREPARE_EXTRACTION();
            DDLTYPE(uint32)::CPPType requestId;
            ServiceItemGetBalanceParam getBalanceParam;
            _MSG_EXTRACT_VARIABLE(TGetBalanceRequest_getBalanceParam, getBalanceParam);
            pProtocol->GetBalanceRequest( &requestId, getBalanceParam );
            PROTO_PREPARE_RETURN(ServiceItemProtocol,GetBalanceRequest);
            _MSG_ADD_VARIABLE(TGetBalanceRequest_requestId, requestId);
        }
        
        typedef DDLTYPE(uint32) TGetBalanceResponse_requestId;
        typedef CLASSMETATYPE(ServiceItemGetBalanceResponse) TGetBalanceResponse_getBalanceResponse;
        PROTO_RMCIMPL_STUB(ServiceItemProtocol, GetBalanceResponse)
        {
            PROTO_PREPARE_EXTRACTION();
            DDLTYPE(uint32)::CPPType requestId;
            _MSG_EXTRACT_VARIABLE(TGetBalanceResponse_requestId, requestId);
            ServiceItemGetBalanceResponse getBalanceResponse;
            pProtocol->GetBalanceResponse( requestId, &getBalanceResponse );
            PROTO_PREPARE_RETURN(ServiceItemProtocol,GetBalanceResponse);
            _MSG_ADD_VARIABLE(TGetBalanceResponse_getBalanceResponse, getBalanceResponse);
        }
        
        typedef DDLTYPE(uint32) TGetPrepurchaseInfoRequest_requestId;
        typedef CLASSMETATYPE(ServiceItemGetPrepurchaseInfoParam) TGetPrepurchaseInfoRequest_getPrepurchaseInfoParam;
        PROTO_RMCIMPL_STUB(ServiceItemProtocol, GetPrepurchaseInfoRequest)
        {
            PROTO_PREPARE_EXTRACTION();
            DDLTYPE(uint32)::CPPType requestId;
            ServiceItemGetPrepurchaseInfoParam getPrepurchaseInfoParam;
            _MSG_EXTRACT_VARIABLE(TGetPrepurchaseInfoRequest_getPrepurchaseInfoParam, getPrepurchaseInfoParam);
            pProtocol->GetPrepurchaseInfoRequest( &requestId, getPrepurchaseInfoParam );
            PROTO_PREPARE_RETURN(ServiceItemProtocol,GetPrepurchaseInfoRequest);
            _MSG_ADD_VARIABLE(TGetPrepurchaseInfoRequest_requestId, requestId);
        }
        
        typedef DDLTYPE(uint32) TGetPrepurchaseInfoResponse_requestId;
        typedef CLASSMETATYPE(ServiceItemGetPrepurchaseInfoResponse) TGetPrepurchaseInfoResponse_getPrepurchaseInfoResponse;
        PROTO_RMCIMPL_STUB(ServiceItemProtocol, GetPrepurchaseInfoResponse)
        {
            PROTO_PREPARE_EXTRACTION();
            DDLTYPE(uint32)::CPPType requestId;
            _MSG_EXTRACT_VARIABLE(TGetPrepurchaseInfoResponse_requestId, requestId);
            ServiceItemGetPrepurchaseInfoResponse getPrepurchaseInfoResponse;
            pProtocol->GetPrepurchaseInfoResponse( requestId, &getPrepurchaseInfoResponse );
            PROTO_PREPARE_RETURN(ServiceItemProtocol,GetPrepurchaseInfoResponse);
            _MSG_ADD_VARIABLE(TGetPrepurchaseInfoResponse_getPrepurchaseInfoResponse, getPrepurchaseInfoResponse);
        }
        
        typedef DDLTYPE(uint32) TGetServiceItemRightRequest_requestId;
        typedef CLASSMETATYPE(ServiceItemGetServiceItemRightParam) TGetServiceItemRightRequest_getServiceItemRightParam;
        typedef DDLTYPE(bool) TGetServiceItemRightRequest_withoutRightBinary;
        PROTO_RMCIMPL_STUB(ServiceItemProtocol, GetServiceItemRightRequest)
        {
            PROTO_PREPARE_EXTRACTION();
            DDLTYPE(uint32)::CPPType requestId;
            ServiceItemGetServiceItemRightParam getServiceItemRightParam;
            _MSG_EXTRACT_VARIABLE(TGetServiceItemRightRequest_getServiceItemRightParam, getServiceItemRightParam);
            DDLTYPE(bool)::CPPType withoutRightBinary;
            _MSG_EXTRACT_VARIABLE(TGetServiceItemRightRequest_withoutRightBinary, withoutRightBinary);
            pProtocol->GetServiceItemRightRequest( &requestId, getServiceItemRightParam, withoutRightBinary );
            PROTO_PREPARE_RETURN(ServiceItemProtocol,GetServiceItemRightRequest);
            _MSG_ADD_VARIABLE(TGetServiceItemRightRequest_requestId, requestId);
        }
        
        typedef DDLTYPE(uint32) TGetServiceItemRightResponse_requestId;
        typedef CLASSMETATYPE(ServiceItemGetServiceItemRightResponse) TGetServiceItemRightResponse_getServiceItemRightResponse;
        PROTO_RMCIMPL_STUB(ServiceItemProtocol, GetServiceItemRightResponse)
        {
            PROTO_PREPARE_EXTRACTION();
            DDLTYPE(uint32)::CPPType requestId;
            _MSG_EXTRACT_VARIABLE(TGetServiceItemRightResponse_requestId, requestId);
            ServiceItemGetServiceItemRightResponse getServiceItemRightResponse;
            pProtocol->GetServiceItemRightResponse( requestId, &getServiceItemRightResponse );
            PROTO_PREPARE_RETURN(ServiceItemProtocol,GetServiceItemRightResponse);
            _MSG_ADD_VARIABLE(TGetServiceItemRightResponse_getServiceItemRightResponse, getServiceItemRightResponse);
        }
        
        typedef DDLTYPE(uint32) TGetPurchaseHistoryRequest_requestId;
        typedef CLASSMETATYPE(ServiceItemGetPurchaseHistoryParam) TGetPurchaseHistoryRequest_getPurchaseHistoryParam;
        PROTO_RMCIMPL_STUB(ServiceItemProtocol, GetPurchaseHistoryRequest)
        {
            PROTO_PREPARE_EXTRACTION();
            DDLTYPE(uint32)::CPPType requestId;
            ServiceItemGetPurchaseHistoryParam getPurchaseHistoryParam;
            _MSG_EXTRACT_VARIABLE(TGetPurchaseHistoryRequest_getPurchaseHistoryParam, getPurchaseHistoryParam);
            pProtocol->GetPurchaseHistoryRequest( &requestId, getPurchaseHistoryParam );
            PROTO_PREPARE_RETURN(ServiceItemProtocol,GetPurchaseHistoryRequest);
            _MSG_ADD_VARIABLE(TGetPurchaseHistoryRequest_requestId, requestId);
        }
        
        typedef DDLTYPE(uint32) TGetPurchaseHistoryResponse_requestId;
        typedef CLASSMETATYPE(ServiceItemGetPurchaseHistoryResponse) TGetPurchaseHistoryResponse_getPurchaseHistoryResponse;
        PROTO_RMCIMPL_STUB(ServiceItemProtocol, GetPurchaseHistoryResponse)
        {
            PROTO_PREPARE_EXTRACTION();
            DDLTYPE(uint32)::CPPType requestId;
            _MSG_EXTRACT_VARIABLE(TGetPurchaseHistoryResponse_requestId, requestId);
            ServiceItemGetPurchaseHistoryResponse getPurchaseHistoryResponse;
            pProtocol->GetPurchaseHistoryResponse( requestId, &getPurchaseHistoryResponse );
            PROTO_PREPARE_RETURN(ServiceItemProtocol,GetPurchaseHistoryResponse);
            _MSG_ADD_VARIABLE(TGetPurchaseHistoryResponse_getPurchaseHistoryResponse, getPurchaseHistoryResponse);
        }
        
        typedef CLASSMETATYPE(ServiceItemPostRightBinaryByAccountParam) TPostRightBinaryByAccount_postRightBinaryByAccountParam;
        typedef CLASSMETATYPE(ServiceItemPostRightBinaryResponse) TPostRightBinaryByAccount_postRightBinaryResponse;
        PROTO_RMCIMPL_STUB(ServiceItemProtocol, PostRightBinaryByAccount)
        {
            PROTO_PREPARE_EXTRACTION();
            ServiceItemPostRightBinaryByAccountParam postRightBinaryByAccountParam;
            _MSG_EXTRACT_VARIABLE(TPostRightBinaryByAccount_postRightBinaryByAccountParam, postRightBinaryByAccountParam);
            ServiceItemPostRightBinaryResponse postRightBinaryResponse;
            pProtocol->PostRightBinaryByAccount( postRightBinaryByAccountParam, &postRightBinaryResponse );
            PROTO_PREPARE_RETURN(ServiceItemProtocol,PostRightBinaryByAccount);
            _MSG_ADD_VARIABLE(TPostRightBinaryByAccount_postRightBinaryResponse, postRightBinaryResponse);
        }
        
        typedef DDLTYPE(uint32) TUseServiceItemByAccountRequest_requestId;
        typedef CLASSMETATYPE(ServiceItemUseServiceItemByAccountParam) TUseServiceItemByAccountRequest_useServiceItemByAccountParam;
        PROTO_RMCIMPL_STUB(ServiceItemProtocol, UseServiceItemByAccountRequest)
        {
            PROTO_PREPARE_EXTRACTION();
            DDLTYPE(uint32)::CPPType requestId;
            ServiceItemUseServiceItemByAccountParam useServiceItemByAccountParam;
            _MSG_EXTRACT_VARIABLE(TUseServiceItemByAccountRequest_useServiceItemByAccountParam, useServiceItemByAccountParam);
            pProtocol->UseServiceItemByAccountRequest( &requestId, useServiceItemByAccountParam );
            PROTO_PREPARE_RETURN(ServiceItemProtocol,UseServiceItemByAccountRequest);
            _MSG_ADD_VARIABLE(TUseServiceItemByAccountRequest_requestId, requestId);
        }
        
        typedef DDLTYPE(uint32) TUseServiceItemByAccountResponse_requestId;
        typedef CLASSMETATYPE(ServiceItemUseServiceItemResponse) TUseServiceItemByAccountResponse_useServiceItemResponse;
        PROTO_RMCIMPL_STUB(ServiceItemProtocol, UseServiceItemByAccountResponse)
        {
            PROTO_PREPARE_EXTRACTION();
            DDLTYPE(uint32)::CPPType requestId;
            _MSG_EXTRACT_VARIABLE(TUseServiceItemByAccountResponse_requestId, requestId);
            ServiceItemUseServiceItemResponse useServiceItemResponse;
            pProtocol->UseServiceItemByAccountResponse( requestId, &useServiceItemResponse );
            PROTO_PREPARE_RETURN(ServiceItemProtocol,UseServiceItemByAccountResponse);
            _MSG_ADD_VARIABLE(TUseServiceItemByAccountResponse_useServiceItemResponse, useServiceItemResponse);
        }
        
        typedef CLASSMETATYPE(ServiceItemAcquireServiceItemByAccountParam) TAcquireServiceItemByAccount_acquireServiceItemByAccountParam;
        typedef CLASSMETATYPE(ServiceItemAcquireServiceItemResponse) TAcquireServiceItemByAccount_acquireServiceItemResponse;
        PROTO_RMCIMPL_STUB(ServiceItemProtocol, AcquireServiceItemByAccount)
        {
            PROTO_PREPARE_EXTRACTION();
            ServiceItemAcquireServiceItemByAccountParam acquireServiceItemByAccountParam;
            _MSG_EXTRACT_VARIABLE(TAcquireServiceItemByAccount_acquireServiceItemByAccountParam, acquireServiceItemByAccountParam);
            ServiceItemAcquireServiceItemResponse acquireServiceItemResponse;
            pProtocol->AcquireServiceItemByAccount( acquireServiceItemByAccountParam, &acquireServiceItemResponse );
            PROTO_PREPARE_RETURN(ServiceItemProtocol,AcquireServiceItemByAccount);
            _MSG_ADD_VARIABLE(TAcquireServiceItemByAccount_acquireServiceItemResponse, acquireServiceItemResponse);
        }
        
        typedef DDLTYPE(string) TGetSupportId_supportId;
        typedef CLASSMETATYPE(ServiceItemGetSupportIdParam) TGetSupportId_getSuppordIdParam;
        PROTO_RMCIMPL_STUB(ServiceItemProtocol, GetSupportId)
        {
            PROTO_PREPARE_EXTRACTION();
            DDLTYPE(string)::CPPType supportId;
            ServiceItemGetSupportIdParam getSuppordIdParam;
            _MSG_EXTRACT_VARIABLE(TGetSupportId_getSuppordIdParam, getSuppordIdParam);
            pProtocol->GetSupportId( &supportId, getSuppordIdParam );
            PROTO_PREPARE_RETURN(ServiceItemProtocol,GetSupportId);
            _MSG_ADD_VARIABLE(TGetSupportId_supportId, supportId);
        }
        
        typedef DDLTYPE(uint32) TGetLawMessageRequest_requestId;
        typedef CLASSMETATYPE(ServiceItemGetLawMessageParam) TGetLawMessageRequest_getLawMessageParam;
        PROTO_RMCIMPL_STUB(ServiceItemProtocol, GetLawMessageRequest)
        {
            PROTO_PREPARE_EXTRACTION();
            DDLTYPE(uint32)::CPPType requestId;
            ServiceItemGetLawMessageParam getLawMessageParam;
            _MSG_EXTRACT_VARIABLE(TGetLawMessageRequest_getLawMessageParam, getLawMessageParam);
            pProtocol->GetLawMessageRequest( &requestId, getLawMessageParam );
            PROTO_PREPARE_RETURN(ServiceItemProtocol,GetLawMessageRequest);
            _MSG_ADD_VARIABLE(TGetLawMessageRequest_requestId, requestId);
        }
        
        typedef DDLTYPE(uint32) TGetLawMessageResponse_requestId;
        typedef CLASSMETATYPE(ServiceItemGetLawMessageResponse) TGetLawMessageResponse_getLawMessageResponse;
        PROTO_RMCIMPL_STUB(ServiceItemProtocol, GetLawMessageResponse)
        {
            PROTO_PREPARE_EXTRACTION();
            DDLTYPE(uint32)::CPPType requestId;
            _MSG_EXTRACT_VARIABLE(TGetLawMessageResponse_requestId, requestId);
            ServiceItemGetLawMessageResponse getLawMessageResponse;
            pProtocol->GetLawMessageResponse( requestId, &getLawMessageResponse );
            PROTO_PREPARE_RETURN(ServiceItemProtocol,GetLawMessageResponse);
            _MSG_ADD_VARIABLE(TGetLawMessageResponse_getLawMessageResponse, getLawMessageResponse);
        }
        
        typedef DDLTYPE(uint32) TListAutoBillingServiceItemRequest_requestId;
        typedef CLASSMETATYPE(ServiceItemListAutoBillingServiceItemParam) TListAutoBillingServiceItemRequest_serviceItemListAutoBillingServiceItemParam;
        PROTO_RMCIMPL_STUB(ServiceItemProtocol, ListAutoBillingServiceItemRequest)
        {
            PROTO_PREPARE_EXTRACTION();
            DDLTYPE(uint32)::CPPType requestId;
            ServiceItemListAutoBillingServiceItemParam serviceItemListAutoBillingServiceItemParam;
            _MSG_EXTRACT_VARIABLE(TListAutoBillingServiceItemRequest_serviceItemListAutoBillingServiceItemParam, serviceItemListAutoBillingServiceItemParam);
            pProtocol->ListAutoBillingServiceItemRequest( &requestId, serviceItemListAutoBillingServiceItemParam );
            PROTO_PREPARE_RETURN(ServiceItemProtocol,ListAutoBillingServiceItemRequest);
            _MSG_ADD_VARIABLE(TListAutoBillingServiceItemRequest_requestId, requestId);
        }
        
        typedef DDLTYPE(uint32) TListAutoBillingServiceItemResponse_requestId;
        typedef CLASSMETATYPE(ServiceItemListAutoBillingServiceItemResponse) TListAutoBillingServiceItemResponse_serviceItemListAutoBillingServiceItemResponse;
        PROTO_RMCIMPL_STUB(ServiceItemProtocol, ListAutoBillingServiceItemResponse)
        {
            PROTO_PREPARE_EXTRACTION();
            DDLTYPE(uint32)::CPPType requestId;
            _MSG_EXTRACT_VARIABLE(TListAutoBillingServiceItemResponse_requestId, requestId);
            ServiceItemListAutoBillingServiceItemResponse serviceItemListAutoBillingServiceItemResponse;
            pProtocol->ListAutoBillingServiceItemResponse( requestId, &serviceItemListAutoBillingServiceItemResponse );
            PROTO_PREPARE_RETURN(ServiceItemProtocol,ListAutoBillingServiceItemResponse);
            _MSG_ADD_VARIABLE(TListAutoBillingServiceItemResponse_serviceItemListAutoBillingServiceItemResponse, serviceItemListAutoBillingServiceItemResponse);
        }
        
        typedef DDLTYPE(uint32) TGetAutoBillingContractRequest_requestId;
        typedef CLASSMETATYPE(ServiceItemGetAutoBillingContractParam) TGetAutoBillingContractRequest_serviceItemGetAutoBillingContractParam;
        PROTO_RMCIMPL_STUB(ServiceItemProtocol, GetAutoBillingContractRequest)
        {
            PROTO_PREPARE_EXTRACTION();
            DDLTYPE(uint32)::CPPType requestId;
            ServiceItemGetAutoBillingContractParam serviceItemGetAutoBillingContractParam;
            _MSG_EXTRACT_VARIABLE(TGetAutoBillingContractRequest_serviceItemGetAutoBillingContractParam, serviceItemGetAutoBillingContractParam);
            pProtocol->GetAutoBillingContractRequest( &requestId, serviceItemGetAutoBillingContractParam );
            PROTO_PREPARE_RETURN(ServiceItemProtocol,GetAutoBillingContractRequest);
            _MSG_ADD_VARIABLE(TGetAutoBillingContractRequest_requestId, requestId);
        }
        
        typedef DDLTYPE(uint32) TGetAutoBillingContractResponse_requestId;
        typedef CLASSMETATYPE(ServiceItemGetAutoBillingContractResponse) TGetAutoBillingContractResponse_serviceItemGetAutoBillingContractResponse;
        PROTO_RMCIMPL_STUB(ServiceItemProtocol, GetAutoBillingContractResponse)
        {
            PROTO_PREPARE_EXTRACTION();
            DDLTYPE(uint32)::CPPType requestId;
            _MSG_EXTRACT_VARIABLE(TGetAutoBillingContractResponse_requestId, requestId);
            ServiceItemGetAutoBillingContractResponse serviceItemGetAutoBillingContractResponse;
            pProtocol->GetAutoBillingContractResponse( requestId, &serviceItemGetAutoBillingContractResponse );
            PROTO_PREPARE_RETURN(ServiceItemProtocol,GetAutoBillingContractResponse);
            _MSG_ADD_VARIABLE(TGetAutoBillingContractResponse_serviceItemGetAutoBillingContractResponse, serviceItemGetAutoBillingContractResponse);
        }
        
        typedef DDLTYPE(uint32) TCancelAutoBillingRequest_requestId;
        typedef CLASSMETATYPE(ServiceItemCancelAutoBillingParam) TCancelAutoBillingRequest_serviceItemCancelAutoBillingParam;
        PROTO_RMCIMPL_STUB(ServiceItemProtocol, CancelAutoBillingRequest)
        {
            PROTO_PREPARE_EXTRACTION();
            DDLTYPE(uint32)::CPPType requestId;
            ServiceItemCancelAutoBillingParam serviceItemCancelAutoBillingParam;
            _MSG_EXTRACT_VARIABLE(TCancelAutoBillingRequest_serviceItemCancelAutoBillingParam, serviceItemCancelAutoBillingParam);
            pProtocol->CancelAutoBillingRequest( &requestId, serviceItemCancelAutoBillingParam );
            PROTO_PREPARE_RETURN(ServiceItemProtocol,CancelAutoBillingRequest);
            _MSG_ADD_VARIABLE(TCancelAutoBillingRequest_requestId, requestId);
        }
        
        typedef DDLTYPE(uint32) TCancelAutoBillingResponse_requestId;
        typedef CLASSMETATYPE(ServiceItemCancelAutoBillingResponse) TCancelAutoBillingResponse_serviceItemCancelAutoBillingResponse;
        PROTO_RMCIMPL_STUB(ServiceItemProtocol, CancelAutoBillingResponse)
        {
            PROTO_PREPARE_EXTRACTION();
            DDLTYPE(uint32)::CPPType requestId;
            _MSG_EXTRACT_VARIABLE(TCancelAutoBillingResponse_requestId, requestId);
            ServiceItemCancelAutoBillingResponse serviceItemCancelAutoBillingResponse;
            pProtocol->CancelAutoBillingResponse( requestId, &serviceItemCancelAutoBillingResponse );
            PROTO_PREPARE_RETURN(ServiceItemProtocol,CancelAutoBillingResponse);
            _MSG_ADD_VARIABLE(TCancelAutoBillingResponse_serviceItemCancelAutoBillingResponse, serviceItemCancelAutoBillingResponse);
        }
        
        typedef DDLTYPE(uint32) TListRedemptionServiceItemRequest_requestId;
        typedef CLASSMETATYPE(ServiceItemListRedemptionServiceItemParam) TListRedemptionServiceItemRequest_listServiceItemParam;
        PROTO_RMCIMPL_STUB(ServiceItemProtocol, ListRedemptionServiceItemRequest)
        {
            PROTO_PREPARE_EXTRACTION();
            DDLTYPE(uint32)::CPPType requestId;
            ServiceItemListRedemptionServiceItemParam listServiceItemParam;
            _MSG_EXTRACT_VARIABLE(TListRedemptionServiceItemRequest_listServiceItemParam, listServiceItemParam);
            pProtocol->ListRedemptionServiceItemRequest( &requestId, listServiceItemParam );
            PROTO_PREPARE_RETURN(ServiceItemProtocol,ListRedemptionServiceItemRequest);
            _MSG_ADD_VARIABLE(TListRedemptionServiceItemRequest_requestId, requestId);
        }
        
        typedef DDLTYPE(uint32) TListRedemptionServiceItemResponse_requestId;
        typedef CLASSMETATYPE(ServiceItemListRedemptionServiceItemResponse) TListRedemptionServiceItemResponse_listServiceItemResponse;
        PROTO_RMCIMPL_STUB(ServiceItemProtocol, ListRedemptionServiceItemResponse)
        {
            PROTO_PREPARE_EXTRACTION();
            DDLTYPE(uint32)::CPPType requestId;
            _MSG_EXTRACT_VARIABLE(TListRedemptionServiceItemResponse_requestId, requestId);
            ServiceItemListRedemptionServiceItemResponse listServiceItemResponse;
            pProtocol->ListRedemptionServiceItemResponse( requestId, &listServiceItemResponse );
            PROTO_PREPARE_RETURN(ServiceItemProtocol,ListRedemptionServiceItemResponse);
            _MSG_ADD_VARIABLE(TListRedemptionServiceItemResponse_listServiceItemResponse, listServiceItemResponse);
        }
        
        typedef DDLTYPE(uint32) TRedeemServiceItemRequest_requestId;
        typedef CLASSMETATYPE(ServiceItemRedeemServiceItemParam) TRedeemServiceItemRequest_redeemServiceItemParam;
        PROTO_RMCIMPL_STUB(ServiceItemProtocol, RedeemServiceItemRequest)
        {
            PROTO_PREPARE_EXTRACTION();
            DDLTYPE(uint32)::CPPType requestId;
            ServiceItemRedeemServiceItemParam redeemServiceItemParam;
            _MSG_EXTRACT_VARIABLE(TRedeemServiceItemRequest_redeemServiceItemParam, redeemServiceItemParam);
            pProtocol->RedeemServiceItemRequest( &requestId, redeemServiceItemParam );
            PROTO_PREPARE_RETURN(ServiceItemProtocol,RedeemServiceItemRequest);
            _MSG_ADD_VARIABLE(TRedeemServiceItemRequest_requestId, requestId);
        }
        
        typedef DDLTYPE(uint32) TRedeemServiceItemResponse_requestId;
        typedef CLASSMETATYPE(ServiceItemRedeemServiceItemResponse) TRedeemServiceItemResponse_redeemServiceItemResponse;
        PROTO_RMCIMPL_STUB(ServiceItemProtocol, RedeemServiceItemResponse)
        {
            PROTO_PREPARE_EXTRACTION();
            DDLTYPE(uint32)::CPPType requestId;
            _MSG_EXTRACT_VARIABLE(TRedeemServiceItemResponse_requestId, requestId);
            ServiceItemRedeemServiceItemResponse redeemServiceItemResponse;
            pProtocol->RedeemServiceItemResponse( requestId, &redeemServiceItemResponse );
            PROTO_PREPARE_RETURN(ServiceItemProtocol,RedeemServiceItemResponse);
            _MSG_ADD_VARIABLE(TRedeemServiceItemResponse_redeemServiceItemResponse, redeemServiceItemResponse);
        }
        
        private:
        // Call this function with a message previously generated by a
        // <RMC name>_PrepareRequest() call to have it dispatched to the correct RMC.
        virtual void DispatchProtocolMessage( Message *pMessage, Message *pReturnMessage, qBool *boReturnsMessage, EndPoint *pEndPoint);
        public:
        
        virtual void GetEnvironment(const DDLTYPE(string)::CPPType& uniqueId, DDLTYPE(string)::CPPType* str, const DDLTYPE(byte)::CPPType& platform) = 0;
        virtual void HttpGetRequest(DDLTYPE(uint32)::CPPType* requestId, const ServiceItemHttpGetParam& url) = 0;
        virtual void HttpGetResponse(const DDLTYPE(uint32)::CPPType& requestId, ServiceItemHttpGetResponse* response) = 0;
        virtual void PurchaseServiceItemRequest(DDLTYPE(uint32)::CPPType* requestId, const ServiceItemPurchaseServiceItemParam& purchaseServiceItemParam) = 0;
        virtual void PurchaseServiceItemResponse(const DDLTYPE(uint32)::CPPType& requestId, ServiceItemPurchaseServiceItemResponse* purchaseServiceItemResponse) = 0;
        virtual void ListServiceItemRequest(DDLTYPE(uint32)::CPPType* requestId, const ServiceItemListServiceItemParam& listServiceItemParam) = 0;
        virtual void ListServiceItemResponse(const DDLTYPE(uint32)::CPPType& requestId, ServiceItemListServiceItemResponse* listServiceItemResponse) = 0;
        virtual void GetBalanceRequest(DDLTYPE(uint32)::CPPType* requestId, const ServiceItemGetBalanceParam& getBalanceParam) = 0;
        virtual void GetBalanceResponse(const DDLTYPE(uint32)::CPPType& requestId, ServiceItemGetBalanceResponse* getBalanceResponse) = 0;
        virtual void GetPrepurchaseInfoRequest(DDLTYPE(uint32)::CPPType* requestId, const ServiceItemGetPrepurchaseInfoParam& getPrepurchaseInfoParam) = 0;
        virtual void GetPrepurchaseInfoResponse(const DDLTYPE(uint32)::CPPType& requestId, ServiceItemGetPrepurchaseInfoResponse* getPrepurchaseInfoResponse) = 0;
        virtual void GetServiceItemRightRequest(DDLTYPE(uint32)::CPPType* requestId, const ServiceItemGetServiceItemRightParam& getServiceItemRightParam, const DDLTYPE(bool)::CPPType& withoutRightBinary) = 0;
        virtual void GetServiceItemRightResponse(const DDLTYPE(uint32)::CPPType& requestId, ServiceItemGetServiceItemRightResponse* getServiceItemRightResponse) = 0;
        virtual void GetPurchaseHistoryRequest(DDLTYPE(uint32)::CPPType* requestId, const ServiceItemGetPurchaseHistoryParam& getPurchaseHistoryParam) = 0;
        virtual void GetPurchaseHistoryResponse(const DDLTYPE(uint32)::CPPType& requestId, ServiceItemGetPurchaseHistoryResponse* getPurchaseHistoryResponse) = 0;
        virtual void PostRightBinaryByAccount(const ServiceItemPostRightBinaryByAccountParam& postRightBinaryByAccountParam, ServiceItemPostRightBinaryResponse* postRightBinaryResponse) = 0;
        virtual void UseServiceItemByAccountRequest(DDLTYPE(uint32)::CPPType* requestId, const ServiceItemUseServiceItemByAccountParam& useServiceItemByAccountParam) = 0;
        virtual void UseServiceItemByAccountResponse(const DDLTYPE(uint32)::CPPType& requestId, ServiceItemUseServiceItemResponse* useServiceItemResponse) = 0;
        virtual void AcquireServiceItemByAccount(const ServiceItemAcquireServiceItemByAccountParam& acquireServiceItemByAccountParam, ServiceItemAcquireServiceItemResponse* acquireServiceItemResponse) = 0;
        virtual void GetSupportId(DDLTYPE(string)::CPPType* supportId, const ServiceItemGetSupportIdParam& getSuppordIdParam) = 0;
        virtual void GetLawMessageRequest(DDLTYPE(uint32)::CPPType* requestId, const ServiceItemGetLawMessageParam& getLawMessageParam) = 0;
        virtual void GetLawMessageResponse(const DDLTYPE(uint32)::CPPType& requestId, ServiceItemGetLawMessageResponse* getLawMessageResponse) = 0;
        virtual void ListAutoBillingServiceItemRequest(DDLTYPE(uint32)::CPPType* requestId, const ServiceItemListAutoBillingServiceItemParam& serviceItemListAutoBillingServiceItemParam) = 0;
        virtual void ListAutoBillingServiceItemResponse(const DDLTYPE(uint32)::CPPType& requestId, ServiceItemListAutoBillingServiceItemResponse* serviceItemListAutoBillingServiceItemResponse) = 0;
        virtual void GetAutoBillingContractRequest(DDLTYPE(uint32)::CPPType* requestId, const ServiceItemGetAutoBillingContractParam& serviceItemGetAutoBillingContractParam) = 0;
        virtual void GetAutoBillingContractResponse(const DDLTYPE(uint32)::CPPType& requestId, ServiceItemGetAutoBillingContractResponse* serviceItemGetAutoBillingContractResponse) = 0;
        virtual void CancelAutoBillingRequest(DDLTYPE(uint32)::CPPType* requestId, const ServiceItemCancelAutoBillingParam& serviceItemCancelAutoBillingParam) = 0;
        virtual void CancelAutoBillingResponse(const DDLTYPE(uint32)::CPPType& requestId, ServiceItemCancelAutoBillingResponse* serviceItemCancelAutoBillingResponse) = 0;
        virtual void ListRedemptionServiceItemRequest(DDLTYPE(uint32)::CPPType* requestId, const ServiceItemListRedemptionServiceItemParam& listServiceItemParam) = 0;
        virtual void ListRedemptionServiceItemResponse(const DDLTYPE(uint32)::CPPType& requestId, ServiceItemListRedemptionServiceItemResponse* listServiceItemResponse) = 0;
        virtual void RedeemServiceItemRequest(DDLTYPE(uint32)::CPPType* requestId, const ServiceItemRedeemServiceItemParam& redeemServiceItemParam) = 0;
        virtual void RedeemServiceItemResponse(const DDLTYPE(uint32)::CPPType& requestId, ServiceItemRedeemServiceItemResponse* redeemServiceItemResponse) = 0;
    
#if defined(LIVE_VERSION)
    private:
        ProfilingUnit m_GetEnvironmentProfilingUnit;
        ProfilingUnit m_HttpGetRequestProfilingUnit;
        ProfilingUnit m_HttpGetResponseProfilingUnit;
        ProfilingUnit m_PurchaseServiceItemRequestProfilingUnit;
        ProfilingUnit m_PurchaseServiceItemResponseProfilingUnit;
        ProfilingUnit m_ListServiceItemRequestProfilingUnit;
        ProfilingUnit m_ListServiceItemResponseProfilingUnit;
        ProfilingUnit m_GetBalanceRequestProfilingUnit;
        ProfilingUnit m_GetBalanceResponseProfilingUnit;
        ProfilingUnit m_GetPrepurchaseInfoRequestProfilingUnit;
        ProfilingUnit m_GetPrepurchaseInfoResponseProfilingUnit;
        ProfilingUnit m_GetServiceItemRightRequestProfilingUnit;
        ProfilingUnit m_GetServiceItemRightResponseProfilingUnit;
        ProfilingUnit m_GetPurchaseHistoryRequestProfilingUnit;
        ProfilingUnit m_GetPurchaseHistoryResponseProfilingUnit;
        ProfilingUnit m_PostRightBinaryByAccountProfilingUnit;
        ProfilingUnit m_UseServiceItemByAccountRequestProfilingUnit;
        ProfilingUnit m_UseServiceItemByAccountResponseProfilingUnit;
        ProfilingUnit m_AcquireServiceItemByAccountProfilingUnit;
        ProfilingUnit m_GetSupportIdProfilingUnit;
        ProfilingUnit m_GetLawMessageRequestProfilingUnit;
        ProfilingUnit m_GetLawMessageResponseProfilingUnit;
        ProfilingUnit m_ListAutoBillingServiceItemRequestProfilingUnit;
        ProfilingUnit m_ListAutoBillingServiceItemResponseProfilingUnit;
        ProfilingUnit m_GetAutoBillingContractRequestProfilingUnit;
        ProfilingUnit m_GetAutoBillingContractResponseProfilingUnit;
        ProfilingUnit m_CancelAutoBillingRequestProfilingUnit;
        ProfilingUnit m_CancelAutoBillingResponseProfilingUnit;
        ProfilingUnit m_ListRedemptionServiceItemRequestProfilingUnit;
        ProfilingUnit m_ListRedemptionServiceItemResponseProfilingUnit;
        ProfilingUnit m_RedeemServiceItemRequestProfilingUnit;
        ProfilingUnit m_RedeemServiceItemResponseProfilingUnit;
#endif // LIVE_VERSION
    
};


END_NAMESPACE_NEX

#if defined(__ARMCC_VERSION) && (__ARMCC_VERSION >= 5000000)
#pragma pop
#endif // defined(__ARMCC_VERSION) && (__ARMCC_VERSION >= 5000000)
#if defined(_MSC_VER)
#pragma warning( pop )
#endif // defined(_MSC_VER)
