﻿/*---------------------------------------------------------------------------*
  (C) Copyright 1998-2018, Technologies Quazal Inc.  All rights reserved.
  Quazal Net-Z, Quazal Rendez-Vous and Quazal are trademarks of Quazal.

  Copyright (C)2011-2018 Nintendo  All rights reserved.

  These coded instructions, statements, and computer programs contain
  proprietary information of Nintendo and/or its licensors and are
  protected by national and international copyright laws.
  They may not be disclosed to third parties or copied or duplicated
  in any form, in whole or in part, without the prior written consent
  of Nintendo.
  The content herein is highly confidential and should be handled
  accordingly.
 *---------------------------------------------------------------------------*/

#pragma once

#include <OnlineCore/src/Platform/Core/PlatformDecl.h>
#include <RendezVous/Services/MatchMaking/src/Common/Gathering.h>
#include <RendezVous/Core/src/Common/AnyObjectAdapter.h>

BEGIN_NAMESPACE_NEX

class AnyGatheringAdapter: public AnyObjectAdapter<Gathering, String>
{
public:
    AnyGatheringAdapter();
    virtual ~AnyGatheringAdapter() {};

    // Returns false if prototype already exists.
    qBool RegisterPrototype(Gathering* pNewPrototype);
    qBool UnregisterPrototype(const String& strGatheringType);
    void UnregisterAllPrototypes();
    const Gathering* FindPrototype(const String& strGatheringType) const;

    Gathering* CreateObject(const String& strType) const;

    virtual void StreamIn(Message* pMessageToSend, const Gathering& oValue) const;
    virtual void StreamOut(Message* pReceivedMessage, Gathering **ppValue) const;

    static AnyGatheringAdapter* GetInstance()
    {
        return &s_oInstance;
    }

    static qUnsignedInt32 RegisterUse();
    static qUnsignedInt32 UnregisterUse();

private:
    qUnsignedInt32 m_uiUseCount;
    static AnyGatheringAdapter s_oInstance;
    //n1589:lock:Default
    static CriticalSection s_csList; // We do not reuse the SystemLock, since this class is shared between multiple context.
};

END_NAMESPACE_NEX

