﻿/*---------------------------------------------------------------------------*
  (C) Copyright 1998-2018, Technologies Quazal Inc.  All rights reserved.
  Quazal Net-Z, Quazal Rendez-Vous and Quazal are trademarks of Quazal.

  Copyright (C)2011-2018 Nintendo  All rights reserved.

  These coded instructions, statements, and computer programs contain
  proprietary information of Nintendo and/or its licensors and are
  protected by national and international copyright laws.
  They may not be disclosed to third parties or copied or duplicated
  in any form, in whole or in part, without the prior written consent
  of Nintendo.
  The content herein is highly confidential and should be handled
  accordingly.
 *---------------------------------------------------------------------------*/

#pragma once

BEGIN_NAMESPACE_NEX

/**
   \ingroup group_rdv_services_gathering_client
   \brief   This class contains the enumeration of reasons why a Gathering is flagged for deletion.
*/
class DeletionReasons
{
public:
    /**
       \brief   Enumerates the various reasons why a Gathering is flagged for deletion.
       \note    These flags cannot be set by the user but are returned by Rendez-Vous and
                listed in the Deletions database table.
    */
    enum Reasons
    {
        /**
        The reason why the Gathering is flagged for deletion is unknown.
        */
        Unknown = 0,
        /**
        The Gathering is flagged for deletion as it has been completed. This flag is set when the Gathering owner
        calls MatchMakingClient::UnregisterGathering.
        */
        Finished = 1,
        /**
        The Gathering is flagged for deletion as the Gathering is non-persistent and the Gathering owner has
        disconnected from the lobby.
        */
        Disconnected = 2
    };
};

END_NAMESPACE_NEX

