#pragma once
#if defined(__ARMCC_VERSION) && (__ARMCC_VERSION >= 5000000)
#pragma push
#pragma diag_suppress 228,381,550,1300,1301,2530
#endif // defined(__ARMCC_VERSION) && (__ARMCC_VERSION >= 5000000)
#if defined(_MSC_VER)
#pragma warning( push )
#pragma warning( disable : 4458 )
#endif // defined(_MSC_VER)


#include <OnlineCore/src/DDLTypes/CGCoreExports.h>

#include <RendezVous/Core/src/Common/ClientProtocol.h>
#include <RendezVous/Core/src/Common/ServerProtocol.h>
#include <OnlineCore/src/Core/CallContextRegister.h>
#include <RendezVous/Core/src/Common/ProtocolCGMacros.h>
#include <RendezVous/Core/src/Common/ProtocolCallContext.h>
#include <RendezVous/Core/src/Common/ProtocolRequestBrokerInterface.h>
#include <RendezVous/Core/src/Common/Protocol.h>
#include <RendezVous/Core/src/Common/ProtocolList.h>
#include <OnlineCore/src/Transport/Interface/TransportError.h>
#include <RendezVous/Core/src/Client/RVClientCore.h>
#include <RendezVous/Core/src/Client/ProtocolRegistry.h>
#include "OnlineCore/src/DDLTypes/OnlineCoreTypes.h"
#include "OnlineCore/src/DDLTypes/STLExtTypes.h"
#include "ParticipantDetailsDDL.h"
#include "GatheringURLs.h"

BEGIN_NAMESPACE_NEX

PROTO_DEFINE_RMCID(MatchMakingProtocolExt, EndParticipation, 1 );
PROTO_DEFINE_RMCID(MatchMakingProtocolExt, GetParticipants, 2 );
PROTO_DEFINE_RMCID(MatchMakingProtocolExt, GetDetailedParticipants, 3 );
PROTO_DEFINE_RMCID(MatchMakingProtocolExt, GetParticipantsURLs, 4 );
PROTO_DEFINE_RMCID(MatchMakingProtocolExt, GetGatheringRelations, 5 );
PROTO_DEFINE_RMCID(MatchMakingProtocolExt, DeleteFromDeletions, 6 );
PROTO_DEFINE_NUM_RMC(MatchMakingProtocolExt, 6);

class MatchMakingProtocolExtClient : public ClientProtocol {
    public:
        typedef DDLTYPE(bool) TEndParticipation_result;
        typedef DDLTYPE(uint32) TEndParticipation_idGathering;
        typedef DDLTYPE(string) TEndParticipation_strMessage;
        PROTO_RMCIMPL_RETURN(MatchMakingProtocolExt, EndParticipation)
        {
            PROTO_RETURNSTUB_IMPL();
            _DO_RMC_ExtractReturnValue(TEndParticipation_result,1);
            PROTO_RETURNSTUB_END();
        };
        
        typedef DDLTYPE(uint32) TGetParticipants_idGathering;
        typedef DDLTYPE(std_list)< DDLTYPE(uint32) > TGetParticipants_lstParticipants;
        typedef DDLTYPE(bool) TGetParticipants_bOnlyActive;
        PROTO_RMCIMPL_RETURN(MatchMakingProtocolExt, GetParticipants)
        {
            PROTO_RETURNSTUB_IMPL();
            _DO_RMC_ExtractReturnValue(TGetParticipants_lstParticipants,1);
            PROTO_RETURNSTUB_END();
        };
        
        typedef DDLTYPE(uint32) TGetDetailedParticipants_idGathering;
        typedef DDLTYPE(std_list)< CLASSMETATYPE(ParticipantDetails) > TGetDetailedParticipants_lstParticipants;
        typedef DDLTYPE(bool) TGetDetailedParticipants_bOnlyActive;
        PROTO_RMCIMPL_RETURN(MatchMakingProtocolExt, GetDetailedParticipants)
        {
            PROTO_RETURNSTUB_IMPL();
            _DO_RMC_ExtractReturnValue(TGetDetailedParticipants_lstParticipants,1);
            PROTO_RETURNSTUB_END();
        };
        
        typedef DDLTYPE(std_list)< DDLTYPE(uint32) > TGetParticipantsURLs_lstGatherings;
        typedef DDLTYPE(std_list)< CLASSMETATYPE(GatheringURLs) > TGetParticipantsURLs_lstGatheringURLs;
        PROTO_RMCIMPL_RETURN(MatchMakingProtocolExt, GetParticipantsURLs)
        {
            PROTO_RETURNSTUB_IMPL();
            _DO_RMC_ExtractReturnValue(TGetParticipantsURLs_lstGatheringURLs,1);
            PROTO_RETURNSTUB_END();
        };
        
        typedef DDLTYPE(string) TGetGatheringRelations_result;
        typedef DDLTYPE(uint32) TGetGatheringRelations_id;
        typedef DDLTYPE(string) TGetGatheringRelations_descr;
        PROTO_RMCIMPL_RETURN(MatchMakingProtocolExt, GetGatheringRelations)
        {
            PROTO_RETURNSTUB_IMPL();
            _DO_RMC_ExtractReturnValue(TGetGatheringRelations_result,1);
            PROTO_RETURNSTUB_END();
        };
        
        typedef DDLTYPE(std_list)< DDLTYPE(uint32) > TDeleteFromDeletions_lstDeletions;
        typedef DDLTYPE(uint32) TDeleteFromDeletions_pid;
        PROTO_RMCIMPL_RETURN(MatchMakingProtocolExt, DeleteFromDeletions)
        {
            PROTO_RETURNSTUB_IMPL();
            PROTO_RETURNSTUB_END();
        };
        
        MatchMakingProtocolExtClient(ProtocolID uiProtocolID);
        virtual ClientProtocol* CreateResponder() const { return qNew MatchMakingProtocolExtClient(ProtocolList::Unknown); }
        void RegisterProtocol()
        {
            SYSTEMCHECK(GetProtocolID() != ProtocolList::Unknown);
            SYSTEMCHECK(RVClientCore::GetInstance() != NULL && "You should create ServiceClient or NgsFacade(RendezVous) first.");
            RVClientCore::GetInstance()->GetProtocolRegistry()->RegisterProtocol(GetProtocolID(), CreateResponder());
        }
        virtual void ExtractCallSpecificResults(Message *pMessage, ProtocolCallContext* pContext);
        
        qBool CallEndParticipation(ProtocolCallContext *pContext, DDLTYPE(bool)::CPPType *pReturn, const DDLTYPE(uint32)::CPPType& idGathering, const DDLTYPE(string)::CPPType& strMessage);
        static qBool EndParticipation_PrepareRequest(ProtocolCallContext *pContext, Message *pMsg, DDLTYPE(bool)::CPPType *pReturn, const DDLTYPE(uint32)::CPPType& idGathering, const DDLTYPE(string)::CPPType& strMessage);
        qBool CallGetParticipants(ProtocolCallContext *pContext, const DDLTYPE(uint32)::CPPType& idGathering, DDLTYPE(std_list)< DDLTYPE(uint32) >::CPPType* lstParticipants, const DDLTYPE(bool)::CPPType& bOnlyActive);
        static qBool GetParticipants_PrepareRequest(ProtocolCallContext *pContext, Message *pMsg, const DDLTYPE(uint32)::CPPType& idGathering, DDLTYPE(std_list)< DDLTYPE(uint32) >::CPPType* lstParticipants, const DDLTYPE(bool)::CPPType& bOnlyActive);
        qBool CallGetDetailedParticipants(ProtocolCallContext *pContext, const DDLTYPE(uint32)::CPPType& idGathering, DDLTYPE(std_list)< CLASSMETATYPE(ParticipantDetails) >::CPPType* lstParticipants, const DDLTYPE(bool)::CPPType& bOnlyActive);
        static qBool GetDetailedParticipants_PrepareRequest(ProtocolCallContext *pContext, Message *pMsg, const DDLTYPE(uint32)::CPPType& idGathering, DDLTYPE(std_list)< CLASSMETATYPE(ParticipantDetails) >::CPPType* lstParticipants, const DDLTYPE(bool)::CPPType& bOnlyActive);
        qBool CallGetParticipantsURLs(ProtocolCallContext *pContext, const DDLTYPE(std_list)< DDLTYPE(uint32) >::CPPType& lstGatherings, DDLTYPE(std_list)< CLASSMETATYPE(GatheringURLs) >::CPPType* lstGatheringURLs);
        static qBool GetParticipantsURLs_PrepareRequest(ProtocolCallContext *pContext, Message *pMsg, const DDLTYPE(std_list)< DDLTYPE(uint32) >::CPPType& lstGatherings, DDLTYPE(std_list)< CLASSMETATYPE(GatheringURLs) >::CPPType* lstGatheringURLs);
        qBool CallGetGatheringRelations(ProtocolCallContext *pContext, DDLTYPE(string)::CPPType *pReturn, const DDLTYPE(uint32)::CPPType& id, const DDLTYPE(string)::CPPType& descr);
        static qBool GetGatheringRelations_PrepareRequest(ProtocolCallContext *pContext, Message *pMsg, DDLTYPE(string)::CPPType *pReturn, const DDLTYPE(uint32)::CPPType& id, const DDLTYPE(string)::CPPType& descr);
        qBool CallDeleteFromDeletions(ProtocolCallContext *pContext, const DDLTYPE(std_list)< DDLTYPE(uint32) >::CPPType& lstDeletions, const DDLTYPE(uint32)::CPPType& pid);
        static qBool DeleteFromDeletions_PrepareRequest(ProtocolCallContext *pContext, Message *pMsg, const DDLTYPE(std_list)< DDLTYPE(uint32) >::CPPType& lstDeletions, const DDLTYPE(uint32)::CPPType& pid);
        
        protected:
        static ProtoReturnFunction s_protoReturnFunctions[PROTO_NUM_RMC(MatchMakingProtocolExt) + 1];
};

class DDLPROTOCOL(MatchMakingProtocolExtServer) : public ServerProtocol {
    public:
        DDLPROTOCOL(MatchMakingProtocolExtServer)()
            : ServerProtocol()
#if defined(LIVE_VERSION)
            , m_EndParticipationProfilingUnit(NEX_T("MatchMakingProtocolExt::EndParticipation"))
            , m_GetParticipantsProfilingUnit(NEX_T("MatchMakingProtocolExt::GetParticipants"))
            , m_GetDetailedParticipantsProfilingUnit(NEX_T("MatchMakingProtocolExt::GetDetailedParticipants"))
            , m_GetParticipantsURLsProfilingUnit(NEX_T("MatchMakingProtocolExt::GetParticipantsURLs"))
            , m_GetGatheringRelationsProfilingUnit(NEX_T("MatchMakingProtocolExt::GetGatheringRelations"))
            , m_DeleteFromDeletionsProfilingUnit(NEX_T("MatchMakingProtocolExt::DeleteFromDeletions"))
#endif // LIVE_VERSION
            {}
        
        typedef DDLTYPE(bool) TEndParticipation_result;
        typedef DDLTYPE(uint32) TEndParticipation_idGathering;
        typedef DDLTYPE(string) TEndParticipation_strMessage;
        PROTO_RMCIMPL_STUB(MatchMakingProtocolExt, EndParticipation)
        {
            PROTO_PREPARE_EXTRACTION();
            DDLTYPE(uint32)::CPPType idGathering;
            _MSG_EXTRACT_VARIABLE(TEndParticipation_idGathering, idGathering);
            DDLTYPE(string)::CPPType strMessage;
            _MSG_EXTRACT_VARIABLE(TEndParticipation_strMessage, strMessage);
            DDLTYPE(bool)::CPPType __result=pProtocol->EndParticipation( idGathering, strMessage );
            PROTO_PREPARE_RETURN(MatchMakingProtocolExt,EndParticipation);
            _MSG_ADD_VARIABLE(TEndParticipation_result,__result);
        }
        
        typedef DDLTYPE(uint32) TGetParticipants_idGathering;
        typedef DDLTYPE(std_list)< DDLTYPE(uint32) > TGetParticipants_lstParticipants;
        typedef DDLTYPE(bool) TGetParticipants_bOnlyActive;
        PROTO_RMCIMPL_STUB(MatchMakingProtocolExt, GetParticipants)
        {
            PROTO_PREPARE_EXTRACTION();
            DDLTYPE(uint32)::CPPType idGathering;
            _MSG_EXTRACT_VARIABLE(TGetParticipants_idGathering, idGathering);
            DDLTYPE(std_list)< DDLTYPE(uint32) >::CPPType lstParticipants;
            DDLTYPE(bool)::CPPType bOnlyActive;
            _MSG_EXTRACT_VARIABLE(TGetParticipants_bOnlyActive, bOnlyActive);
            pProtocol->GetParticipants( idGathering, &lstParticipants, bOnlyActive );
            PROTO_PREPARE_RETURN(MatchMakingProtocolExt,GetParticipants);
            _MSG_ADD_VARIABLE(TGetParticipants_lstParticipants, lstParticipants);
        }
        
        typedef DDLTYPE(uint32) TGetDetailedParticipants_idGathering;
        typedef DDLTYPE(std_list)< CLASSMETATYPE(ParticipantDetails) > TGetDetailedParticipants_lstParticipants;
        typedef DDLTYPE(bool) TGetDetailedParticipants_bOnlyActive;
        PROTO_RMCIMPL_STUB(MatchMakingProtocolExt, GetDetailedParticipants)
        {
            PROTO_PREPARE_EXTRACTION();
            DDLTYPE(uint32)::CPPType idGathering;
            _MSG_EXTRACT_VARIABLE(TGetDetailedParticipants_idGathering, idGathering);
            DDLTYPE(std_list)< CLASSMETATYPE(ParticipantDetails) >::CPPType lstParticipants;
            DDLTYPE(bool)::CPPType bOnlyActive;
            _MSG_EXTRACT_VARIABLE(TGetDetailedParticipants_bOnlyActive, bOnlyActive);
            pProtocol->GetDetailedParticipants( idGathering, &lstParticipants, bOnlyActive );
            PROTO_PREPARE_RETURN(MatchMakingProtocolExt,GetDetailedParticipants);
            _MSG_ADD_VARIABLE(TGetDetailedParticipants_lstParticipants, lstParticipants);
        }
        
        typedef DDLTYPE(std_list)< DDLTYPE(uint32) > TGetParticipantsURLs_lstGatherings;
        typedef DDLTYPE(std_list)< CLASSMETATYPE(GatheringURLs) > TGetParticipantsURLs_lstGatheringURLs;
        PROTO_RMCIMPL_STUB(MatchMakingProtocolExt, GetParticipantsURLs)
        {
            PROTO_PREPARE_EXTRACTION();
            DDLTYPE(std_list)< DDLTYPE(uint32) >::CPPType lstGatherings;
            _MSG_EXTRACT_VARIABLE(TGetParticipantsURLs_lstGatherings, lstGatherings);
            DDLTYPE(std_list)< CLASSMETATYPE(GatheringURLs) >::CPPType lstGatheringURLs;
            pProtocol->GetParticipantsURLs( lstGatherings, &lstGatheringURLs );
            PROTO_PREPARE_RETURN(MatchMakingProtocolExt,GetParticipantsURLs);
            _MSG_ADD_VARIABLE(TGetParticipantsURLs_lstGatheringURLs, lstGatheringURLs);
        }
        
        typedef DDLTYPE(string) TGetGatheringRelations_result;
        typedef DDLTYPE(uint32) TGetGatheringRelations_id;
        typedef DDLTYPE(string) TGetGatheringRelations_descr;
        PROTO_RMCIMPL_STUB(MatchMakingProtocolExt, GetGatheringRelations)
        {
            PROTO_PREPARE_EXTRACTION();
            DDLTYPE(uint32)::CPPType id;
            _MSG_EXTRACT_VARIABLE(TGetGatheringRelations_id, id);
            DDLTYPE(string)::CPPType descr;
            _MSG_EXTRACT_VARIABLE(TGetGatheringRelations_descr, descr);
            DDLTYPE(string)::CPPType __result=pProtocol->GetGatheringRelations( id, descr );
            PROTO_PREPARE_RETURN(MatchMakingProtocolExt,GetGatheringRelations);
            _MSG_ADD_VARIABLE(TGetGatheringRelations_result,__result);
        }
        
        typedef DDLTYPE(std_list)< DDLTYPE(uint32) > TDeleteFromDeletions_lstDeletions;
        typedef DDLTYPE(uint32) TDeleteFromDeletions_pid;
        PROTO_RMCIMPL_STUB(MatchMakingProtocolExt, DeleteFromDeletions)
        {
            PROTO_PREPARE_EXTRACTION();
            DDLTYPE(std_list)< DDLTYPE(uint32) >::CPPType lstDeletions;
            _MSG_EXTRACT_VARIABLE(TDeleteFromDeletions_lstDeletions, lstDeletions);
            DDLTYPE(uint32)::CPPType pid;
            _MSG_EXTRACT_VARIABLE(TDeleteFromDeletions_pid, pid);
            pProtocol->DeleteFromDeletions( lstDeletions, pid );
            PROTO_PREPARE_RETURN(MatchMakingProtocolExt,DeleteFromDeletions);
        }
        
        private:
        // Call this function with a message previously generated by a
        // <RMC name>_PrepareRequest() call to have it dispatched to the correct RMC.
        virtual void DispatchProtocolMessage( Message *pMessage, Message *pReturnMessage, qBool *boReturnsMessage, EndPoint *pEndPoint);
        public:
        
        virtual DDLTYPE(bool)::CPPType EndParticipation(const DDLTYPE(uint32)::CPPType& idGathering, const DDLTYPE(string)::CPPType& strMessage) = 0;
        virtual void GetParticipants(const DDLTYPE(uint32)::CPPType& idGathering, DDLTYPE(std_list)< DDLTYPE(uint32) >::CPPType* lstParticipants, const DDLTYPE(bool)::CPPType& bOnlyActive) = 0;
        virtual void GetDetailedParticipants(const DDLTYPE(uint32)::CPPType& idGathering, DDLTYPE(std_list)< CLASSMETATYPE(ParticipantDetails) >::CPPType* lstParticipants, const DDLTYPE(bool)::CPPType& bOnlyActive) = 0;
        virtual void GetParticipantsURLs(const DDLTYPE(std_list)< DDLTYPE(uint32) >::CPPType& lstGatherings, DDLTYPE(std_list)< CLASSMETATYPE(GatheringURLs) >::CPPType* lstGatheringURLs) = 0;
        virtual DDLTYPE(string)::CPPType GetGatheringRelations(const DDLTYPE(uint32)::CPPType& id, const DDLTYPE(string)::CPPType& descr) = 0;
        virtual void DeleteFromDeletions(const DDLTYPE(std_list)< DDLTYPE(uint32) >::CPPType& lstDeletions, const DDLTYPE(uint32)::CPPType& pid) = 0;
    
#if defined(LIVE_VERSION)
    private:
        ProfilingUnit m_EndParticipationProfilingUnit;
        ProfilingUnit m_GetParticipantsProfilingUnit;
        ProfilingUnit m_GetDetailedParticipantsProfilingUnit;
        ProfilingUnit m_GetParticipantsURLsProfilingUnit;
        ProfilingUnit m_GetGatheringRelationsProfilingUnit;
        ProfilingUnit m_DeleteFromDeletionsProfilingUnit;
#endif // LIVE_VERSION
    
};


END_NAMESPACE_NEX

#if defined(__ARMCC_VERSION) && (__ARMCC_VERSION >= 5000000)
#pragma pop
#endif // defined(__ARMCC_VERSION) && (__ARMCC_VERSION >= 5000000)
#if defined(_MSC_VER)
#pragma warning( pop )
#endif // defined(_MSC_VER)
